/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v4/org/bluez/AdapterDBusProxy.hpp>

namespace v4 {
namespace org {
namespace bluez {

std::shared_ptr<CommonAPI::DBus::DBusProxy> createAdapterDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection) {
	return std::make_shared<AdapterDBusProxy>(_address, _connection);
}

INITIALIZER(registerAdapterDBusProxy) {
     CommonAPI::DBus::Factory::get()->registerProxyCreateMethod(
		Adapter::getInterface(),
		&createAdapterDBusProxy);
}

AdapterDBusProxy::AdapterDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection)
	:	CommonAPI::DBus::DBusProxy(_address, _connection)
,		propertyChanged_(*this, "PropertyChanged", "s(yv)", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<Adapter_::VariantDeployment_t*>(nullptr))),
		deviceCreated_(*this, "DeviceCreated", "s", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))),
		deviceRemoved_(*this, "DeviceRemoved", "s", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))),
		deviceFound_(*this, "DeviceFound", "sa{s(yv)}", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<Adapter_::tDeviceFound_valuesDictDeployment_t*>(nullptr))),
		deviceDisappeared_(*this, "DeviceDisappeared", "s", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)))
{
}


AdapterDBusProxy::PropertyChangedEvent& AdapterDBusProxy::getPropertyChangedEvent() {
    return propertyChanged_;
}
AdapterDBusProxy::DeviceCreatedEvent& AdapterDBusProxy::getDeviceCreatedEvent() {
    return deviceCreated_;
}
AdapterDBusProxy::DeviceRemovedEvent& AdapterDBusProxy::getDeviceRemovedEvent() {
    return deviceRemoved_;
}
AdapterDBusProxy::DeviceFoundEvent& AdapterDBusProxy::getDeviceFoundEvent() {
    return deviceFound_;
}
AdapterDBusProxy::DeviceDisappearedEvent& AdapterDBusProxy::getDeviceDisappearedEvent() {
    return deviceDisappeared_;
}
    
    void AdapterDBusProxy::GetProperties(CommonAPI::CallStatus &_internalCallStatus, Adapter::tGetProperties_propertiesDict &_properties, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Adapter::tGetProperties_propertiesDict, Adapter_::tGetProperties_propertiesDictDeployment_t> deploy_properties(static_cast<Adapter_::tGetProperties_propertiesDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Adapter::tGetProperties_propertiesDict,Adapter_::tGetProperties_propertiesDictDeployment_t>
            >
        	>::callMethodWithReply(
        *this,
        "GetProperties",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus,
deploy_properties);
_properties = deploy_properties.getValue();
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::GetPropertiesAsync(GetPropertiesAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Adapter::tGetProperties_propertiesDict, Adapter_::tGetProperties_propertiesDictDeployment_t> deploy_properties(static_cast<Adapter_::tGetProperties_propertiesDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Adapter::tGetProperties_propertiesDict,Adapter_::tGetProperties_propertiesDictDeployment_t>
            >
        	>::callMethodAsync(
        *this,
        "GetProperties",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<Adapter::tGetProperties_propertiesDict, Adapter_::tGetProperties_propertiesDictDeployment_t> _properties) {
        	if (_callback)
        		_callback(_internalCallStatus, _properties.getValue());
        },
        std::make_tuple(deploy_properties));
    }
    void AdapterDBusProxy::SetProperty(const std::string &_name, const Adapter::Variant &_value, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_name(_name, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Adapter::Variant, Adapter_::VariantDeployment_t> deploy_value(_value, static_cast<Adapter_::VariantDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Adapter::Variant, Adapter_::VariantDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "SetProperty",
        "s(yv)",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_name, deploy_value,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::SetPropertyAsync(const std::string &_name, const Adapter::Variant &_value, SetPropertyAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_name(_name, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Adapter::Variant, Adapter_::VariantDeployment_t> deploy_value(_value, static_cast<Adapter_::VariantDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Adapter::Variant, Adapter_::VariantDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "SetProperty",
        "s(yv)",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_name, deploy_value,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void AdapterDBusProxy::RequestSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "RequestSession",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::RequestSessionAsync(RequestSessionAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "RequestSession",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void AdapterDBusProxy::ReleaseSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "ReleaseSession",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::ReleaseSessionAsync(ReleaseSessionAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "ReleaseSession",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void AdapterDBusProxy::StartDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "StartDiscovery",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::StartDiscoveryAsync(StartDiscoveryAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "StartDiscovery",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void AdapterDBusProxy::StopDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "StopDiscovery",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::StopDiscoveryAsync(StopDiscoveryAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "StopDiscovery",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void AdapterDBusProxy::ListDevices(CommonAPI::CallStatus &_internalCallStatus, std::vector<std::string> &_devices, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>> deploy_devices(static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::vector<std::string>,CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>>
            >
        	>::callMethodWithReply(
        *this,
        "ListDevices",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus,
deploy_devices);
_devices = deploy_devices.getValue();
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::ListDevicesAsync(ListDevicesAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>> deploy_devices(static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::vector<std::string>,CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>>
            >
        	>::callMethodAsync(
        *this,
        "ListDevices",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>> _devices) {
        	if (_callback)
        		_callback(_internalCallStatus, _devices.getValue());
        },
        std::make_tuple(deploy_devices));
    }
    void AdapterDBusProxy::CreateDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_address(_address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_device(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "CreateDevice",
        "s",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_address,
_internalCallStatus,
deploy_device);
_device = deploy_device.getValue();
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::CreateDeviceAsync(const std::string &_address, CreateDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_address(_address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_device(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodAsync(
        *this,
        "CreateDevice",
        "s",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_address,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _device) {
        	if (_callback)
        		_callback(_internalCallStatus, _device.getValue());
        },
        std::make_tuple(deploy_device));
    }
    void AdapterDBusProxy::CreatePairedDevice(const std::string &_address, const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_address(_address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_agent(_agent, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_capability(_capability, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_device(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "CreatePairedDevice",
        "sss",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_address, deploy_agent, deploy_capability,
_internalCallStatus,
deploy_device);
_device = deploy_device.getValue();
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::CreatePairedDeviceAsync(const std::string &_address, const std::string &_agent, const std::string &_capability, CreatePairedDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_address(_address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_agent(_agent, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_capability(_capability, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_device(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodAsync(
        *this,
        "CreatePairedDevice",
        "sss",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_address, deploy_agent, deploy_capability,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _device) {
        	if (_callback)
        		_callback(_internalCallStatus, _device.getValue());
        },
        std::make_tuple(deploy_device));
    }
    void AdapterDBusProxy::CancelDeviceCreation(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_address(_address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "CancelDeviceCreation",
        "s",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_address,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::CancelDeviceCreationAsync(const std::string &_address, CancelDeviceCreationAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_address(_address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "CancelDeviceCreation",
        "s",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_address,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void AdapterDBusProxy::RemoveDevice(const std::string &_device, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_device(_device, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "RemoveDevice",
        "s",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_device,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::RemoveDeviceAsync(const std::string &_device, RemoveDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_device(_device, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "RemoveDevice",
        "s",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_device,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void AdapterDBusProxy::FindDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_address(_address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_device(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "FindDevice",
        "s",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_address,
_internalCallStatus,
deploy_device);
_device = deploy_device.getValue();
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::FindDeviceAsync(const std::string &_address, FindDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_address(_address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_device(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodAsync(
        *this,
        "FindDevice",
        "s",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_address,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _device) {
        	if (_callback)
        		_callback(_internalCallStatus, _device.getValue());
        },
        std::make_tuple(deploy_device));
    }
    void AdapterDBusProxy::RegisterAgent(const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_agent(_agent, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_capability(_capability, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "RegisterAgent",
        "ss",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_agent, deploy_capability,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::RegisterAgentAsync(const std::string &_agent, const std::string &_capability, RegisterAgentAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_agent(_agent, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_capability(_capability, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "RegisterAgent",
        "ss",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_agent, deploy_capability,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void AdapterDBusProxy::UnregisterAgent(const std::string &_agent, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_agent(_agent, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "UnregisterAgent",
        "s",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_agent,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> AdapterDBusProxy::UnregisterAgentAsync(const std::string &_agent, UnregisterAgentAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_agent(_agent, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "UnregisterAgent",
        "s",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_agent,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }


void AdapterDBusProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
          ownVersionMajor = 4;
          ownVersionMinor = 1;
      }

      } // namespace bluez
      } // namespace org
      } // namespace v4
