/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Adapter_DBUS_PROXY_HPP_
#define V4_ORG_BLUEZ_Adapter_DBUS_PROXY_HPP_

#include <v4/org/bluez/AdapterProxyBase.hpp>
#include "v4/org/bluez/AdapterDBusDeployment.hpp"

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddress.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusProxy.hpp>
#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusEvent.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

#include <string>

namespace v4 {
namespace org {
namespace bluez {

class AdapterDBusProxy
    : virtual public AdapterProxyBase, 
      virtual public CommonAPI::DBus::DBusProxy {
public:
    AdapterDBusProxy(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection);

    virtual ~AdapterDBusProxy() { }


    virtual PropertyChangedEvent& getPropertyChangedEvent();
    virtual DeviceCreatedEvent& getDeviceCreatedEvent();
    virtual DeviceRemovedEvent& getDeviceRemovedEvent();
    virtual DeviceFoundEvent& getDeviceFoundEvent();
    virtual DeviceDisappearedEvent& getDeviceDisappearedEvent();

    virtual void GetProperties(CommonAPI::CallStatus &_internalCallStatus, Adapter::tGetProperties_propertiesDict &_properties, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> GetPropertiesAsync(GetPropertiesAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void SetProperty(const std::string &_name, const Adapter::Variant &_value, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> SetPropertyAsync(const std::string &_name, const Adapter::Variant &_value, SetPropertyAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void RequestSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> RequestSessionAsync(RequestSessionAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void ReleaseSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> ReleaseSessionAsync(ReleaseSessionAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void StartDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> StartDiscoveryAsync(StartDiscoveryAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void StopDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> StopDiscoveryAsync(StopDiscoveryAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void ListDevices(CommonAPI::CallStatus &_internalCallStatus, std::vector<std::string> &_devices, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> ListDevicesAsync(ListDevicesAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void CreateDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> CreateDeviceAsync(const std::string &_address, CreateDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void CreatePairedDevice(const std::string &_address, const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> CreatePairedDeviceAsync(const std::string &_address, const std::string &_agent, const std::string &_capability, CreatePairedDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void CancelDeviceCreation(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> CancelDeviceCreationAsync(const std::string &_address, CancelDeviceCreationAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void RemoveDevice(const std::string &_device, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> RemoveDeviceAsync(const std::string &_device, RemoveDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void FindDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> FindDeviceAsync(const std::string &_address, FindDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void RegisterAgent(const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> RegisterAgentAsync(const std::string &_agent, const std::string &_capability, RegisterAgentAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void UnregisterAgent(const std::string &_agent, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> UnregisterAgentAsync(const std::string &_agent, UnregisterAgentAsyncCallback _callback, const CommonAPI::CallInfo *_info);


    virtual void getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const;

private:
   

    CommonAPI::DBus::DBusEvent<PropertyChangedEvent, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>, CommonAPI::Deployable<::v4::org::bluez::Adapter::Variant, Adapter_::VariantDeployment_t>> propertyChanged_;
    CommonAPI::DBus::DBusEvent<DeviceCreatedEvent, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>> deviceCreated_;
    CommonAPI::DBus::DBusEvent<DeviceRemovedEvent, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>> deviceRemoved_;
    CommonAPI::DBus::DBusEvent<DeviceFoundEvent, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>, CommonAPI::Deployable<::v4::org::bluez::Adapter::tDeviceFound_valuesDict, Adapter_::tDeviceFound_valuesDictDeployment_t>> deviceFound_;
    CommonAPI::DBus::DBusEvent<DeviceDisappearedEvent, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>> deviceDisappeared_;

};

} // namespace bluez
} // namespace org
} // namespace v4

#endif // V4_ORG_BLUEZ_Adapter_DBUS_PROXY_HPP_

