/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v4/org/bluez/Adapter.hpp>
#include <v4/org/bluez/AdapterDBusStubAdapter.hpp>

namespace v4 {
namespace org {
namespace bluez {

std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> createAdapterDBusStubAdapter(
                   const CommonAPI::DBus::DBusAddress &_address,
                   const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
                   const std::shared_ptr<CommonAPI::StubBase> &_stub) {
    return std::make_shared<AdapterDBusStubAdapter>(_address, _connection, _stub);
}

INITIALIZER(registerAdapterDBusStubAdapter) {
    CommonAPI::DBus::Factory::get()->registerStubAdapterCreateMethod(
    	Adapter::getInterface(), &createAdapterDBusStubAdapter);
}

AdapterDBusStubAdapterInternal::~AdapterDBusStubAdapterInternal() {
    deactivateManagedInstances();
    AdapterDBusStubAdapterHelper::deinit();
}

void AdapterDBusStubAdapterInternal::deactivateManagedInstances() {

}

const char* AdapterDBusStubAdapterInternal::getMethodsDBusIntrospectionXmlData() const {
    static const std::string introspectionData =
        "<method name=\"getInterfaceVersion\">\n"
            "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
        "</method>\n"
        "<signal name=\"PropertyChanged\">\n"
            "<arg name=\"name\" type=\"s\" />\n"
            "<arg name=\"value\" type=\"(yv)\" />\n"
        "</signal>\n"
        "<signal name=\"DeviceCreated\">\n"
            "<arg name=\"device\" type=\"s\" />\n"
        "</signal>\n"
        "<signal name=\"DeviceRemoved\">\n"
            "<arg name=\"device\" type=\"s\" />\n"
        "</signal>\n"
        "<signal name=\"DeviceFound\">\n"
            "<arg name=\"address\" type=\"s\" />\n"
            "<arg name=\"values\" type=\"a{s(yv)}\" />\n"
        "</signal>\n"
        "<signal name=\"DeviceDisappeared\">\n"
            "<arg name=\"address\" type=\"s\" />\n"
        "</signal>\n"
        "<method name=\"GetProperties\">\n"
            "<arg name=\"_properties\" type=\"a{s(yv)}\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"SetProperty\">\n"
            "<arg name=\"_name\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_value\" type=\"(yv)\" direction=\"in\" />\n"
        "</method>\n"
        "<method name=\"RequestSession\">\n"
        "</method>\n"
        "<method name=\"ReleaseSession\">\n"
        "</method>\n"
        "<method name=\"StartDiscovery\">\n"
        "</method>\n"
        "<method name=\"StopDiscovery\">\n"
        "</method>\n"
        "<method name=\"ListDevices\">\n"
            "<arg name=\"_devices\" type=\"as\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"CreateDevice\">\n"
            "<arg name=\"_address\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_device\" type=\"s\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"CreatePairedDevice\">\n"
            "<arg name=\"_address\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_agent\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_capability\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_device\" type=\"s\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"CancelDeviceCreation\">\n"
            "<arg name=\"_address\" type=\"s\" direction=\"in\" />\n"
        "</method>\n"
        "<method name=\"RemoveDevice\">\n"
            "<arg name=\"_device\" type=\"s\" direction=\"in\" />\n"
        "</method>\n"
        "<method name=\"FindDevice\">\n"
            "<arg name=\"_address\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_device\" type=\"s\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"RegisterAgent\">\n"
            "<arg name=\"_agent\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_capability\" type=\"s\" direction=\"in\" />\n"
        "</method>\n"
        "<method name=\"UnregisterAgent\">\n"
            "<arg name=\"_agent\" type=\"s\" direction=\"in\" />\n"
        "</method>\n"

    ;
    return introspectionData.c_str();
}

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        CommonAPI::Version
        > AdapterDBusStubAdapterInternal::getAdapterInterfaceVersionStubDispatcher(&AdapterStub::getInterfaceVersion, "uu");




CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<Adapter::tGetProperties_propertiesDict>,
    std::tuple<>,
    std::tuple<Adapter_::tGetProperties_propertiesDictDeployment_t>
    
    > AdapterDBusStubAdapterInternal::getPropertiesStubDispatcher(
    &AdapterStub::GetProperties, "a{s(yv)}",
					std::make_tuple(),
                	std::make_tuple(static_cast<Adapter_::tGetProperties_propertiesDictDeployment_t*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string, Adapter::Variant>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment, Adapter_::VariantDeployment_t>,
    std::tuple<>
    
    > AdapterDBusStubAdapterInternal::setPropertyStubDispatcher(
    &AdapterStub::SetProperty, "",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<Adapter_::VariantDeployment_t*>(nullptr)),
                	std::make_tuple());

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>
    
    > AdapterDBusStubAdapterInternal::requestSessionStubDispatcher(
    &AdapterStub::RequestSession, "",
					std::make_tuple(),
                	std::make_tuple());

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>
    
    > AdapterDBusStubAdapterInternal::releaseSessionStubDispatcher(
    &AdapterStub::ReleaseSession, "",
					std::make_tuple(),
                	std::make_tuple());

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>
    
    > AdapterDBusStubAdapterInternal::startDiscoveryStubDispatcher(
    &AdapterStub::StartDiscovery, "",
					std::make_tuple(),
                	std::make_tuple());

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>
    
    > AdapterDBusStubAdapterInternal::stopDiscoveryStubDispatcher(
    &AdapterStub::StopDiscovery, "",
					std::make_tuple(),
                	std::make_tuple());

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<std::vector<std::string>>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>>
    
    > AdapterDBusStubAdapterInternal::listDevicesStubDispatcher(
    &AdapterStub::ListDevices, "as",
					std::make_tuple(),
                	std::make_tuple(static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<std::string>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > AdapterDBusStubAdapterInternal::createDeviceStubDispatcher(
    &AdapterStub::CreateDevice, "s",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
                	std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string, std::string, std::string>,
    std::tuple<std::string>,
    std::tuple<CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > AdapterDBusStubAdapterInternal::createPairedDeviceStubDispatcher(
    &AdapterStub::CreatePairedDevice, "s",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
                	std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<>
    
    > AdapterDBusStubAdapterInternal::cancelDeviceCreationStubDispatcher(
    &AdapterStub::CancelDeviceCreation, "",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
                	std::make_tuple());

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<>
    
    > AdapterDBusStubAdapterInternal::removeDeviceStubDispatcher(
    &AdapterStub::RemoveDevice, "",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
                	std::make_tuple());

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<std::string>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > AdapterDBusStubAdapterInternal::findDeviceStubDispatcher(
    &AdapterStub::FindDevice, "s",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
                	std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string, std::string>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment>,
    std::tuple<>
    
    > AdapterDBusStubAdapterInternal::registerAgentStubDispatcher(
    &AdapterStub::RegisterAgent, "",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
                	std::make_tuple());

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<>
    
    > AdapterDBusStubAdapterInternal::unregisterAgentStubDispatcher(
    &AdapterStub::UnregisterAgent, "",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
                	std::make_tuple());



void AdapterDBusStubAdapterInternal::firePropertyChangedEvent(const std::string& name, const ::v4::org::bluez::Adapter::Variant& value) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>,
    CommonAPI::Deployable<::v4::org::bluez::Adapter::Variant, Adapter_::VariantDeployment_t>
    >>::sendSignal(
            *this,
            "PropertyChanged",
            "s(yv)",
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>(name, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
    CommonAPI::Deployable<::v4::org::bluez::Adapter::Variant, Adapter_::VariantDeployment_t>(value, static_cast<Adapter_::VariantDeployment_t*>(nullptr))
    );
}
void AdapterDBusStubAdapterInternal::fireDeviceCreatedEvent(const std::string& device) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "DeviceCreated",
            "s",
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>(device, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
    );
}
void AdapterDBusStubAdapterInternal::fireDeviceRemovedEvent(const std::string& device) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "DeviceRemoved",
            "s",
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>(device, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
    );
}
void AdapterDBusStubAdapterInternal::fireDeviceFoundEvent(const std::string& address, const ::v4::org::bluez::Adapter::tDeviceFound_valuesDict& values) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>,
    CommonAPI::Deployable<::v4::org::bluez::Adapter::tDeviceFound_valuesDict, Adapter_::tDeviceFound_valuesDictDeployment_t>
    >>::sendSignal(
            *this,
            "DeviceFound",
            "sa{s(yv)}",
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>(address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
    CommonAPI::Deployable<::v4::org::bluez::Adapter::tDeviceFound_valuesDict, Adapter_::tDeviceFound_valuesDictDeployment_t>(values, static_cast<Adapter_::tDeviceFound_valuesDictDeployment_t*>(nullptr))
    );
}
void AdapterDBusStubAdapterInternal::fireDeviceDisappearedEvent(const std::string& address) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "DeviceDisappeared",
            "s",
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>(address, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
    );
}


const AdapterDBusStubAdapterHelper::StubDispatcherTable& AdapterDBusStubAdapterInternal::getStubDispatcherTable() {
    return stubDispatcherTable_;
}

const CommonAPI::DBus::StubAttributeTable& AdapterDBusStubAdapterInternal::getStubAttributeTable() {
    return stubAttributeTable_;
}

AdapterDBusStubAdapterInternal::AdapterDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub)
	: CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      AdapterDBusStubAdapterHelper(_address, _connection, std::dynamic_pointer_cast<AdapterStub>(_stub), false),
      stubDispatcherTable_({
            { { "GetProperties", "" }, &org::bluez::AdapterDBusStubAdapterInternal::getPropertiesStubDispatcher },
            { { "SetProperty", "s(yv)" }, &org::bluez::AdapterDBusStubAdapterInternal::setPropertyStubDispatcher },
            { { "RequestSession", "" }, &org::bluez::AdapterDBusStubAdapterInternal::requestSessionStubDispatcher },
            { { "ReleaseSession", "" }, &org::bluez::AdapterDBusStubAdapterInternal::releaseSessionStubDispatcher },
            { { "StartDiscovery", "" }, &org::bluez::AdapterDBusStubAdapterInternal::startDiscoveryStubDispatcher },
            { { "StopDiscovery", "" }, &org::bluez::AdapterDBusStubAdapterInternal::stopDiscoveryStubDispatcher },
            { { "ListDevices", "" }, &org::bluez::AdapterDBusStubAdapterInternal::listDevicesStubDispatcher },
            { { "CreateDevice", "s" }, &org::bluez::AdapterDBusStubAdapterInternal::createDeviceStubDispatcher },
            { { "CreatePairedDevice", "sss" }, &org::bluez::AdapterDBusStubAdapterInternal::createPairedDeviceStubDispatcher },
            { { "CancelDeviceCreation", "s" }, &org::bluez::AdapterDBusStubAdapterInternal::cancelDeviceCreationStubDispatcher },
            { { "RemoveDevice", "s" }, &org::bluez::AdapterDBusStubAdapterInternal::removeDeviceStubDispatcher },
            { { "FindDevice", "s" }, &org::bluez::AdapterDBusStubAdapterInternal::findDeviceStubDispatcher },
            { { "RegisterAgent", "ss" }, &org::bluez::AdapterDBusStubAdapterInternal::registerAgentStubDispatcher },
            { { "UnregisterAgent", "s" }, &org::bluez::AdapterDBusStubAdapterInternal::unregisterAgentStubDispatcher }
            }),
        stubAttributeTable_() {

    stubDispatcherTable_.insert({ { "getInterfaceVersion", "" }, &org::bluez::AdapterDBusStubAdapterInternal::getAdapterInterfaceVersionStubDispatcher });
}

bool AdapterDBusStubAdapterInternal::hasFreedesktopProperties() {
    return false;
}

} // namespace bluez
} // namespace org
} // namespace v4
