/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Adapter_DBUS_STUB_ADAPTER_HPP_
#define V4_ORG_BLUEZ_Adapter_DBUS_STUB_ADAPTER_HPP_

#include <v4/org/bluez/AdapterStub.hpp>
#include "v4/org/bluez/AdapterDBusDeployment.hpp"        
#include <v4/org/bluez/AdapterDBusDeployment.hpp>        

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusStubAdapterHelper.hpp>
#include <CommonAPI/DBus/DBusStubAdapter.hpp>
#include <CommonAPI/DBus/DBusDeployment.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v4 {
namespace org {
namespace bluez {

typedef CommonAPI::DBus::DBusStubAdapterHelper<AdapterStub> AdapterDBusStubAdapterHelper;

class AdapterDBusStubAdapterInternal
    : public virtual AdapterStubAdapter,
      public AdapterDBusStubAdapterHelper
{
public:
    AdapterDBusStubAdapterInternal(
            const CommonAPI::DBus::DBusAddress &_address,
            const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
            const std::shared_ptr<CommonAPI::StubBase> &_stub);

    ~AdapterDBusStubAdapterInternal();

    virtual bool hasFreedesktopProperties();

    inline static const char* getInterface() {
        return Adapter::getInterface();
    }


    void firePropertyChangedEvent(const std::string& name, const ::v4::org::bluez::Adapter::Variant& value);
    void fireDeviceCreatedEvent(const std::string& device);
    void fireDeviceRemovedEvent(const std::string& device);
    void fireDeviceFoundEvent(const std::string& address, const ::v4::org::bluez::Adapter::tDeviceFound_valuesDict& values);
    void fireDeviceDisappearedEvent(const std::string& address);


    const AdapterDBusStubAdapterHelper::StubDispatcherTable& getStubDispatcherTable();
    const CommonAPI::DBus::StubAttributeTable& getStubAttributeTable();

    void deactivateManagedInstances();
    

static CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v4::org::bluez::AdapterStub,
        CommonAPI::Version
        > getAdapterInterfaceVersionStubDispatcher;




static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<Adapter::tGetProperties_propertiesDict>,
    std::tuple<>,
    std::tuple<Adapter_::tGetProperties_propertiesDictDeployment_t>
    
    > getPropertiesStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string, Adapter::Variant>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment, Adapter_::VariantDeployment_t>,
    std::tuple<>
    
    > setPropertyStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>
    
    > requestSessionStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>
    
    > releaseSessionStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>
    
    > startDiscoveryStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>,
    std::tuple<>
    
    > stopDiscoveryStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<>,
    std::tuple<std::vector<std::string>>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>>
    
    > listDevicesStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<std::string>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > createDeviceStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string, std::string, std::string>,
    std::tuple<std::string>,
    std::tuple<CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > createPairedDeviceStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<>
    
    > cancelDeviceCreationStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<>
    
    > removeDeviceStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<std::string>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > findDeviceStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string, std::string>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment>,
    std::tuple<>
    
    > registerAgentStubDispatcher;

static CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::AdapterStub,
    std::tuple<std::string>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<>
    
    > unregisterAgentStubDispatcher;




 protected:
    virtual const char* getMethodsDBusIntrospectionXmlData() const;

 private:
    AdapterDBusStubAdapterHelper::StubDispatcherTable stubDispatcherTable_;
    CommonAPI::DBus::StubAttributeTable stubAttributeTable_;
};

class AdapterDBusStubAdapter
    : public AdapterDBusStubAdapterInternal,
      public std::enable_shared_from_this<AdapterDBusStubAdapter> {
public:
    AdapterDBusStubAdapter(
    	const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub)
    	: CommonAPI::DBus::DBusStubAdapter(
    		_address, 
    		_connection,
            false),
          AdapterDBusStubAdapterInternal(
          	_address, 
          	_connection, 
          	_stub) { 
    }
};

} // namespace bluez
} // namespace org
} // namespace v4

#endif // V4_ORG_BLUEZ_Adapter_DBUS_STUB_ADAPTER_HPP_
