/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Adapter_PROXY_HPP_
#define V4_ORG_BLUEZ_Adapter_PROXY_HPP_

#include <v4/org/bluez/AdapterProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif


#undef COMMONAPI_INTERNAL_COMPILATION

namespace v4 {
namespace org {
namespace bluez {

template <typename ... _AttributeExtensions>
class AdapterProxy
    : virtual public Adapter, 
      virtual public AdapterProxyBase,
      virtual public _AttributeExtensions... {
public:
    AdapterProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~AdapterProxy();

    typedef Adapter InterfaceType;



    /**
     * Returns the wrapper class that provides access to the broadcast PropertyChanged.
     */
    virtual PropertyChangedEvent& getPropertyChangedEvent() {
        return delegate_->getPropertyChangedEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast DeviceCreated.
     */
    virtual DeviceCreatedEvent& getDeviceCreatedEvent() {
        return delegate_->getDeviceCreatedEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast DeviceRemoved.
     */
    virtual DeviceRemovedEvent& getDeviceRemovedEvent() {
        return delegate_->getDeviceRemovedEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast DeviceFound.
     */
    virtual DeviceFoundEvent& getDeviceFoundEvent() {
        return delegate_->getDeviceFoundEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast DeviceDisappeared.
     */
    virtual DeviceDisappearedEvent& getDeviceDisappearedEvent() {
        return delegate_->getDeviceDisappearedEvent();
    }

    /**
     * Calls GetProperties with synchronous semantics.
     * 
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void GetProperties(CommonAPI::CallStatus &_internalCallStatus, Adapter::tGetProperties_propertiesDict &_properties, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls GetProperties with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> GetPropertiesAsync(GetPropertiesAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetProperty with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void SetProperty(const std::string &_name, const Adapter::Variant &_value, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetProperty with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> SetPropertyAsync(const std::string &_name, const Adapter::Variant &_value, SetPropertyAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls RequestSession with synchronous semantics.
     * 
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void RequestSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls RequestSession with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> RequestSessionAsync(RequestSessionAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls ReleaseSession with synchronous semantics.
     * 
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void ReleaseSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls ReleaseSession with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> ReleaseSessionAsync(ReleaseSessionAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls StartDiscovery with synchronous semantics.
     * 
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void StartDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls StartDiscovery with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> StartDiscoveryAsync(StartDiscoveryAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls StopDiscovery with synchronous semantics.
     * 
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void StopDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls StopDiscovery with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> StopDiscoveryAsync(StopDiscoveryAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls ListDevices with synchronous semantics.
     * 
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void ListDevices(CommonAPI::CallStatus &_internalCallStatus, std::vector<std::string> &_devices, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls ListDevices with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> ListDevicesAsync(ListDevicesAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls CreateDevice with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void CreateDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls CreateDevice with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> CreateDeviceAsync(const std::string &_address, CreateDeviceAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls CreatePairedDevice with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void CreatePairedDevice(const std::string &_address, const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls CreatePairedDevice with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> CreatePairedDeviceAsync(const std::string &_address, const std::string &_agent, const std::string &_capability, CreatePairedDeviceAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls CancelDeviceCreation with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void CancelDeviceCreation(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls CancelDeviceCreation with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> CancelDeviceCreationAsync(const std::string &_address, CancelDeviceCreationAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls RemoveDevice with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void RemoveDevice(const std::string &_device, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls RemoveDevice with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> RemoveDeviceAsync(const std::string &_device, RemoveDeviceAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls FindDevice with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void FindDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls FindDevice with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> FindDeviceAsync(const std::string &_address, FindDeviceAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls RegisterAgent with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void RegisterAgent(const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls RegisterAgent with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> RegisterAgentAsync(const std::string &_agent, const std::string &_capability, RegisterAgentAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls UnregisterAgent with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void UnregisterAgent(const std::string &_agent, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls UnregisterAgent with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> UnregisterAgentAsync(const std::string &_agent, UnregisterAgentAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<AdapterProxyBase> delegate_;
};

typedef AdapterProxy<> AdapterProxyDefault;


//
// AdapterProxy Implementation
//
template <typename ... _AttributeExtensions>
AdapterProxy<_AttributeExtensions...>::AdapterProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<AdapterProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<AdapterProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
AdapterProxy<_AttributeExtensions...>::~AdapterProxy() {
}

template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::GetProperties(CommonAPI::CallStatus &_internalCallStatus, Adapter::tGetProperties_propertiesDict &_properties, const CommonAPI::CallInfo *_info) {
    delegate_->GetProperties(_internalCallStatus, _properties, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::GetPropertiesAsync(GetPropertiesAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->GetPropertiesAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::SetProperty(const std::string &_name, const Adapter::Variant &_value, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->SetProperty(_name, _value, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::SetPropertyAsync(const std::string &_name, const Adapter::Variant &_value, SetPropertyAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->SetPropertyAsync(_name, _value, _callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::RequestSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->RequestSession(_internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::RequestSessionAsync(RequestSessionAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->RequestSessionAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::ReleaseSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->ReleaseSession(_internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::ReleaseSessionAsync(ReleaseSessionAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->ReleaseSessionAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::StartDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->StartDiscovery(_internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::StartDiscoveryAsync(StartDiscoveryAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->StartDiscoveryAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::StopDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->StopDiscovery(_internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::StopDiscoveryAsync(StopDiscoveryAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->StopDiscoveryAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::ListDevices(CommonAPI::CallStatus &_internalCallStatus, std::vector<std::string> &_devices, const CommonAPI::CallInfo *_info) {
    delegate_->ListDevices(_internalCallStatus, _devices, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::ListDevicesAsync(ListDevicesAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->ListDevicesAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::CreateDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info) {
    delegate_->CreateDevice(_address, _internalCallStatus, _device, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::CreateDeviceAsync(const std::string &_address, CreateDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->CreateDeviceAsync(_address, _callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::CreatePairedDevice(const std::string &_address, const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info) {
    delegate_->CreatePairedDevice(_address, _agent, _capability, _internalCallStatus, _device, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::CreatePairedDeviceAsync(const std::string &_address, const std::string &_agent, const std::string &_capability, CreatePairedDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->CreatePairedDeviceAsync(_address, _agent, _capability, _callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::CancelDeviceCreation(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->CancelDeviceCreation(_address, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::CancelDeviceCreationAsync(const std::string &_address, CancelDeviceCreationAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->CancelDeviceCreationAsync(_address, _callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::RemoveDevice(const std::string &_device, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->RemoveDevice(_device, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::RemoveDeviceAsync(const std::string &_device, RemoveDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->RemoveDeviceAsync(_device, _callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::FindDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info) {
    delegate_->FindDevice(_address, _internalCallStatus, _device, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::FindDeviceAsync(const std::string &_address, FindDeviceAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->FindDeviceAsync(_address, _callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::RegisterAgent(const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->RegisterAgent(_agent, _capability, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::RegisterAgentAsync(const std::string &_agent, const std::string &_capability, RegisterAgentAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->RegisterAgentAsync(_agent, _capability, _callback, _info);
}
template <typename ... _AttributeExtensions>
void AdapterProxy<_AttributeExtensions...>::UnregisterAgent(const std::string &_agent, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->UnregisterAgent(_agent, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> AdapterProxy<_AttributeExtensions...>::UnregisterAgentAsync(const std::string &_agent, UnregisterAgentAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->UnregisterAgentAsync(_agent, _callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &AdapterProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool AdapterProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool AdapterProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& AdapterProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& AdapterProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace bluez
} // namespace org
} // namespace v4



// Compatibility
namespace v4_1 = v4;

#endif // V4_ORG_BLUEZ_Adapter_PROXY_HPP_
