/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Adapter_PROXY_BASE_HPP_
#define V4_ORG_BLUEZ_Adapter_PROXY_BASE_HPP_

#include <v4/org/bluez/Adapter.hpp>



#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/Variant.hpp>
#include <cstdint>
#include <memory>
#include <string>
#include <unordered_map>
#include <vector>

#include <CommonAPI/Event.hpp>
#include <CommonAPI/Proxy.hpp>
#include <functional>
#include <future>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v4 {
namespace org {
namespace bluez {

class AdapterProxyBase
    : virtual public CommonAPI::Proxy {
public:
    typedef CommonAPI::Event<
        std::string, ::v4::org::bluez::Adapter::Variant
    > PropertyChangedEvent;
    typedef CommonAPI::Event<
        std::string
    > DeviceCreatedEvent;
    typedef CommonAPI::Event<
        std::string
    > DeviceRemovedEvent;
    typedef CommonAPI::Event<
        std::string, ::v4::org::bluez::Adapter::tDeviceFound_valuesDict
    > DeviceFoundEvent;
    typedef CommonAPI::Event<
        std::string
    > DeviceDisappearedEvent;

    typedef std::function<void(const CommonAPI::CallStatus&, const Adapter::tGetProperties_propertiesDict&)> GetPropertiesAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> SetPropertyAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> RequestSessionAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> ReleaseSessionAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> StartDiscoveryAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> StopDiscoveryAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const std::vector<std::string>&)> ListDevicesAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const std::string&)> CreateDeviceAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const std::string&)> CreatePairedDeviceAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> CancelDeviceCreationAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> RemoveDeviceAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const std::string&)> FindDeviceAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> RegisterAgentAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> UnregisterAgentAsyncCallback;


    virtual PropertyChangedEvent& getPropertyChangedEvent() = 0;
    virtual DeviceCreatedEvent& getDeviceCreatedEvent() = 0;
    virtual DeviceRemovedEvent& getDeviceRemovedEvent() = 0;
    virtual DeviceFoundEvent& getDeviceFoundEvent() = 0;
    virtual DeviceDisappearedEvent& getDeviceDisappearedEvent() = 0;

    virtual void GetProperties(CommonAPI::CallStatus &_internalCallStatus, Adapter::tGetProperties_propertiesDict &_properties, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> GetPropertiesAsync(GetPropertiesAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void SetProperty(const std::string &_name, const Adapter::Variant &_value, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> SetPropertyAsync(const std::string &_name, const Adapter::Variant &_value, SetPropertyAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void RequestSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> RequestSessionAsync(RequestSessionAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void ReleaseSession(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> ReleaseSessionAsync(ReleaseSessionAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void StartDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> StartDiscoveryAsync(StartDiscoveryAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void StopDiscovery(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> StopDiscoveryAsync(StopDiscoveryAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void ListDevices(CommonAPI::CallStatus &_internalCallStatus, std::vector<std::string> &_devices, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> ListDevicesAsync(ListDevicesAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void CreateDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> CreateDeviceAsync(const std::string &_address, CreateDeviceAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void CreatePairedDevice(const std::string &_address, const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> CreatePairedDeviceAsync(const std::string &_address, const std::string &_agent, const std::string &_capability, CreatePairedDeviceAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void CancelDeviceCreation(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> CancelDeviceCreationAsync(const std::string &_address, CancelDeviceCreationAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void RemoveDevice(const std::string &_device, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> RemoveDeviceAsync(const std::string &_device, RemoveDeviceAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void FindDevice(const std::string &_address, CommonAPI::CallStatus &_internalCallStatus, std::string &_device, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> FindDeviceAsync(const std::string &_address, FindDeviceAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void RegisterAgent(const std::string &_agent, const std::string &_capability, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> RegisterAgentAsync(const std::string &_agent, const std::string &_capability, RegisterAgentAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void UnregisterAgent(const std::string &_agent, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> UnregisterAgentAsync(const std::string &_agent, UnregisterAgentAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
};

} // namespace bluez
} // namespace org
} // namespace v4


// Compatibility
namespace v4_1 = v4;

#endif // V4_ORG_BLUEZ_Adapter_PROXY_BASE_HPP_
