/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Adapter_STUB_HPP_
#define V4_ORG_BLUEZ_Adapter_STUB_HPP_

#include <functional>




#include <v4/org/bluez/Adapter.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/Variant.hpp>
#include <cstdint>
#include <memory>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v4 {
namespace org {
namespace bluez {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Adapter. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class AdapterStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual Adapter {
 public:

    /**
     * Sends a broadcast event for PropertyChanged. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void firePropertyChangedEvent(const std::string &_name, const ::v4::org::bluez::Adapter::Variant &_value) = 0;
    /**
     * Sends a broadcast event for DeviceCreated. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireDeviceCreatedEvent(const std::string &_device) = 0;
    /**
     * Sends a broadcast event for DeviceRemoved. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireDeviceRemovedEvent(const std::string &_device) = 0;
    /**
     * Sends a broadcast event for DeviceFound. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireDeviceFoundEvent(const std::string &_address, const ::v4::org::bluez::Adapter::tDeviceFound_valuesDict &_values) = 0;
    /**
     * Sends a broadcast event for DeviceDisappeared. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireDeviceDisappearedEvent(const std::string &_address) = 0;


    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Adapter.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class AdapterStubRemoteEvent
{
public:
    virtual ~AdapterStubRemoteEvent() { }

};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Adapter to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class AdapterStub
    : public virtual CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>
{
public:
    typedef std::function<void (Adapter::tGetProperties_propertiesDict _properties)>GetPropertiesReply_t;
    typedef std::function<void ()>SetPropertyReply_t;
    typedef std::function<void ()>RequestSessionReply_t;
    typedef std::function<void ()>ReleaseSessionReply_t;
    typedef std::function<void ()>StartDiscoveryReply_t;
    typedef std::function<void ()>StopDiscoveryReply_t;
    typedef std::function<void (std::vector<std::string> _devices)>ListDevicesReply_t;
    typedef std::function<void (std::string _device)>CreateDeviceReply_t;
    typedef std::function<void (std::string _device)>CreatePairedDeviceReply_t;
    typedef std::function<void ()>CancelDeviceCreationReply_t;
    typedef std::function<void ()>RemoveDeviceReply_t;
    typedef std::function<void (std::string _device)>FindDeviceReply_t;
    typedef std::function<void ()>RegisterAgentReply_t;
    typedef std::function<void ()>UnregisterAgentReply_t;

    virtual ~AdapterStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;


    /// This is the method that will be called on remote calls on the method GetProperties.
    virtual void GetProperties(const std::shared_ptr<CommonAPI::ClientId> _client, GetPropertiesReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method SetProperty.
    virtual void SetProperty(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _name, Adapter::Variant _value, SetPropertyReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method RequestSession.
    virtual void RequestSession(const std::shared_ptr<CommonAPI::ClientId> _client, RequestSessionReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method ReleaseSession.
    virtual void ReleaseSession(const std::shared_ptr<CommonAPI::ClientId> _client, ReleaseSessionReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method StartDiscovery.
    virtual void StartDiscovery(const std::shared_ptr<CommonAPI::ClientId> _client, StartDiscoveryReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method StopDiscovery.
    virtual void StopDiscovery(const std::shared_ptr<CommonAPI::ClientId> _client, StopDiscoveryReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method ListDevices.
    virtual void ListDevices(const std::shared_ptr<CommonAPI::ClientId> _client, ListDevicesReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method CreateDevice.
    virtual void CreateDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, CreateDeviceReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method CreatePairedDevice.
    virtual void CreatePairedDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, std::string _agent, std::string _capability, CreatePairedDeviceReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method CancelDeviceCreation.
    virtual void CancelDeviceCreation(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, CancelDeviceCreationReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method RemoveDevice.
    virtual void RemoveDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _device, RemoveDeviceReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method FindDevice.
    virtual void FindDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, FindDeviceReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method RegisterAgent.
    virtual void RegisterAgent(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _agent, std::string _capability, RegisterAgentReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method UnregisterAgent.
    virtual void UnregisterAgent(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _agent, UnregisterAgentReply_t _reply) = 0;
    /// Sends a broadcast event for PropertyChanged.
    virtual void firePropertyChangedEvent(const std::string &_name, const ::v4::org::bluez::Adapter::Variant &_value) = 0;
    /// Sends a broadcast event for DeviceCreated.
    virtual void fireDeviceCreatedEvent(const std::string &_device) = 0;
    /// Sends a broadcast event for DeviceRemoved.
    virtual void fireDeviceRemovedEvent(const std::string &_device) = 0;
    /// Sends a broadcast event for DeviceFound.
    virtual void fireDeviceFoundEvent(const std::string &_address, const ::v4::org::bluez::Adapter::tDeviceFound_valuesDict &_values) = 0;
    /// Sends a broadcast event for DeviceDisappeared.
    virtual void fireDeviceDisappearedEvent(const std::string &_address) = 0;

    using CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef AdapterStubRemoteEvent RemoteEventType;
    typedef Adapter StubInterface;
};

} // namespace bluez
} // namespace org
} // namespace v4


// Compatibility
namespace v4_1 = v4;

#endif // V4_ORG_BLUEZ_Adapter_STUB_HPP_
