/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v4/org/bluez/AdapterStubDefault.hpp>
#include <assert.h>

namespace v4 {
namespace org {
namespace bluez {

AdapterStubDefault::AdapterStubDefault():
        remoteEventHandler_(this),
        interfaceVersion_(Adapter::getInterfaceVersion()) {
}

const CommonAPI::Version& AdapterStubDefault::getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return interfaceVersion_;
}

AdapterStubRemoteEvent* AdapterStubDefault::initStubAdapter(const std::shared_ptr<AdapterStubAdapter> &_adapter) {
    CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_ = _adapter;
    return &remoteEventHandler_;
}


void AdapterStubDefault::GetProperties(const std::shared_ptr<CommonAPI::ClientId> _client, GetPropertiesReply_t _reply) {
    (void)_client;
    Adapter::tGetProperties_propertiesDict properties;
    _reply(properties);
}

void AdapterStubDefault::SetProperty(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _name, Adapter::Variant _value, SetPropertyReply_t _reply) {
    (void)_client;
    (void) _name;
    (void) _value;
    _reply();
}

void AdapterStubDefault::RequestSession(const std::shared_ptr<CommonAPI::ClientId> _client, RequestSessionReply_t _reply) {
    (void)_client;
    _reply();
}

void AdapterStubDefault::ReleaseSession(const std::shared_ptr<CommonAPI::ClientId> _client, ReleaseSessionReply_t _reply) {
    (void)_client;
    _reply();
}

void AdapterStubDefault::StartDiscovery(const std::shared_ptr<CommonAPI::ClientId> _client, StartDiscoveryReply_t _reply) {
    (void)_client;
    _reply();
}

void AdapterStubDefault::StopDiscovery(const std::shared_ptr<CommonAPI::ClientId> _client, StopDiscoveryReply_t _reply) {
    (void)_client;
    _reply();
}

void AdapterStubDefault::ListDevices(const std::shared_ptr<CommonAPI::ClientId> _client, ListDevicesReply_t _reply) {
    (void)_client;
    std::vector<std::string> devices = {};
    _reply(devices);
}

void AdapterStubDefault::CreateDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, CreateDeviceReply_t _reply) {
    (void)_client;
    (void) _address;
    std::string device = "";
    _reply(device);
}

void AdapterStubDefault::CreatePairedDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, std::string _agent, std::string _capability, CreatePairedDeviceReply_t _reply) {
    (void)_client;
    (void) _address;
    (void) _agent;
    (void) _capability;
    std::string device = "";
    _reply(device);
}

void AdapterStubDefault::CancelDeviceCreation(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, CancelDeviceCreationReply_t _reply) {
    (void)_client;
    (void) _address;
    _reply();
}

void AdapterStubDefault::RemoveDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _device, RemoveDeviceReply_t _reply) {
    (void)_client;
    (void) _device;
    _reply();
}

void AdapterStubDefault::FindDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, FindDeviceReply_t _reply) {
    (void)_client;
    (void) _address;
    std::string device = "";
    _reply(device);
}

void AdapterStubDefault::RegisterAgent(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _agent, std::string _capability, RegisterAgentReply_t _reply) {
    (void)_client;
    (void) _agent;
    (void) _capability;
    _reply();
}

void AdapterStubDefault::UnregisterAgent(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _agent, UnregisterAgentReply_t _reply) {
    (void)_client;
    (void) _agent;
    _reply();
}


void AdapterStubDefault::firePropertyChangedEvent(const std::string &_name, const ::v4::org::bluez::Adapter::Variant &_value) {
    assert((CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock();
   	if (stubAdapter)
        stubAdapter->firePropertyChangedEvent(_name, _value);
}
void AdapterStubDefault::fireDeviceCreatedEvent(const std::string &_device) {
    assert((CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock();
   	if (stubAdapter)
        stubAdapter->fireDeviceCreatedEvent(_device);
}
void AdapterStubDefault::fireDeviceRemovedEvent(const std::string &_device) {
    assert((CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock();
   	if (stubAdapter)
        stubAdapter->fireDeviceRemovedEvent(_device);
}
void AdapterStubDefault::fireDeviceFoundEvent(const std::string &_address, const ::v4::org::bluez::Adapter::tDeviceFound_valuesDict &_values) {
    assert((CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock();
   	if (stubAdapter)
        stubAdapter->fireDeviceFoundEvent(_address, _values);
}
void AdapterStubDefault::fireDeviceDisappearedEvent(const std::string &_address) {
    assert((CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<AdapterStubAdapter, AdapterStubRemoteEvent>::stubAdapter_.lock();
   	if (stubAdapter)
        stubAdapter->fireDeviceDisappearedEvent(_address);
}


AdapterStubDefault::RemoteEventHandler::RemoteEventHandler(AdapterStubDefault *_defaultStub)
    : 
      defaultStub_(_defaultStub) {
}

} // namespace bluez
} // namespace org
} // namespace v4
