/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Adapter_STUB_DEFAULT_HPP_
#define V4_ORG_BLUEZ_Adapter_STUB_DEFAULT_HPP_


#include <v4/org/bluez/AdapterStub.hpp>
#include <sstream>

namespace v4 {
namespace org {
namespace bluez {

/**
 * Provides a default implementation for AdapterStubRemoteEvent and
 * AdapterStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class AdapterStubDefault
    : public virtual AdapterStub {
public:
    AdapterStubDefault();

    AdapterStubRemoteEvent* initStubAdapter(const std::shared_ptr<AdapterStubAdapter> &_adapter);

    const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client);


    virtual void GetProperties(const std::shared_ptr<CommonAPI::ClientId> _client, GetPropertiesReply_t _reply);
    virtual void SetProperty(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _name, Adapter::Variant _value, SetPropertyReply_t _reply);
    virtual void RequestSession(const std::shared_ptr<CommonAPI::ClientId> _client, RequestSessionReply_t _reply);
    virtual void ReleaseSession(const std::shared_ptr<CommonAPI::ClientId> _client, ReleaseSessionReply_t _reply);
    virtual void StartDiscovery(const std::shared_ptr<CommonAPI::ClientId> _client, StartDiscoveryReply_t _reply);
    virtual void StopDiscovery(const std::shared_ptr<CommonAPI::ClientId> _client, StopDiscoveryReply_t _reply);
    virtual void ListDevices(const std::shared_ptr<CommonAPI::ClientId> _client, ListDevicesReply_t _reply);
    virtual void CreateDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, CreateDeviceReply_t _reply);
    virtual void CreatePairedDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, std::string _agent, std::string _capability, CreatePairedDeviceReply_t _reply);
    virtual void CancelDeviceCreation(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, CancelDeviceCreationReply_t _reply);
    virtual void RemoveDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _device, RemoveDeviceReply_t _reply);
    virtual void FindDevice(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _address, FindDeviceReply_t _reply);
    virtual void RegisterAgent(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _agent, std::string _capability, RegisterAgentReply_t _reply);
    virtual void UnregisterAgent(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _agent, UnregisterAgentReply_t _reply);

virtual void firePropertyChangedEvent(const std::string &_name, const ::v4::org::bluez::Adapter::Variant &_value);
virtual void fireDeviceCreatedEvent(const std::string &_device);
virtual void fireDeviceRemovedEvent(const std::string &_device);
virtual void fireDeviceFoundEvent(const std::string &_address, const ::v4::org::bluez::Adapter::tDeviceFound_valuesDict &_values);
virtual void fireDeviceDisappearedEvent(const std::string &_address);


protected:
    class RemoteEventHandler: public virtual AdapterStubRemoteEvent {
    public:
        RemoteEventHandler(AdapterStubDefault *_defaultStub);


    private:
        AdapterStubDefault *defaultStub_;
    };
private:
    AdapterStubDefault::RemoteEventHandler remoteEventHandler_;


    CommonAPI::Version interfaceVersion_;
};

} // namespace bluez
} // namespace org
} // namespace v4


// Compatibility
namespace v4_1 = v4;

#endif // V4_ORG_BLUEZ_Adapter_STUB_DEFAULT
