/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v4/org/bluez/ManagerDBusProxy.hpp>

namespace v4 {
namespace org {
namespace bluez {

std::shared_ptr<CommonAPI::DBus::DBusProxy> createManagerDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection) {
	return std::make_shared<ManagerDBusProxy>(_address, _connection);
}

INITIALIZER(registerManagerDBusProxy) {
     CommonAPI::DBus::Factory::get()->registerProxyCreateMethod(
		Manager::getInterface(),
		&createManagerDBusProxy);
}

ManagerDBusProxy::ManagerDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection)
	:	CommonAPI::DBus::DBusProxy(_address, _connection)
,		propertyChanged_(*this, "PropertyChanged", "s(yv)", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<Manager_::VariantDeployment_t*>(nullptr))),
		adapterAdded_(*this, "AdapterAdded", "s", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))),
		adapterRemoved_(*this, "AdapterRemoved", "s", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))),
		defaultAdapterChanged_(*this, "DefaultAdapterChanged", "s", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)))
{
}


ManagerDBusProxy::PropertyChangedEvent& ManagerDBusProxy::getPropertyChangedEvent() {
    return propertyChanged_;
}
ManagerDBusProxy::AdapterAddedEvent& ManagerDBusProxy::getAdapterAddedEvent() {
    return adapterAdded_;
}
ManagerDBusProxy::AdapterRemovedEvent& ManagerDBusProxy::getAdapterRemovedEvent() {
    return adapterRemoved_;
}
ManagerDBusProxy::DefaultAdapterChangedEvent& ManagerDBusProxy::getDefaultAdapterChangedEvent() {
    return defaultAdapterChanged_;
}
    
    void ManagerDBusProxy::GetProperties(CommonAPI::CallStatus &_internalCallStatus, Manager::tGetProperties_propertiesDict &_properties, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Manager::tGetProperties_propertiesDict, Manager_::tGetProperties_propertiesDictDeployment_t> deploy_properties(static_cast<Manager_::tGetProperties_propertiesDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Manager::tGetProperties_propertiesDict,Manager_::tGetProperties_propertiesDictDeployment_t>
            >
        	>::callMethodWithReply(
        *this,
        "GetProperties",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus,
deploy_properties);
_properties = deploy_properties.getValue();
}
    std::future<CommonAPI::CallStatus> ManagerDBusProxy::GetPropertiesAsync(GetPropertiesAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Manager::tGetProperties_propertiesDict, Manager_::tGetProperties_propertiesDictDeployment_t> deploy_properties(static_cast<Manager_::tGetProperties_propertiesDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Manager::tGetProperties_propertiesDict,Manager_::tGetProperties_propertiesDictDeployment_t>
            >
        	>::callMethodAsync(
        *this,
        "GetProperties",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<Manager::tGetProperties_propertiesDict, Manager_::tGetProperties_propertiesDictDeployment_t> _properties) {
        	if (_callback)
        		_callback(_internalCallStatus, _properties.getValue());
        },
        std::make_tuple(deploy_properties));
    }
    void ManagerDBusProxy::DefaultAdapter(CommonAPI::CallStatus &_internalCallStatus, std::string &_adapter, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_adapter(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "DefaultAdapter",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus,
deploy_adapter);
_adapter = deploy_adapter.getValue();
}
    std::future<CommonAPI::CallStatus> ManagerDBusProxy::DefaultAdapterAsync(DefaultAdapterAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_adapter(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodAsync(
        *this,
        "DefaultAdapter",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _adapter) {
        	if (_callback)
        		_callback(_internalCallStatus, _adapter.getValue());
        },
        std::make_tuple(deploy_adapter));
    }
    void ManagerDBusProxy::FindAdapter(const std::string &_pattern, CommonAPI::CallStatus &_internalCallStatus, std::string &_adapter, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_pattern(_pattern, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_adapter(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "FindAdapter",
        "s",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_pattern,
_internalCallStatus,
deploy_adapter);
_adapter = deploy_adapter.getValue();
}
    std::future<CommonAPI::CallStatus> ManagerDBusProxy::FindAdapterAsync(const std::string &_pattern, FindAdapterAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_pattern(_pattern, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_adapter(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodAsync(
        *this,
        "FindAdapter",
        "s",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_pattern,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _adapter) {
        	if (_callback)
        		_callback(_internalCallStatus, _adapter.getValue());
        },
        std::make_tuple(deploy_adapter));
    }
    void ManagerDBusProxy::ListAdapters(CommonAPI::CallStatus &_internalCallStatus, std::vector<std::string> &_adapters, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>> deploy_adapters(static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::vector<std::string>,CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>>
            >
        	>::callMethodWithReply(
        *this,
        "ListAdapters",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus,
deploy_adapters);
_adapters = deploy_adapters.getValue();
}
    std::future<CommonAPI::CallStatus> ManagerDBusProxy::ListAdaptersAsync(ListAdaptersAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>> deploy_adapters(static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::vector<std::string>,CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>>
            >
        	>::callMethodAsync(
        *this,
        "ListAdapters",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>> _adapters) {
        	if (_callback)
        		_callback(_internalCallStatus, _adapters.getValue());
        },
        std::make_tuple(deploy_adapters));
    }


void ManagerDBusProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
          ownVersionMajor = 4;
          ownVersionMinor = 1;
      }

      } // namespace bluez
      } // namespace org
      } // namespace v4
