/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v4/org/bluez/Manager.hpp>
#include <v4/org/bluez/ManagerDBusStubAdapter.hpp>

namespace v4 {
namespace org {
namespace bluez {

std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> createManagerDBusStubAdapter(
                   const CommonAPI::DBus::DBusAddress &_address,
                   const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
                   const std::shared_ptr<CommonAPI::StubBase> &_stub) {
    return std::make_shared<ManagerDBusStubAdapter>(_address, _connection, _stub);
}

INITIALIZER(registerManagerDBusStubAdapter) {
    CommonAPI::DBus::Factory::get()->registerStubAdapterCreateMethod(
    	Manager::getInterface(), &createManagerDBusStubAdapter);
}

ManagerDBusStubAdapterInternal::~ManagerDBusStubAdapterInternal() {
    deactivateManagedInstances();
    ManagerDBusStubAdapterHelper::deinit();
}

void ManagerDBusStubAdapterInternal::deactivateManagedInstances() {

}

const char* ManagerDBusStubAdapterInternal::getMethodsDBusIntrospectionXmlData() const {
    static const std::string introspectionData =
        "<method name=\"getInterfaceVersion\">\n"
            "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
        "</method>\n"
        "<signal name=\"PropertyChanged\">\n"
            "<arg name=\"name\" type=\"s\" />\n"
            "<arg name=\"value\" type=\"(yv)\" />\n"
        "</signal>\n"
        "<signal name=\"AdapterAdded\">\n"
            "<arg name=\"adapter\" type=\"s\" />\n"
        "</signal>\n"
        "<signal name=\"AdapterRemoved\">\n"
            "<arg name=\"adapter\" type=\"s\" />\n"
        "</signal>\n"
        "<signal name=\"DefaultAdapterChanged\">\n"
            "<arg name=\"adapter\" type=\"s\" />\n"
        "</signal>\n"
        "<method name=\"GetProperties\">\n"
            "<arg name=\"_properties\" type=\"a{s(yv)}\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"DefaultAdapter\">\n"
            "<arg name=\"_adapter\" type=\"s\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"FindAdapter\">\n"
            "<arg name=\"_pattern\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_adapter\" type=\"s\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"ListAdapters\">\n"
            "<arg name=\"_adapters\" type=\"as\" direction=\"out\" />\n"
        "</method>\n"

    ;
    return introspectionData.c_str();
}

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v4::org::bluez::ManagerStub,
        CommonAPI::Version
        > ManagerDBusStubAdapterInternal::getManagerInterfaceVersionStubDispatcher(&ManagerStub::getInterfaceVersion, "uu");




CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::ManagerStub,
    std::tuple<>,
    std::tuple<Manager::tGetProperties_propertiesDict>,
    std::tuple<>,
    std::tuple<Manager_::tGetProperties_propertiesDictDeployment_t>
    
    > ManagerDBusStubAdapterInternal::getPropertiesStubDispatcher(
    &ManagerStub::GetProperties, "a{s(yv)}",
					std::make_tuple(),
                	std::make_tuple(static_cast<Manager_::tGetProperties_propertiesDictDeployment_t*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::ManagerStub,
    std::tuple<>,
    std::tuple<std::string>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > ManagerDBusStubAdapterInternal::defaultAdapterStubDispatcher(
    &ManagerStub::DefaultAdapter, "s",
					std::make_tuple(),
                	std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::ManagerStub,
    std::tuple<std::string>,
    std::tuple<std::string>,
    std::tuple<CommonAPI::DBus::StringDeployment>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > ManagerDBusStubAdapterInternal::findAdapterStubDispatcher(
    &ManagerStub::FindAdapter, "s",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
                	std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v4::org::bluez::ManagerStub,
    std::tuple<>,
    std::tuple<std::vector<std::string>>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>>
    
    > ManagerDBusStubAdapterInternal::listAdaptersStubDispatcher(
    &ManagerStub::ListAdapters, "as",
					std::make_tuple(),
                	std::make_tuple(static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr)));



void ManagerDBusStubAdapterInternal::firePropertyChangedEvent(const std::string& name, const ::v4::org::bluez::Manager::Variant& value) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>,
    CommonAPI::Deployable<::v4::org::bluez::Manager::Variant, Manager_::VariantDeployment_t>
    >>::sendSignal(
            *this,
            "PropertyChanged",
            "s(yv)",
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>(name, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
    CommonAPI::Deployable<::v4::org::bluez::Manager::Variant, Manager_::VariantDeployment_t>(value, static_cast<Manager_::VariantDeployment_t*>(nullptr))
    );
}
void ManagerDBusStubAdapterInternal::fireAdapterAddedEvent(const std::string& adapter) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "AdapterAdded",
            "s",
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>(adapter, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
    );
}
void ManagerDBusStubAdapterInternal::fireAdapterRemovedEvent(const std::string& adapter) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "AdapterRemoved",
            "s",
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>(adapter, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
    );
}
void ManagerDBusStubAdapterInternal::fireDefaultAdapterChangedEvent(const std::string& adapter) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>
    >>::sendSignal(
            *this,
            "DefaultAdapterChanged",
            "s",
    CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment>(adapter, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
    );
}


const ManagerDBusStubAdapterHelper::StubDispatcherTable& ManagerDBusStubAdapterInternal::getStubDispatcherTable() {
    return stubDispatcherTable_;
}

const CommonAPI::DBus::StubAttributeTable& ManagerDBusStubAdapterInternal::getStubAttributeTable() {
    return stubAttributeTable_;
}

ManagerDBusStubAdapterInternal::ManagerDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub)
	: CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      ManagerDBusStubAdapterHelper(_address, _connection, std::dynamic_pointer_cast<ManagerStub>(_stub), false),
      stubDispatcherTable_({
            { { "GetProperties", "" }, &org::bluez::ManagerDBusStubAdapterInternal::getPropertiesStubDispatcher },
            { { "DefaultAdapter", "" }, &org::bluez::ManagerDBusStubAdapterInternal::defaultAdapterStubDispatcher },
            { { "FindAdapter", "s" }, &org::bluez::ManagerDBusStubAdapterInternal::findAdapterStubDispatcher },
            { { "ListAdapters", "" }, &org::bluez::ManagerDBusStubAdapterInternal::listAdaptersStubDispatcher }
            }),
        stubAttributeTable_() {

    stubDispatcherTable_.insert({ { "getInterfaceVersion", "" }, &org::bluez::ManagerDBusStubAdapterInternal::getManagerInterfaceVersionStubDispatcher });
}

bool ManagerDBusStubAdapterInternal::hasFreedesktopProperties() {
    return false;
}

} // namespace bluez
} // namespace org
} // namespace v4
