/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Manager_PROXY_HPP_
#define V4_ORG_BLUEZ_Manager_PROXY_HPP_

#include <v4/org/bluez/ManagerProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif


#undef COMMONAPI_INTERNAL_COMPILATION

namespace v4 {
namespace org {
namespace bluez {

template <typename ... _AttributeExtensions>
class ManagerProxy
    : virtual public Manager, 
      virtual public ManagerProxyBase,
      virtual public _AttributeExtensions... {
public:
    ManagerProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~ManagerProxy();

    typedef Manager InterfaceType;



    /**
     * Returns the wrapper class that provides access to the broadcast PropertyChanged.
     */
    virtual PropertyChangedEvent& getPropertyChangedEvent() {
        return delegate_->getPropertyChangedEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast AdapterAdded.
     */
    virtual AdapterAddedEvent& getAdapterAddedEvent() {
        return delegate_->getAdapterAddedEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast AdapterRemoved.
     */
    virtual AdapterRemovedEvent& getAdapterRemovedEvent() {
        return delegate_->getAdapterRemovedEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast DefaultAdapterChanged.
     */
    virtual DefaultAdapterChangedEvent& getDefaultAdapterChangedEvent() {
        return delegate_->getDefaultAdapterChangedEvent();
    }

    /**
     * Calls GetProperties with synchronous semantics.
     * 
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void GetProperties(CommonAPI::CallStatus &_internalCallStatus, Manager::tGetProperties_propertiesDict &_properties, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls GetProperties with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> GetPropertiesAsync(GetPropertiesAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls DefaultAdapter with synchronous semantics.
     * 
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void DefaultAdapter(CommonAPI::CallStatus &_internalCallStatus, std::string &_adapter, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls DefaultAdapter with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> DefaultAdapterAsync(DefaultAdapterAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls FindAdapter with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void FindAdapter(const std::string &_pattern, CommonAPI::CallStatus &_internalCallStatus, std::string &_adapter, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls FindAdapter with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> FindAdapterAsync(const std::string &_pattern, FindAdapterAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls ListAdapters with synchronous semantics.
     * 
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void ListAdapters(CommonAPI::CallStatus &_internalCallStatus, std::vector<std::string> &_adapters, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls ListAdapters with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> ListAdaptersAsync(ListAdaptersAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<ManagerProxyBase> delegate_;
};

typedef ManagerProxy<> ManagerProxyDefault;


//
// ManagerProxy Implementation
//
template <typename ... _AttributeExtensions>
ManagerProxy<_AttributeExtensions...>::ManagerProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<ManagerProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<ManagerProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
ManagerProxy<_AttributeExtensions...>::~ManagerProxy() {
}

template <typename ... _AttributeExtensions>
void ManagerProxy<_AttributeExtensions...>::GetProperties(CommonAPI::CallStatus &_internalCallStatus, Manager::tGetProperties_propertiesDict &_properties, const CommonAPI::CallInfo *_info) {
    delegate_->GetProperties(_internalCallStatus, _properties, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ManagerProxy<_AttributeExtensions...>::GetPropertiesAsync(GetPropertiesAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->GetPropertiesAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void ManagerProxy<_AttributeExtensions...>::DefaultAdapter(CommonAPI::CallStatus &_internalCallStatus, std::string &_adapter, const CommonAPI::CallInfo *_info) {
    delegate_->DefaultAdapter(_internalCallStatus, _adapter, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ManagerProxy<_AttributeExtensions...>::DefaultAdapterAsync(DefaultAdapterAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->DefaultAdapterAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void ManagerProxy<_AttributeExtensions...>::FindAdapter(const std::string &_pattern, CommonAPI::CallStatus &_internalCallStatus, std::string &_adapter, const CommonAPI::CallInfo *_info) {
    delegate_->FindAdapter(_pattern, _internalCallStatus, _adapter, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ManagerProxy<_AttributeExtensions...>::FindAdapterAsync(const std::string &_pattern, FindAdapterAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->FindAdapterAsync(_pattern, _callback, _info);
}
template <typename ... _AttributeExtensions>
void ManagerProxy<_AttributeExtensions...>::ListAdapters(CommonAPI::CallStatus &_internalCallStatus, std::vector<std::string> &_adapters, const CommonAPI::CallInfo *_info) {
    delegate_->ListAdapters(_internalCallStatus, _adapters, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ManagerProxy<_AttributeExtensions...>::ListAdaptersAsync(ListAdaptersAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->ListAdaptersAsync(_callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &ManagerProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool ManagerProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool ManagerProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& ManagerProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& ManagerProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace bluez
} // namespace org
} // namespace v4



// Compatibility
namespace v4_1 = v4;

#endif // V4_ORG_BLUEZ_Manager_PROXY_HPP_
