/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V4_ORG_BLUEZ_Manager_STUB_HPP_
#define V4_ORG_BLUEZ_Manager_STUB_HPP_

#include <functional>




#include <v4/org/bluez/Manager.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/Variant.hpp>
#include <cstdint>
#include <memory>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v4 {
namespace org {
namespace bluez {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Manager. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class ManagerStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual Manager {
 public:

    /**
     * Sends a broadcast event for PropertyChanged. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void firePropertyChangedEvent(const std::string &_name, const ::v4::org::bluez::Manager::Variant &_value) = 0;
    /**
     * Sends a broadcast event for AdapterAdded. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireAdapterAddedEvent(const std::string &_adapter) = 0;
    /**
     * Sends a broadcast event for AdapterRemoved. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireAdapterRemovedEvent(const std::string &_adapter) = 0;
    /**
     * Sends a broadcast event for DefaultAdapterChanged. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireDefaultAdapterChangedEvent(const std::string &_adapter) = 0;


    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Manager.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class ManagerStubRemoteEvent
{
public:
    virtual ~ManagerStubRemoteEvent() { }

};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Manager to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class ManagerStub
    : public virtual CommonAPI::Stub<ManagerStubAdapter, ManagerStubRemoteEvent>
{
public:
    typedef std::function<void (Manager::tGetProperties_propertiesDict _properties)>GetPropertiesReply_t;
    typedef std::function<void (std::string _adapter)>DefaultAdapterReply_t;
    typedef std::function<void (std::string _adapter)>FindAdapterReply_t;
    typedef std::function<void (std::vector<std::string> _adapters)>ListAdaptersReply_t;

    virtual ~ManagerStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;


    /// This is the method that will be called on remote calls on the method GetProperties.
    virtual void GetProperties(const std::shared_ptr<CommonAPI::ClientId> _client, GetPropertiesReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method DefaultAdapter.
    virtual void DefaultAdapter(const std::shared_ptr<CommonAPI::ClientId> _client, DefaultAdapterReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method FindAdapter.
    virtual void FindAdapter(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _pattern, FindAdapterReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method ListAdapters.
    virtual void ListAdapters(const std::shared_ptr<CommonAPI::ClientId> _client, ListAdaptersReply_t _reply) = 0;
    /// Sends a broadcast event for PropertyChanged.
    virtual void firePropertyChangedEvent(const std::string &_name, const ::v4::org::bluez::Manager::Variant &_value) = 0;
    /// Sends a broadcast event for AdapterAdded.
    virtual void fireAdapterAddedEvent(const std::string &_adapter) = 0;
    /// Sends a broadcast event for AdapterRemoved.
    virtual void fireAdapterRemovedEvent(const std::string &_adapter) = 0;
    /// Sends a broadcast event for DefaultAdapterChanged.
    virtual void fireDefaultAdapterChangedEvent(const std::string &_adapter) = 0;

    using CommonAPI::Stub<ManagerStubAdapter, ManagerStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<ManagerStubAdapter, ManagerStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<ManagerStubAdapter, ManagerStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef ManagerStubRemoteEvent RemoteEventType;
    typedef Manager StubInterface;
};

} // namespace bluez
} // namespace org
} // namespace v4


// Compatibility
namespace v4_1 = v4;

#endif // V4_ORG_BLUEZ_Manager_STUB_HPP_
