/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_E02_Attributes_PROXY_HPP_
#define V1_COMMONAPI_EXAMPLES_E02_Attributes_PROXY_HPP_

#include <v1/commonapi/examples/E02AttributesProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

template <typename ... _AttributeExtensions>
class E02AttributesProxy
    : virtual public E02Attributes, 
      virtual public E02AttributesProxyBase,
      virtual public _AttributeExtensions... {
public:
    E02AttributesProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~E02AttributesProxy();

    typedef E02Attributes InterfaceType;


    /**
     * Returns the wrapper class that provides access to the attribute x.
     */
    virtual XAttribute& getXAttribute() {
        return delegate_->getXAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute a1.
     */
    virtual A1Attribute& getA1Attribute() {
        return delegate_->getA1Attribute();
    }




    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<E02AttributesProxyBase> delegate_;
};

typedef E02AttributesProxy<> E02AttributesProxyDefault;

namespace E02AttributesExtensions {
    template <template <typename > class _ExtensionType>
    class XAttributeExtension {
     public:
        typedef _ExtensionType<E02AttributesProxyBase::XAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<E02AttributesProxyBase::XAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        XAttributeExtension() {}
    #endif
    
        XAttributeExtension(E02AttributesProxyBase& proxy): attributeExtension_(proxy.getXAttribute()) {
        }
    
        inline extension_type& getXAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class A1AttributeExtension {
     public:
        typedef _ExtensionType<E02AttributesProxyBase::A1Attribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<E02AttributesProxyBase::A1Attribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        A1AttributeExtension() {}
    #endif
    
        A1AttributeExtension(E02AttributesProxyBase& proxy): attributeExtension_(proxy.getA1Attribute()) {
        }
    
        inline extension_type& getA1AttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace E02AttributesExtensions

//
// E02AttributesProxy Implementation
//
template <typename ... _AttributeExtensions>
E02AttributesProxy<_AttributeExtensions...>::E02AttributesProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<E02AttributesProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<E02AttributesProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
E02AttributesProxy<_AttributeExtensions...>::~E02AttributesProxy() {
}


template <typename ... _AttributeExtensions>
const CommonAPI::Address &E02AttributesProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool E02AttributesProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool E02AttributesProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& E02AttributesProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& E02AttributesProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace examples
} // namespace commonapi
} // namespace v1

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::v1::commonapi::examples::E02AttributesProxy,
    _AttributeExtension> {
    typedef typename ::v1::commonapi::examples::E02AttributesProxy<
            ::v1::commonapi::examples::E02AttributesExtensions::XAttributeExtension<_AttributeExtension>, 
            ::v1::commonapi::examples::E02AttributesExtensions::A1AttributeExtension<_AttributeExtension>
    > class_t;
};
}


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_E02_Attributes_PROXY_HPP_
