/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v1/commonapi/examples/E02Attributes.hpp>
#include <v1/commonapi/examples/E02AttributesDBusStubAdapter.hpp>

namespace v1 {
namespace commonapi {
namespace examples {

std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> createE02AttributesDBusStubAdapter(
                   const CommonAPI::DBus::DBusAddress &_address,
                   const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
                   const std::shared_ptr<CommonAPI::StubBase> &_stub) {
    return std::make_shared<E02AttributesDBusStubAdapter>(_address, _connection, _stub);
}

INITIALIZER(registerE02AttributesDBusStubAdapter) {
    CommonAPI::DBus::Factory::get()->registerStubAdapterCreateMethod(
    	E02Attributes::getInterface(), &createE02AttributesDBusStubAdapter);
}

E02AttributesDBusStubAdapterInternal::~E02AttributesDBusStubAdapterInternal() {
    deactivateManagedInstances();
    E02AttributesDBusStubAdapterHelper::deinit();
}

void E02AttributesDBusStubAdapterInternal::deactivateManagedInstances() {

}

const char* E02AttributesDBusStubAdapterInternal::getMethodsDBusIntrospectionXmlData() const {
    static const std::string introspectionData =
        "<method name=\"getInterfaceVersion\">\n"
            "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"getXAttribute\">\n"
            "<arg name=\"value\" type=\"i\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"setXAttribute\">\n"
            "<arg name=\"requestedValue\" type=\"i\" direction=\"in\" />\n"
            "<arg name=\"setValue\" type=\"i\" direction=\"out\" />\n"
        "</method>\n"
        "<signal name=\"onXAttributeChanged\">\n"
            "<arg name=\"changedValue\" type=\"i\" />\n"
        "</signal>\n"
        "<method name=\"getA1Attribute\">\n"
            "<arg name=\"value\" type=\"(s(ibd))\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"setA1Attribute\">\n"
            "<arg name=\"requestedValue\" type=\"(s(ibd))\" direction=\"in\" />\n"
            "<arg name=\"setValue\" type=\"(s(ibd))\" direction=\"out\" />\n"
        "</method>\n"
        "<signal name=\"onA1AttributeChanged\">\n"
            "<arg name=\"changedValue\" type=\"(s(ibd))\" />\n"
        "</signal>\n"

    ;
    return introspectionData.c_str();
}

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v1::commonapi::examples::E02AttributesStub,
        CommonAPI::Version
        > E02AttributesDBusStubAdapterInternal::getE02AttributesInterfaceVersionStubDispatcher(&E02AttributesStub::getInterfaceVersion, "uu");

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v1::commonapi::examples::E02AttributesStub,
        int32_t
        > E02AttributesDBusStubAdapterInternal::getXAttributeStubDispatcher(
            &::v1::commonapi::examples::E02AttributesStub::getXAttribute
            , "i"
            );
CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
        ::v1::commonapi::examples::E02AttributesStub,
        int32_t
        > E02AttributesDBusStubAdapterInternal::setXAttributeStubDispatcher(
                &::v1::commonapi::examples::E02AttributesStub::getXAttribute,
                &E02AttributesStubRemoteEvent::onRemoteSetXAttribute,
                &E02AttributesStubRemoteEvent::onRemoteXAttributeChanged
                ,&E02AttributesStubAdapter::fireXAttributeChanged
                ,"i"
                );
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v1::commonapi::examples::E02AttributesStub,
        ::v1::commonapi::examples::CommonTypes::a1Struct,
        CommonTypes_::a1StructDeployment_t
        > E02AttributesDBusStubAdapterInternal::getA1AttributeStubDispatcher(
            &::v1::commonapi::examples::E02AttributesStub::getA1Attribute
            , "(s(ibd))"
            );
CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
        ::v1::commonapi::examples::E02AttributesStub,
        ::v1::commonapi::examples::CommonTypes::a1Struct,
        CommonTypes_::a1StructDeployment_t
        > E02AttributesDBusStubAdapterInternal::setA1AttributeStubDispatcher(
                &::v1::commonapi::examples::E02AttributesStub::getA1Attribute,
                &E02AttributesStubRemoteEvent::onRemoteSetA1Attribute,
                &E02AttributesStubRemoteEvent::onRemoteA1AttributeChanged
                ,&E02AttributesStubAdapter::fireA1AttributeChanged
                ,"(s(ibd))"
                );




void E02AttributesDBusStubAdapterInternal::fireXAttributeChanged(const int32_t& value) {
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    int32_t
    >>
        ::sendSignal(
            *this,
            "onXAttributeChanged",
            "i",
            value
    
    );
}
void E02AttributesDBusStubAdapterInternal::fireA1AttributeChanged(const ::v1::commonapi::examples::CommonTypes::a1Struct& value) {
    CommonAPI::Deployable<CommonTypes::a1Struct, CommonTypes_::a1StructDeployment_t> deployedValue(value, static_cast<CommonTypes_::a1StructDeployment_t*>(nullptr));
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<
        ::v1::commonapi::examples::CommonTypes::a1Struct,
        CommonTypes_::a1StructDeployment_t
    >
    >>
        ::sendSignal(
            *this,
            "onA1AttributeChanged",
            "(s(ibd))",
            deployedValue
    
    );
}



const E02AttributesDBusStubAdapterHelper::StubDispatcherTable& E02AttributesDBusStubAdapterInternal::getStubDispatcherTable() {
    return stubDispatcherTable_;
}

const CommonAPI::DBus::StubAttributeTable& E02AttributesDBusStubAdapterInternal::getStubAttributeTable() {
    return stubAttributeTable_;
}

E02AttributesDBusStubAdapterInternal::E02AttributesDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub)
	: CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      E02AttributesDBusStubAdapterHelper(_address, _connection, std::dynamic_pointer_cast<E02AttributesStub>(_stub), false),
      stubDispatcherTable_({
            { { "getXAttribute", "" }, &commonapi::examples::E02AttributesDBusStubAdapterInternal::getXAttributeStubDispatcher }
            , { { "setXAttribute", "i" }, &commonapi::examples::E02AttributesDBusStubAdapterInternal::setXAttributeStubDispatcher },
            { { "getA1Attribute", "" }, &commonapi::examples::E02AttributesDBusStubAdapterInternal::getA1AttributeStubDispatcher }
            , { { "setA1Attribute", "(s(ibd))" }, &commonapi::examples::E02AttributesDBusStubAdapterInternal::setA1AttributeStubDispatcher }
            }),
        stubAttributeTable_() {

    stubDispatcherTable_.insert({ { "getInterfaceVersion", "" }, &commonapi::examples::E02AttributesDBusStubAdapterInternal::getE02AttributesInterfaceVersionStubDispatcher });
}

bool E02AttributesDBusStubAdapterInternal::hasFreedesktopProperties() {
    return false;
}

} // namespace examples
} // namespace commonapi
} // namespace v1
