/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_E03_Methods_STUB_HPP_
#define V1_COMMONAPI_EXAMPLES_E03_Methods_STUB_HPP_

#include <functional>




#include <v1/commonapi/examples/E03Methods.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <cstdint>
#include <unordered_set>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service E03Methods. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class E03MethodsStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual E03Methods {
 public:

    /**
     * Sends a broadcast event for myStatus. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireMyStatusEvent(const int32_t &_myCurrentValue) = 0;


    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for E03Methods.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E03MethodsStubRemoteEvent
{
public:
    virtual ~E03MethodsStubRemoteEvent() { }

};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service E03Methods to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E03MethodsStub
    : public virtual CommonAPI::Stub<E03MethodsStubAdapter, E03MethodsStubRemoteEvent>
{
public:
    typedef std::function<void (E03Methods::stdErrorTypeEnum _error, int32_t _y1, std::string _y2)>fooReply_t;

    virtual ~E03MethodsStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;


    /// This is the method that will be called on remote calls on the method foo.
    virtual void foo(const std::shared_ptr<CommonAPI::ClientId> _client, int32_t _x1, std::string _x2, fooReply_t _reply) = 0;
    /// Sends a broadcast event for myStatus.
    virtual void fireMyStatusEvent(const int32_t &_myCurrentValue) = 0;

    using CommonAPI::Stub<E03MethodsStubAdapter, E03MethodsStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<E03MethodsStubAdapter, E03MethodsStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<E03MethodsStubAdapter, E03MethodsStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef E03MethodsStubRemoteEvent RemoteEventType;
    typedef E03Methods StubInterface;
};

} // namespace examples
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_2 = v1;

#endif // V1_COMMONAPI_EXAMPLES_E03_Methods_STUB_HPP_
