/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V0_COMMONAPI_EXAMPLES_E04_Phone_Book_PROXY_HPP_
#define V0_COMMONAPI_EXAMPLES_E04_Phone_Book_PROXY_HPP_

#include <commonapi/examples/E04PhoneBookProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace commonapi {
namespace examples {

template <typename ... _AttributeExtensions>
class E04PhoneBookProxy
    : virtual public E04PhoneBook, 
      virtual public E04PhoneBookProxyBase,
      virtual public _AttributeExtensions... {
public:
    E04PhoneBookProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~E04PhoneBookProxy();

    typedef E04PhoneBook InterfaceType;


    /**
     * description: the phone book itself
     */
    /**
     * Returns the wrapper class that provides access to the attribute phoneBook.
     */
    virtual PhoneBookAttribute& getPhoneBookAttribute() {
        return delegate_->getPhoneBookAttribute();
    }

    /**
     * description: filter result
     */
    /**
     * Returns the wrapper class that provides access to the broadcast phoneBookDataSet.
     */
    virtual PhoneBookDataSetSelectiveEvent& getPhoneBookDataSetSelectiveEvent() {
        return delegate_->getPhoneBookDataSetSelectiveEvent();
    }

    /**
     * description: filter operations
     * Calls setPhoneBookDataFilter with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void setPhoneBookDataFilter(const E04PhoneBook::elementFilterStruct &_elementFilter, const std::vector<E04PhoneBook::contentFilterStruct> &_contentFilter, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls setPhoneBookDataFilter with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> setPhoneBookDataFilterAsync(const E04PhoneBook::elementFilterStruct &_elementFilter, const std::vector<E04PhoneBook::contentFilterStruct> &_contentFilter, SetPhoneBookDataFilterAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<E04PhoneBookProxyBase> delegate_;
};

typedef E04PhoneBookProxy<> E04PhoneBookProxyDefault;

namespace E04PhoneBookExtensions {
    /**
     * description: the phone book itself
     */
    template <template <typename > class _ExtensionType>
    class PhoneBookAttributeExtension {
     public:
        typedef _ExtensionType<E04PhoneBookProxyBase::PhoneBookAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<E04PhoneBookProxyBase::PhoneBookAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        PhoneBookAttributeExtension() {}
    #endif
    
        PhoneBookAttributeExtension(E04PhoneBookProxyBase& proxy): attributeExtension_(proxy.getPhoneBookAttribute()) {
        }
    
        inline extension_type& getPhoneBookAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace E04PhoneBookExtensions

//
// E04PhoneBookProxy Implementation
//
template <typename ... _AttributeExtensions>
E04PhoneBookProxy<_AttributeExtensions...>::E04PhoneBookProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<E04PhoneBookProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<E04PhoneBookProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
E04PhoneBookProxy<_AttributeExtensions...>::~E04PhoneBookProxy() {
}

/**
 * description: filter operations
 */
template <typename ... _AttributeExtensions>
void E04PhoneBookProxy<_AttributeExtensions...>::setPhoneBookDataFilter(const E04PhoneBook::elementFilterStruct &_elementFilter, const std::vector<E04PhoneBook::contentFilterStruct> &_contentFilter, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->setPhoneBookDataFilter(_elementFilter, _contentFilter, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> E04PhoneBookProxy<_AttributeExtensions...>::setPhoneBookDataFilterAsync(const E04PhoneBook::elementFilterStruct &_elementFilter, const std::vector<E04PhoneBook::contentFilterStruct> &_contentFilter, SetPhoneBookDataFilterAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->setPhoneBookDataFilterAsync(_elementFilter, _contentFilter, _callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &E04PhoneBookProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool E04PhoneBookProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool E04PhoneBookProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& E04PhoneBookProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& E04PhoneBookProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace examples
} // namespace commonapi

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::commonapi::examples::E04PhoneBookProxy,
    _AttributeExtension> {
    typedef typename ::commonapi::examples::E04PhoneBookProxy<
            ::commonapi::examples::E04PhoneBookExtensions::PhoneBookAttributeExtension<_AttributeExtension>
    > class_t;
};
}



#endif // V0_COMMONAPI_EXAMPLES_E04_Phone_Book_PROXY_HPP_
