/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V0_COMMONAPI_EXAMPLES_E04_Phone_Book_STUB_DEFAULT_HPP_
#define V0_COMMONAPI_EXAMPLES_E04_Phone_Book_STUB_DEFAULT_HPP_


#include <commonapi/examples/E04PhoneBookStub.hpp>
#include <sstream>

namespace commonapi {
namespace examples {

/**
 * Provides a default implementation for E04PhoneBookStubRemoteEvent and
 * E04PhoneBookStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class E04PhoneBookStubDefault
    : public virtual E04PhoneBookStub {
public:
    E04PhoneBookStubDefault();

    E04PhoneBookStubRemoteEvent* initStubAdapter(const std::shared_ptr<E04PhoneBookStubAdapter> &_adapter);

    const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client);

    virtual const std::vector<::commonapi::examples::E04PhoneBook::phoneBookStruct>& getPhoneBookAttribute();
    virtual const std::vector<::commonapi::examples::E04PhoneBook::phoneBookStruct>& getPhoneBookAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setPhoneBookAttribute(std::vector<::commonapi::examples::E04PhoneBook::phoneBookStruct> _value);

    /**
     * description: filter operations
     */
    virtual void setPhoneBookDataFilter(const std::shared_ptr<CommonAPI::ClientId> _client, E04PhoneBook::elementFilterStruct _elementFilter, std::vector<E04PhoneBook::contentFilterStruct> _contentFilter, setPhoneBookDataFilterReply_t _reply);

/**
 * description: filter result
 */
virtual void firePhoneBookDataSetSelective(const std::vector<::commonapi::examples::E04PhoneBook::phoneBookDataElementMap> &_phoneBookDataSet, const std::shared_ptr<CommonAPI::ClientIdList> _receivers = nullptr);
virtual std::shared_ptr<CommonAPI::ClientIdList> const getSubscribersForPhoneBookDataSetSelective();
/// Hook method for reacting on new subscriptions or removed subscriptions respectively for selective broadcasts.
virtual void onPhoneBookDataSetSelectiveSubscriptionChanged(const std::shared_ptr<CommonAPI::ClientId> _client, const CommonAPI::SelectiveBroadcastSubscriptionEvent _event);
/// Hook method for reacting accepting or denying new subscriptions 
virtual bool onPhoneBookDataSetSelectiveSubscriptionRequested(const std::shared_ptr<CommonAPI::ClientId> _client);


protected:
    /**
     * description: the phone book itself
     */
    virtual bool trySetPhoneBookAttribute(std::vector<::commonapi::examples::E04PhoneBook::phoneBookStruct> _value);
    virtual bool validatePhoneBookAttributeRequestedValue(const std::vector<::commonapi::examples::E04PhoneBook::phoneBookStruct> &_value);
    class RemoteEventHandler: public virtual E04PhoneBookStubRemoteEvent {
    public:
        RemoteEventHandler(E04PhoneBookStubDefault *_defaultStub);

        /**
         * description: the phone book itself
         */


    private:
        E04PhoneBookStubDefault *defaultStub_;
    };
private:
    E04PhoneBookStubDefault::RemoteEventHandler remoteEventHandler_;

    /**
     * description: the phone book itself
     */
    std::vector<::commonapi::examples::E04PhoneBook::phoneBookStruct> phoneBookAttributeValue_ {};

    CommonAPI::Version interfaceVersion_;
};

} // namespace examples
} // namespace commonapi



#endif // V0_COMMONAPI_EXAMPLES_E04_Phone_Book_STUB_DEFAULT
