/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_E05_Device_STUB_HPP_
#define V1_COMMONAPI_EXAMPLES_E05_Device_STUB_HPP_

#include <functional>




#include <v1/commonapi/examples/E05Device.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service E05Device. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class E05DeviceStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual E05Device {
 public:



    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for E05Device.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E05DeviceStubRemoteEvent
{
public:
    virtual ~E05DeviceStubRemoteEvent() { }

};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service E05Device to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E05DeviceStub
    : public virtual CommonAPI::Stub<E05DeviceStubAdapter, E05DeviceStubRemoteEvent>
{
public:
    typedef std::function<void ()>doSomethingReply_t;

    virtual ~E05DeviceStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;


    /// This is the method that will be called on remote calls on the method doSomething.
    virtual void doSomething(const std::shared_ptr<CommonAPI::ClientId> _client, doSomethingReply_t _reply) = 0;

    using CommonAPI::Stub<E05DeviceStubAdapter, E05DeviceStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<E05DeviceStubAdapter, E05DeviceStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<E05DeviceStubAdapter, E05DeviceStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef E05DeviceStubRemoteEvent RemoteEventType;
    typedef E05Device StubInterface;
};

} // namespace examples
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_E05_Device_STUB_HPP_
