/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_E05_Manager_STUB_HPP_
#define V1_COMMONAPI_EXAMPLES_E05_Manager_STUB_HPP_

#include <functional>



#include <v1/commonapi/examples/E05DeviceStub.hpp>
#include <v1/commonapi/examples/E05SpecialDeviceStub.hpp>

#include <v1/commonapi/examples/E05Manager.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service E05Manager. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class E05ManagerStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual E05Manager {
 public:
    ///Notifies all remote listeners about a change of value of the attribute myDevices.
    virtual void fireMyDevicesAttributeChanged(const std::vector<std::string>& myDevices) = 0;


    virtual bool registerManagedStubE05Device(std::shared_ptr<::v1::commonapi::examples::E05DeviceStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubE05Device(const std::string&) = 0;
    virtual std::set<std::string>& getE05DeviceInstances() = 0;
    virtual bool registerManagedStubE05SpecialDevice(std::shared_ptr<::v1::commonapi::examples::E05SpecialDeviceStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubE05SpecialDevice(const std::string&) = 0;
    virtual std::set<std::string>& getE05SpecialDeviceInstances() = 0;

    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for E05Manager.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E05ManagerStubRemoteEvent
{
public:
    virtual ~E05ManagerStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute myDevices
    virtual bool onRemoteSetMyDevicesAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<std::string> _value) = 0;
    /// Action callback for remote set requests on the attribute myDevices
    virtual void onRemoteMyDevicesAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service E05Manager to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E05ManagerStub
    : public virtual CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>
{
public:

    virtual ~E05ManagerStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute myDevices
    virtual const std::vector<std::string> &getMyDevicesAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;


    virtual bool registerManagedStubE05Device(std::shared_ptr<::v1::commonapi::examples::E05DeviceStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubE05Device(const std::string&) = 0;
    virtual std::set<std::string>& getE05DeviceInstances() = 0;
    virtual bool registerManagedStubE05SpecialDevice(std::shared_ptr<::v1::commonapi::examples::E05SpecialDeviceStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubE05SpecialDevice(const std::string&) = 0;
    virtual std::set<std::string>& getE05SpecialDeviceInstances() = 0;
    using CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef E05ManagerStubRemoteEvent RemoteEventType;
    typedef E05Manager StubInterface;
};

} // namespace examples
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_E05_Manager_STUB_HPP_
