/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v1/commonapi/examples/E05ManagerStubDefault.hpp>
#include <assert.h>

namespace v1 {
namespace commonapi {
namespace examples {

E05ManagerStubDefault::E05ManagerStubDefault():
        remoteEventHandler_(this),
        autoInstanceCounter_(0),
        interfaceVersion_(E05Manager::getInterfaceVersion()) {
}

const CommonAPI::Version& E05ManagerStubDefault::getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return interfaceVersion_;
}

E05ManagerStubRemoteEvent* E05ManagerStubDefault::initStubAdapter(const std::shared_ptr<E05ManagerStubAdapter> &_adapter) {
    CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_ = _adapter;
    return &remoteEventHandler_;
}

const std::vector<std::string>& E05ManagerStubDefault::getMyDevicesAttribute() {
    return myDevicesAttributeValue_;
}

const std::vector<std::string>& E05ManagerStubDefault::getMyDevicesAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getMyDevicesAttribute();
}

void E05ManagerStubDefault::setMyDevicesAttribute(std::vector<std::string> _value) {
    const bool valueChanged = trySetMyDevicesAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMyDevicesAttributeChanged(myDevicesAttributeValue_);
    }
}

bool E05ManagerStubDefault::trySetMyDevicesAttribute(std::vector<std::string> _value) {
    if (!validateMyDevicesAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (myDevicesAttributeValue_ != _value);
    myDevicesAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool E05ManagerStubDefault::validateMyDevicesAttributeRequestedValue(const std::vector<std::string> &_value) {
    (void)_value;
	return true;
}

void E05ManagerStubDefault::setMyDevicesAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<std::string> _value) {
    (void)_client;
    setMyDevicesAttribute(_value);
}

void E05ManagerStubDefault::onRemoteMyDevicesAttributeChanged() {
    // No operation in default
}

void E05ManagerStubDefault::RemoteEventHandler::onRemoteMyDevicesAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteMyDevicesAttributeChanged();
}

bool E05ManagerStubDefault::RemoteEventHandler::onRemoteSetMyDevicesAttribute(std::vector<std::string> _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetMyDevicesAttribute(std::move(_value));
}

bool E05ManagerStubDefault::RemoteEventHandler::onRemoteSetMyDevicesAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<std::string> _value) {
    (void)_client;
    return onRemoteSetMyDevicesAttribute(_value);
}




bool E05ManagerStubDefault::registerManagedStubE05DeviceAutoInstance(std::shared_ptr<::v1::commonapi::examples::E05DeviceStub> _stub) {
    autoInstanceCounter_++;
    std::stringstream ss;
    assert((CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        ss << stubAdapter->getAddress().getInstance() << ".i" << autoInstanceCounter_;
        std::string instance = ss.str();
        return stubAdapter->registerManagedStubE05Device(_stub, instance);
    } else {
        return false;
    }
}
bool E05ManagerStubDefault::registerManagedStubE05Device(std::shared_ptr<::v1::commonapi::examples::E05DeviceStub> _stub, const std::string &_instance) {
    assert((CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->registerManagedStubE05Device(_stub, _instance);
    else
        return false;
}
bool E05ManagerStubDefault::deregisterManagedStubE05Device(const std::string &_instance) {
    assert((CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->deregisterManagedStubE05Device(_instance);
    else
        return false;
}
std::set<std::string>& E05ManagerStubDefault::getE05DeviceInstances() {
    assert((CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        return stubAdapter->getE05DeviceInstances();
    } else {
        static std::set<std::string> emptySet = std::set<std::string>();
        return emptySet;
    }
}
bool E05ManagerStubDefault::registerManagedStubE05SpecialDeviceAutoInstance(std::shared_ptr<::v1::commonapi::examples::E05SpecialDeviceStub> _stub) {
    autoInstanceCounter_++;
    std::stringstream ss;
    assert((CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        ss << stubAdapter->getAddress().getInstance() << ".i" << autoInstanceCounter_;
        std::string instance = ss.str();
        return stubAdapter->registerManagedStubE05SpecialDevice(_stub, instance);
    } else {
        return false;
    }
}
bool E05ManagerStubDefault::registerManagedStubE05SpecialDevice(std::shared_ptr<::v1::commonapi::examples::E05SpecialDeviceStub> _stub, const std::string &_instance) {
    assert((CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->registerManagedStubE05SpecialDevice(_stub, _instance);
    else
        return false;
}
bool E05ManagerStubDefault::deregisterManagedStubE05SpecialDevice(const std::string &_instance) {
    assert((CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->deregisterManagedStubE05SpecialDevice(_instance);
    else
        return false;
}
std::set<std::string>& E05ManagerStubDefault::getE05SpecialDeviceInstances() {
    assert((CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<E05ManagerStubAdapter, E05ManagerStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        return stubAdapter->getE05SpecialDeviceInstances();
    } else {
        static std::set<std::string> emptySet = std::set<std::string>();
        return emptySet;
    }
}

E05ManagerStubDefault::RemoteEventHandler::RemoteEventHandler(E05ManagerStubDefault *_defaultStub)
    : 
      defaultStub_(_defaultStub) {
}

} // namespace examples
} // namespace commonapi
} // namespace v1
