/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_E05_Special_Device_PROXY_HPP_
#define V1_COMMONAPI_EXAMPLES_E05_Special_Device_PROXY_HPP_

#include <v1/commonapi/examples/E05SpecialDeviceProxyBase.hpp>

#include "v1/commonapi/examples/E05DeviceProxy.hpp"

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif


#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

template <typename ... _AttributeExtensions>
class E05SpecialDeviceProxy
    : virtual public E05SpecialDevice, 
      virtual public E05SpecialDeviceProxyBase,
      public E05DeviceProxy<_AttributeExtensions...>,
      virtual public _AttributeExtensions... {
public:
    E05SpecialDeviceProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~E05SpecialDeviceProxy();

    typedef E05SpecialDevice InterfaceType;

    inline static const char* getInterface() {
        return(E05SpecialDevice::getInterface());
    }



    /**
     * Calls doSomethingSpecial with synchronous semantics.
     * 
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void doSomethingSpecial(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls doSomethingSpecial with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> doSomethingSpecialAsync(DoSomethingSpecialAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<E05SpecialDeviceProxyBase> delegate_;
};

typedef E05SpecialDeviceProxy<> E05SpecialDeviceProxyDefault;


//
// E05SpecialDeviceProxy Implementation
//
template <typename ... _AttributeExtensions>
E05SpecialDeviceProxy<_AttributeExtensions...>::E05SpecialDeviceProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        ::v1::commonapi::examples::E05DeviceProxy<_AttributeExtensions...>(delegate),
        _AttributeExtensions(*(std::dynamic_pointer_cast<E05SpecialDeviceProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<E05SpecialDeviceProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
E05SpecialDeviceProxy<_AttributeExtensions...>::~E05SpecialDeviceProxy() {
}

template <typename ... _AttributeExtensions>
void E05SpecialDeviceProxy<_AttributeExtensions...>::doSomethingSpecial(CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->doSomethingSpecial(_internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> E05SpecialDeviceProxy<_AttributeExtensions...>::doSomethingSpecialAsync(DoSomethingSpecialAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->doSomethingSpecialAsync(_callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &E05SpecialDeviceProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool E05SpecialDeviceProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool E05SpecialDeviceProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& E05SpecialDeviceProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& E05SpecialDeviceProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace examples
} // namespace commonapi
} // namespace v1



// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_E05_Special_Device_PROXY_HPP_
