/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_E05_Special_Device_STUB_HPP_
#define V1_COMMONAPI_EXAMPLES_E05_Special_Device_STUB_HPP_

#include <functional>



#include <v1/commonapi/examples/E05DeviceStub.hpp>

#include <v1/commonapi/examples/E05SpecialDevice.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service E05SpecialDevice. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class E05SpecialDeviceStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual E05SpecialDevice, 
      public virtual E05DeviceStubAdapter {
 public:



    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for E05SpecialDevice.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E05SpecialDeviceStubRemoteEvent
: public virtual E05DeviceStubRemoteEvent
{
public:
    virtual ~E05SpecialDeviceStubRemoteEvent() { }

};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service E05SpecialDevice to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E05SpecialDeviceStub
    : public virtual CommonAPI::Stub<E05SpecialDeviceStubAdapter, E05SpecialDeviceStubRemoteEvent>, 
      public virtual E05DeviceStub
{
public:
    typedef std::function<void ()>doSomethingSpecialReply_t;

    virtual ~E05SpecialDeviceStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;


    /// This is the method that will be called on remote calls on the method doSomethingSpecial.
    virtual void doSomethingSpecial(const std::shared_ptr<CommonAPI::ClientId> _client, doSomethingSpecialReply_t _reply) = 0;

    using CommonAPI::Stub<E05SpecialDeviceStubAdapter, E05SpecialDeviceStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<E05SpecialDeviceStubAdapter, E05SpecialDeviceStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<E05SpecialDeviceStubAdapter, E05SpecialDeviceStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef E05SpecialDeviceStubRemoteEvent RemoteEventType;
    typedef E05SpecialDevice StubInterface;
};

} // namespace examples
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_E05_Special_Device_STUB_HPP_
