/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v1/commonapi/examples/E05Manager.hpp>
#include <v1/commonapi/examples/E05ManagerDBusStubAdapter.hpp>

namespace v1 {
namespace commonapi {
namespace examples {

std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> createE05ManagerDBusStubAdapter(
                   const CommonAPI::DBus::DBusAddress &_address,
                   const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
                   const std::shared_ptr<CommonAPI::StubBase> &_stub) {
    return std::make_shared<E05ManagerDBusStubAdapter>(_address, _connection, _stub);
}

INITIALIZER(registerE05ManagerDBusStubAdapter) {
    CommonAPI::DBus::Factory::get()->registerStubAdapterCreateMethod(
    	E05Manager::getInterface(), &createE05ManagerDBusStubAdapter);
}

E05ManagerDBusStubAdapterInternal::~E05ManagerDBusStubAdapterInternal() {
    deactivateManagedInstances();
    E05ManagerDBusStubAdapterHelper::deinit();
}

void E05ManagerDBusStubAdapterInternal::deactivateManagedInstances() {
    std::set<std::string>::iterator iter;
    std::set<std::string>::iterator iterNext;

    iter = registeredE05DeviceInstances.begin();
    while (iter != registeredE05DeviceInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubE05Device(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    iter = registeredE05SpecialDeviceInstances.begin();
    while (iter != registeredE05SpecialDeviceInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubE05SpecialDevice(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
}

const char* E05ManagerDBusStubAdapterInternal::getMethodsDBusIntrospectionXmlData() const {
    static const std::string introspectionData =
        "<method name=\"getInterfaceVersion\">\n"
            "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"getMyDevicesAttribute\">\n"
            "<arg name=\"value\" type=\"as\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"setMyDevicesAttribute\">\n"
            "<arg name=\"requestedValue\" type=\"as\" direction=\"in\" />\n"
            "<arg name=\"setValue\" type=\"as\" direction=\"out\" />\n"
        "</method>\n"
        "<signal name=\"onMyDevicesAttributeChanged\">\n"
            "<arg name=\"changedValue\" type=\"as\" />\n"
        "</signal>\n"

    ;
    return introspectionData.c_str();
}

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v1::commonapi::examples::E05ManagerStub,
        CommonAPI::Version
        > E05ManagerDBusStubAdapterInternal::getE05ManagerInterfaceVersionStubDispatcher(&E05ManagerStub::getInterfaceVersion, "uu");

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v1::commonapi::examples::E05ManagerStub,
        std::vector<std::string>,
        CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>
        > E05ManagerDBusStubAdapterInternal::getMyDevicesAttributeStubDispatcher(
            &::v1::commonapi::examples::E05ManagerStub::getMyDevicesAttribute
            , "as"
            );
CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
        ::v1::commonapi::examples::E05ManagerStub,
        std::vector<std::string>,
        CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>
        > E05ManagerDBusStubAdapterInternal::setMyDevicesAttributeStubDispatcher(
                &::v1::commonapi::examples::E05ManagerStub::getMyDevicesAttribute,
                &E05ManagerStubRemoteEvent::onRemoteSetMyDevicesAttribute,
                &E05ManagerStubRemoteEvent::onRemoteMyDevicesAttributeChanged
                ,&E05ManagerStubAdapter::fireMyDevicesAttributeChanged
                ,"as"
                );




void E05ManagerDBusStubAdapterInternal::fireMyDevicesAttributeChanged(const std::vector<std::string>& value) {
    CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>> deployedValue(value, static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr));
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<
        std::vector<std::string>,
        CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>
    >
    >>
        ::sendSignal(
            *this,
            "onMyDevicesAttributeChanged",
            "as",
            deployedValue
    
    );
}



const E05ManagerDBusStubAdapterHelper::StubDispatcherTable& E05ManagerDBusStubAdapterInternal::getStubDispatcherTable() {
    return stubDispatcherTable_;
}

const CommonAPI::DBus::StubAttributeTable& E05ManagerDBusStubAdapterInternal::getStubAttributeTable() {
    return stubAttributeTable_;
}
bool E05ManagerDBusStubAdapterInternal::registerManagedStubE05Device(std::shared_ptr<::v1::commonapi::examples::E05DeviceStub> _stub, const std::string &_instance) {
    if (registeredE05DeviceInstances.find(_instance) == registeredE05DeviceInstances.end()) {
    	std::string itsAddress = "local:commonapi.examples.E05Device:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string objectPath(itsDBusAddress.getObjectPath());
        std::string adapterObjectPath(getDBusAddress().getObjectPath());

        if (objectPath.compare(0, adapterObjectPath.length(), adapterObjectPath) == 0) {
        	std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

            auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "commonapi.examples.E05Device", itsDBusAddress, connection_);
            bool isRegistered = itsFactory->registerManagedService(stubAdapter);
            if (isRegistered) {
                bool isExported = connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
                if (isExported) {
                    registeredE05DeviceInstances.insert(_instance);
                    return true;
                } else {
                    itsFactory->unregisterManagedService(itsAddress);
                }
            }
        }
    }
    return false;
}

bool E05ManagerDBusStubAdapterInternal::deregisterManagedStubE05Device(const std::string &_instance) {
    std::string itsAddress = "local:commonapi.examples.E05Device:" + _instance;
    if (registeredE05DeviceInstances.find(_instance) != registeredE05DeviceInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredE05DeviceInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

std::set<std::string>& E05ManagerDBusStubAdapterInternal::getE05DeviceInstances() {
    return registeredE05DeviceInstances;
}
bool E05ManagerDBusStubAdapterInternal::registerManagedStubE05SpecialDevice(std::shared_ptr<::v1::commonapi::examples::E05SpecialDeviceStub> _stub, const std::string &_instance) {
    if (registeredE05SpecialDeviceInstances.find(_instance) == registeredE05SpecialDeviceInstances.end()) {
    	std::string itsAddress = "local:commonapi.examples.E05SpecialDevice:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string objectPath(itsDBusAddress.getObjectPath());
        std::string adapterObjectPath(getDBusAddress().getObjectPath());

        if (objectPath.compare(0, adapterObjectPath.length(), adapterObjectPath) == 0) {
        	std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

            auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "commonapi.examples.E05SpecialDevice", itsDBusAddress, connection_);
            bool isRegistered = itsFactory->registerManagedService(stubAdapter);
            if (isRegistered) {
                bool isExported = connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
                if (isExported) {
                    registeredE05SpecialDeviceInstances.insert(_instance);
                    return true;
                } else {
                    itsFactory->unregisterManagedService(itsAddress);
                }
            }
        }
    }
    return false;
}

bool E05ManagerDBusStubAdapterInternal::deregisterManagedStubE05SpecialDevice(const std::string &_instance) {
    std::string itsAddress = "local:commonapi.examples.E05SpecialDevice:" + _instance;
    if (registeredE05SpecialDeviceInstances.find(_instance) != registeredE05SpecialDeviceInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredE05SpecialDeviceInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

std::set<std::string>& E05ManagerDBusStubAdapterInternal::getE05SpecialDeviceInstances() {
    return registeredE05SpecialDeviceInstances;
}

E05ManagerDBusStubAdapterInternal::E05ManagerDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub)
	: CommonAPI::DBus::DBusStubAdapter(_address, _connection,true),
      E05ManagerDBusStubAdapterHelper(_address, _connection, std::dynamic_pointer_cast<E05ManagerStub>(_stub), true),
      stubDispatcherTable_({
            { { "getMyDevicesAttribute", "" }, &commonapi::examples::E05ManagerDBusStubAdapterInternal::getMyDevicesAttributeStubDispatcher }
            , { { "setMyDevicesAttribute", "as" }, &commonapi::examples::E05ManagerDBusStubAdapterInternal::setMyDevicesAttributeStubDispatcher }
            }),
        stubAttributeTable_() {

    stubDispatcherTable_.insert({ { "getInterfaceVersion", "" }, &commonapi::examples::E05ManagerDBusStubAdapterInternal::getE05ManagerInterfaceVersionStubDispatcher });
}

bool E05ManagerDBusStubAdapterInternal::hasFreedesktopProperties() {
    return false;
}

} // namespace examples
} // namespace commonapi
} // namespace v1
