/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V0_COMMONAPI_EXAMPLES_Common_Types_HPP_
#define V0_COMMONAPI_EXAMPLES_Common_Types_HPP_



#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <CommonAPI/Types.hpp>
#include <CommonAPI/Variant.hpp>
#include <cstdint>
#include <memory>
#include <string>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace commonapi {
namespace examples {

struct CommonTypes {
    typedef int32_t MyTypedef;
    
    struct MyEnum : CommonAPI::Enumeration<int32_t> {
        enum Literal : int32_t {
            DEFAULT = 0,
            ON = 1,
            OFF = 2
        };
        
        MyEnum() 
            : CommonAPI::Enumeration<int32_t>(static_cast<int32_t>(Literal::DEFAULT)) {}
        MyEnum(Literal _literal) 
            : CommonAPI::Enumeration<int32_t>(static_cast<int32_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast<int32_t>(Literal::DEFAULT):
                case static_cast<int32_t>(Literal::ON):
                case static_cast<int32_t>(Literal::OFF):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const MyEnum &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const MyEnum &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const MyEnum &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const MyEnum &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const MyEnum &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const MyEnum &_other) const { return (value_ > _other.value_); }
        
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast<int32_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast<int32_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast<int32_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast<int32_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast<int32_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast<int32_t>(_value)); }
    };
    typedef CommonAPI::Variant<MyTypedef, MyEnum, uint8_t, std::string>  SettingsUnion;
    static const CommonAPI::Serial SETTINGSSTRUCT_SERIAL = 0x1D47FC57;
    static const CommonAPI::Serial SETTINGSSTRUCTMYTYPEDEF_SERIAL = 0xE223FA0E;
    static const CommonAPI::Serial SETTINGSSTRUCTMYENUM_SERIAL = 0x56DB8D07;
    static const CommonAPI::Serial SETTINGSSTRUCTUINT8_SERIAL = 0x682F9539;
    static const CommonAPI::Serial SETTINGSSTRUCTSTRING_SERIAL = 0x8E5081D7;
    
    struct SettingsStruct : CommonAPI::PolymorphicStruct {
    	static std::shared_ptr<SettingsStruct> create(CommonAPI::Serial _serial);
    	CommonAPI::Serial getSerial() const { return SETTINGSSTRUCT_SERIAL; }
    	
    	SettingsStruct() {
    	}
    	template<class _Input>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const CommonAPI::EmptyDeployment *_depl) {
    		switch (getSerial()) {
    		case SETTINGSSTRUCTMYTYPEDEF_SERIAL:
    			static_cast<SettingsStructMyTypedef *>(this)->template readValue<_Input>(_input, _depl);
    			break;
    		case SETTINGSSTRUCTMYENUM_SERIAL:
    			static_cast<SettingsStructMyEnum *>(this)->template readValue<_Input>(_input, _depl);
    			break;
    		case SETTINGSSTRUCTUINT8_SERIAL:
    			static_cast<SettingsStructUInt8 *>(this)->template readValue<_Input>(_input, _depl);
    			break;
    		case SETTINGSSTRUCTSTRING_SERIAL:
    			static_cast<SettingsStructString *>(this)->template readValue<_Input>(_input, _depl);
    			break;
    		default:
    			break;
    		}
    	}
    
    	template<class _Input, class _Deployment>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const _Deployment *_depl) {
    		switch (getSerial()) {
    		case SETTINGSSTRUCTMYTYPEDEF_SERIAL:
    			static_cast<SettingsStructMyTypedef *>(this)->template readValue<>(_input, _depl);
    			break;
    		case SETTINGSSTRUCTMYENUM_SERIAL:
    			static_cast<SettingsStructMyEnum *>(this)->template readValue<>(_input, _depl);
    			break;
    		case SETTINGSSTRUCTUINT8_SERIAL:
    			static_cast<SettingsStructUInt8 *>(this)->template readValue<>(_input, _depl);
    			break;
    		case SETTINGSSTRUCTSTRING_SERIAL:
    			static_cast<SettingsStructString *>(this)->template readValue<>(_input, _depl);
    			break;
    		default:
    			break;
    		}
    	}
    	template<class _Output>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    		switch (getSerial()) {
    		case SETTINGSSTRUCTMYTYPEDEF_SERIAL:
    			static_cast<SettingsStructMyTypedef *>(this)->template writeType<_Output>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTMYENUM_SERIAL:
    			static_cast<SettingsStructMyEnum *>(this)->template writeType<_Output>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTUINT8_SERIAL:
    			static_cast<SettingsStructUInt8 *>(this)->template writeType<_Output>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTSTRING_SERIAL:
    			static_cast<SettingsStructString *>(this)->template writeType<_Output>(_output, _depl);
    			break;
    		default:
    			break;
    		}
    	}
    	template<class _Output, class _Deployment>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const _Deployment *_depl) {
    		switch (getSerial()) {
    		case SETTINGSSTRUCTMYTYPEDEF_SERIAL:
    			static_cast<SettingsStructMyTypedef *>(this)->template writeType<_Output, _Deployment>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTMYENUM_SERIAL:
    			static_cast<SettingsStructMyEnum *>(this)->template writeType<_Output, _Deployment>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTUINT8_SERIAL:
    			static_cast<SettingsStructUInt8 *>(this)->template writeType<_Output, _Deployment>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTSTRING_SERIAL:
    			static_cast<SettingsStructString *>(this)->template writeType<_Output, _Deployment>(_output, _depl);
    			break;
    		default:
    			break;
    		}
    	}
    
    	template<class _Output>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    		switch (getSerial()) {
    		case SETTINGSSTRUCTMYTYPEDEF_SERIAL:
    			static_cast<SettingsStructMyTypedef *>(this)->template writeValue<_Output>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTMYENUM_SERIAL:
    			static_cast<SettingsStructMyEnum *>(this)->template writeValue<_Output>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTUINT8_SERIAL:
    			static_cast<SettingsStructUInt8 *>(this)->template writeValue<_Output>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTSTRING_SERIAL:
    			static_cast<SettingsStructString *>(this)->template writeValue<_Output>(_output, _depl);
    			break;
    		default:
    			break;
    		}
    	}
    
    	template<class _Output, class _Deployment>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const _Deployment *_depl) {
    		switch (getSerial()) {
    		case SETTINGSSTRUCTMYTYPEDEF_SERIAL:
    			static_cast<SettingsStructMyTypedef *>(this)->template writeValue<>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTMYENUM_SERIAL:
    			static_cast<SettingsStructMyEnum *>(this)->template writeValue<>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTUINT8_SERIAL:
    			static_cast<SettingsStructUInt8 *>(this)->template writeValue<>(_output, _depl);
    			break;
    		case SETTINGSSTRUCTSTRING_SERIAL:
    			static_cast<SettingsStructString *>(this)->template writeValue<>(_output, _depl);
    			break;
    		default:
    			break;
    		}
    	}
    	
    	inline bool operator==(const SettingsStruct& _other) const {
                (void) _other;
                return true;
                    }
    	inline bool operator!=(const SettingsStruct &_other) const {
    		return !((*this) == _other);
    	}
    
    };
    struct SettingsStructMyTypedef : SettingsStruct {
    	CommonAPI::Serial getSerial() const { return SETTINGSSTRUCTMYTYPEDEF_SERIAL; }
    	
    	SettingsStructMyTypedef() {
    	}
    	SettingsStructMyTypedef(const MyTypedef &_id)
    	: SettingsStruct()
    	{
    		std::get<0>(values_) = _id;
    	}
    	template<class _Input>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const CommonAPI::EmptyDeployment *_depl) {
    	    (void) _depl;
    		_input.template readValue<CommonAPI::EmptyDeployment>(std::get<0>(values_));
    	}
    
    	template<class _Input, class _Deployment>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const _Deployment *_depl) {
    		_input.template readValue<>(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    	template<class _Output>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    		_output.writeType(std::get<0>(values_), _depl);
    	}
    	template<class _Output, class _Deployment>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const _Deployment *_depl) {
    		_output.writeType(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    
    	template<class _Output>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    	    (void) _depl;
    		_output.template writeValue<CommonAPI::EmptyDeployment>(std::get<0>(values_));
    	}
    
    	template<class _Output, class _Deployment>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const _Deployment *_depl) {
    		_output.template writeValue<>(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    	inline const MyTypedef &getId() const { return std::get<0>(values_); }
    	inline void setId(const MyTypedef &_value) { std::get<0>(values_) = _value; }
    	
    	std::tuple<MyTypedef> values_;
    	inline bool operator==(const SettingsStructMyTypedef& _other) const {
                return (getId() == _other.getId());
        }
    	inline bool operator!=(const SettingsStructMyTypedef &_other) const {
    		return !((*this) == _other);
    	}
    
    };
    struct SettingsStructMyEnum : SettingsStruct {
    	CommonAPI::Serial getSerial() const { return SETTINGSSTRUCTMYENUM_SERIAL; }
    	
    	SettingsStructMyEnum() {
    	}
    	SettingsStructMyEnum(const MyEnum &_status)
    	: SettingsStruct()
    	{
    		std::get<0>(values_) = _status;
    	}
    	template<class _Input>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const CommonAPI::EmptyDeployment *_depl) {
    	    (void) _depl;
    		_input.template readValue<CommonAPI::EmptyDeployment>(std::get<0>(values_));
    	}
    
    	template<class _Input, class _Deployment>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const _Deployment *_depl) {
    		_input.template readValue<>(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    	template<class _Output>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    		_output.writeType(std::get<0>(values_), _depl);
    	}
    	template<class _Output, class _Deployment>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const _Deployment *_depl) {
    		_output.writeType(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    
    	template<class _Output>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    	    (void) _depl;
    		_output.template writeValue<CommonAPI::EmptyDeployment>(std::get<0>(values_));
    	}
    
    	template<class _Output, class _Deployment>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const _Deployment *_depl) {
    		_output.template writeValue<>(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    	inline const MyEnum &getStatus() const { return std::get<0>(values_); }
    	inline void setStatus(const MyEnum &_value) { std::get<0>(values_) = _value; }
    	
    	std::tuple<MyEnum> values_;
    	inline bool operator==(const SettingsStructMyEnum& _other) const {
                return (getStatus() == _other.getStatus());
        }
    	inline bool operator!=(const SettingsStructMyEnum &_other) const {
    		return !((*this) == _other);
    	}
    
    };
    struct SettingsStructUInt8 : SettingsStruct {
    	CommonAPI::Serial getSerial() const { return SETTINGSSTRUCTUINT8_SERIAL; }
    	
    	SettingsStructUInt8() {
    	}
    	SettingsStructUInt8(const uint8_t &_channel)
    	: SettingsStruct()
    	{
    		std::get<0>(values_) = _channel;
    	}
    	template<class _Input>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const CommonAPI::EmptyDeployment *_depl) {
    	    (void) _depl;
    		_input.template readValue<CommonAPI::EmptyDeployment>(std::get<0>(values_));
    	}
    
    	template<class _Input, class _Deployment>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const _Deployment *_depl) {
    		_input.template readValue<>(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    	template<class _Output>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    		_output.writeType(std::get<0>(values_), _depl);
    	}
    	template<class _Output, class _Deployment>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const _Deployment *_depl) {
    		_output.writeType(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    
    	template<class _Output>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    	    (void) _depl;
    		_output.template writeValue<CommonAPI::EmptyDeployment>(std::get<0>(values_));
    	}
    
    	template<class _Output, class _Deployment>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const _Deployment *_depl) {
    		_output.template writeValue<>(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    	inline const uint8_t &getChannel() const { return std::get<0>(values_); }
    	inline void setChannel(const uint8_t &_value) { std::get<0>(values_) = _value; }
    	
    	std::tuple<uint8_t> values_;
    	inline bool operator==(const SettingsStructUInt8& _other) const {
                return (getChannel() == _other.getChannel());
        }
    	inline bool operator!=(const SettingsStructUInt8 &_other) const {
    		return !((*this) == _other);
    	}
    
    };
    struct SettingsStructString : SettingsStruct {
    	CommonAPI::Serial getSerial() const { return SETTINGSSTRUCTSTRING_SERIAL; }
    	
    	SettingsStructString() {
    	}
    	SettingsStructString(const std::string &_name)
    	: SettingsStruct()
    	{
    		std::get<0>(values_) = _name;
    	}
    	template<class _Input>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const CommonAPI::EmptyDeployment *_depl) {
    	    (void) _depl;
    		_input.template readValue<CommonAPI::EmptyDeployment>(std::get<0>(values_));
    	}
    
    	template<class _Input, class _Deployment>
    	void readValue(CommonAPI::InputStream<_Input> &_input, const _Deployment *_depl) {
    		_input.template readValue<>(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    	template<class _Output>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    		_output.writeType(std::get<0>(values_), _depl);
    	}
    	template<class _Output, class _Deployment>
    	void writeType(CommonAPI::TypeOutputStream<_Output> &_output, const _Deployment *_depl) {
    		_output.writeType(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    
    	template<class _Output>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const CommonAPI::EmptyDeployment *_depl) {
    	    (void) _depl;
    		_output.template writeValue<CommonAPI::EmptyDeployment>(std::get<0>(values_));
    	}
    
    	template<class _Output, class _Deployment>
    	void writeValue(CommonAPI::OutputStream<_Output> &_output, const _Deployment *_depl) {
    		_output.template writeValue<>(std::get<0>(values_), std::get<0>(_depl->values_));
    	}
    	inline const std::string &getName() const { return std::get<0>(values_); }
    	inline void setName(const std::string &_value) { std::get<0>(values_) = _value; }
    	
    	std::tuple<std::string> values_;
    	inline bool operator==(const SettingsStructString& _other) const {
                return (getName() == _other.getName());
        }
    	inline bool operator!=(const SettingsStructString &_other) const {
    		return !((*this) == _other);
    	}
    
    };



static inline const char* getTypeCollectionName() {
    static const char* typeCollectionName = "commonapi.examples.CommonTypes";
    return typeCollectionName;
}

inline CommonAPI::Version getTypeCollectionVersion() {
    return CommonAPI::Version(0, 0);
}

}; // struct CommonTypes

} // namespace examples
} // namespace commonapi

namespace CommonAPI {
}


namespace std {
    //Hash for MyEnum
    template<>
    struct hash<::commonapi::examples::CommonTypes::MyEnum> {
        inline size_t operator()(const ::commonapi::examples::CommonTypes::MyEnum& myEnum) const {
            return static_cast<int32_t>(myEnum);
        }
    };
}



#endif // V0_COMMONAPI_EXAMPLES_Common_Types_HPP_
