/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V0_COMMONAPI_EXAMPLES_E06_Unions_PROXY_HPP_
#define V0_COMMONAPI_EXAMPLES_E06_Unions_PROXY_HPP_

#include <commonapi/examples/E06UnionsProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace commonapi {
namespace examples {

template <typename ... _AttributeExtensions>
class E06UnionsProxy
    : virtual public E06Unions, 
      virtual public E06UnionsProxyBase,
      virtual public _AttributeExtensions... {
public:
    E06UnionsProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~E06UnionsProxy();

    typedef E06Unions InterfaceType;


    /**
     * Returns the wrapper class that provides access to the attribute u.
     */
    virtual UAttribute& getUAttribute() {
        return delegate_->getUAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute x.
     */
    virtual XAttribute& getXAttribute() {
        return delegate_->getXAttribute();
    }




    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<E06UnionsProxyBase> delegate_;
};

typedef E06UnionsProxy<> E06UnionsProxyDefault;

namespace E06UnionsExtensions {
    template <template <typename > class _ExtensionType>
    class UAttributeExtension {
     public:
        typedef _ExtensionType<E06UnionsProxyBase::UAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<E06UnionsProxyBase::UAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        UAttributeExtension() {}
    #endif
    
        UAttributeExtension(E06UnionsProxyBase& proxy): attributeExtension_(proxy.getUAttribute()) {
        }
    
        inline extension_type& getUAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class XAttributeExtension {
     public:
        typedef _ExtensionType<E06UnionsProxyBase::XAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<E06UnionsProxyBase::XAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        XAttributeExtension() {}
    #endif
    
        XAttributeExtension(E06UnionsProxyBase& proxy): attributeExtension_(proxy.getXAttribute()) {
        }
    
        inline extension_type& getXAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace E06UnionsExtensions

//
// E06UnionsProxy Implementation
//
template <typename ... _AttributeExtensions>
E06UnionsProxy<_AttributeExtensions...>::E06UnionsProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<E06UnionsProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<E06UnionsProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
E06UnionsProxy<_AttributeExtensions...>::~E06UnionsProxy() {
}


template <typename ... _AttributeExtensions>
const CommonAPI::Address &E06UnionsProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool E06UnionsProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool E06UnionsProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& E06UnionsProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& E06UnionsProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace examples
} // namespace commonapi

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::commonapi::examples::E06UnionsProxy,
    _AttributeExtension> {
    typedef typename ::commonapi::examples::E06UnionsProxy<
            ::commonapi::examples::E06UnionsExtensions::UAttributeExtension<_AttributeExtension>, 
            ::commonapi::examples::E06UnionsExtensions::XAttributeExtension<_AttributeExtension>
    > class_t;
};
}



#endif // V0_COMMONAPI_EXAMPLES_E06_Unions_PROXY_HPP_
