/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V0_COMMONAPI_EXAMPLES_E06_Unions_STUB_HPP_
#define V0_COMMONAPI_EXAMPLES_E06_Unions_STUB_HPP_

#include <functional>



#include <commonapi/examples/CommonTypes.hpp>

#include <commonapi/examples/E06Unions.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <CommonAPI/Variant.hpp>
#include <cstdint>
#include <memory>
#include <string>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace commonapi {
namespace examples {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service E06Unions. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class E06UnionsStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual E06Unions {
 public:
    ///Notifies all remote listeners about a change of value of the attribute u.
    virtual void fireUAttributeChanged(const ::commonapi::examples::CommonTypes::SettingsUnion& u) = 0;
    ///Notifies all remote listeners about a change of value of the attribute x.
    virtual void fireXAttributeChanged(const std::shared_ptr<::commonapi::examples::CommonTypes::SettingsStruct>& x) = 0;



    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for E06Unions.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E06UnionsStubRemoteEvent
{
public:
    virtual ~E06UnionsStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute u
    virtual bool onRemoteSetUAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, ::commonapi::examples::CommonTypes::SettingsUnion _value) = 0;
    /// Action callback for remote set requests on the attribute u
    virtual void onRemoteUAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute x
    virtual bool onRemoteSetXAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::shared_ptr<::commonapi::examples::CommonTypes::SettingsStruct> _value) = 0;
    /// Action callback for remote set requests on the attribute x
    virtual void onRemoteXAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service E06Unions to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E06UnionsStub
    : public virtual CommonAPI::Stub<E06UnionsStubAdapter, E06UnionsStubRemoteEvent>
{
public:

    virtual ~E06UnionsStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute u
    virtual const ::commonapi::examples::CommonTypes::SettingsUnion &getUAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute x
    virtual const std::shared_ptr<::commonapi::examples::CommonTypes::SettingsStruct> &getXAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;


    using CommonAPI::Stub<E06UnionsStubAdapter, E06UnionsStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<E06UnionsStubAdapter, E06UnionsStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<E06UnionsStubAdapter, E06UnionsStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef E06UnionsStubRemoteEvent RemoteEventType;
    typedef E06Unions StubInterface;
};

} // namespace examples
} // namespace commonapi



#endif // V0_COMMONAPI_EXAMPLES_E06_Unions_STUB_HPP_
