/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <commonapi/examples/E06Unions.hpp>
#include <commonapi/examples/E06UnionsDBusStubAdapter.hpp>

namespace commonapi {
namespace examples {

std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> createE06UnionsDBusStubAdapter(
                   const CommonAPI::DBus::DBusAddress &_address,
                   const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
                   const std::shared_ptr<CommonAPI::StubBase> &_stub) {
    return std::make_shared<E06UnionsDBusStubAdapter>(_address, _connection, _stub);
}

INITIALIZER(registerE06UnionsDBusStubAdapter) {
    CommonAPI::DBus::Factory::get()->registerStubAdapterCreateMethod(
    	E06Unions::getInterface(), &createE06UnionsDBusStubAdapter);
}

E06UnionsDBusStubAdapterInternal::~E06UnionsDBusStubAdapterInternal() {
    deactivateManagedInstances();
    E06UnionsDBusStubAdapterHelper::deinit();
}

void E06UnionsDBusStubAdapterInternal::deactivateManagedInstances() {

}

const char* E06UnionsDBusStubAdapterInternal::getMethodsDBusIntrospectionXmlData() const {
    static const std::string introspectionData =
        "<method name=\"getInterfaceVersion\">\n"
            "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"getUAttribute\">\n"
            "<arg name=\"value\" type=\"(yv)\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"setUAttribute\">\n"
            "<arg name=\"requestedValue\" type=\"(yv)\" direction=\"in\" />\n"
            "<arg name=\"setValue\" type=\"(yv)\" direction=\"out\" />\n"
        "</method>\n"
        "<signal name=\"onUAttributeChanged\">\n"
            "<arg name=\"changedValue\" type=\"(yv)\" />\n"
        "</signal>\n"
        "<method name=\"getXAttribute\">\n"
            "<arg name=\"value\" type=\"(uv)\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"setXAttribute\">\n"
            "<arg name=\"requestedValue\" type=\"(uv)\" direction=\"in\" />\n"
            "<arg name=\"setValue\" type=\"(uv)\" direction=\"out\" />\n"
        "</method>\n"
        "<signal name=\"onXAttributeChanged\">\n"
            "<arg name=\"changedValue\" type=\"(uv)\" />\n"
        "</signal>\n"

    ;
    return introspectionData.c_str();
}

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::commonapi::examples::E06UnionsStub,
        CommonAPI::Version
        > E06UnionsDBusStubAdapterInternal::getE06UnionsInterfaceVersionStubDispatcher(&E06UnionsStub::getInterfaceVersion, "uu");

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::commonapi::examples::E06UnionsStub,
        ::commonapi::examples::CommonTypes::SettingsUnion,
        CommonTypes_::SettingsUnionDeployment_t
        > E06UnionsDBusStubAdapterInternal::getUAttributeStubDispatcher(
            &::commonapi::examples::E06UnionsStub::getUAttribute
            , "(yv)"
            );
CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
        ::commonapi::examples::E06UnionsStub,
        ::commonapi::examples::CommonTypes::SettingsUnion,
        CommonTypes_::SettingsUnionDeployment_t
        > E06UnionsDBusStubAdapterInternal::setUAttributeStubDispatcher(
                &::commonapi::examples::E06UnionsStub::getUAttribute,
                &E06UnionsStubRemoteEvent::onRemoteSetUAttribute,
                &E06UnionsStubRemoteEvent::onRemoteUAttributeChanged
                ,&E06UnionsStubAdapter::fireUAttributeChanged
                ,"(yv)"
                );
CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::commonapi::examples::E06UnionsStub,
        std::shared_ptr<::commonapi::examples::CommonTypes::SettingsStruct>,
        CommonTypes_::SettingsStructDeployment_t
        > E06UnionsDBusStubAdapterInternal::getXAttributeStubDispatcher(
            &::commonapi::examples::E06UnionsStub::getXAttribute
            , "(uv)"
            );
CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
        ::commonapi::examples::E06UnionsStub,
        std::shared_ptr<::commonapi::examples::CommonTypes::SettingsStruct>,
        CommonTypes_::SettingsStructDeployment_t
        > E06UnionsDBusStubAdapterInternal::setXAttributeStubDispatcher(
                &::commonapi::examples::E06UnionsStub::getXAttribute,
                &E06UnionsStubRemoteEvent::onRemoteSetXAttribute,
                &E06UnionsStubRemoteEvent::onRemoteXAttributeChanged
                ,&E06UnionsStubAdapter::fireXAttributeChanged
                ,"(uv)"
                );




void E06UnionsDBusStubAdapterInternal::fireUAttributeChanged(const ::commonapi::examples::CommonTypes::SettingsUnion& value) {
    CommonAPI::Deployable<CommonTypes::SettingsUnion, CommonTypes_::SettingsUnionDeployment_t> deployedValue(value, static_cast<CommonTypes_::SettingsUnionDeployment_t*>(nullptr));
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<
        ::commonapi::examples::CommonTypes::SettingsUnion,
        CommonTypes_::SettingsUnionDeployment_t
    >
    >>
        ::sendSignal(
            *this,
            "onUAttributeChanged",
            "(yv)",
            deployedValue
    
    );
}
void E06UnionsDBusStubAdapterInternal::fireXAttributeChanged(const std::shared_ptr<::commonapi::examples::CommonTypes::SettingsStruct>& value) {
    CommonAPI::Deployable<std::shared_ptr<CommonTypes::SettingsStruct>, CommonTypes_::SettingsStructDeployment_t> deployedValue(value, static_cast<CommonTypes_::SettingsStructDeployment_t*>(nullptr));
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<
        std::shared_ptr<::commonapi::examples::CommonTypes::SettingsStruct>,
        CommonTypes_::SettingsStructDeployment_t
    >
    >>
        ::sendSignal(
            *this,
            "onXAttributeChanged",
            "(uv)",
            deployedValue
    
    );
}



const E06UnionsDBusStubAdapterHelper::StubDispatcherTable& E06UnionsDBusStubAdapterInternal::getStubDispatcherTable() {
    return stubDispatcherTable_;
}

const CommonAPI::DBus::StubAttributeTable& E06UnionsDBusStubAdapterInternal::getStubAttributeTable() {
    return stubAttributeTable_;
}

E06UnionsDBusStubAdapterInternal::E06UnionsDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub)
	: CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      E06UnionsDBusStubAdapterHelper(_address, _connection, std::dynamic_pointer_cast<E06UnionsStub>(_stub), false),
      stubDispatcherTable_({
            { { "getUAttribute", "" }, &commonapi::examples::E06UnionsDBusStubAdapterInternal::getUAttributeStubDispatcher }
            , { { "setUAttribute", "(yv)" }, &commonapi::examples::E06UnionsDBusStubAdapterInternal::setUAttributeStubDispatcher },
            { { "getXAttribute", "" }, &commonapi::examples::E06UnionsDBusStubAdapterInternal::getXAttributeStubDispatcher }
            , { { "setXAttribute", "(uv)" }, &commonapi::examples::E06UnionsDBusStubAdapterInternal::setXAttributeStubDispatcher }
            }),
        stubAttributeTable_() {

    stubDispatcherTable_.insert({ { "getInterfaceVersion", "" }, &commonapi::examples::E06UnionsDBusStubAdapterInternal::getE06UnionsInterfaceVersionStubDispatcher });
}

bool E06UnionsDBusStubAdapterInternal::hasFreedesktopProperties() {
    return false;
}

} // namespace examples
} // namespace commonapi
