/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_E07_Mainloop_STUB_HPP_
#define V1_COMMONAPI_EXAMPLES_E07_Mainloop_STUB_HPP_

#include <functional>




#include <v1/commonapi/examples/E07Mainloop.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service E07Mainloop. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class E07MainloopStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual E07Mainloop {
 public:
    ///Notifies all remote listeners about a change of value of the attribute x.
    virtual void fireXAttributeChanged(const int32_t& x) = 0;



    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for E07Mainloop.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E07MainloopStubRemoteEvent
{
public:
    virtual ~E07MainloopStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute x
    virtual bool onRemoteSetXAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, int32_t _value) = 0;
    /// Action callback for remote set requests on the attribute x
    virtual void onRemoteXAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service E07Mainloop to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class E07MainloopStub
    : public virtual CommonAPI::Stub<E07MainloopStubAdapter, E07MainloopStubRemoteEvent>
{
public:
    typedef std::function<void (std::string _message)>sayHelloReply_t;

    virtual ~E07MainloopStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute x
    virtual const int32_t &getXAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /// This is the method that will be called on remote calls on the method sayHello.
    virtual void sayHello(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _name, sayHelloReply_t _reply) = 0;

    using CommonAPI::Stub<E07MainloopStubAdapter, E07MainloopStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<E07MainloopStubAdapter, E07MainloopStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<E07MainloopStubAdapter, E07MainloopStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef E07MainloopStubRemoteEvent RemoteEventType;
    typedef E07Mainloop StubInterface;
};

} // namespace examples
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_E07_Mainloop_STUB_HPP_
