/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_Legacy_Test_PROXY_HPP_
#define V1_COMMONAPI_EXAMPLES_Legacy_Test_PROXY_HPP_

#include <v1/commonapi/examples/LegacyTestProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

template <typename ... _AttributeExtensions>
class LegacyTestProxy
    : virtual public LegacyTest, 
      virtual public LegacyTestProxyBase,
      virtual public _AttributeExtensions... {
public:
    LegacyTestProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~LegacyTestProxy();

    typedef LegacyTest InterfaceType;


    /**
     * Returns the wrapper class that provides access to the attribute nopath.
     */
    virtual NopathAttribute& getNopathAttribute() {
        return delegate_->getNopathAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute objectpath.
     */
    virtual ObjectpathAttribute& getObjectpathAttribute() {
        return delegate_->getObjectpathAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute defvalue.
     */
    virtual DefvalueAttribute& getDefvalueAttribute() {
        return delegate_->getDefvalueAttribute();
    }

    /**
     * Returns the wrapper class that provides access to the broadcast testb.
     */
    virtual TestbEvent& getTestbEvent() {
        return delegate_->getTestbEvent();
    }

    /**
     * Calls test with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void test(const std::string &_plain, const std::string &_path, CommonAPI::CallStatus &_internalCallStatus, std::string &_path2, std::string &_plain2, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls test with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> testAsync(const std::string &_plain, const std::string &_path, TestAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls teststruct with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void teststruct(const LegacyTest::pathstruct &_pathsin, CommonAPI::CallStatus &_internalCallStatus, LegacyTest::pathstruct &_pathsout, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls teststruct with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> teststructAsync(const LegacyTest::pathstruct &_pathsin, TeststructAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls testunion with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void testunion(const int32_t &_intin, const LegacyTest::pathunion &_pathuin, CommonAPI::CallStatus &_internalCallStatus, int32_t &_intout, LegacyTest::pathunion &_pathuout, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls testunion with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> testunionAsync(const int32_t &_intin, const LegacyTest::pathunion &_pathuin, TestunionAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<LegacyTestProxyBase> delegate_;
};

typedef LegacyTestProxy<> LegacyTestProxyDefault;

namespace LegacyTestExtensions {
    template <template <typename > class _ExtensionType>
    class NopathAttributeExtension {
     public:
        typedef _ExtensionType<LegacyTestProxyBase::NopathAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<LegacyTestProxyBase::NopathAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        NopathAttributeExtension() {}
    #endif
    
        NopathAttributeExtension(LegacyTestProxyBase& proxy): attributeExtension_(proxy.getNopathAttribute()) {
        }
    
        inline extension_type& getNopathAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class ObjectpathAttributeExtension {
     public:
        typedef _ExtensionType<LegacyTestProxyBase::ObjectpathAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<LegacyTestProxyBase::ObjectpathAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        ObjectpathAttributeExtension() {}
    #endif
    
        ObjectpathAttributeExtension(LegacyTestProxyBase& proxy): attributeExtension_(proxy.getObjectpathAttribute()) {
        }
    
        inline extension_type& getObjectpathAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class DefvalueAttributeExtension {
     public:
        typedef _ExtensionType<LegacyTestProxyBase::DefvalueAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<LegacyTestProxyBase::DefvalueAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        DefvalueAttributeExtension() {}
    #endif
    
        DefvalueAttributeExtension(LegacyTestProxyBase& proxy): attributeExtension_(proxy.getDefvalueAttribute()) {
        }
    
        inline extension_type& getDefvalueAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace LegacyTestExtensions

//
// LegacyTestProxy Implementation
//
template <typename ... _AttributeExtensions>
LegacyTestProxy<_AttributeExtensions...>::LegacyTestProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<LegacyTestProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<LegacyTestProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
LegacyTestProxy<_AttributeExtensions...>::~LegacyTestProxy() {
}

template <typename ... _AttributeExtensions>
void LegacyTestProxy<_AttributeExtensions...>::test(const std::string &_plain, const std::string &_path, CommonAPI::CallStatus &_internalCallStatus, std::string &_path2, std::string &_plain2, const CommonAPI::CallInfo *_info) {
    delegate_->test(_plain, _path, _internalCallStatus, _path2, _plain2, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> LegacyTestProxy<_AttributeExtensions...>::testAsync(const std::string &_plain, const std::string &_path, TestAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->testAsync(_plain, _path, _callback, _info);
}
template <typename ... _AttributeExtensions>
void LegacyTestProxy<_AttributeExtensions...>::teststruct(const LegacyTest::pathstruct &_pathsin, CommonAPI::CallStatus &_internalCallStatus, LegacyTest::pathstruct &_pathsout, const CommonAPI::CallInfo *_info) {
    delegate_->teststruct(_pathsin, _internalCallStatus, _pathsout, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> LegacyTestProxy<_AttributeExtensions...>::teststructAsync(const LegacyTest::pathstruct &_pathsin, TeststructAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->teststructAsync(_pathsin, _callback, _info);
}
template <typename ... _AttributeExtensions>
void LegacyTestProxy<_AttributeExtensions...>::testunion(const int32_t &_intin, const LegacyTest::pathunion &_pathuin, CommonAPI::CallStatus &_internalCallStatus, int32_t &_intout, LegacyTest::pathunion &_pathuout, const CommonAPI::CallInfo *_info) {
    delegate_->testunion(_intin, _pathuin, _internalCallStatus, _intout, _pathuout, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> LegacyTestProxy<_AttributeExtensions...>::testunionAsync(const int32_t &_intin, const LegacyTest::pathunion &_pathuin, TestunionAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->testunionAsync(_intin, _pathuin, _callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &LegacyTestProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool LegacyTestProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool LegacyTestProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& LegacyTestProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& LegacyTestProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace examples
} // namespace commonapi
} // namespace v1

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::v1::commonapi::examples::LegacyTestProxy,
    _AttributeExtension> {
    typedef typename ::v1::commonapi::examples::LegacyTestProxy<
            ::v1::commonapi::examples::LegacyTestExtensions::NopathAttributeExtension<_AttributeExtension>, 
            ::v1::commonapi::examples::LegacyTestExtensions::ObjectpathAttributeExtension<_AttributeExtension>, 
            ::v1::commonapi::examples::LegacyTestExtensions::DefvalueAttributeExtension<_AttributeExtension>
    > class_t;
};
}


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_Legacy_Test_PROXY_HPP_
