/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_Legacy_Test_STUB_HPP_
#define V1_COMMONAPI_EXAMPLES_Legacy_Test_STUB_HPP_

#include <functional>




#include <v1/commonapi/examples/LegacyTest.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <CommonAPI/Variant.hpp>
#include <cstdint>
#include <memory>
#include <string>
#include <unordered_set>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v1 {
namespace commonapi {
namespace examples {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service LegacyTest. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class LegacyTestStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual LegacyTest {
 public:
    ///Notifies all remote listeners about a change of value of the attribute nopath.
    virtual void fireNopathAttributeChanged(const std::string& nopath) = 0;
    ///Notifies all remote listeners about a change of value of the attribute objectpath.
    virtual void fireObjectpathAttributeChanged(const std::string& objectpath) = 0;
    ///Notifies all remote listeners about a change of value of the attribute defvalue.
    virtual void fireDefvalueAttributeChanged(const std::string& defvalue) = 0;

    /**
     * Sends a broadcast event for testb. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireTestbEvent(const std::string &_plain3, const std::string &_path3) = 0;


    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for LegacyTest.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class LegacyTestStubRemoteEvent
{
public:
    virtual ~LegacyTestStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute nopath
    virtual bool onRemoteSetNopathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute nopath
    virtual void onRemoteNopathAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute objectpath
    virtual bool onRemoteSetObjectpathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute objectpath
    virtual void onRemoteObjectpathAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute defvalue
    virtual bool onRemoteSetDefvalueAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute defvalue
    virtual void onRemoteDefvalueAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service LegacyTest to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class LegacyTestStub
    : public virtual CommonAPI::Stub<LegacyTestStubAdapter, LegacyTestStubRemoteEvent>
{
public:
    typedef std::function<void (std::string _path2, std::string _plain2)>testReply_t;
    typedef std::function<void (LegacyTest::pathstruct _pathsout)>teststructReply_t;
    typedef std::function<void (int32_t _intout, LegacyTest::pathunion _pathuout)>testunionReply_t;

    virtual ~LegacyTestStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute nopath
    virtual const std::string &getNopathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute objectpath
    virtual const std::string &getObjectpathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute defvalue
    virtual const std::string &getDefvalueAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /// This is the method that will be called on remote calls on the method test.
    virtual void test(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _plain, std::string _path, testReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method teststruct.
    virtual void teststruct(const std::shared_ptr<CommonAPI::ClientId> _client, LegacyTest::pathstruct _pathsin, teststructReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method testunion.
    virtual void testunion(const std::shared_ptr<CommonAPI::ClientId> _client, int32_t _intin, LegacyTest::pathunion _pathuin, testunionReply_t _reply) = 0;
    /// Sends a broadcast event for testb.
    virtual void fireTestbEvent(const std::string &_plain3, const std::string &_path3) = 0;

    using CommonAPI::Stub<LegacyTestStubAdapter, LegacyTestStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<LegacyTestStubAdapter, LegacyTestStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<LegacyTestStubAdapter, LegacyTestStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef LegacyTestStubRemoteEvent RemoteEventType;
    typedef LegacyTest StubInterface;
};

} // namespace examples
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_Legacy_Test_STUB_HPP_
