/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v1/commonapi/examples/ObjectPathSimpleDBusProxy.hpp>

namespace v1 {
namespace commonapi {
namespace examples {

std::shared_ptr<CommonAPI::DBus::DBusProxy> createObjectPathSimpleDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection) {
	return std::make_shared<ObjectPathSimpleDBusProxy>(_address, _connection);
}

INITIALIZER(registerObjectPathSimpleDBusProxy) {
     CommonAPI::DBus::Factory::get()->registerProxyCreateMethod(
		ObjectPathSimple::getInterface(),
		&createObjectPathSimpleDBusProxy);
}

ObjectPathSimpleDBusProxy::ObjectPathSimpleDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection)
	:	CommonAPI::DBus::DBusProxy(_address, _connection)
,		nopath_(*this, "onNopathAttributeChanged", "setNopathAttribute", "s", "getNopathAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		objectpath_(*this, "onObjectpathAttributeChanged", "setObjectpathAttribute", "o", "getObjectpathAttribute", &ObjectPathSimple_::objectpathDeployment),
		defvalue_(*this, "onDefvalueAttributeChanged", "setDefvalueAttribute", "s", "getDefvalueAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
,		testb_(*this, "testb", "so", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), &ObjectPathSimple_::testb_path3Deployment))
{
}

      ObjectPathSimpleDBusProxy::NopathAttribute& ObjectPathSimpleDBusProxy::getNopathAttribute() {
          return nopath_;
      }
      ObjectPathSimpleDBusProxy::ObjectpathAttribute& ObjectPathSimpleDBusProxy::getObjectpathAttribute() {
          return objectpath_;
      }
      ObjectPathSimpleDBusProxy::DefvalueAttribute& ObjectPathSimpleDBusProxy::getDefvalueAttribute() {
          return defvalue_;
      }

ObjectPathSimpleDBusProxy::TestbEvent& ObjectPathSimpleDBusProxy::getTestbEvent() {
    return testb_;
}
    
    void ObjectPathSimpleDBusProxy::test(const std::string &_plain, const std::string &_path, CommonAPI::CallStatus &_internalCallStatus, std::string &_path2, std::string &_plain2, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_plain(_plain, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_path(_path, &ObjectPathSimple_::test_pathDeployment);
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_path2(&ObjectPathSimple_::test_path2Deployment);
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_plain2(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        static CommonAPI::CallInfo info(1234);
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>,
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "test",
        "so",
(_info ? _info : &info),
deploy_plain, deploy_path,
_internalCallStatus,
deploy_path2, deploy_plain2);
_path2 = deploy_path2.getValue();
_plain2 = deploy_plain2.getValue();
}
    std::future<CommonAPI::CallStatus> ObjectPathSimpleDBusProxy::testAsync(const std::string &_plain, const std::string &_path, TestAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_plain(_plain, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_path(_path, &ObjectPathSimple_::test_pathDeployment);
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_path2(&ObjectPathSimple_::test_path2Deployment);
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_plain2(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        static CommonAPI::CallInfo info(1234);
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>,
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodAsync(
        *this,
        "test",
        "so",
        (_info ? _info : &info),
        deploy_plain, deploy_path,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _path2, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _plain2) {
        	if (_callback)
        		_callback(_internalCallStatus, _path2.getValue(), _plain2.getValue());
        },
        std::make_tuple(deploy_path2, deploy_plain2));
    }
    void ObjectPathSimpleDBusProxy::teststruct(const ObjectPathSimple::pathstruct &_pathsin, CommonAPI::CallStatus &_internalCallStatus, ObjectPathSimple::pathstruct &_pathsout, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<ObjectPathSimple::pathstruct, ObjectPathSimple_::pathstructDeployment_t> deploy_pathsin(_pathsin, &ObjectPathSimple_::pathstructDeployment);
        CommonAPI::Deployable<ObjectPathSimple::pathstruct, ObjectPathSimple_::pathstructDeployment_t> deploy_pathsout(&ObjectPathSimple_::pathstructDeployment);
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<ObjectPathSimple::pathstruct, ObjectPathSimple_::pathstructDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<ObjectPathSimple::pathstruct,ObjectPathSimple_::pathstructDeployment_t>
            >
        	>::callMethodWithReply(
        *this,
        "teststruct",
        "(os)",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_pathsin,
_internalCallStatus,
deploy_pathsout);
_pathsout = deploy_pathsout.getValue();
}
    std::future<CommonAPI::CallStatus> ObjectPathSimpleDBusProxy::teststructAsync(const ObjectPathSimple::pathstruct &_pathsin, TeststructAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<ObjectPathSimple::pathstruct, ObjectPathSimple_::pathstructDeployment_t> deploy_pathsin(_pathsin, &ObjectPathSimple_::pathstructDeployment);
        CommonAPI::Deployable<ObjectPathSimple::pathstruct, ObjectPathSimple_::pathstructDeployment_t> deploy_pathsout(&ObjectPathSimple_::pathstructDeployment);
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<ObjectPathSimple::pathstruct, ObjectPathSimple_::pathstructDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<ObjectPathSimple::pathstruct,ObjectPathSimple_::pathstructDeployment_t>
            >
        	>::callMethodAsync(
        *this,
        "teststruct",
        "(os)",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_pathsin,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<ObjectPathSimple::pathstruct, ObjectPathSimple_::pathstructDeployment_t> _pathsout) {
        	if (_callback)
        		_callback(_internalCallStatus, _pathsout.getValue());
        },
        std::make_tuple(deploy_pathsout));
    }
    void ObjectPathSimpleDBusProxy::testunion(const int32_t &_intin, const ObjectPathSimple::pathunion &_pathuin, CommonAPI::CallStatus &_internalCallStatus, int32_t &_intout, ObjectPathSimple::pathunion &_pathuout, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<int32_t, CommonAPI::EmptyDeployment> deploy_intin(_intin, static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<ObjectPathSimple::pathunion, ObjectPathSimple_::pathunionDeployment_t> deploy_pathuin(_pathuin, &ObjectPathSimple_::pathunionDeployment);
        CommonAPI::Deployable<int32_t, CommonAPI::EmptyDeployment> deploy_intout(static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<ObjectPathSimple::pathunion, ObjectPathSimple_::pathunionDeployment_t> deploy_pathuout(&ObjectPathSimple_::pathunionDeployment);
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<int32_t, CommonAPI::EmptyDeployment >,
            CommonAPI::Deployable<ObjectPathSimple::pathunion, ObjectPathSimple_::pathunionDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<int32_t,CommonAPI::EmptyDeployment>,
            CommonAPI::Deployable<ObjectPathSimple::pathunion,ObjectPathSimple_::pathunionDeployment_t>
            >
        	>::callMethodWithReply(
        *this,
        "testunion",
        "i(yv)",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_intin, deploy_pathuin,
_internalCallStatus,
deploy_intout, deploy_pathuout);
_intout = deploy_intout.getValue();
_pathuout = deploy_pathuout.getValue();
}
    std::future<CommonAPI::CallStatus> ObjectPathSimpleDBusProxy::testunionAsync(const int32_t &_intin, const ObjectPathSimple::pathunion &_pathuin, TestunionAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<int32_t, CommonAPI::EmptyDeployment> deploy_intin(_intin, static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<ObjectPathSimple::pathunion, ObjectPathSimple_::pathunionDeployment_t> deploy_pathuin(_pathuin, &ObjectPathSimple_::pathunionDeployment);
        CommonAPI::Deployable<int32_t, CommonAPI::EmptyDeployment> deploy_intout(static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<ObjectPathSimple::pathunion, ObjectPathSimple_::pathunionDeployment_t> deploy_pathuout(&ObjectPathSimple_::pathunionDeployment);
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<int32_t, CommonAPI::EmptyDeployment >,
            CommonAPI::Deployable<ObjectPathSimple::pathunion, ObjectPathSimple_::pathunionDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<int32_t,CommonAPI::EmptyDeployment>,
            CommonAPI::Deployable<ObjectPathSimple::pathunion,ObjectPathSimple_::pathunionDeployment_t>
            >
        	>::callMethodAsync(
        *this,
        "testunion",
        "i(yv)",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_intin, deploy_pathuin,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<int32_t, CommonAPI::EmptyDeployment> _intout, CommonAPI::Deployable<ObjectPathSimple::pathunion, ObjectPathSimple_::pathunionDeployment_t> _pathuout) {
        	if (_callback)
        		_callback(_internalCallStatus, _intout.getValue(), _pathuout.getValue());
        },
        std::make_tuple(deploy_intout, deploy_pathuout));
    }


void ObjectPathSimpleDBusProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
          ownVersionMajor = 1;
          ownVersionMinor = 0;
      }

      } // namespace examples
      } // namespace commonapi
      } // namespace v1
