/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_EXAMPLES_Object_Path_Simple_STUB_DEFAULT_HPP_
#define V1_COMMONAPI_EXAMPLES_Object_Path_Simple_STUB_DEFAULT_HPP_


#include <v1/commonapi/examples/ObjectPathSimpleStub.hpp>
#include <sstream>

namespace v1 {
namespace commonapi {
namespace examples {

/**
 * Provides a default implementation for ObjectPathSimpleStubRemoteEvent and
 * ObjectPathSimpleStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class ObjectPathSimpleStubDefault
    : public virtual ObjectPathSimpleStub {
public:
    ObjectPathSimpleStubDefault();

    ObjectPathSimpleStubRemoteEvent* initStubAdapter(const std::shared_ptr<ObjectPathSimpleStubAdapter> &_adapter);

    const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client);

    virtual const std::string& getNopathAttribute();
    virtual const std::string& getNopathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setNopathAttribute(std::string _value);
    virtual void setNopathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
    virtual const std::string& getObjectpathAttribute();
    virtual const std::string& getObjectpathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setObjectpathAttribute(std::string _value);
    virtual void setObjectpathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
    virtual const std::string& getDefvalueAttribute();
    virtual const std::string& getDefvalueAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setDefvalueAttribute(std::string _value);
    virtual void setDefvalueAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);

    virtual void test(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _plain, std::string _path, testReply_t _reply);
    virtual void teststruct(const std::shared_ptr<CommonAPI::ClientId> _client, ObjectPathSimple::pathstruct _pathsin, teststructReply_t _reply);
    virtual void testunion(const std::shared_ptr<CommonAPI::ClientId> _client, int32_t _intin, ObjectPathSimple::pathunion _pathuin, testunionReply_t _reply);

virtual void fireTestbEvent(const std::string &_plain3, const std::string &_path3);


protected:
    virtual bool trySetNopathAttribute(std::string _value);
    virtual bool validateNopathAttributeRequestedValue(const std::string &_value);
    virtual void onRemoteNopathAttributeChanged();
    virtual bool trySetObjectpathAttribute(std::string _value);
    virtual bool validateObjectpathAttributeRequestedValue(const std::string &_value);
    virtual void onRemoteObjectpathAttributeChanged();
    virtual bool trySetDefvalueAttribute(std::string _value);
    virtual bool validateDefvalueAttributeRequestedValue(const std::string &_value);
    virtual void onRemoteDefvalueAttributeChanged();
    class RemoteEventHandler: public virtual ObjectPathSimpleStubRemoteEvent {
    public:
        RemoteEventHandler(ObjectPathSimpleStubDefault *_defaultStub);

        virtual bool onRemoteSetNopathAttribute(std::string _value);
        virtual bool onRemoteSetNopathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        virtual void onRemoteNopathAttributeChanged();

        virtual bool onRemoteSetObjectpathAttribute(std::string _value);
        virtual bool onRemoteSetObjectpathAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        virtual void onRemoteObjectpathAttributeChanged();

        virtual bool onRemoteSetDefvalueAttribute(std::string _value);
        virtual bool onRemoteSetDefvalueAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        virtual void onRemoteDefvalueAttributeChanged();


    private:
        ObjectPathSimpleStubDefault *defaultStub_;
    };
private:
    ObjectPathSimpleStubDefault::RemoteEventHandler remoteEventHandler_;

    std::string nopathAttributeValue_ {};
    std::string objectpathAttributeValue_ {};
    std::string defvalueAttributeValue_ {};

    CommonAPI::Version interfaceVersion_;
};

} // namespace examples
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_EXAMPLES_Object_Path_Simple_STUB_DEFAULT
