/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/BlockDBusProxy.hpp>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

std::shared_ptr<CommonAPI::DBus::DBusProxy> createBlockDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection) {
	return std::make_shared<BlockDBusProxy>(_address, _connection);
}

INITIALIZER(registerBlockDBusProxy) {
     CommonAPI::DBus::Factory::get()->registerProxyCreateMethod(
		Block::getInterface(),
		&createBlockDBusProxy);
}

BlockDBusProxy::BlockDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection)
	:	CommonAPI::DBus::DBusProxy(_address, _connection)
,		device_(*this, "onDeviceAttributeChanged", "setDeviceAttribute", "ay", "getDeviceAttribute", static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::EmptyDeployment>*>(nullptr)),
		preferredDevice_(*this, "onPreferredDeviceAttributeChanged", "setPreferredDeviceAttribute", "ay", "getPreferredDeviceAttribute", static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::EmptyDeployment>*>(nullptr)),
		symlinks_(*this, "onSymlinksAttributeChanged", "setSymlinksAttribute", "aay", "getSymlinksAttribute", static_cast<CommonAPI::DBus::ArrayDeployment<Block_::tSymlinksArrayDeployment_t>*>(nullptr)),
		deviceNumber_(*this, "onDeviceNumberAttributeChanged", "setDeviceNumberAttribute", "t", "getDeviceNumberAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		id_(*this, "onIdAttributeChanged", "setIdAttribute", "s", "getIdAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		size_(*this, "onSizeAttributeChanged", "setSizeAttribute", "t", "getSizeAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		readOnly_(*this, "onReadOnlyAttributeChanged", "setReadOnlyAttribute", "b", "getReadOnlyAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		drive_(*this, "onDriveAttributeChanged", "setDriveAttribute", "s", "getDriveAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		mDRaid_(*this, "onMDRaidAttributeChanged", "setMDRaidAttribute", "s", "getMDRaidAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		mDRaidMember_(*this, "onMDRaidMemberAttributeChanged", "setMDRaidMemberAttribute", "s", "getMDRaidMemberAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		idUsage_(*this, "onIdUsageAttributeChanged", "setIdUsageAttribute", "s", "getIdUsageAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		idType_(*this, "onIdTypeAttributeChanged", "setIdTypeAttribute", "s", "getIdTypeAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		idVersion_(*this, "onIdVersionAttributeChanged", "setIdVersionAttribute", "s", "getIdVersionAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		idLabel_(*this, "onIdLabelAttributeChanged", "setIdLabelAttribute", "s", "getIdLabelAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		idUUID_(*this, "onIdUUIDAttributeChanged", "setIdUUIDAttribute", "s", "getIdUUIDAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		configuration_(*this, "onConfigurationAttributeChanged", "setConfigurationAttribute", "a(sa{s(yv)})", "getConfigurationAttribute", static_cast<CommonAPI::DBus::ArrayDeployment<Block_::tConfigurationStructDeployment_t>*>(nullptr)),
		cryptoBackingDevice_(*this, "onCryptoBackingDeviceAttributeChanged", "setCryptoBackingDeviceAttribute", "s", "getCryptoBackingDeviceAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		hintPartitionable_(*this, "onHintPartitionableAttributeChanged", "setHintPartitionableAttribute", "b", "getHintPartitionableAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		hintSystem_(*this, "onHintSystemAttributeChanged", "setHintSystemAttribute", "b", "getHintSystemAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		hintIgnore_(*this, "onHintIgnoreAttributeChanged", "setHintIgnoreAttribute", "b", "getHintIgnoreAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		hintAuto_(*this, "onHintAutoAttributeChanged", "setHintAutoAttribute", "b", "getHintAutoAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		hintName_(*this, "onHintNameAttributeChanged", "setHintNameAttribute", "s", "getHintNameAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		hintIconName_(*this, "onHintIconNameAttributeChanged", "setHintIconNameAttribute", "s", "getHintIconNameAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		hintSymbolicIconName_(*this, "onHintSymbolicIconNameAttributeChanged", "setHintSymbolicIconNameAttribute", "s", "getHintSymbolicIconNameAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
{
}

      BlockDBusProxy::DeviceAttribute& BlockDBusProxy::getDeviceAttribute() {
          return device_;
      }
      BlockDBusProxy::PreferredDeviceAttribute& BlockDBusProxy::getPreferredDeviceAttribute() {
          return preferredDevice_;
      }
      BlockDBusProxy::SymlinksAttribute& BlockDBusProxy::getSymlinksAttribute() {
          return symlinks_;
      }
      BlockDBusProxy::DeviceNumberAttribute& BlockDBusProxy::getDeviceNumberAttribute() {
          return deviceNumber_;
      }
      BlockDBusProxy::IdAttribute& BlockDBusProxy::getIdAttribute() {
          return id_;
      }
      BlockDBusProxy::SizeAttribute& BlockDBusProxy::getSizeAttribute() {
          return size_;
      }
      BlockDBusProxy::ReadOnlyAttribute& BlockDBusProxy::getReadOnlyAttribute() {
          return readOnly_;
      }
      BlockDBusProxy::DriveAttribute& BlockDBusProxy::getDriveAttribute() {
          return drive_;
      }
      BlockDBusProxy::MDRaidAttribute& BlockDBusProxy::getMDRaidAttribute() {
          return mDRaid_;
      }
      BlockDBusProxy::MDRaidMemberAttribute& BlockDBusProxy::getMDRaidMemberAttribute() {
          return mDRaidMember_;
      }
      BlockDBusProxy::IdUsageAttribute& BlockDBusProxy::getIdUsageAttribute() {
          return idUsage_;
      }
      BlockDBusProxy::IdTypeAttribute& BlockDBusProxy::getIdTypeAttribute() {
          return idType_;
      }
      BlockDBusProxy::IdVersionAttribute& BlockDBusProxy::getIdVersionAttribute() {
          return idVersion_;
      }
      BlockDBusProxy::IdLabelAttribute& BlockDBusProxy::getIdLabelAttribute() {
          return idLabel_;
      }
      BlockDBusProxy::IdUUIDAttribute& BlockDBusProxy::getIdUUIDAttribute() {
          return idUUID_;
      }
      BlockDBusProxy::ConfigurationAttribute& BlockDBusProxy::getConfigurationAttribute() {
          return configuration_;
      }
      BlockDBusProxy::CryptoBackingDeviceAttribute& BlockDBusProxy::getCryptoBackingDeviceAttribute() {
          return cryptoBackingDevice_;
      }
      BlockDBusProxy::HintPartitionableAttribute& BlockDBusProxy::getHintPartitionableAttribute() {
          return hintPartitionable_;
      }
      BlockDBusProxy::HintSystemAttribute& BlockDBusProxy::getHintSystemAttribute() {
          return hintSystem_;
      }
      BlockDBusProxy::HintIgnoreAttribute& BlockDBusProxy::getHintIgnoreAttribute() {
          return hintIgnore_;
      }
      BlockDBusProxy::HintAutoAttribute& BlockDBusProxy::getHintAutoAttribute() {
          return hintAuto_;
      }
      BlockDBusProxy::HintNameAttribute& BlockDBusProxy::getHintNameAttribute() {
          return hintName_;
      }
      BlockDBusProxy::HintIconNameAttribute& BlockDBusProxy::getHintIconNameAttribute() {
          return hintIconName_;
      }
      BlockDBusProxy::HintSymbolicIconNameAttribute& BlockDBusProxy::getHintSymbolicIconNameAttribute() {
          return hintSymbolicIconName_;
      }

    
    void BlockDBusProxy::AddConfigurationItem(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tAddConfigurationItem_itemStruct, Block_::tAddConfigurationItem_itemStructDeployment_t> deploy_item(_item, static_cast<Block_::tAddConfigurationItem_itemStructDeployment_t*>(nullptr));
        CommonAPI::Deployable<Block::tAddConfigurationItem_optionsDict, Block_::tAddConfigurationItem_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tAddConfigurationItem_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tAddConfigurationItem_itemStruct, Block_::tAddConfigurationItem_itemStructDeployment_t >,
            CommonAPI::Deployable<Block::tAddConfigurationItem_optionsDict, Block_::tAddConfigurationItem_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "AddConfigurationItem",
        "(sa{s(yv)})a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_item, deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> BlockDBusProxy::AddConfigurationItemAsync(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, AddConfigurationItemAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tAddConfigurationItem_itemStruct, Block_::tAddConfigurationItem_itemStructDeployment_t> deploy_item(_item, static_cast<Block_::tAddConfigurationItem_itemStructDeployment_t*>(nullptr));
        CommonAPI::Deployable<Block::tAddConfigurationItem_optionsDict, Block_::tAddConfigurationItem_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tAddConfigurationItem_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tAddConfigurationItem_itemStruct, Block_::tAddConfigurationItem_itemStructDeployment_t >,
            CommonAPI::Deployable<Block::tAddConfigurationItem_optionsDict, Block_::tAddConfigurationItem_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "AddConfigurationItem",
        "(sa{s(yv)})a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_item, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void BlockDBusProxy::RemoveConfigurationItem(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tRemoveConfigurationItem_itemStruct, Block_::tRemoveConfigurationItem_itemStructDeployment_t> deploy_item(_item, static_cast<Block_::tRemoveConfigurationItem_itemStructDeployment_t*>(nullptr));
        CommonAPI::Deployable<Block::tRemoveConfigurationItem_optionsDict, Block_::tRemoveConfigurationItem_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tRemoveConfigurationItem_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tRemoveConfigurationItem_itemStruct, Block_::tRemoveConfigurationItem_itemStructDeployment_t >,
            CommonAPI::Deployable<Block::tRemoveConfigurationItem_optionsDict, Block_::tRemoveConfigurationItem_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "RemoveConfigurationItem",
        "(sa{s(yv)})a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_item, deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> BlockDBusProxy::RemoveConfigurationItemAsync(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, RemoveConfigurationItemAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tRemoveConfigurationItem_itemStruct, Block_::tRemoveConfigurationItem_itemStructDeployment_t> deploy_item(_item, static_cast<Block_::tRemoveConfigurationItem_itemStructDeployment_t*>(nullptr));
        CommonAPI::Deployable<Block::tRemoveConfigurationItem_optionsDict, Block_::tRemoveConfigurationItem_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tRemoveConfigurationItem_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tRemoveConfigurationItem_itemStruct, Block_::tRemoveConfigurationItem_itemStructDeployment_t >,
            CommonAPI::Deployable<Block::tRemoveConfigurationItem_optionsDict, Block_::tRemoveConfigurationItem_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "RemoveConfigurationItem",
        "(sa{s(yv)})a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_item, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void BlockDBusProxy::UpdateConfigurationItem(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tUpdateConfigurationItem_old_itemStruct, Block_::tUpdateConfigurationItem_old_itemStructDeployment_t> deploy_old_item(_old_item, static_cast<Block_::tUpdateConfigurationItem_old_itemStructDeployment_t*>(nullptr));
        CommonAPI::Deployable<Block::tUpdateConfigurationItem_new_itemStruct, Block_::tUpdateConfigurationItem_new_itemStructDeployment_t> deploy_new_item(_new_item, static_cast<Block_::tUpdateConfigurationItem_new_itemStructDeployment_t*>(nullptr));
        CommonAPI::Deployable<Block::tUpdateConfigurationItem_optionsDict, Block_::tUpdateConfigurationItem_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tUpdateConfigurationItem_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tUpdateConfigurationItem_old_itemStruct, Block_::tUpdateConfigurationItem_old_itemStructDeployment_t >,
            CommonAPI::Deployable<Block::tUpdateConfigurationItem_new_itemStruct, Block_::tUpdateConfigurationItem_new_itemStructDeployment_t >,
            CommonAPI::Deployable<Block::tUpdateConfigurationItem_optionsDict, Block_::tUpdateConfigurationItem_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "UpdateConfigurationItem",
        "(sa{s(yv)})(sa{s(yv)})a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_old_item, deploy_new_item, deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> BlockDBusProxy::UpdateConfigurationItemAsync(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, UpdateConfigurationItemAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tUpdateConfigurationItem_old_itemStruct, Block_::tUpdateConfigurationItem_old_itemStructDeployment_t> deploy_old_item(_old_item, static_cast<Block_::tUpdateConfigurationItem_old_itemStructDeployment_t*>(nullptr));
        CommonAPI::Deployable<Block::tUpdateConfigurationItem_new_itemStruct, Block_::tUpdateConfigurationItem_new_itemStructDeployment_t> deploy_new_item(_new_item, static_cast<Block_::tUpdateConfigurationItem_new_itemStructDeployment_t*>(nullptr));
        CommonAPI::Deployable<Block::tUpdateConfigurationItem_optionsDict, Block_::tUpdateConfigurationItem_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tUpdateConfigurationItem_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tUpdateConfigurationItem_old_itemStruct, Block_::tUpdateConfigurationItem_old_itemStructDeployment_t >,
            CommonAPI::Deployable<Block::tUpdateConfigurationItem_new_itemStruct, Block_::tUpdateConfigurationItem_new_itemStructDeployment_t >,
            CommonAPI::Deployable<Block::tUpdateConfigurationItem_optionsDict, Block_::tUpdateConfigurationItem_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "UpdateConfigurationItem",
        "(sa{s(yv)})(sa{s(yv)})a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_old_item, deploy_new_item, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void BlockDBusProxy::GetSecretConfiguration(const Block::tGetSecretConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::vector<Block::tGetSecretConfiguration_configurationStruct> &_configuration, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tGetSecretConfiguration_optionsDict, Block_::tGetSecretConfiguration_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tGetSecretConfiguration_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<std::vector<Block::tGetSecretConfiguration_configurationStruct>, CommonAPI::DBus::ArrayDeployment<Block_::tGetSecretConfiguration_configurationStructDeployment_t>> deploy_configuration(static_cast<CommonAPI::DBus::ArrayDeployment<Block_::tGetSecretConfiguration_configurationStructDeployment_t>*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tGetSecretConfiguration_optionsDict, Block_::tGetSecretConfiguration_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::vector<Block::tGetSecretConfiguration_configurationStruct>,CommonAPI::DBus::ArrayDeployment<Block_::tGetSecretConfiguration_configurationStructDeployment_t>>
            >
        	>::callMethodWithReply(
        *this,
        "GetSecretConfiguration",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus,
deploy_configuration);
_configuration = deploy_configuration.getValue();
}
    std::future<CommonAPI::CallStatus> BlockDBusProxy::GetSecretConfigurationAsync(const Block::tGetSecretConfiguration_optionsDict &_options, GetSecretConfigurationAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tGetSecretConfiguration_optionsDict, Block_::tGetSecretConfiguration_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tGetSecretConfiguration_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<std::vector<Block::tGetSecretConfiguration_configurationStruct>, CommonAPI::DBus::ArrayDeployment<Block_::tGetSecretConfiguration_configurationStructDeployment_t>> deploy_configuration(static_cast<CommonAPI::DBus::ArrayDeployment<Block_::tGetSecretConfiguration_configurationStructDeployment_t>*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tGetSecretConfiguration_optionsDict, Block_::tGetSecretConfiguration_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::vector<Block::tGetSecretConfiguration_configurationStruct>,CommonAPI::DBus::ArrayDeployment<Block_::tGetSecretConfiguration_configurationStructDeployment_t>>
            >
        	>::callMethodAsync(
        *this,
        "GetSecretConfiguration",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::vector<Block::tGetSecretConfiguration_configurationStruct>, CommonAPI::DBus::ArrayDeployment<Block_::tGetSecretConfiguration_configurationStructDeployment_t>> _configuration) {
        	if (_callback)
        		_callback(_internalCallStatus, _configuration.getValue());
        },
        std::make_tuple(deploy_configuration));
    }
    void BlockDBusProxy::Format(const std::string &_type, const Block::tFormat_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_type(_type, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Block::tFormat_optionsDict, Block_::tFormat_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tFormat_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Block::tFormat_optionsDict, Block_::tFormat_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "Format",
        "sa{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_type, deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> BlockDBusProxy::FormatAsync(const std::string &_type, const Block::tFormat_optionsDict &_options, FormatAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_type(_type, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Block::tFormat_optionsDict, Block_::tFormat_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tFormat_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Block::tFormat_optionsDict, Block_::tFormat_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "Format",
        "sa{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_type, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void BlockDBusProxy::OpenForBackup(const Block::tOpenForBackup_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tOpenForBackup_optionsDict, Block_::tOpenForBackup_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tOpenForBackup_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> deploy_fd(static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tOpenForBackup_optionsDict, Block_::tOpenForBackup_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint32_t,CommonAPI::EmptyDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "OpenForBackup",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus,
deploy_fd);
_fd = deploy_fd.getValue();
}
    std::future<CommonAPI::CallStatus> BlockDBusProxy::OpenForBackupAsync(const Block::tOpenForBackup_optionsDict &_options, OpenForBackupAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tOpenForBackup_optionsDict, Block_::tOpenForBackup_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tOpenForBackup_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> deploy_fd(static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tOpenForBackup_optionsDict, Block_::tOpenForBackup_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint32_t,CommonAPI::EmptyDeployment>
            >
        	>::callMethodAsync(
        *this,
        "OpenForBackup",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> _fd) {
        	if (_callback)
        		_callback(_internalCallStatus, _fd.getValue());
        },
        std::make_tuple(deploy_fd));
    }
    void BlockDBusProxy::OpenForRestore(const Block::tOpenForRestore_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tOpenForRestore_optionsDict, Block_::tOpenForRestore_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tOpenForRestore_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> deploy_fd(static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tOpenForRestore_optionsDict, Block_::tOpenForRestore_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint32_t,CommonAPI::EmptyDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "OpenForRestore",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus,
deploy_fd);
_fd = deploy_fd.getValue();
}
    std::future<CommonAPI::CallStatus> BlockDBusProxy::OpenForRestoreAsync(const Block::tOpenForRestore_optionsDict &_options, OpenForRestoreAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tOpenForRestore_optionsDict, Block_::tOpenForRestore_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tOpenForRestore_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> deploy_fd(static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tOpenForRestore_optionsDict, Block_::tOpenForRestore_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint32_t,CommonAPI::EmptyDeployment>
            >
        	>::callMethodAsync(
        *this,
        "OpenForRestore",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> _fd) {
        	if (_callback)
        		_callback(_internalCallStatus, _fd.getValue());
        },
        std::make_tuple(deploy_fd));
    }
    void BlockDBusProxy::OpenForBenchmark(const Block::tOpenForBenchmark_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tOpenForBenchmark_optionsDict, Block_::tOpenForBenchmark_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tOpenForBenchmark_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> deploy_fd(static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tOpenForBenchmark_optionsDict, Block_::tOpenForBenchmark_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint32_t,CommonAPI::EmptyDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "OpenForBenchmark",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus,
deploy_fd);
_fd = deploy_fd.getValue();
}
    std::future<CommonAPI::CallStatus> BlockDBusProxy::OpenForBenchmarkAsync(const Block::tOpenForBenchmark_optionsDict &_options, OpenForBenchmarkAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tOpenForBenchmark_optionsDict, Block_::tOpenForBenchmark_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tOpenForBenchmark_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> deploy_fd(static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tOpenForBenchmark_optionsDict, Block_::tOpenForBenchmark_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint32_t,CommonAPI::EmptyDeployment>
            >
        	>::callMethodAsync(
        *this,
        "OpenForBenchmark",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> _fd) {
        	if (_callback)
        		_callback(_internalCallStatus, _fd.getValue());
        },
        std::make_tuple(deploy_fd));
    }
    void BlockDBusProxy::Rescan(const Block::tRescan_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tRescan_optionsDict, Block_::tRescan_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tRescan_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tRescan_optionsDict, Block_::tRescan_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "Rescan",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> BlockDBusProxy::RescanAsync(const Block::tRescan_optionsDict &_options, RescanAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Block::tRescan_optionsDict, Block_::tRescan_optionsDictDeployment_t> deploy_options(_options, static_cast<Block_::tRescan_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Block::tRescan_optionsDict, Block_::tRescan_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "Rescan",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }


void BlockDBusProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
          ownVersionMajor = 2;
          ownVersionMinor = 1;
      }

      } // namespace UDisks2
      } // namespace freedesktop
      } // namespace org
      } // namespace v2
