/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Block_DBUS_PROXY_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Block_DBUS_PROXY_HPP_

#include <v2/org/freedesktop/UDisks2/BlockProxyBase.hpp>
#include "v2/org/freedesktop/UDisks2/BlockDBusDeployment.hpp"

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddress.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusProxy.hpp>
#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusAttribute.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

#include <string>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

class BlockDBusProxy
    : virtual public BlockProxyBase, 
      virtual public CommonAPI::DBus::DBusProxy {
public:
    BlockDBusProxy(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection);

    virtual ~BlockDBusProxy() { }

    virtual DeviceAttribute& getDeviceAttribute();
    virtual PreferredDeviceAttribute& getPreferredDeviceAttribute();
    virtual SymlinksAttribute& getSymlinksAttribute();
    virtual DeviceNumberAttribute& getDeviceNumberAttribute();
    virtual IdAttribute& getIdAttribute();
    virtual SizeAttribute& getSizeAttribute();
    virtual ReadOnlyAttribute& getReadOnlyAttribute();
    virtual DriveAttribute& getDriveAttribute();
    virtual MDRaidAttribute& getMDRaidAttribute();
    virtual MDRaidMemberAttribute& getMDRaidMemberAttribute();
    virtual IdUsageAttribute& getIdUsageAttribute();
    virtual IdTypeAttribute& getIdTypeAttribute();
    virtual IdVersionAttribute& getIdVersionAttribute();
    virtual IdLabelAttribute& getIdLabelAttribute();
    virtual IdUUIDAttribute& getIdUUIDAttribute();
    virtual ConfigurationAttribute& getConfigurationAttribute();
    virtual CryptoBackingDeviceAttribute& getCryptoBackingDeviceAttribute();
    virtual HintPartitionableAttribute& getHintPartitionableAttribute();
    virtual HintSystemAttribute& getHintSystemAttribute();
    virtual HintIgnoreAttribute& getHintIgnoreAttribute();
    virtual HintAutoAttribute& getHintAutoAttribute();
    virtual HintNameAttribute& getHintNameAttribute();
    virtual HintIconNameAttribute& getHintIconNameAttribute();
    virtual HintSymbolicIconNameAttribute& getHintSymbolicIconNameAttribute();


    virtual void AddConfigurationItem(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> AddConfigurationItemAsync(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, AddConfigurationItemAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void RemoveConfigurationItem(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> RemoveConfigurationItemAsync(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, RemoveConfigurationItemAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void UpdateConfigurationItem(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> UpdateConfigurationItemAsync(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, UpdateConfigurationItemAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void GetSecretConfiguration(const Block::tGetSecretConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::vector<Block::tGetSecretConfiguration_configurationStruct> &_configuration, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> GetSecretConfigurationAsync(const Block::tGetSecretConfiguration_optionsDict &_options, GetSecretConfigurationAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void Format(const std::string &_type, const Block::tFormat_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> FormatAsync(const std::string &_type, const Block::tFormat_optionsDict &_options, FormatAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void OpenForBackup(const Block::tOpenForBackup_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> OpenForBackupAsync(const Block::tOpenForBackup_optionsDict &_options, OpenForBackupAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void OpenForRestore(const Block::tOpenForRestore_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> OpenForRestoreAsync(const Block::tOpenForRestore_optionsDict &_options, OpenForRestoreAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void OpenForBenchmark(const Block::tOpenForBenchmark_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> OpenForBenchmarkAsync(const Block::tOpenForBenchmark_optionsDict &_options, OpenForBenchmarkAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void Rescan(const Block::tRescan_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> RescanAsync(const Block::tRescan_optionsDict &_options, RescanAsyncCallback _callback, const CommonAPI::CallInfo *_info);


    virtual void getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const;

private:
   
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<DeviceAttribute, CommonAPI::DBus::ArrayDeployment<CommonAPI::EmptyDeployment>>> device_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<PreferredDeviceAttribute, CommonAPI::DBus::ArrayDeployment<CommonAPI::EmptyDeployment>>> preferredDevice_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<SymlinksAttribute, CommonAPI::DBus::ArrayDeployment<Block_::tSymlinksArrayDeployment_t>>> symlinks_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<DeviceNumberAttribute>> deviceNumber_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<IdAttribute, CommonAPI::DBus::StringDeployment>> id_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<SizeAttribute>> size_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<ReadOnlyAttribute>> readOnly_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<DriveAttribute, CommonAPI::DBus::StringDeployment>> drive_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<MDRaidAttribute, CommonAPI::DBus::StringDeployment>> mDRaid_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<MDRaidMemberAttribute, CommonAPI::DBus::StringDeployment>> mDRaidMember_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<IdUsageAttribute, CommonAPI::DBus::StringDeployment>> idUsage_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<IdTypeAttribute, CommonAPI::DBus::StringDeployment>> idType_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<IdVersionAttribute, CommonAPI::DBus::StringDeployment>> idVersion_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<IdLabelAttribute, CommonAPI::DBus::StringDeployment>> idLabel_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<IdUUIDAttribute, CommonAPI::DBus::StringDeployment>> idUUID_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<ConfigurationAttribute, CommonAPI::DBus::ArrayDeployment<Block_::tConfigurationStructDeployment_t>>> configuration_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<CryptoBackingDeviceAttribute, CommonAPI::DBus::StringDeployment>> cryptoBackingDevice_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<HintPartitionableAttribute>> hintPartitionable_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<HintSystemAttribute>> hintSystem_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<HintIgnoreAttribute>> hintIgnore_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<HintAutoAttribute>> hintAuto_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<HintNameAttribute, CommonAPI::DBus::StringDeployment>> hintName_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<HintIconNameAttribute, CommonAPI::DBus::StringDeployment>> hintIconName_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<HintSymbolicIconNameAttribute, CommonAPI::DBus::StringDeployment>> hintSymbolicIconName_;


};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Block_DBUS_PROXY_HPP_

