/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Block_PROXY_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Block_PROXY_HPP_

#include <v2/org/freedesktop/UDisks2/BlockProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

template <typename ... _AttributeExtensions>
class BlockProxy
    : virtual public Block, 
      virtual public BlockProxyBase,
      virtual public _AttributeExtensions... {
public:
    BlockProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~BlockProxy();

    typedef Block InterfaceType;


    /**
     * Returns the wrapper class that provides access to the attribute Device.
     */
    virtual DeviceAttribute& getDeviceAttribute() {
        return delegate_->getDeviceAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute PreferredDevice.
     */
    virtual PreferredDeviceAttribute& getPreferredDeviceAttribute() {
        return delegate_->getPreferredDeviceAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Symlinks.
     */
    virtual SymlinksAttribute& getSymlinksAttribute() {
        return delegate_->getSymlinksAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute DeviceNumber.
     */
    virtual DeviceNumberAttribute& getDeviceNumberAttribute() {
        return delegate_->getDeviceNumberAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Id.
     */
    virtual IdAttribute& getIdAttribute() {
        return delegate_->getIdAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Size.
     */
    virtual SizeAttribute& getSizeAttribute() {
        return delegate_->getSizeAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute ReadOnly.
     */
    virtual ReadOnlyAttribute& getReadOnlyAttribute() {
        return delegate_->getReadOnlyAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Drive.
     */
    virtual DriveAttribute& getDriveAttribute() {
        return delegate_->getDriveAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute MDRaid.
     */
    virtual MDRaidAttribute& getMDRaidAttribute() {
        return delegate_->getMDRaidAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute MDRaidMember.
     */
    virtual MDRaidMemberAttribute& getMDRaidMemberAttribute() {
        return delegate_->getMDRaidMemberAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute IdUsage.
     */
    virtual IdUsageAttribute& getIdUsageAttribute() {
        return delegate_->getIdUsageAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute IdType.
     */
    virtual IdTypeAttribute& getIdTypeAttribute() {
        return delegate_->getIdTypeAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute IdVersion.
     */
    virtual IdVersionAttribute& getIdVersionAttribute() {
        return delegate_->getIdVersionAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute IdLabel.
     */
    virtual IdLabelAttribute& getIdLabelAttribute() {
        return delegate_->getIdLabelAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute IdUUID.
     */
    virtual IdUUIDAttribute& getIdUUIDAttribute() {
        return delegate_->getIdUUIDAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Configuration.
     */
    virtual ConfigurationAttribute& getConfigurationAttribute() {
        return delegate_->getConfigurationAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute CryptoBackingDevice.
     */
    virtual CryptoBackingDeviceAttribute& getCryptoBackingDeviceAttribute() {
        return delegate_->getCryptoBackingDeviceAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute HintPartitionable.
     */
    virtual HintPartitionableAttribute& getHintPartitionableAttribute() {
        return delegate_->getHintPartitionableAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute HintSystem.
     */
    virtual HintSystemAttribute& getHintSystemAttribute() {
        return delegate_->getHintSystemAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute HintIgnore.
     */
    virtual HintIgnoreAttribute& getHintIgnoreAttribute() {
        return delegate_->getHintIgnoreAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute HintAuto.
     */
    virtual HintAutoAttribute& getHintAutoAttribute() {
        return delegate_->getHintAutoAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute HintName.
     */
    virtual HintNameAttribute& getHintNameAttribute() {
        return delegate_->getHintNameAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute HintIconName.
     */
    virtual HintIconNameAttribute& getHintIconNameAttribute() {
        return delegate_->getHintIconNameAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute HintSymbolicIconName.
     */
    virtual HintSymbolicIconNameAttribute& getHintSymbolicIconNameAttribute() {
        return delegate_->getHintSymbolicIconNameAttribute();
    }


    /**
     * Calls AddConfigurationItem with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void AddConfigurationItem(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls AddConfigurationItem with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> AddConfigurationItemAsync(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, AddConfigurationItemAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls RemoveConfigurationItem with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void RemoveConfigurationItem(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls RemoveConfigurationItem with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> RemoveConfigurationItemAsync(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, RemoveConfigurationItemAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls UpdateConfigurationItem with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void UpdateConfigurationItem(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls UpdateConfigurationItem with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> UpdateConfigurationItemAsync(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, UpdateConfigurationItemAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls GetSecretConfiguration with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void GetSecretConfiguration(const Block::tGetSecretConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::vector<Block::tGetSecretConfiguration_configurationStruct> &_configuration, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls GetSecretConfiguration with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> GetSecretConfigurationAsync(const Block::tGetSecretConfiguration_optionsDict &_options, GetSecretConfigurationAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Format with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void Format(const std::string &_type, const Block::tFormat_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Format with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> FormatAsync(const std::string &_type, const Block::tFormat_optionsDict &_options, FormatAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls OpenForBackup with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void OpenForBackup(const Block::tOpenForBackup_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls OpenForBackup with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> OpenForBackupAsync(const Block::tOpenForBackup_optionsDict &_options, OpenForBackupAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls OpenForRestore with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void OpenForRestore(const Block::tOpenForRestore_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls OpenForRestore with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> OpenForRestoreAsync(const Block::tOpenForRestore_optionsDict &_options, OpenForRestoreAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls OpenForBenchmark with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void OpenForBenchmark(const Block::tOpenForBenchmark_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls OpenForBenchmark with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> OpenForBenchmarkAsync(const Block::tOpenForBenchmark_optionsDict &_options, OpenForBenchmarkAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Rescan with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void Rescan(const Block::tRescan_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Rescan with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> RescanAsync(const Block::tRescan_optionsDict &_options, RescanAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<BlockProxyBase> delegate_;
};

typedef BlockProxy<> BlockProxyDefault;

namespace BlockExtensions {
    template <template <typename > class _ExtensionType>
    class DeviceAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::DeviceAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::DeviceAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        DeviceAttributeExtension() {}
    #endif
    
        DeviceAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getDeviceAttribute()) {
        }
    
        inline extension_type& getDeviceAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class PreferredDeviceAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::PreferredDeviceAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::PreferredDeviceAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        PreferredDeviceAttributeExtension() {}
    #endif
    
        PreferredDeviceAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getPreferredDeviceAttribute()) {
        }
    
        inline extension_type& getPreferredDeviceAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class SymlinksAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::SymlinksAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::SymlinksAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        SymlinksAttributeExtension() {}
    #endif
    
        SymlinksAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getSymlinksAttribute()) {
        }
    
        inline extension_type& getSymlinksAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class DeviceNumberAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::DeviceNumberAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::DeviceNumberAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        DeviceNumberAttributeExtension() {}
    #endif
    
        DeviceNumberAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getDeviceNumberAttribute()) {
        }
    
        inline extension_type& getDeviceNumberAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class IdAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::IdAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::IdAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        IdAttributeExtension() {}
    #endif
    
        IdAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getIdAttribute()) {
        }
    
        inline extension_type& getIdAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class SizeAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::SizeAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::SizeAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        SizeAttributeExtension() {}
    #endif
    
        SizeAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getSizeAttribute()) {
        }
    
        inline extension_type& getSizeAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class ReadOnlyAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::ReadOnlyAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::ReadOnlyAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        ReadOnlyAttributeExtension() {}
    #endif
    
        ReadOnlyAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getReadOnlyAttribute()) {
        }
    
        inline extension_type& getReadOnlyAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class DriveAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::DriveAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::DriveAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        DriveAttributeExtension() {}
    #endif
    
        DriveAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getDriveAttribute()) {
        }
    
        inline extension_type& getDriveAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class MDRaidAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::MDRaidAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::MDRaidAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        MDRaidAttributeExtension() {}
    #endif
    
        MDRaidAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getMDRaidAttribute()) {
        }
    
        inline extension_type& getMDRaidAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class MDRaidMemberAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::MDRaidMemberAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::MDRaidMemberAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        MDRaidMemberAttributeExtension() {}
    #endif
    
        MDRaidMemberAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getMDRaidMemberAttribute()) {
        }
    
        inline extension_type& getMDRaidMemberAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class IdUsageAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::IdUsageAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::IdUsageAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        IdUsageAttributeExtension() {}
    #endif
    
        IdUsageAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getIdUsageAttribute()) {
        }
    
        inline extension_type& getIdUsageAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class IdTypeAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::IdTypeAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::IdTypeAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        IdTypeAttributeExtension() {}
    #endif
    
        IdTypeAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getIdTypeAttribute()) {
        }
    
        inline extension_type& getIdTypeAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class IdVersionAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::IdVersionAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::IdVersionAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        IdVersionAttributeExtension() {}
    #endif
    
        IdVersionAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getIdVersionAttribute()) {
        }
    
        inline extension_type& getIdVersionAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class IdLabelAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::IdLabelAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::IdLabelAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        IdLabelAttributeExtension() {}
    #endif
    
        IdLabelAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getIdLabelAttribute()) {
        }
    
        inline extension_type& getIdLabelAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class IdUUIDAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::IdUUIDAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::IdUUIDAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        IdUUIDAttributeExtension() {}
    #endif
    
        IdUUIDAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getIdUUIDAttribute()) {
        }
    
        inline extension_type& getIdUUIDAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class ConfigurationAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::ConfigurationAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::ConfigurationAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        ConfigurationAttributeExtension() {}
    #endif
    
        ConfigurationAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getConfigurationAttribute()) {
        }
    
        inline extension_type& getConfigurationAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class CryptoBackingDeviceAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::CryptoBackingDeviceAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::CryptoBackingDeviceAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        CryptoBackingDeviceAttributeExtension() {}
    #endif
    
        CryptoBackingDeviceAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getCryptoBackingDeviceAttribute()) {
        }
    
        inline extension_type& getCryptoBackingDeviceAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class HintPartitionableAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::HintPartitionableAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::HintPartitionableAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        HintPartitionableAttributeExtension() {}
    #endif
    
        HintPartitionableAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getHintPartitionableAttribute()) {
        }
    
        inline extension_type& getHintPartitionableAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class HintSystemAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::HintSystemAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::HintSystemAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        HintSystemAttributeExtension() {}
    #endif
    
        HintSystemAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getHintSystemAttribute()) {
        }
    
        inline extension_type& getHintSystemAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class HintIgnoreAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::HintIgnoreAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::HintIgnoreAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        HintIgnoreAttributeExtension() {}
    #endif
    
        HintIgnoreAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getHintIgnoreAttribute()) {
        }
    
        inline extension_type& getHintIgnoreAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class HintAutoAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::HintAutoAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::HintAutoAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        HintAutoAttributeExtension() {}
    #endif
    
        HintAutoAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getHintAutoAttribute()) {
        }
    
        inline extension_type& getHintAutoAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class HintNameAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::HintNameAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::HintNameAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        HintNameAttributeExtension() {}
    #endif
    
        HintNameAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getHintNameAttribute()) {
        }
    
        inline extension_type& getHintNameAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class HintIconNameAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::HintIconNameAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::HintIconNameAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        HintIconNameAttributeExtension() {}
    #endif
    
        HintIconNameAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getHintIconNameAttribute()) {
        }
    
        inline extension_type& getHintIconNameAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class HintSymbolicIconNameAttributeExtension {
     public:
        typedef _ExtensionType<BlockProxyBase::HintSymbolicIconNameAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<BlockProxyBase::HintSymbolicIconNameAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        HintSymbolicIconNameAttributeExtension() {}
    #endif
    
        HintSymbolicIconNameAttributeExtension(BlockProxyBase& proxy): attributeExtension_(proxy.getHintSymbolicIconNameAttribute()) {
        }
    
        inline extension_type& getHintSymbolicIconNameAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace BlockExtensions

//
// BlockProxy Implementation
//
template <typename ... _AttributeExtensions>
BlockProxy<_AttributeExtensions...>::BlockProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<BlockProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<BlockProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
BlockProxy<_AttributeExtensions...>::~BlockProxy() {
}

template <typename ... _AttributeExtensions>
void BlockProxy<_AttributeExtensions...>::AddConfigurationItem(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->AddConfigurationItem(_item, _options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> BlockProxy<_AttributeExtensions...>::AddConfigurationItemAsync(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, AddConfigurationItemAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->AddConfigurationItemAsync(_item, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void BlockProxy<_AttributeExtensions...>::RemoveConfigurationItem(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->RemoveConfigurationItem(_item, _options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> BlockProxy<_AttributeExtensions...>::RemoveConfigurationItemAsync(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, RemoveConfigurationItemAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->RemoveConfigurationItemAsync(_item, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void BlockProxy<_AttributeExtensions...>::UpdateConfigurationItem(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->UpdateConfigurationItem(_old_item, _new_item, _options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> BlockProxy<_AttributeExtensions...>::UpdateConfigurationItemAsync(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, UpdateConfigurationItemAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->UpdateConfigurationItemAsync(_old_item, _new_item, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void BlockProxy<_AttributeExtensions...>::GetSecretConfiguration(const Block::tGetSecretConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::vector<Block::tGetSecretConfiguration_configurationStruct> &_configuration, const CommonAPI::CallInfo *_info) {
    delegate_->GetSecretConfiguration(_options, _internalCallStatus, _configuration, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> BlockProxy<_AttributeExtensions...>::GetSecretConfigurationAsync(const Block::tGetSecretConfiguration_optionsDict &_options, GetSecretConfigurationAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->GetSecretConfigurationAsync(_options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void BlockProxy<_AttributeExtensions...>::Format(const std::string &_type, const Block::tFormat_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->Format(_type, _options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> BlockProxy<_AttributeExtensions...>::FormatAsync(const std::string &_type, const Block::tFormat_optionsDict &_options, FormatAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->FormatAsync(_type, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void BlockProxy<_AttributeExtensions...>::OpenForBackup(const Block::tOpenForBackup_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info) {
    delegate_->OpenForBackup(_options, _internalCallStatus, _fd, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> BlockProxy<_AttributeExtensions...>::OpenForBackupAsync(const Block::tOpenForBackup_optionsDict &_options, OpenForBackupAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->OpenForBackupAsync(_options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void BlockProxy<_AttributeExtensions...>::OpenForRestore(const Block::tOpenForRestore_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info) {
    delegate_->OpenForRestore(_options, _internalCallStatus, _fd, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> BlockProxy<_AttributeExtensions...>::OpenForRestoreAsync(const Block::tOpenForRestore_optionsDict &_options, OpenForRestoreAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->OpenForRestoreAsync(_options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void BlockProxy<_AttributeExtensions...>::OpenForBenchmark(const Block::tOpenForBenchmark_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info) {
    delegate_->OpenForBenchmark(_options, _internalCallStatus, _fd, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> BlockProxy<_AttributeExtensions...>::OpenForBenchmarkAsync(const Block::tOpenForBenchmark_optionsDict &_options, OpenForBenchmarkAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->OpenForBenchmarkAsync(_options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void BlockProxy<_AttributeExtensions...>::Rescan(const Block::tRescan_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->Rescan(_options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> BlockProxy<_AttributeExtensions...>::RescanAsync(const Block::tRescan_optionsDict &_options, RescanAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->RescanAsync(_options, _callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &BlockProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool BlockProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool BlockProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& BlockProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& BlockProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::v2::org::freedesktop::UDisks2::BlockProxy,
    _AttributeExtension> {
    typedef typename ::v2::org::freedesktop::UDisks2::BlockProxy<
            ::v2::org::freedesktop::UDisks2::BlockExtensions::DeviceAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::PreferredDeviceAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::SymlinksAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::DeviceNumberAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::IdAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::SizeAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::ReadOnlyAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::DriveAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::MDRaidAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::MDRaidMemberAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::IdUsageAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::IdTypeAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::IdVersionAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::IdLabelAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::IdUUIDAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::ConfigurationAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::CryptoBackingDeviceAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::HintPartitionableAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::HintSystemAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::HintIgnoreAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::HintAutoAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::HintNameAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::HintIconNameAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::BlockExtensions::HintSymbolicIconNameAttributeExtension<_AttributeExtension>
    > class_t;
};
}


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Block_PROXY_HPP_
