/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Block_PROXY_BASE_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Block_PROXY_BASE_HPP_

#include <v2/org/freedesktop/UDisks2/Block.hpp>



#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <cstdint>
#include <string>
#include <unordered_map>
#include <vector>

#include <CommonAPI/Attribute.hpp>
#include <CommonAPI/Proxy.hpp>
#include <functional>
#include <future>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

class BlockProxyBase
    : virtual public CommonAPI::Proxy {
public:
    typedef CommonAPI::ObservableAttribute<std::vector<uint8_t>> DeviceAttribute;
    typedef CommonAPI::ObservableAttribute<std::vector<uint8_t>> PreferredDeviceAttribute;
    typedef CommonAPI::ObservableAttribute<std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray>> SymlinksAttribute;
    typedef CommonAPI::ObservableAttribute<uint64_t> DeviceNumberAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> IdAttribute;
    typedef CommonAPI::ObservableAttribute<uint64_t> SizeAttribute;
    typedef CommonAPI::ObservableAttribute<bool> ReadOnlyAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> DriveAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> MDRaidAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> MDRaidMemberAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> IdUsageAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> IdTypeAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> IdVersionAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> IdLabelAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> IdUUIDAttribute;
    typedef CommonAPI::ObservableAttribute<std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct>> ConfigurationAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> CryptoBackingDeviceAttribute;
    typedef CommonAPI::ObservableAttribute<bool> HintPartitionableAttribute;
    typedef CommonAPI::ObservableAttribute<bool> HintSystemAttribute;
    typedef CommonAPI::ObservableAttribute<bool> HintIgnoreAttribute;
    typedef CommonAPI::ObservableAttribute<bool> HintAutoAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> HintNameAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> HintIconNameAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> HintSymbolicIconNameAttribute;

    typedef std::function<void(const CommonAPI::CallStatus&)> AddConfigurationItemAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> RemoveConfigurationItemAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> UpdateConfigurationItemAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const std::vector<Block::tGetSecretConfiguration_configurationStruct>&)> GetSecretConfigurationAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> FormatAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const uint32_t&)> OpenForBackupAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const uint32_t&)> OpenForRestoreAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const uint32_t&)> OpenForBenchmarkAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> RescanAsyncCallback;

    virtual DeviceAttribute& getDeviceAttribute() = 0;
    virtual PreferredDeviceAttribute& getPreferredDeviceAttribute() = 0;
    virtual SymlinksAttribute& getSymlinksAttribute() = 0;
    virtual DeviceNumberAttribute& getDeviceNumberAttribute() = 0;
    virtual IdAttribute& getIdAttribute() = 0;
    virtual SizeAttribute& getSizeAttribute() = 0;
    virtual ReadOnlyAttribute& getReadOnlyAttribute() = 0;
    virtual DriveAttribute& getDriveAttribute() = 0;
    virtual MDRaidAttribute& getMDRaidAttribute() = 0;
    virtual MDRaidMemberAttribute& getMDRaidMemberAttribute() = 0;
    virtual IdUsageAttribute& getIdUsageAttribute() = 0;
    virtual IdTypeAttribute& getIdTypeAttribute() = 0;
    virtual IdVersionAttribute& getIdVersionAttribute() = 0;
    virtual IdLabelAttribute& getIdLabelAttribute() = 0;
    virtual IdUUIDAttribute& getIdUUIDAttribute() = 0;
    virtual ConfigurationAttribute& getConfigurationAttribute() = 0;
    virtual CryptoBackingDeviceAttribute& getCryptoBackingDeviceAttribute() = 0;
    virtual HintPartitionableAttribute& getHintPartitionableAttribute() = 0;
    virtual HintSystemAttribute& getHintSystemAttribute() = 0;
    virtual HintIgnoreAttribute& getHintIgnoreAttribute() = 0;
    virtual HintAutoAttribute& getHintAutoAttribute() = 0;
    virtual HintNameAttribute& getHintNameAttribute() = 0;
    virtual HintIconNameAttribute& getHintIconNameAttribute() = 0;
    virtual HintSymbolicIconNameAttribute& getHintSymbolicIconNameAttribute() = 0;


    virtual void AddConfigurationItem(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> AddConfigurationItemAsync(const Block::tAddConfigurationItem_itemStruct &_item, const Block::tAddConfigurationItem_optionsDict &_options, AddConfigurationItemAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void RemoveConfigurationItem(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> RemoveConfigurationItemAsync(const Block::tRemoveConfigurationItem_itemStruct &_item, const Block::tRemoveConfigurationItem_optionsDict &_options, RemoveConfigurationItemAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void UpdateConfigurationItem(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> UpdateConfigurationItemAsync(const Block::tUpdateConfigurationItem_old_itemStruct &_old_item, const Block::tUpdateConfigurationItem_new_itemStruct &_new_item, const Block::tUpdateConfigurationItem_optionsDict &_options, UpdateConfigurationItemAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void GetSecretConfiguration(const Block::tGetSecretConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::vector<Block::tGetSecretConfiguration_configurationStruct> &_configuration, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> GetSecretConfigurationAsync(const Block::tGetSecretConfiguration_optionsDict &_options, GetSecretConfigurationAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void Format(const std::string &_type, const Block::tFormat_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> FormatAsync(const std::string &_type, const Block::tFormat_optionsDict &_options, FormatAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void OpenForBackup(const Block::tOpenForBackup_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> OpenForBackupAsync(const Block::tOpenForBackup_optionsDict &_options, OpenForBackupAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void OpenForRestore(const Block::tOpenForRestore_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> OpenForRestoreAsync(const Block::tOpenForRestore_optionsDict &_options, OpenForRestoreAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void OpenForBenchmark(const Block::tOpenForBenchmark_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, uint32_t &_fd, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> OpenForBenchmarkAsync(const Block::tOpenForBenchmark_optionsDict &_options, OpenForBenchmarkAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void Rescan(const Block::tRescan_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> RescanAsync(const Block::tRescan_optionsDict &_options, RescanAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Block_PROXY_BASE_HPP_
