/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Block_STUB_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Block_STUB_HPP_

#include <functional>




#include <v2/org/freedesktop/UDisks2/Block.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <cstdint>
#include <string>
#include <unordered_map>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Block. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class BlockStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual Block {
 public:
    ///Notifies all remote listeners about a change of value of the attribute Device.
    virtual void fireDeviceAttributeChanged(const std::vector<uint8_t>& Device) = 0;
    ///Notifies all remote listeners about a change of value of the attribute PreferredDevice.
    virtual void firePreferredDeviceAttributeChanged(const std::vector<uint8_t>& PreferredDevice) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Symlinks.
    virtual void fireSymlinksAttributeChanged(const std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray>& Symlinks) = 0;
    ///Notifies all remote listeners about a change of value of the attribute DeviceNumber.
    virtual void fireDeviceNumberAttributeChanged(const uint64_t& DeviceNumber) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Id.
    virtual void fireIdAttributeChanged(const std::string& Id) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Size.
    virtual void fireSizeAttributeChanged(const uint64_t& Size) = 0;
    ///Notifies all remote listeners about a change of value of the attribute ReadOnly.
    virtual void fireReadOnlyAttributeChanged(const bool& ReadOnly) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Drive.
    virtual void fireDriveAttributeChanged(const std::string& Drive) = 0;
    ///Notifies all remote listeners about a change of value of the attribute MDRaid.
    virtual void fireMDRaidAttributeChanged(const std::string& MDRaid) = 0;
    ///Notifies all remote listeners about a change of value of the attribute MDRaidMember.
    virtual void fireMDRaidMemberAttributeChanged(const std::string& MDRaidMember) = 0;
    ///Notifies all remote listeners about a change of value of the attribute IdUsage.
    virtual void fireIdUsageAttributeChanged(const std::string& IdUsage) = 0;
    ///Notifies all remote listeners about a change of value of the attribute IdType.
    virtual void fireIdTypeAttributeChanged(const std::string& IdType) = 0;
    ///Notifies all remote listeners about a change of value of the attribute IdVersion.
    virtual void fireIdVersionAttributeChanged(const std::string& IdVersion) = 0;
    ///Notifies all remote listeners about a change of value of the attribute IdLabel.
    virtual void fireIdLabelAttributeChanged(const std::string& IdLabel) = 0;
    ///Notifies all remote listeners about a change of value of the attribute IdUUID.
    virtual void fireIdUUIDAttributeChanged(const std::string& IdUUID) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Configuration.
    virtual void fireConfigurationAttributeChanged(const std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct>& Configuration) = 0;
    ///Notifies all remote listeners about a change of value of the attribute CryptoBackingDevice.
    virtual void fireCryptoBackingDeviceAttributeChanged(const std::string& CryptoBackingDevice) = 0;
    ///Notifies all remote listeners about a change of value of the attribute HintPartitionable.
    virtual void fireHintPartitionableAttributeChanged(const bool& HintPartitionable) = 0;
    ///Notifies all remote listeners about a change of value of the attribute HintSystem.
    virtual void fireHintSystemAttributeChanged(const bool& HintSystem) = 0;
    ///Notifies all remote listeners about a change of value of the attribute HintIgnore.
    virtual void fireHintIgnoreAttributeChanged(const bool& HintIgnore) = 0;
    ///Notifies all remote listeners about a change of value of the attribute HintAuto.
    virtual void fireHintAutoAttributeChanged(const bool& HintAuto) = 0;
    ///Notifies all remote listeners about a change of value of the attribute HintName.
    virtual void fireHintNameAttributeChanged(const std::string& HintName) = 0;
    ///Notifies all remote listeners about a change of value of the attribute HintIconName.
    virtual void fireHintIconNameAttributeChanged(const std::string& HintIconName) = 0;
    ///Notifies all remote listeners about a change of value of the attribute HintSymbolicIconName.
    virtual void fireHintSymbolicIconNameAttributeChanged(const std::string& HintSymbolicIconName) = 0;



    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Block.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class BlockStubRemoteEvent
{
public:
    virtual ~BlockStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute Device
    virtual bool onRemoteSetDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<uint8_t> _value) = 0;
    /// Action callback for remote set requests on the attribute Device
    virtual void onRemoteDeviceAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute PreferredDevice
    virtual bool onRemoteSetPreferredDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<uint8_t> _value) = 0;
    /// Action callback for remote set requests on the attribute PreferredDevice
    virtual void onRemotePreferredDeviceAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Symlinks
    virtual bool onRemoteSetSymlinksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray> _value) = 0;
    /// Action callback for remote set requests on the attribute Symlinks
    virtual void onRemoteSymlinksAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute DeviceNumber
    virtual bool onRemoteSetDeviceNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) = 0;
    /// Action callback for remote set requests on the attribute DeviceNumber
    virtual void onRemoteDeviceNumberAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Id
    virtual bool onRemoteSetIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Id
    virtual void onRemoteIdAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Size
    virtual bool onRemoteSetSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) = 0;
    /// Action callback for remote set requests on the attribute Size
    virtual void onRemoteSizeAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute ReadOnly
    virtual bool onRemoteSetReadOnlyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute ReadOnly
    virtual void onRemoteReadOnlyAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Drive
    virtual bool onRemoteSetDriveAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Drive
    virtual void onRemoteDriveAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute MDRaid
    virtual bool onRemoteSetMDRaidAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute MDRaid
    virtual void onRemoteMDRaidAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute MDRaidMember
    virtual bool onRemoteSetMDRaidMemberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute MDRaidMember
    virtual void onRemoteMDRaidMemberAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute IdUsage
    virtual bool onRemoteSetIdUsageAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute IdUsage
    virtual void onRemoteIdUsageAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute IdType
    virtual bool onRemoteSetIdTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute IdType
    virtual void onRemoteIdTypeAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute IdVersion
    virtual bool onRemoteSetIdVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute IdVersion
    virtual void onRemoteIdVersionAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute IdLabel
    virtual bool onRemoteSetIdLabelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute IdLabel
    virtual void onRemoteIdLabelAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute IdUUID
    virtual bool onRemoteSetIdUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute IdUUID
    virtual void onRemoteIdUUIDAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Configuration
    virtual bool onRemoteSetConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct> _value) = 0;
    /// Action callback for remote set requests on the attribute Configuration
    virtual void onRemoteConfigurationAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute CryptoBackingDevice
    virtual bool onRemoteSetCryptoBackingDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute CryptoBackingDevice
    virtual void onRemoteCryptoBackingDeviceAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute HintPartitionable
    virtual bool onRemoteSetHintPartitionableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute HintPartitionable
    virtual void onRemoteHintPartitionableAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute HintSystem
    virtual bool onRemoteSetHintSystemAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute HintSystem
    virtual void onRemoteHintSystemAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute HintIgnore
    virtual bool onRemoteSetHintIgnoreAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute HintIgnore
    virtual void onRemoteHintIgnoreAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute HintAuto
    virtual bool onRemoteSetHintAutoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute HintAuto
    virtual void onRemoteHintAutoAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute HintName
    virtual bool onRemoteSetHintNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute HintName
    virtual void onRemoteHintNameAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute HintIconName
    virtual bool onRemoteSetHintIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute HintIconName
    virtual void onRemoteHintIconNameAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute HintSymbolicIconName
    virtual bool onRemoteSetHintSymbolicIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute HintSymbolicIconName
    virtual void onRemoteHintSymbolicIconNameAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Block to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class BlockStub
    : public virtual CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>
{
public:
    typedef std::function<void ()>AddConfigurationItemReply_t;
    typedef std::function<void ()>RemoveConfigurationItemReply_t;
    typedef std::function<void ()>UpdateConfigurationItemReply_t;
    typedef std::function<void (std::vector<Block::tGetSecretConfiguration_configurationStruct> _configuration)>GetSecretConfigurationReply_t;
    typedef std::function<void ()>FormatReply_t;
    typedef std::function<void (uint32_t _fd)>OpenForBackupReply_t;
    typedef std::function<void (uint32_t _fd)>OpenForRestoreReply_t;
    typedef std::function<void (uint32_t _fd)>OpenForBenchmarkReply_t;
    typedef std::function<void ()>RescanReply_t;

    virtual ~BlockStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute Device
    virtual const std::vector<uint8_t> &getDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute PreferredDevice
    virtual const std::vector<uint8_t> &getPreferredDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Symlinks
    virtual const std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray> &getSymlinksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute DeviceNumber
    virtual const uint64_t &getDeviceNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Id
    virtual const std::string &getIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Size
    virtual const uint64_t &getSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute ReadOnly
    virtual const bool &getReadOnlyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Drive
    virtual const std::string &getDriveAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute MDRaid
    virtual const std::string &getMDRaidAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute MDRaidMember
    virtual const std::string &getMDRaidMemberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute IdUsage
    virtual const std::string &getIdUsageAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute IdType
    virtual const std::string &getIdTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute IdVersion
    virtual const std::string &getIdVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute IdLabel
    virtual const std::string &getIdLabelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute IdUUID
    virtual const std::string &getIdUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Configuration
    virtual const std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct> &getConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute CryptoBackingDevice
    virtual const std::string &getCryptoBackingDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute HintPartitionable
    virtual const bool &getHintPartitionableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute HintSystem
    virtual const bool &getHintSystemAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute HintIgnore
    virtual const bool &getHintIgnoreAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute HintAuto
    virtual const bool &getHintAutoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute HintName
    virtual const std::string &getHintNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute HintIconName
    virtual const std::string &getHintIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute HintSymbolicIconName
    virtual const std::string &getHintSymbolicIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /// This is the method that will be called on remote calls on the method AddConfigurationItem.
    virtual void AddConfigurationItem(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tAddConfigurationItem_itemStruct _item, Block::tAddConfigurationItem_optionsDict _options, AddConfigurationItemReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method RemoveConfigurationItem.
    virtual void RemoveConfigurationItem(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tRemoveConfigurationItem_itemStruct _item, Block::tRemoveConfigurationItem_optionsDict _options, RemoveConfigurationItemReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method UpdateConfigurationItem.
    virtual void UpdateConfigurationItem(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tUpdateConfigurationItem_old_itemStruct _old_item, Block::tUpdateConfigurationItem_new_itemStruct _new_item, Block::tUpdateConfigurationItem_optionsDict _options, UpdateConfigurationItemReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method GetSecretConfiguration.
    virtual void GetSecretConfiguration(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tGetSecretConfiguration_optionsDict _options, GetSecretConfigurationReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method Format.
    virtual void Format(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _type, Block::tFormat_optionsDict _options, FormatReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method OpenForBackup.
    virtual void OpenForBackup(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tOpenForBackup_optionsDict _options, OpenForBackupReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method OpenForRestore.
    virtual void OpenForRestore(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tOpenForRestore_optionsDict _options, OpenForRestoreReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method OpenForBenchmark.
    virtual void OpenForBenchmark(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tOpenForBenchmark_optionsDict _options, OpenForBenchmarkReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method Rescan.
    virtual void Rescan(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tRescan_optionsDict _options, RescanReply_t _reply) = 0;

    using CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef BlockStubRemoteEvent RemoteEventType;
    typedef Block StubInterface;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Block_STUB_HPP_
