/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/BlockStubDefault.hpp>
#include <assert.h>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

BlockStubDefault::BlockStubDefault():
        remoteEventHandler_(this),
        interfaceVersion_(Block::getInterfaceVersion()) {
}

const CommonAPI::Version& BlockStubDefault::getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return interfaceVersion_;
}

BlockStubRemoteEvent* BlockStubDefault::initStubAdapter(const std::shared_ptr<BlockStubAdapter> &_adapter) {
    CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_ = _adapter;
    return &remoteEventHandler_;
}

const std::vector<uint8_t>& BlockStubDefault::getDeviceAttribute() {
    return deviceAttributeValue_;
}

const std::vector<uint8_t>& BlockStubDefault::getDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getDeviceAttribute();
}

void BlockStubDefault::setDeviceAttribute(std::vector<uint8_t> _value) {
    const bool valueChanged = trySetDeviceAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireDeviceAttributeChanged(deviceAttributeValue_);
    }
}

bool BlockStubDefault::trySetDeviceAttribute(std::vector<uint8_t> _value) {
    if (!validateDeviceAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (deviceAttributeValue_ != _value);
    deviceAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateDeviceAttributeRequestedValue(const std::vector<uint8_t> &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<uint8_t> _value) {
    (void)_client;
    setDeviceAttribute(_value);
}

void BlockStubDefault::onRemoteDeviceAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteDeviceAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteDeviceAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetDeviceAttribute(std::vector<uint8_t> _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetDeviceAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<uint8_t> _value) {
    (void)_client;
    return onRemoteSetDeviceAttribute(_value);
}

const std::vector<uint8_t>& BlockStubDefault::getPreferredDeviceAttribute() {
    return preferredDeviceAttributeValue_;
}

const std::vector<uint8_t>& BlockStubDefault::getPreferredDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getPreferredDeviceAttribute();
}

void BlockStubDefault::setPreferredDeviceAttribute(std::vector<uint8_t> _value) {
    const bool valueChanged = trySetPreferredDeviceAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->firePreferredDeviceAttributeChanged(preferredDeviceAttributeValue_);
    }
}

bool BlockStubDefault::trySetPreferredDeviceAttribute(std::vector<uint8_t> _value) {
    if (!validatePreferredDeviceAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (preferredDeviceAttributeValue_ != _value);
    preferredDeviceAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validatePreferredDeviceAttributeRequestedValue(const std::vector<uint8_t> &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setPreferredDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<uint8_t> _value) {
    (void)_client;
    setPreferredDeviceAttribute(_value);
}

void BlockStubDefault::onRemotePreferredDeviceAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemotePreferredDeviceAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemotePreferredDeviceAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetPreferredDeviceAttribute(std::vector<uint8_t> _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetPreferredDeviceAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetPreferredDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<uint8_t> _value) {
    (void)_client;
    return onRemoteSetPreferredDeviceAttribute(_value);
}

const std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray>& BlockStubDefault::getSymlinksAttribute() {
    return symlinksAttributeValue_;
}

const std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray>& BlockStubDefault::getSymlinksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getSymlinksAttribute();
}

void BlockStubDefault::setSymlinksAttribute(std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray> _value) {
    const bool valueChanged = trySetSymlinksAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireSymlinksAttributeChanged(symlinksAttributeValue_);
    }
}

bool BlockStubDefault::trySetSymlinksAttribute(std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray> _value) {
    if (!validateSymlinksAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (symlinksAttributeValue_ != _value);
    symlinksAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateSymlinksAttributeRequestedValue(const std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray> &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setSymlinksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray> _value) {
    (void)_client;
    setSymlinksAttribute(_value);
}

void BlockStubDefault::onRemoteSymlinksAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteSymlinksAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteSymlinksAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetSymlinksAttribute(std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray> _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetSymlinksAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetSymlinksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Block::tSymlinksArray> _value) {
    (void)_client;
    return onRemoteSetSymlinksAttribute(_value);
}

const uint64_t& BlockStubDefault::getDeviceNumberAttribute() {
    return deviceNumberAttributeValue_;
}

const uint64_t& BlockStubDefault::getDeviceNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getDeviceNumberAttribute();
}

void BlockStubDefault::setDeviceNumberAttribute(uint64_t _value) {
    const bool valueChanged = trySetDeviceNumberAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireDeviceNumberAttributeChanged(deviceNumberAttributeValue_);
    }
}

bool BlockStubDefault::trySetDeviceNumberAttribute(uint64_t _value) {
    if (!validateDeviceNumberAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (deviceNumberAttributeValue_ != _value);
    deviceNumberAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateDeviceNumberAttributeRequestedValue(const uint64_t &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setDeviceNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    setDeviceNumberAttribute(_value);
}

void BlockStubDefault::onRemoteDeviceNumberAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteDeviceNumberAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteDeviceNumberAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetDeviceNumberAttribute(uint64_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetDeviceNumberAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetDeviceNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    return onRemoteSetDeviceNumberAttribute(_value);
}

const std::string& BlockStubDefault::getIdAttribute() {
    return idAttributeValue_;
}

const std::string& BlockStubDefault::getIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getIdAttribute();
}

void BlockStubDefault::setIdAttribute(std::string _value) {
    const bool valueChanged = trySetIdAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireIdAttributeChanged(idAttributeValue_);
    }
}

bool BlockStubDefault::trySetIdAttribute(std::string _value) {
    if (!validateIdAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (idAttributeValue_ != _value);
    idAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateIdAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setIdAttribute(_value);
}

void BlockStubDefault::onRemoteIdAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteIdAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteIdAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetIdAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetIdAttribute(_value);
}

const uint64_t& BlockStubDefault::getSizeAttribute() {
    return sizeAttributeValue_;
}

const uint64_t& BlockStubDefault::getSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getSizeAttribute();
}

void BlockStubDefault::setSizeAttribute(uint64_t _value) {
    const bool valueChanged = trySetSizeAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireSizeAttributeChanged(sizeAttributeValue_);
    }
}

bool BlockStubDefault::trySetSizeAttribute(uint64_t _value) {
    if (!validateSizeAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (sizeAttributeValue_ != _value);
    sizeAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateSizeAttributeRequestedValue(const uint64_t &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    setSizeAttribute(_value);
}

void BlockStubDefault::onRemoteSizeAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteSizeAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteSizeAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetSizeAttribute(uint64_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetSizeAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    return onRemoteSetSizeAttribute(_value);
}

const bool& BlockStubDefault::getReadOnlyAttribute() {
    return readOnlyAttributeValue_;
}

const bool& BlockStubDefault::getReadOnlyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getReadOnlyAttribute();
}

void BlockStubDefault::setReadOnlyAttribute(bool _value) {
    const bool valueChanged = trySetReadOnlyAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireReadOnlyAttributeChanged(readOnlyAttributeValue_);
    }
}

bool BlockStubDefault::trySetReadOnlyAttribute(bool _value) {
    if (!validateReadOnlyAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (readOnlyAttributeValue_ != _value);
    readOnlyAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateReadOnlyAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setReadOnlyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setReadOnlyAttribute(_value);
}

void BlockStubDefault::onRemoteReadOnlyAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteReadOnlyAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteReadOnlyAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetReadOnlyAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetReadOnlyAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetReadOnlyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetReadOnlyAttribute(_value);
}

const std::string& BlockStubDefault::getDriveAttribute() {
    return driveAttributeValue_;
}

const std::string& BlockStubDefault::getDriveAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getDriveAttribute();
}

void BlockStubDefault::setDriveAttribute(std::string _value) {
    const bool valueChanged = trySetDriveAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireDriveAttributeChanged(driveAttributeValue_);
    }
}

bool BlockStubDefault::trySetDriveAttribute(std::string _value) {
    if (!validateDriveAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (driveAttributeValue_ != _value);
    driveAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateDriveAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setDriveAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setDriveAttribute(_value);
}

void BlockStubDefault::onRemoteDriveAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteDriveAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteDriveAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetDriveAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetDriveAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetDriveAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetDriveAttribute(_value);
}

const std::string& BlockStubDefault::getMDRaidAttribute() {
    return mDRaidAttributeValue_;
}

const std::string& BlockStubDefault::getMDRaidAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getMDRaidAttribute();
}

void BlockStubDefault::setMDRaidAttribute(std::string _value) {
    const bool valueChanged = trySetMDRaidAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMDRaidAttributeChanged(mDRaidAttributeValue_);
    }
}

bool BlockStubDefault::trySetMDRaidAttribute(std::string _value) {
    if (!validateMDRaidAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (mDRaidAttributeValue_ != _value);
    mDRaidAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateMDRaidAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setMDRaidAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setMDRaidAttribute(_value);
}

void BlockStubDefault::onRemoteMDRaidAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteMDRaidAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteMDRaidAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetMDRaidAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetMDRaidAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetMDRaidAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetMDRaidAttribute(_value);
}

const std::string& BlockStubDefault::getMDRaidMemberAttribute() {
    return mDRaidMemberAttributeValue_;
}

const std::string& BlockStubDefault::getMDRaidMemberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getMDRaidMemberAttribute();
}

void BlockStubDefault::setMDRaidMemberAttribute(std::string _value) {
    const bool valueChanged = trySetMDRaidMemberAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMDRaidMemberAttributeChanged(mDRaidMemberAttributeValue_);
    }
}

bool BlockStubDefault::trySetMDRaidMemberAttribute(std::string _value) {
    if (!validateMDRaidMemberAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (mDRaidMemberAttributeValue_ != _value);
    mDRaidMemberAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateMDRaidMemberAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setMDRaidMemberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setMDRaidMemberAttribute(_value);
}

void BlockStubDefault::onRemoteMDRaidMemberAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteMDRaidMemberAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteMDRaidMemberAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetMDRaidMemberAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetMDRaidMemberAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetMDRaidMemberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetMDRaidMemberAttribute(_value);
}

const std::string& BlockStubDefault::getIdUsageAttribute() {
    return idUsageAttributeValue_;
}

const std::string& BlockStubDefault::getIdUsageAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getIdUsageAttribute();
}

void BlockStubDefault::setIdUsageAttribute(std::string _value) {
    const bool valueChanged = trySetIdUsageAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireIdUsageAttributeChanged(idUsageAttributeValue_);
    }
}

bool BlockStubDefault::trySetIdUsageAttribute(std::string _value) {
    if (!validateIdUsageAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (idUsageAttributeValue_ != _value);
    idUsageAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateIdUsageAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setIdUsageAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setIdUsageAttribute(_value);
}

void BlockStubDefault::onRemoteIdUsageAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteIdUsageAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteIdUsageAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdUsageAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetIdUsageAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdUsageAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetIdUsageAttribute(_value);
}

const std::string& BlockStubDefault::getIdTypeAttribute() {
    return idTypeAttributeValue_;
}

const std::string& BlockStubDefault::getIdTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getIdTypeAttribute();
}

void BlockStubDefault::setIdTypeAttribute(std::string _value) {
    const bool valueChanged = trySetIdTypeAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireIdTypeAttributeChanged(idTypeAttributeValue_);
    }
}

bool BlockStubDefault::trySetIdTypeAttribute(std::string _value) {
    if (!validateIdTypeAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (idTypeAttributeValue_ != _value);
    idTypeAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateIdTypeAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setIdTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setIdTypeAttribute(_value);
}

void BlockStubDefault::onRemoteIdTypeAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteIdTypeAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteIdTypeAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdTypeAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetIdTypeAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetIdTypeAttribute(_value);
}

const std::string& BlockStubDefault::getIdVersionAttribute() {
    return idVersionAttributeValue_;
}

const std::string& BlockStubDefault::getIdVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getIdVersionAttribute();
}

void BlockStubDefault::setIdVersionAttribute(std::string _value) {
    const bool valueChanged = trySetIdVersionAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireIdVersionAttributeChanged(idVersionAttributeValue_);
    }
}

bool BlockStubDefault::trySetIdVersionAttribute(std::string _value) {
    if (!validateIdVersionAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (idVersionAttributeValue_ != _value);
    idVersionAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateIdVersionAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setIdVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setIdVersionAttribute(_value);
}

void BlockStubDefault::onRemoteIdVersionAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteIdVersionAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteIdVersionAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdVersionAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetIdVersionAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetIdVersionAttribute(_value);
}

const std::string& BlockStubDefault::getIdLabelAttribute() {
    return idLabelAttributeValue_;
}

const std::string& BlockStubDefault::getIdLabelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getIdLabelAttribute();
}

void BlockStubDefault::setIdLabelAttribute(std::string _value) {
    const bool valueChanged = trySetIdLabelAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireIdLabelAttributeChanged(idLabelAttributeValue_);
    }
}

bool BlockStubDefault::trySetIdLabelAttribute(std::string _value) {
    if (!validateIdLabelAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (idLabelAttributeValue_ != _value);
    idLabelAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateIdLabelAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setIdLabelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setIdLabelAttribute(_value);
}

void BlockStubDefault::onRemoteIdLabelAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteIdLabelAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteIdLabelAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdLabelAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetIdLabelAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdLabelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetIdLabelAttribute(_value);
}

const std::string& BlockStubDefault::getIdUUIDAttribute() {
    return idUUIDAttributeValue_;
}

const std::string& BlockStubDefault::getIdUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getIdUUIDAttribute();
}

void BlockStubDefault::setIdUUIDAttribute(std::string _value) {
    const bool valueChanged = trySetIdUUIDAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireIdUUIDAttributeChanged(idUUIDAttributeValue_);
    }
}

bool BlockStubDefault::trySetIdUUIDAttribute(std::string _value) {
    if (!validateIdUUIDAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (idUUIDAttributeValue_ != _value);
    idUUIDAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateIdUUIDAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setIdUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setIdUUIDAttribute(_value);
}

void BlockStubDefault::onRemoteIdUUIDAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteIdUUIDAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteIdUUIDAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdUUIDAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetIdUUIDAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetIdUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetIdUUIDAttribute(_value);
}

const std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct>& BlockStubDefault::getConfigurationAttribute() {
    return configurationAttributeValue_;
}

const std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct>& BlockStubDefault::getConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getConfigurationAttribute();
}

void BlockStubDefault::setConfigurationAttribute(std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct> _value) {
    const bool valueChanged = trySetConfigurationAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireConfigurationAttributeChanged(configurationAttributeValue_);
    }
}

bool BlockStubDefault::trySetConfigurationAttribute(std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct> _value) {
    if (!validateConfigurationAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (configurationAttributeValue_ != _value);
    configurationAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateConfigurationAttributeRequestedValue(const std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct> &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct> _value) {
    (void)_client;
    setConfigurationAttribute(_value);
}

void BlockStubDefault::onRemoteConfigurationAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteConfigurationAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteConfigurationAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetConfigurationAttribute(std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct> _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetConfigurationAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Block::tConfigurationStruct> _value) {
    (void)_client;
    return onRemoteSetConfigurationAttribute(_value);
}

const std::string& BlockStubDefault::getCryptoBackingDeviceAttribute() {
    return cryptoBackingDeviceAttributeValue_;
}

const std::string& BlockStubDefault::getCryptoBackingDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getCryptoBackingDeviceAttribute();
}

void BlockStubDefault::setCryptoBackingDeviceAttribute(std::string _value) {
    const bool valueChanged = trySetCryptoBackingDeviceAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireCryptoBackingDeviceAttributeChanged(cryptoBackingDeviceAttributeValue_);
    }
}

bool BlockStubDefault::trySetCryptoBackingDeviceAttribute(std::string _value) {
    if (!validateCryptoBackingDeviceAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (cryptoBackingDeviceAttributeValue_ != _value);
    cryptoBackingDeviceAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateCryptoBackingDeviceAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setCryptoBackingDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setCryptoBackingDeviceAttribute(_value);
}

void BlockStubDefault::onRemoteCryptoBackingDeviceAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteCryptoBackingDeviceAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteCryptoBackingDeviceAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetCryptoBackingDeviceAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetCryptoBackingDeviceAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetCryptoBackingDeviceAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetCryptoBackingDeviceAttribute(_value);
}

const bool& BlockStubDefault::getHintPartitionableAttribute() {
    return hintPartitionableAttributeValue_;
}

const bool& BlockStubDefault::getHintPartitionableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getHintPartitionableAttribute();
}

void BlockStubDefault::setHintPartitionableAttribute(bool _value) {
    const bool valueChanged = trySetHintPartitionableAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireHintPartitionableAttributeChanged(hintPartitionableAttributeValue_);
    }
}

bool BlockStubDefault::trySetHintPartitionableAttribute(bool _value) {
    if (!validateHintPartitionableAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (hintPartitionableAttributeValue_ != _value);
    hintPartitionableAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateHintPartitionableAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setHintPartitionableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setHintPartitionableAttribute(_value);
}

void BlockStubDefault::onRemoteHintPartitionableAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteHintPartitionableAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteHintPartitionableAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintPartitionableAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetHintPartitionableAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintPartitionableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetHintPartitionableAttribute(_value);
}

const bool& BlockStubDefault::getHintSystemAttribute() {
    return hintSystemAttributeValue_;
}

const bool& BlockStubDefault::getHintSystemAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getHintSystemAttribute();
}

void BlockStubDefault::setHintSystemAttribute(bool _value) {
    const bool valueChanged = trySetHintSystemAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireHintSystemAttributeChanged(hintSystemAttributeValue_);
    }
}

bool BlockStubDefault::trySetHintSystemAttribute(bool _value) {
    if (!validateHintSystemAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (hintSystemAttributeValue_ != _value);
    hintSystemAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateHintSystemAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setHintSystemAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setHintSystemAttribute(_value);
}

void BlockStubDefault::onRemoteHintSystemAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteHintSystemAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteHintSystemAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintSystemAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetHintSystemAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintSystemAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetHintSystemAttribute(_value);
}

const bool& BlockStubDefault::getHintIgnoreAttribute() {
    return hintIgnoreAttributeValue_;
}

const bool& BlockStubDefault::getHintIgnoreAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getHintIgnoreAttribute();
}

void BlockStubDefault::setHintIgnoreAttribute(bool _value) {
    const bool valueChanged = trySetHintIgnoreAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireHintIgnoreAttributeChanged(hintIgnoreAttributeValue_);
    }
}

bool BlockStubDefault::trySetHintIgnoreAttribute(bool _value) {
    if (!validateHintIgnoreAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (hintIgnoreAttributeValue_ != _value);
    hintIgnoreAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateHintIgnoreAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setHintIgnoreAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setHintIgnoreAttribute(_value);
}

void BlockStubDefault::onRemoteHintIgnoreAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteHintIgnoreAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteHintIgnoreAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintIgnoreAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetHintIgnoreAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintIgnoreAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetHintIgnoreAttribute(_value);
}

const bool& BlockStubDefault::getHintAutoAttribute() {
    return hintAutoAttributeValue_;
}

const bool& BlockStubDefault::getHintAutoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getHintAutoAttribute();
}

void BlockStubDefault::setHintAutoAttribute(bool _value) {
    const bool valueChanged = trySetHintAutoAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireHintAutoAttributeChanged(hintAutoAttributeValue_);
    }
}

bool BlockStubDefault::trySetHintAutoAttribute(bool _value) {
    if (!validateHintAutoAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (hintAutoAttributeValue_ != _value);
    hintAutoAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateHintAutoAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setHintAutoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setHintAutoAttribute(_value);
}

void BlockStubDefault::onRemoteHintAutoAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteHintAutoAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteHintAutoAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintAutoAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetHintAutoAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintAutoAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetHintAutoAttribute(_value);
}

const std::string& BlockStubDefault::getHintNameAttribute() {
    return hintNameAttributeValue_;
}

const std::string& BlockStubDefault::getHintNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getHintNameAttribute();
}

void BlockStubDefault::setHintNameAttribute(std::string _value) {
    const bool valueChanged = trySetHintNameAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireHintNameAttributeChanged(hintNameAttributeValue_);
    }
}

bool BlockStubDefault::trySetHintNameAttribute(std::string _value) {
    if (!validateHintNameAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (hintNameAttributeValue_ != _value);
    hintNameAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateHintNameAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setHintNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setHintNameAttribute(_value);
}

void BlockStubDefault::onRemoteHintNameAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteHintNameAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteHintNameAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintNameAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetHintNameAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetHintNameAttribute(_value);
}

const std::string& BlockStubDefault::getHintIconNameAttribute() {
    return hintIconNameAttributeValue_;
}

const std::string& BlockStubDefault::getHintIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getHintIconNameAttribute();
}

void BlockStubDefault::setHintIconNameAttribute(std::string _value) {
    const bool valueChanged = trySetHintIconNameAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireHintIconNameAttributeChanged(hintIconNameAttributeValue_);
    }
}

bool BlockStubDefault::trySetHintIconNameAttribute(std::string _value) {
    if (!validateHintIconNameAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (hintIconNameAttributeValue_ != _value);
    hintIconNameAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateHintIconNameAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setHintIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setHintIconNameAttribute(_value);
}

void BlockStubDefault::onRemoteHintIconNameAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteHintIconNameAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteHintIconNameAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintIconNameAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetHintIconNameAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetHintIconNameAttribute(_value);
}

const std::string& BlockStubDefault::getHintSymbolicIconNameAttribute() {
    return hintSymbolicIconNameAttributeValue_;
}

const std::string& BlockStubDefault::getHintSymbolicIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getHintSymbolicIconNameAttribute();
}

void BlockStubDefault::setHintSymbolicIconNameAttribute(std::string _value) {
    const bool valueChanged = trySetHintSymbolicIconNameAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<BlockStubAdapter, BlockStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireHintSymbolicIconNameAttributeChanged(hintSymbolicIconNameAttributeValue_);
    }
}

bool BlockStubDefault::trySetHintSymbolicIconNameAttribute(std::string _value) {
    if (!validateHintSymbolicIconNameAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (hintSymbolicIconNameAttributeValue_ != _value);
    hintSymbolicIconNameAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool BlockStubDefault::validateHintSymbolicIconNameAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void BlockStubDefault::setHintSymbolicIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setHintSymbolicIconNameAttribute(_value);
}

void BlockStubDefault::onRemoteHintSymbolicIconNameAttributeChanged() {
    // No operation in default
}

void BlockStubDefault::RemoteEventHandler::onRemoteHintSymbolicIconNameAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteHintSymbolicIconNameAttributeChanged();
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintSymbolicIconNameAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetHintSymbolicIconNameAttribute(std::move(_value));
}

bool BlockStubDefault::RemoteEventHandler::onRemoteSetHintSymbolicIconNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetHintSymbolicIconNameAttribute(_value);
}


void BlockStubDefault::AddConfigurationItem(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tAddConfigurationItem_itemStruct _item, Block::tAddConfigurationItem_optionsDict _options, AddConfigurationItemReply_t _reply) {
    (void)_client;
    (void) _item;
    (void) _options;
    _reply();
}

void BlockStubDefault::RemoveConfigurationItem(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tRemoveConfigurationItem_itemStruct _item, Block::tRemoveConfigurationItem_optionsDict _options, RemoveConfigurationItemReply_t _reply) {
    (void)_client;
    (void) _item;
    (void) _options;
    _reply();
}

void BlockStubDefault::UpdateConfigurationItem(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tUpdateConfigurationItem_old_itemStruct _old_item, Block::tUpdateConfigurationItem_new_itemStruct _new_item, Block::tUpdateConfigurationItem_optionsDict _options, UpdateConfigurationItemReply_t _reply) {
    (void)_client;
    (void) _old_item;
    (void) _new_item;
    (void) _options;
    _reply();
}

void BlockStubDefault::GetSecretConfiguration(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tGetSecretConfiguration_optionsDict _options, GetSecretConfigurationReply_t _reply) {
    (void)_client;
    (void) _options;
    std::vector<Block::tGetSecretConfiguration_configurationStruct> configuration = {};
    _reply(configuration);
}

void BlockStubDefault::Format(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _type, Block::tFormat_optionsDict _options, FormatReply_t _reply) {
    (void)_client;
    (void) _type;
    (void) _options;
    _reply();
}

void BlockStubDefault::OpenForBackup(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tOpenForBackup_optionsDict _options, OpenForBackupReply_t _reply) {
    (void)_client;
    (void) _options;
    uint32_t fd = 0ul;
    _reply(fd);
}

void BlockStubDefault::OpenForRestore(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tOpenForRestore_optionsDict _options, OpenForRestoreReply_t _reply) {
    (void)_client;
    (void) _options;
    uint32_t fd = 0ul;
    _reply(fd);
}

void BlockStubDefault::OpenForBenchmark(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tOpenForBenchmark_optionsDict _options, OpenForBenchmarkReply_t _reply) {
    (void)_client;
    (void) _options;
    uint32_t fd = 0ul;
    _reply(fd);
}

void BlockStubDefault::Rescan(const std::shared_ptr<CommonAPI::ClientId> _client, Block::tRescan_optionsDict _options, RescanReply_t _reply) {
    (void)_client;
    (void) _options;
    _reply();
}




BlockStubDefault::RemoteEventHandler::RemoteEventHandler(BlockStubDefault *_defaultStub)
    : 
      defaultStub_(_defaultStub) {
}

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2
