/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/DriveDBusProxy.hpp>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

std::shared_ptr<CommonAPI::DBus::DBusProxy> createDriveDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection) {
	return std::make_shared<DriveDBusProxy>(_address, _connection);
}

INITIALIZER(registerDriveDBusProxy) {
     CommonAPI::DBus::Factory::get()->registerProxyCreateMethod(
		Drive::getInterface(),
		&createDriveDBusProxy);
}

DriveDBusProxy::DriveDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection)
	:	CommonAPI::DBus::DBusProxy(_address, _connection)
,		vendor_(*this, "onVendorAttributeChanged", "setVendorAttribute", "s", "getVendorAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		model_(*this, "onModelAttributeChanged", "setModelAttribute", "s", "getModelAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		revision_(*this, "onRevisionAttributeChanged", "setRevisionAttribute", "s", "getRevisionAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		serial_(*this, "onSerialAttributeChanged", "setSerialAttribute", "s", "getSerialAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		wWN_(*this, "onWWNAttributeChanged", "setWWNAttribute", "s", "getWWNAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		id_(*this, "onIdAttributeChanged", "setIdAttribute", "s", "getIdAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		configuration_(*this, "onConfigurationAttributeChanged", "setConfigurationAttribute", "a{s(yv)}", "getConfigurationAttribute", static_cast<Drive_::tConfigurationDictDeployment_t*>(nullptr)),
		media_(*this, "onMediaAttributeChanged", "setMediaAttribute", "s", "getMediaAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		mediaCompatibility_(*this, "onMediaCompatibilityAttributeChanged", "setMediaCompatibilityAttribute", "as", "getMediaCompatibilityAttribute", static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr)),
		mediaRemovable_(*this, "onMediaRemovableAttributeChanged", "setMediaRemovableAttribute", "b", "getMediaRemovableAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		mediaAvailable_(*this, "onMediaAvailableAttributeChanged", "setMediaAvailableAttribute", "b", "getMediaAvailableAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		mediaChangeDetected_(*this, "onMediaChangeDetectedAttributeChanged", "setMediaChangeDetectedAttribute", "b", "getMediaChangeDetectedAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		size_(*this, "onSizeAttributeChanged", "setSizeAttribute", "t", "getSizeAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		timeDetected_(*this, "onTimeDetectedAttributeChanged", "setTimeDetectedAttribute", "t", "getTimeDetectedAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		timeMediaDetected_(*this, "onTimeMediaDetectedAttributeChanged", "setTimeMediaDetectedAttribute", "t", "getTimeMediaDetectedAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		optical_(*this, "onOpticalAttributeChanged", "setOpticalAttribute", "b", "getOpticalAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		opticalBlank_(*this, "onOpticalBlankAttributeChanged", "setOpticalBlankAttribute", "b", "getOpticalBlankAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		opticalNumTracks_(*this, "onOpticalNumTracksAttributeChanged", "setOpticalNumTracksAttribute", "u", "getOpticalNumTracksAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		opticalNumAudioTracks_(*this, "onOpticalNumAudioTracksAttributeChanged", "setOpticalNumAudioTracksAttribute", "u", "getOpticalNumAudioTracksAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		opticalNumDataTracks_(*this, "onOpticalNumDataTracksAttributeChanged", "setOpticalNumDataTracksAttribute", "u", "getOpticalNumDataTracksAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		opticalNumSessions_(*this, "onOpticalNumSessionsAttributeChanged", "setOpticalNumSessionsAttribute", "u", "getOpticalNumSessionsAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		rotationRate_(*this, "onRotationRateAttributeChanged", "setRotationRateAttribute", "i", "getRotationRateAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		connectionBus_(*this, "onConnectionBusAttributeChanged", "setConnectionBusAttribute", "s", "getConnectionBusAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		seat_(*this, "onSeatAttributeChanged", "setSeatAttribute", "s", "getSeatAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		removable_(*this, "onRemovableAttributeChanged", "setRemovableAttribute", "b", "getRemovableAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		ejectable_(*this, "onEjectableAttributeChanged", "setEjectableAttribute", "b", "getEjectableAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		sortKey_(*this, "onSortKeyAttributeChanged", "setSortKeyAttribute", "s", "getSortKeyAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		canPowerOff_(*this, "onCanPowerOffAttributeChanged", "setCanPowerOffAttribute", "b", "getCanPowerOffAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		siblingId_(*this, "onSiblingIdAttributeChanged", "setSiblingIdAttribute", "s", "getSiblingIdAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
{
}

      DriveDBusProxy::VendorAttribute& DriveDBusProxy::getVendorAttribute() {
          return vendor_;
      }
      DriveDBusProxy::ModelAttribute& DriveDBusProxy::getModelAttribute() {
          return model_;
      }
      DriveDBusProxy::RevisionAttribute& DriveDBusProxy::getRevisionAttribute() {
          return revision_;
      }
      DriveDBusProxy::SerialAttribute& DriveDBusProxy::getSerialAttribute() {
          return serial_;
      }
      DriveDBusProxy::WWNAttribute& DriveDBusProxy::getWWNAttribute() {
          return wWN_;
      }
      DriveDBusProxy::IdAttribute& DriveDBusProxy::getIdAttribute() {
          return id_;
      }
      DriveDBusProxy::ConfigurationAttribute& DriveDBusProxy::getConfigurationAttribute() {
          return configuration_;
      }
      DriveDBusProxy::MediaAttribute& DriveDBusProxy::getMediaAttribute() {
          return media_;
      }
      DriveDBusProxy::MediaCompatibilityAttribute& DriveDBusProxy::getMediaCompatibilityAttribute() {
          return mediaCompatibility_;
      }
      DriveDBusProxy::MediaRemovableAttribute& DriveDBusProxy::getMediaRemovableAttribute() {
          return mediaRemovable_;
      }
      DriveDBusProxy::MediaAvailableAttribute& DriveDBusProxy::getMediaAvailableAttribute() {
          return mediaAvailable_;
      }
      DriveDBusProxy::MediaChangeDetectedAttribute& DriveDBusProxy::getMediaChangeDetectedAttribute() {
          return mediaChangeDetected_;
      }
      DriveDBusProxy::SizeAttribute& DriveDBusProxy::getSizeAttribute() {
          return size_;
      }
      DriveDBusProxy::TimeDetectedAttribute& DriveDBusProxy::getTimeDetectedAttribute() {
          return timeDetected_;
      }
      DriveDBusProxy::TimeMediaDetectedAttribute& DriveDBusProxy::getTimeMediaDetectedAttribute() {
          return timeMediaDetected_;
      }
      DriveDBusProxy::OpticalAttribute& DriveDBusProxy::getOpticalAttribute() {
          return optical_;
      }
      DriveDBusProxy::OpticalBlankAttribute& DriveDBusProxy::getOpticalBlankAttribute() {
          return opticalBlank_;
      }
      DriveDBusProxy::OpticalNumTracksAttribute& DriveDBusProxy::getOpticalNumTracksAttribute() {
          return opticalNumTracks_;
      }
      DriveDBusProxy::OpticalNumAudioTracksAttribute& DriveDBusProxy::getOpticalNumAudioTracksAttribute() {
          return opticalNumAudioTracks_;
      }
      DriveDBusProxy::OpticalNumDataTracksAttribute& DriveDBusProxy::getOpticalNumDataTracksAttribute() {
          return opticalNumDataTracks_;
      }
      DriveDBusProxy::OpticalNumSessionsAttribute& DriveDBusProxy::getOpticalNumSessionsAttribute() {
          return opticalNumSessions_;
      }
      DriveDBusProxy::RotationRateAttribute& DriveDBusProxy::getRotationRateAttribute() {
          return rotationRate_;
      }
      DriveDBusProxy::ConnectionBusAttribute& DriveDBusProxy::getConnectionBusAttribute() {
          return connectionBus_;
      }
      DriveDBusProxy::SeatAttribute& DriveDBusProxy::getSeatAttribute() {
          return seat_;
      }
      DriveDBusProxy::RemovableAttribute& DriveDBusProxy::getRemovableAttribute() {
          return removable_;
      }
      DriveDBusProxy::EjectableAttribute& DriveDBusProxy::getEjectableAttribute() {
          return ejectable_;
      }
      DriveDBusProxy::SortKeyAttribute& DriveDBusProxy::getSortKeyAttribute() {
          return sortKey_;
      }
      DriveDBusProxy::CanPowerOffAttribute& DriveDBusProxy::getCanPowerOffAttribute() {
          return canPowerOff_;
      }
      DriveDBusProxy::SiblingIdAttribute& DriveDBusProxy::getSiblingIdAttribute() {
          return siblingId_;
      }

    
    void DriveDBusProxy::Eject(const Drive::tEject_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Drive::tEject_optionsDict, Drive_::tEject_optionsDictDeployment_t> deploy_options(_options, static_cast<Drive_::tEject_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Drive::tEject_optionsDict, Drive_::tEject_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "Eject",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> DriveDBusProxy::EjectAsync(const Drive::tEject_optionsDict &_options, EjectAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Drive::tEject_optionsDict, Drive_::tEject_optionsDictDeployment_t> deploy_options(_options, static_cast<Drive_::tEject_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Drive::tEject_optionsDict, Drive_::tEject_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "Eject",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void DriveDBusProxy::SetConfiguration(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Drive::tSetConfiguration_valueDict, Drive_::tSetConfiguration_valueDictDeployment_t> deploy_value(_value, static_cast<Drive_::tSetConfiguration_valueDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<Drive::tSetConfiguration_optionsDict, Drive_::tSetConfiguration_optionsDictDeployment_t> deploy_options(_options, static_cast<Drive_::tSetConfiguration_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Drive::tSetConfiguration_valueDict, Drive_::tSetConfiguration_valueDictDeployment_t >,
            CommonAPI::Deployable<Drive::tSetConfiguration_optionsDict, Drive_::tSetConfiguration_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "SetConfiguration",
        "a{s(yv)}a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_value, deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> DriveDBusProxy::SetConfigurationAsync(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, SetConfigurationAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Drive::tSetConfiguration_valueDict, Drive_::tSetConfiguration_valueDictDeployment_t> deploy_value(_value, static_cast<Drive_::tSetConfiguration_valueDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<Drive::tSetConfiguration_optionsDict, Drive_::tSetConfiguration_optionsDictDeployment_t> deploy_options(_options, static_cast<Drive_::tSetConfiguration_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Drive::tSetConfiguration_valueDict, Drive_::tSetConfiguration_valueDictDeployment_t >,
            CommonAPI::Deployable<Drive::tSetConfiguration_optionsDict, Drive_::tSetConfiguration_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "SetConfiguration",
        "a{s(yv)}a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_value, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void DriveDBusProxy::PowerOff(const Drive::tPowerOff_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Drive::tPowerOff_optionsDict, Drive_::tPowerOff_optionsDictDeployment_t> deploy_options(_options, static_cast<Drive_::tPowerOff_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Drive::tPowerOff_optionsDict, Drive_::tPowerOff_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "PowerOff",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> DriveDBusProxy::PowerOffAsync(const Drive::tPowerOff_optionsDict &_options, PowerOffAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Drive::tPowerOff_optionsDict, Drive_::tPowerOff_optionsDictDeployment_t> deploy_options(_options, static_cast<Drive_::tPowerOff_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Drive::tPowerOff_optionsDict, Drive_::tPowerOff_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "PowerOff",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }


void DriveDBusProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
          ownVersionMajor = 2;
          ownVersionMinor = 1;
      }

      } // namespace UDisks2
      } // namespace freedesktop
      } // namespace org
      } // namespace v2
