/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Drive_DBUS_PROXY_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Drive_DBUS_PROXY_HPP_

#include <v2/org/freedesktop/UDisks2/DriveProxyBase.hpp>
#include "v2/org/freedesktop/UDisks2/DriveDBusDeployment.hpp"

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/DBus/DBusAddress.hpp>
#include <CommonAPI/DBus/DBusFactory.hpp>
#include <CommonAPI/DBus/DBusProxy.hpp>
#include <CommonAPI/DBus/DBusAddressTranslator.hpp>
#include <CommonAPI/DBus/DBusAttribute.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

#include <string>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

class DriveDBusProxy
    : virtual public DriveProxyBase, 
      virtual public CommonAPI::DBus::DBusProxy {
public:
    DriveDBusProxy(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection);

    virtual ~DriveDBusProxy() { }

    virtual VendorAttribute& getVendorAttribute();
    virtual ModelAttribute& getModelAttribute();
    virtual RevisionAttribute& getRevisionAttribute();
    virtual SerialAttribute& getSerialAttribute();
    virtual WWNAttribute& getWWNAttribute();
    virtual IdAttribute& getIdAttribute();
    virtual ConfigurationAttribute& getConfigurationAttribute();
    virtual MediaAttribute& getMediaAttribute();
    virtual MediaCompatibilityAttribute& getMediaCompatibilityAttribute();
    virtual MediaRemovableAttribute& getMediaRemovableAttribute();
    virtual MediaAvailableAttribute& getMediaAvailableAttribute();
    virtual MediaChangeDetectedAttribute& getMediaChangeDetectedAttribute();
    virtual SizeAttribute& getSizeAttribute();
    virtual TimeDetectedAttribute& getTimeDetectedAttribute();
    virtual TimeMediaDetectedAttribute& getTimeMediaDetectedAttribute();
    virtual OpticalAttribute& getOpticalAttribute();
    virtual OpticalBlankAttribute& getOpticalBlankAttribute();
    virtual OpticalNumTracksAttribute& getOpticalNumTracksAttribute();
    virtual OpticalNumAudioTracksAttribute& getOpticalNumAudioTracksAttribute();
    virtual OpticalNumDataTracksAttribute& getOpticalNumDataTracksAttribute();
    virtual OpticalNumSessionsAttribute& getOpticalNumSessionsAttribute();
    virtual RotationRateAttribute& getRotationRateAttribute();
    virtual ConnectionBusAttribute& getConnectionBusAttribute();
    virtual SeatAttribute& getSeatAttribute();
    virtual RemovableAttribute& getRemovableAttribute();
    virtual EjectableAttribute& getEjectableAttribute();
    virtual SortKeyAttribute& getSortKeyAttribute();
    virtual CanPowerOffAttribute& getCanPowerOffAttribute();
    virtual SiblingIdAttribute& getSiblingIdAttribute();


    virtual void Eject(const Drive::tEject_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> EjectAsync(const Drive::tEject_optionsDict &_options, EjectAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void SetConfiguration(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> SetConfigurationAsync(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, SetConfigurationAsyncCallback _callback, const CommonAPI::CallInfo *_info);
    virtual void PowerOff(const Drive::tPowerOff_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info);
    virtual std::future<CommonAPI::CallStatus> PowerOffAsync(const Drive::tPowerOff_optionsDict &_options, PowerOffAsyncCallback _callback, const CommonAPI::CallInfo *_info);


    virtual void getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const;

private:
   
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<VendorAttribute, CommonAPI::DBus::StringDeployment>> vendor_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<ModelAttribute, CommonAPI::DBus::StringDeployment>> model_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<RevisionAttribute, CommonAPI::DBus::StringDeployment>> revision_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<SerialAttribute, CommonAPI::DBus::StringDeployment>> serial_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<WWNAttribute, CommonAPI::DBus::StringDeployment>> wWN_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<IdAttribute, CommonAPI::DBus::StringDeployment>> id_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<ConfigurationAttribute, Drive_::tConfigurationDictDeployment_t>> configuration_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<MediaAttribute, CommonAPI::DBus::StringDeployment>> media_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<MediaCompatibilityAttribute, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>>> mediaCompatibility_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<MediaRemovableAttribute>> mediaRemovable_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<MediaAvailableAttribute>> mediaAvailable_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<MediaChangeDetectedAttribute>> mediaChangeDetected_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<SizeAttribute>> size_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<TimeDetectedAttribute>> timeDetected_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<TimeMediaDetectedAttribute>> timeMediaDetected_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<OpticalAttribute>> optical_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<OpticalBlankAttribute>> opticalBlank_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<OpticalNumTracksAttribute>> opticalNumTracks_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<OpticalNumAudioTracksAttribute>> opticalNumAudioTracks_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<OpticalNumDataTracksAttribute>> opticalNumDataTracks_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<OpticalNumSessionsAttribute>> opticalNumSessions_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<RotationRateAttribute>> rotationRate_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<ConnectionBusAttribute, CommonAPI::DBus::StringDeployment>> connectionBus_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<SeatAttribute, CommonAPI::DBus::StringDeployment>> seat_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<RemovableAttribute>> removable_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<EjectableAttribute>> ejectable_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<SortKeyAttribute, CommonAPI::DBus::StringDeployment>> sortKey_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<CanPowerOffAttribute>> canPowerOff_;
    CommonAPI::DBus::DBusObservableAttribute<CommonAPI::DBus::DBusAttribute<SiblingIdAttribute, CommonAPI::DBus::StringDeployment>> siblingId_;


};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Drive_DBUS_PROXY_HPP_

