/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Drive_PROXY_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Drive_PROXY_HPP_

#include <v2/org/freedesktop/UDisks2/DriveProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

template <typename ... _AttributeExtensions>
class DriveProxy
    : virtual public Drive, 
      virtual public DriveProxyBase,
      virtual public _AttributeExtensions... {
public:
    DriveProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~DriveProxy();

    typedef Drive InterfaceType;


    /**
     * Returns the wrapper class that provides access to the attribute Vendor.
     */
    virtual VendorAttribute& getVendorAttribute() {
        return delegate_->getVendorAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Model.
     */
    virtual ModelAttribute& getModelAttribute() {
        return delegate_->getModelAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Revision.
     */
    virtual RevisionAttribute& getRevisionAttribute() {
        return delegate_->getRevisionAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Serial.
     */
    virtual SerialAttribute& getSerialAttribute() {
        return delegate_->getSerialAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute WWN.
     */
    virtual WWNAttribute& getWWNAttribute() {
        return delegate_->getWWNAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Id.
     */
    virtual IdAttribute& getIdAttribute() {
        return delegate_->getIdAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Configuration.
     */
    virtual ConfigurationAttribute& getConfigurationAttribute() {
        return delegate_->getConfigurationAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Media.
     */
    virtual MediaAttribute& getMediaAttribute() {
        return delegate_->getMediaAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute MediaCompatibility.
     */
    virtual MediaCompatibilityAttribute& getMediaCompatibilityAttribute() {
        return delegate_->getMediaCompatibilityAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute MediaRemovable.
     */
    virtual MediaRemovableAttribute& getMediaRemovableAttribute() {
        return delegate_->getMediaRemovableAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute MediaAvailable.
     */
    virtual MediaAvailableAttribute& getMediaAvailableAttribute() {
        return delegate_->getMediaAvailableAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute MediaChangeDetected.
     */
    virtual MediaChangeDetectedAttribute& getMediaChangeDetectedAttribute() {
        return delegate_->getMediaChangeDetectedAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Size.
     */
    virtual SizeAttribute& getSizeAttribute() {
        return delegate_->getSizeAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute TimeDetected.
     */
    virtual TimeDetectedAttribute& getTimeDetectedAttribute() {
        return delegate_->getTimeDetectedAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute TimeMediaDetected.
     */
    virtual TimeMediaDetectedAttribute& getTimeMediaDetectedAttribute() {
        return delegate_->getTimeMediaDetectedAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Optical.
     */
    virtual OpticalAttribute& getOpticalAttribute() {
        return delegate_->getOpticalAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute OpticalBlank.
     */
    virtual OpticalBlankAttribute& getOpticalBlankAttribute() {
        return delegate_->getOpticalBlankAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute OpticalNumTracks.
     */
    virtual OpticalNumTracksAttribute& getOpticalNumTracksAttribute() {
        return delegate_->getOpticalNumTracksAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute OpticalNumAudioTracks.
     */
    virtual OpticalNumAudioTracksAttribute& getOpticalNumAudioTracksAttribute() {
        return delegate_->getOpticalNumAudioTracksAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute OpticalNumDataTracks.
     */
    virtual OpticalNumDataTracksAttribute& getOpticalNumDataTracksAttribute() {
        return delegate_->getOpticalNumDataTracksAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute OpticalNumSessions.
     */
    virtual OpticalNumSessionsAttribute& getOpticalNumSessionsAttribute() {
        return delegate_->getOpticalNumSessionsAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute RotationRate.
     */
    virtual RotationRateAttribute& getRotationRateAttribute() {
        return delegate_->getRotationRateAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute ConnectionBus.
     */
    virtual ConnectionBusAttribute& getConnectionBusAttribute() {
        return delegate_->getConnectionBusAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Seat.
     */
    virtual SeatAttribute& getSeatAttribute() {
        return delegate_->getSeatAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Removable.
     */
    virtual RemovableAttribute& getRemovableAttribute() {
        return delegate_->getRemovableAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Ejectable.
     */
    virtual EjectableAttribute& getEjectableAttribute() {
        return delegate_->getEjectableAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute SortKey.
     */
    virtual SortKeyAttribute& getSortKeyAttribute() {
        return delegate_->getSortKeyAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute CanPowerOff.
     */
    virtual CanPowerOffAttribute& getCanPowerOffAttribute() {
        return delegate_->getCanPowerOffAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute SiblingId.
     */
    virtual SiblingIdAttribute& getSiblingIdAttribute() {
        return delegate_->getSiblingIdAttribute();
    }


    /**
     * Calls Eject with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void Eject(const Drive::tEject_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Eject with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> EjectAsync(const Drive::tEject_optionsDict &_options, EjectAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetConfiguration with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void SetConfiguration(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetConfiguration with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> SetConfigurationAsync(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, SetConfigurationAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls PowerOff with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void PowerOff(const Drive::tPowerOff_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls PowerOff with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> PowerOffAsync(const Drive::tPowerOff_optionsDict &_options, PowerOffAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<DriveProxyBase> delegate_;
};

typedef DriveProxy<> DriveProxyDefault;

namespace DriveExtensions {
    template <template <typename > class _ExtensionType>
    class VendorAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::VendorAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::VendorAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        VendorAttributeExtension() {}
    #endif
    
        VendorAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getVendorAttribute()) {
        }
    
        inline extension_type& getVendorAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class ModelAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::ModelAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::ModelAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        ModelAttributeExtension() {}
    #endif
    
        ModelAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getModelAttribute()) {
        }
    
        inline extension_type& getModelAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class RevisionAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::RevisionAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::RevisionAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        RevisionAttributeExtension() {}
    #endif
    
        RevisionAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getRevisionAttribute()) {
        }
    
        inline extension_type& getRevisionAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class SerialAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::SerialAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::SerialAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        SerialAttributeExtension() {}
    #endif
    
        SerialAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getSerialAttribute()) {
        }
    
        inline extension_type& getSerialAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class WWNAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::WWNAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::WWNAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        WWNAttributeExtension() {}
    #endif
    
        WWNAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getWWNAttribute()) {
        }
    
        inline extension_type& getWWNAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class IdAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::IdAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::IdAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        IdAttributeExtension() {}
    #endif
    
        IdAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getIdAttribute()) {
        }
    
        inline extension_type& getIdAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class ConfigurationAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::ConfigurationAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::ConfigurationAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        ConfigurationAttributeExtension() {}
    #endif
    
        ConfigurationAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getConfigurationAttribute()) {
        }
    
        inline extension_type& getConfigurationAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class MediaAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::MediaAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::MediaAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        MediaAttributeExtension() {}
    #endif
    
        MediaAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getMediaAttribute()) {
        }
    
        inline extension_type& getMediaAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class MediaCompatibilityAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::MediaCompatibilityAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::MediaCompatibilityAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        MediaCompatibilityAttributeExtension() {}
    #endif
    
        MediaCompatibilityAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getMediaCompatibilityAttribute()) {
        }
    
        inline extension_type& getMediaCompatibilityAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class MediaRemovableAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::MediaRemovableAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::MediaRemovableAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        MediaRemovableAttributeExtension() {}
    #endif
    
        MediaRemovableAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getMediaRemovableAttribute()) {
        }
    
        inline extension_type& getMediaRemovableAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class MediaAvailableAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::MediaAvailableAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::MediaAvailableAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        MediaAvailableAttributeExtension() {}
    #endif
    
        MediaAvailableAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getMediaAvailableAttribute()) {
        }
    
        inline extension_type& getMediaAvailableAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class MediaChangeDetectedAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::MediaChangeDetectedAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::MediaChangeDetectedAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        MediaChangeDetectedAttributeExtension() {}
    #endif
    
        MediaChangeDetectedAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getMediaChangeDetectedAttribute()) {
        }
    
        inline extension_type& getMediaChangeDetectedAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class SizeAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::SizeAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::SizeAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        SizeAttributeExtension() {}
    #endif
    
        SizeAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getSizeAttribute()) {
        }
    
        inline extension_type& getSizeAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class TimeDetectedAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::TimeDetectedAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::TimeDetectedAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        TimeDetectedAttributeExtension() {}
    #endif
    
        TimeDetectedAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getTimeDetectedAttribute()) {
        }
    
        inline extension_type& getTimeDetectedAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class TimeMediaDetectedAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::TimeMediaDetectedAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::TimeMediaDetectedAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        TimeMediaDetectedAttributeExtension() {}
    #endif
    
        TimeMediaDetectedAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getTimeMediaDetectedAttribute()) {
        }
    
        inline extension_type& getTimeMediaDetectedAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class OpticalAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::OpticalAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::OpticalAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        OpticalAttributeExtension() {}
    #endif
    
        OpticalAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getOpticalAttribute()) {
        }
    
        inline extension_type& getOpticalAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class OpticalBlankAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::OpticalBlankAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::OpticalBlankAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        OpticalBlankAttributeExtension() {}
    #endif
    
        OpticalBlankAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getOpticalBlankAttribute()) {
        }
    
        inline extension_type& getOpticalBlankAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class OpticalNumTracksAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::OpticalNumTracksAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::OpticalNumTracksAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        OpticalNumTracksAttributeExtension() {}
    #endif
    
        OpticalNumTracksAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getOpticalNumTracksAttribute()) {
        }
    
        inline extension_type& getOpticalNumTracksAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class OpticalNumAudioTracksAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::OpticalNumAudioTracksAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::OpticalNumAudioTracksAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        OpticalNumAudioTracksAttributeExtension() {}
    #endif
    
        OpticalNumAudioTracksAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getOpticalNumAudioTracksAttribute()) {
        }
    
        inline extension_type& getOpticalNumAudioTracksAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class OpticalNumDataTracksAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::OpticalNumDataTracksAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::OpticalNumDataTracksAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        OpticalNumDataTracksAttributeExtension() {}
    #endif
    
        OpticalNumDataTracksAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getOpticalNumDataTracksAttribute()) {
        }
    
        inline extension_type& getOpticalNumDataTracksAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class OpticalNumSessionsAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::OpticalNumSessionsAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::OpticalNumSessionsAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        OpticalNumSessionsAttributeExtension() {}
    #endif
    
        OpticalNumSessionsAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getOpticalNumSessionsAttribute()) {
        }
    
        inline extension_type& getOpticalNumSessionsAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class RotationRateAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::RotationRateAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::RotationRateAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        RotationRateAttributeExtension() {}
    #endif
    
        RotationRateAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getRotationRateAttribute()) {
        }
    
        inline extension_type& getRotationRateAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class ConnectionBusAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::ConnectionBusAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::ConnectionBusAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        ConnectionBusAttributeExtension() {}
    #endif
    
        ConnectionBusAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getConnectionBusAttribute()) {
        }
    
        inline extension_type& getConnectionBusAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class SeatAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::SeatAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::SeatAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        SeatAttributeExtension() {}
    #endif
    
        SeatAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getSeatAttribute()) {
        }
    
        inline extension_type& getSeatAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class RemovableAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::RemovableAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::RemovableAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        RemovableAttributeExtension() {}
    #endif
    
        RemovableAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getRemovableAttribute()) {
        }
    
        inline extension_type& getRemovableAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class EjectableAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::EjectableAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::EjectableAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        EjectableAttributeExtension() {}
    #endif
    
        EjectableAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getEjectableAttribute()) {
        }
    
        inline extension_type& getEjectableAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class SortKeyAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::SortKeyAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::SortKeyAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        SortKeyAttributeExtension() {}
    #endif
    
        SortKeyAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getSortKeyAttribute()) {
        }
    
        inline extension_type& getSortKeyAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class CanPowerOffAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::CanPowerOffAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::CanPowerOffAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        CanPowerOffAttributeExtension() {}
    #endif
    
        CanPowerOffAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getCanPowerOffAttribute()) {
        }
    
        inline extension_type& getCanPowerOffAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class SiblingIdAttributeExtension {
     public:
        typedef _ExtensionType<DriveProxyBase::SiblingIdAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<DriveProxyBase::SiblingIdAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        SiblingIdAttributeExtension() {}
    #endif
    
        SiblingIdAttributeExtension(DriveProxyBase& proxy): attributeExtension_(proxy.getSiblingIdAttribute()) {
        }
    
        inline extension_type& getSiblingIdAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace DriveExtensions

//
// DriveProxy Implementation
//
template <typename ... _AttributeExtensions>
DriveProxy<_AttributeExtensions...>::DriveProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<DriveProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<DriveProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
DriveProxy<_AttributeExtensions...>::~DriveProxy() {
}

template <typename ... _AttributeExtensions>
void DriveProxy<_AttributeExtensions...>::Eject(const Drive::tEject_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->Eject(_options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> DriveProxy<_AttributeExtensions...>::EjectAsync(const Drive::tEject_optionsDict &_options, EjectAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->EjectAsync(_options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void DriveProxy<_AttributeExtensions...>::SetConfiguration(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->SetConfiguration(_value, _options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> DriveProxy<_AttributeExtensions...>::SetConfigurationAsync(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, SetConfigurationAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->SetConfigurationAsync(_value, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void DriveProxy<_AttributeExtensions...>::PowerOff(const Drive::tPowerOff_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->PowerOff(_options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> DriveProxy<_AttributeExtensions...>::PowerOffAsync(const Drive::tPowerOff_optionsDict &_options, PowerOffAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->PowerOffAsync(_options, _callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &DriveProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool DriveProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool DriveProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& DriveProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& DriveProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::v2::org::freedesktop::UDisks2::DriveProxy,
    _AttributeExtension> {
    typedef typename ::v2::org::freedesktop::UDisks2::DriveProxy<
            ::v2::org::freedesktop::UDisks2::DriveExtensions::VendorAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::ModelAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::RevisionAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::SerialAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::WWNAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::IdAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::ConfigurationAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::MediaAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::MediaCompatibilityAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::MediaRemovableAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::MediaAvailableAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::MediaChangeDetectedAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::SizeAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::TimeDetectedAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::TimeMediaDetectedAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::OpticalAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::OpticalBlankAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::OpticalNumTracksAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::OpticalNumAudioTracksAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::OpticalNumDataTracksAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::OpticalNumSessionsAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::RotationRateAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::ConnectionBusAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::SeatAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::RemovableAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::EjectableAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::SortKeyAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::CanPowerOffAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::DriveExtensions::SiblingIdAttributeExtension<_AttributeExtension>
    > class_t;
};
}


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Drive_PROXY_HPP_
