/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Drive_PROXY_BASE_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Drive_PROXY_BASE_HPP_

#include <v2/org/freedesktop/UDisks2/Drive.hpp>



#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <cstdint>
#include <string>
#include <unordered_map>
#include <vector>

#include <CommonAPI/Attribute.hpp>
#include <CommonAPI/Proxy.hpp>
#include <functional>
#include <future>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

class DriveProxyBase
    : virtual public CommonAPI::Proxy {
public:
    typedef CommonAPI::ObservableAttribute<std::string> VendorAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> ModelAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> RevisionAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> SerialAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> WWNAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> IdAttribute;
    typedef CommonAPI::ObservableAttribute<::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict> ConfigurationAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> MediaAttribute;
    typedef CommonAPI::ObservableAttribute<std::vector<std::string>> MediaCompatibilityAttribute;
    typedef CommonAPI::ObservableAttribute<bool> MediaRemovableAttribute;
    typedef CommonAPI::ObservableAttribute<bool> MediaAvailableAttribute;
    typedef CommonAPI::ObservableAttribute<bool> MediaChangeDetectedAttribute;
    typedef CommonAPI::ObservableAttribute<uint64_t> SizeAttribute;
    typedef CommonAPI::ObservableAttribute<uint64_t> TimeDetectedAttribute;
    typedef CommonAPI::ObservableAttribute<uint64_t> TimeMediaDetectedAttribute;
    typedef CommonAPI::ObservableAttribute<bool> OpticalAttribute;
    typedef CommonAPI::ObservableAttribute<bool> OpticalBlankAttribute;
    typedef CommonAPI::ObservableAttribute<uint32_t> OpticalNumTracksAttribute;
    typedef CommonAPI::ObservableAttribute<uint32_t> OpticalNumAudioTracksAttribute;
    typedef CommonAPI::ObservableAttribute<uint32_t> OpticalNumDataTracksAttribute;
    typedef CommonAPI::ObservableAttribute<uint32_t> OpticalNumSessionsAttribute;
    typedef CommonAPI::ObservableAttribute<int32_t> RotationRateAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> ConnectionBusAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> SeatAttribute;
    typedef CommonAPI::ObservableAttribute<bool> RemovableAttribute;
    typedef CommonAPI::ObservableAttribute<bool> EjectableAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> SortKeyAttribute;
    typedef CommonAPI::ObservableAttribute<bool> CanPowerOffAttribute;
    typedef CommonAPI::ObservableAttribute<std::string> SiblingIdAttribute;

    typedef std::function<void(const CommonAPI::CallStatus&)> EjectAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> SetConfigurationAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&)> PowerOffAsyncCallback;

    virtual VendorAttribute& getVendorAttribute() = 0;
    virtual ModelAttribute& getModelAttribute() = 0;
    virtual RevisionAttribute& getRevisionAttribute() = 0;
    virtual SerialAttribute& getSerialAttribute() = 0;
    virtual WWNAttribute& getWWNAttribute() = 0;
    virtual IdAttribute& getIdAttribute() = 0;
    virtual ConfigurationAttribute& getConfigurationAttribute() = 0;
    virtual MediaAttribute& getMediaAttribute() = 0;
    virtual MediaCompatibilityAttribute& getMediaCompatibilityAttribute() = 0;
    virtual MediaRemovableAttribute& getMediaRemovableAttribute() = 0;
    virtual MediaAvailableAttribute& getMediaAvailableAttribute() = 0;
    virtual MediaChangeDetectedAttribute& getMediaChangeDetectedAttribute() = 0;
    virtual SizeAttribute& getSizeAttribute() = 0;
    virtual TimeDetectedAttribute& getTimeDetectedAttribute() = 0;
    virtual TimeMediaDetectedAttribute& getTimeMediaDetectedAttribute() = 0;
    virtual OpticalAttribute& getOpticalAttribute() = 0;
    virtual OpticalBlankAttribute& getOpticalBlankAttribute() = 0;
    virtual OpticalNumTracksAttribute& getOpticalNumTracksAttribute() = 0;
    virtual OpticalNumAudioTracksAttribute& getOpticalNumAudioTracksAttribute() = 0;
    virtual OpticalNumDataTracksAttribute& getOpticalNumDataTracksAttribute() = 0;
    virtual OpticalNumSessionsAttribute& getOpticalNumSessionsAttribute() = 0;
    virtual RotationRateAttribute& getRotationRateAttribute() = 0;
    virtual ConnectionBusAttribute& getConnectionBusAttribute() = 0;
    virtual SeatAttribute& getSeatAttribute() = 0;
    virtual RemovableAttribute& getRemovableAttribute() = 0;
    virtual EjectableAttribute& getEjectableAttribute() = 0;
    virtual SortKeyAttribute& getSortKeyAttribute() = 0;
    virtual CanPowerOffAttribute& getCanPowerOffAttribute() = 0;
    virtual SiblingIdAttribute& getSiblingIdAttribute() = 0;


    virtual void Eject(const Drive::tEject_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> EjectAsync(const Drive::tEject_optionsDict &_options, EjectAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void SetConfiguration(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> SetConfigurationAsync(const Drive::tSetConfiguration_valueDict &_value, const Drive::tSetConfiguration_optionsDict &_options, SetConfigurationAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void PowerOff(const Drive::tPowerOff_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> PowerOffAsync(const Drive::tPowerOff_optionsDict &_options, PowerOffAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Drive_PROXY_BASE_HPP_
