/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Drive_STUB_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Drive_STUB_HPP_

#include <functional>




#include <v2/org/freedesktop/UDisks2/Drive.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <cstdint>
#include <string>
#include <unordered_map>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Drive. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class DriveStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual Drive {
 public:
    ///Notifies all remote listeners about a change of value of the attribute Vendor.
    virtual void fireVendorAttributeChanged(const std::string& Vendor) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Model.
    virtual void fireModelAttributeChanged(const std::string& Model) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Revision.
    virtual void fireRevisionAttributeChanged(const std::string& Revision) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Serial.
    virtual void fireSerialAttributeChanged(const std::string& Serial) = 0;
    ///Notifies all remote listeners about a change of value of the attribute WWN.
    virtual void fireWWNAttributeChanged(const std::string& WWN) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Id.
    virtual void fireIdAttributeChanged(const std::string& Id) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Configuration.
    virtual void fireConfigurationAttributeChanged(const ::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict& Configuration) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Media.
    virtual void fireMediaAttributeChanged(const std::string& Media) = 0;
    ///Notifies all remote listeners about a change of value of the attribute MediaCompatibility.
    virtual void fireMediaCompatibilityAttributeChanged(const std::vector<std::string>& MediaCompatibility) = 0;
    ///Notifies all remote listeners about a change of value of the attribute MediaRemovable.
    virtual void fireMediaRemovableAttributeChanged(const bool& MediaRemovable) = 0;
    ///Notifies all remote listeners about a change of value of the attribute MediaAvailable.
    virtual void fireMediaAvailableAttributeChanged(const bool& MediaAvailable) = 0;
    ///Notifies all remote listeners about a change of value of the attribute MediaChangeDetected.
    virtual void fireMediaChangeDetectedAttributeChanged(const bool& MediaChangeDetected) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Size.
    virtual void fireSizeAttributeChanged(const uint64_t& Size) = 0;
    ///Notifies all remote listeners about a change of value of the attribute TimeDetected.
    virtual void fireTimeDetectedAttributeChanged(const uint64_t& TimeDetected) = 0;
    ///Notifies all remote listeners about a change of value of the attribute TimeMediaDetected.
    virtual void fireTimeMediaDetectedAttributeChanged(const uint64_t& TimeMediaDetected) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Optical.
    virtual void fireOpticalAttributeChanged(const bool& Optical) = 0;
    ///Notifies all remote listeners about a change of value of the attribute OpticalBlank.
    virtual void fireOpticalBlankAttributeChanged(const bool& OpticalBlank) = 0;
    ///Notifies all remote listeners about a change of value of the attribute OpticalNumTracks.
    virtual void fireOpticalNumTracksAttributeChanged(const uint32_t& OpticalNumTracks) = 0;
    ///Notifies all remote listeners about a change of value of the attribute OpticalNumAudioTracks.
    virtual void fireOpticalNumAudioTracksAttributeChanged(const uint32_t& OpticalNumAudioTracks) = 0;
    ///Notifies all remote listeners about a change of value of the attribute OpticalNumDataTracks.
    virtual void fireOpticalNumDataTracksAttributeChanged(const uint32_t& OpticalNumDataTracks) = 0;
    ///Notifies all remote listeners about a change of value of the attribute OpticalNumSessions.
    virtual void fireOpticalNumSessionsAttributeChanged(const uint32_t& OpticalNumSessions) = 0;
    ///Notifies all remote listeners about a change of value of the attribute RotationRate.
    virtual void fireRotationRateAttributeChanged(const int32_t& RotationRate) = 0;
    ///Notifies all remote listeners about a change of value of the attribute ConnectionBus.
    virtual void fireConnectionBusAttributeChanged(const std::string& ConnectionBus) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Seat.
    virtual void fireSeatAttributeChanged(const std::string& Seat) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Removable.
    virtual void fireRemovableAttributeChanged(const bool& Removable) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Ejectable.
    virtual void fireEjectableAttributeChanged(const bool& Ejectable) = 0;
    ///Notifies all remote listeners about a change of value of the attribute SortKey.
    virtual void fireSortKeyAttributeChanged(const std::string& SortKey) = 0;
    ///Notifies all remote listeners about a change of value of the attribute CanPowerOff.
    virtual void fireCanPowerOffAttributeChanged(const bool& CanPowerOff) = 0;
    ///Notifies all remote listeners about a change of value of the attribute SiblingId.
    virtual void fireSiblingIdAttributeChanged(const std::string& SiblingId) = 0;



    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Drive.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class DriveStubRemoteEvent
{
public:
    virtual ~DriveStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute Vendor
    virtual bool onRemoteSetVendorAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Vendor
    virtual void onRemoteVendorAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Model
    virtual bool onRemoteSetModelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Model
    virtual void onRemoteModelAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Revision
    virtual bool onRemoteSetRevisionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Revision
    virtual void onRemoteRevisionAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Serial
    virtual bool onRemoteSetSerialAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Serial
    virtual void onRemoteSerialAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute WWN
    virtual bool onRemoteSetWWNAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute WWN
    virtual void onRemoteWWNAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Id
    virtual bool onRemoteSetIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Id
    virtual void onRemoteIdAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Configuration
    virtual bool onRemoteSetConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, ::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict _value) = 0;
    /// Action callback for remote set requests on the attribute Configuration
    virtual void onRemoteConfigurationAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Media
    virtual bool onRemoteSetMediaAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Media
    virtual void onRemoteMediaAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute MediaCompatibility
    virtual bool onRemoteSetMediaCompatibilityAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<std::string> _value) = 0;
    /// Action callback for remote set requests on the attribute MediaCompatibility
    virtual void onRemoteMediaCompatibilityAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute MediaRemovable
    virtual bool onRemoteSetMediaRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute MediaRemovable
    virtual void onRemoteMediaRemovableAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute MediaAvailable
    virtual bool onRemoteSetMediaAvailableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute MediaAvailable
    virtual void onRemoteMediaAvailableAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute MediaChangeDetected
    virtual bool onRemoteSetMediaChangeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute MediaChangeDetected
    virtual void onRemoteMediaChangeDetectedAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Size
    virtual bool onRemoteSetSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) = 0;
    /// Action callback for remote set requests on the attribute Size
    virtual void onRemoteSizeAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute TimeDetected
    virtual bool onRemoteSetTimeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) = 0;
    /// Action callback for remote set requests on the attribute TimeDetected
    virtual void onRemoteTimeDetectedAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute TimeMediaDetected
    virtual bool onRemoteSetTimeMediaDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) = 0;
    /// Action callback for remote set requests on the attribute TimeMediaDetected
    virtual void onRemoteTimeMediaDetectedAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Optical
    virtual bool onRemoteSetOpticalAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute Optical
    virtual void onRemoteOpticalAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute OpticalBlank
    virtual bool onRemoteSetOpticalBlankAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute OpticalBlank
    virtual void onRemoteOpticalBlankAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute OpticalNumTracks
    virtual bool onRemoteSetOpticalNumTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) = 0;
    /// Action callback for remote set requests on the attribute OpticalNumTracks
    virtual void onRemoteOpticalNumTracksAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute OpticalNumAudioTracks
    virtual bool onRemoteSetOpticalNumAudioTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) = 0;
    /// Action callback for remote set requests on the attribute OpticalNumAudioTracks
    virtual void onRemoteOpticalNumAudioTracksAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute OpticalNumDataTracks
    virtual bool onRemoteSetOpticalNumDataTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) = 0;
    /// Action callback for remote set requests on the attribute OpticalNumDataTracks
    virtual void onRemoteOpticalNumDataTracksAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute OpticalNumSessions
    virtual bool onRemoteSetOpticalNumSessionsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) = 0;
    /// Action callback for remote set requests on the attribute OpticalNumSessions
    virtual void onRemoteOpticalNumSessionsAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute RotationRate
    virtual bool onRemoteSetRotationRateAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, int32_t _value) = 0;
    /// Action callback for remote set requests on the attribute RotationRate
    virtual void onRemoteRotationRateAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute ConnectionBus
    virtual bool onRemoteSetConnectionBusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute ConnectionBus
    virtual void onRemoteConnectionBusAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Seat
    virtual bool onRemoteSetSeatAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Seat
    virtual void onRemoteSeatAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Removable
    virtual bool onRemoteSetRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute Removable
    virtual void onRemoteRemovableAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Ejectable
    virtual bool onRemoteSetEjectableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute Ejectable
    virtual void onRemoteEjectableAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute SortKey
    virtual bool onRemoteSetSortKeyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute SortKey
    virtual void onRemoteSortKeyAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute CanPowerOff
    virtual bool onRemoteSetCanPowerOffAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute CanPowerOff
    virtual void onRemoteCanPowerOffAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute SiblingId
    virtual bool onRemoteSetSiblingIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute SiblingId
    virtual void onRemoteSiblingIdAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Drive to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class DriveStub
    : public virtual CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>
{
public:
    typedef std::function<void ()>EjectReply_t;
    typedef std::function<void ()>SetConfigurationReply_t;
    typedef std::function<void ()>PowerOffReply_t;

    virtual ~DriveStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute Vendor
    virtual const std::string &getVendorAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Model
    virtual const std::string &getModelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Revision
    virtual const std::string &getRevisionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Serial
    virtual const std::string &getSerialAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute WWN
    virtual const std::string &getWWNAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Id
    virtual const std::string &getIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Configuration
    virtual const ::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict &getConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Media
    virtual const std::string &getMediaAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute MediaCompatibility
    virtual const std::vector<std::string> &getMediaCompatibilityAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute MediaRemovable
    virtual const bool &getMediaRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute MediaAvailable
    virtual const bool &getMediaAvailableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute MediaChangeDetected
    virtual const bool &getMediaChangeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Size
    virtual const uint64_t &getSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute TimeDetected
    virtual const uint64_t &getTimeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute TimeMediaDetected
    virtual const uint64_t &getTimeMediaDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Optical
    virtual const bool &getOpticalAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute OpticalBlank
    virtual const bool &getOpticalBlankAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute OpticalNumTracks
    virtual const uint32_t &getOpticalNumTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute OpticalNumAudioTracks
    virtual const uint32_t &getOpticalNumAudioTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute OpticalNumDataTracks
    virtual const uint32_t &getOpticalNumDataTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute OpticalNumSessions
    virtual const uint32_t &getOpticalNumSessionsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute RotationRate
    virtual const int32_t &getRotationRateAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute ConnectionBus
    virtual const std::string &getConnectionBusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Seat
    virtual const std::string &getSeatAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Removable
    virtual const bool &getRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Ejectable
    virtual const bool &getEjectableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute SortKey
    virtual const std::string &getSortKeyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute CanPowerOff
    virtual const bool &getCanPowerOffAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute SiblingId
    virtual const std::string &getSiblingIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /// This is the method that will be called on remote calls on the method Eject.
    virtual void Eject(const std::shared_ptr<CommonAPI::ClientId> _client, Drive::tEject_optionsDict _options, EjectReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method SetConfiguration.
    virtual void SetConfiguration(const std::shared_ptr<CommonAPI::ClientId> _client, Drive::tSetConfiguration_valueDict _value, Drive::tSetConfiguration_optionsDict _options, SetConfigurationReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method PowerOff.
    virtual void PowerOff(const std::shared_ptr<CommonAPI::ClientId> _client, Drive::tPowerOff_optionsDict _options, PowerOffReply_t _reply) = 0;

    using CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef DriveStubRemoteEvent RemoteEventType;
    typedef Drive StubInterface;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Drive_STUB_HPP_
