/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/DriveStubDefault.hpp>
#include <assert.h>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

DriveStubDefault::DriveStubDefault():
        remoteEventHandler_(this),
        interfaceVersion_(Drive::getInterfaceVersion()) {
}

const CommonAPI::Version& DriveStubDefault::getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return interfaceVersion_;
}

DriveStubRemoteEvent* DriveStubDefault::initStubAdapter(const std::shared_ptr<DriveStubAdapter> &_adapter) {
    CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_ = _adapter;
    return &remoteEventHandler_;
}

const std::string& DriveStubDefault::getVendorAttribute() {
    return vendorAttributeValue_;
}

const std::string& DriveStubDefault::getVendorAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getVendorAttribute();
}

void DriveStubDefault::setVendorAttribute(std::string _value) {
    const bool valueChanged = trySetVendorAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireVendorAttributeChanged(vendorAttributeValue_);
    }
}

bool DriveStubDefault::trySetVendorAttribute(std::string _value) {
    if (!validateVendorAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (vendorAttributeValue_ != _value);
    vendorAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateVendorAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setVendorAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setVendorAttribute(_value);
}

void DriveStubDefault::onRemoteVendorAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteVendorAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteVendorAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetVendorAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetVendorAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetVendorAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetVendorAttribute(_value);
}

const std::string& DriveStubDefault::getModelAttribute() {
    return modelAttributeValue_;
}

const std::string& DriveStubDefault::getModelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getModelAttribute();
}

void DriveStubDefault::setModelAttribute(std::string _value) {
    const bool valueChanged = trySetModelAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireModelAttributeChanged(modelAttributeValue_);
    }
}

bool DriveStubDefault::trySetModelAttribute(std::string _value) {
    if (!validateModelAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (modelAttributeValue_ != _value);
    modelAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateModelAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setModelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setModelAttribute(_value);
}

void DriveStubDefault::onRemoteModelAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteModelAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteModelAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetModelAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetModelAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetModelAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetModelAttribute(_value);
}

const std::string& DriveStubDefault::getRevisionAttribute() {
    return revisionAttributeValue_;
}

const std::string& DriveStubDefault::getRevisionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getRevisionAttribute();
}

void DriveStubDefault::setRevisionAttribute(std::string _value) {
    const bool valueChanged = trySetRevisionAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireRevisionAttributeChanged(revisionAttributeValue_);
    }
}

bool DriveStubDefault::trySetRevisionAttribute(std::string _value) {
    if (!validateRevisionAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (revisionAttributeValue_ != _value);
    revisionAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateRevisionAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setRevisionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setRevisionAttribute(_value);
}

void DriveStubDefault::onRemoteRevisionAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteRevisionAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteRevisionAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetRevisionAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetRevisionAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetRevisionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetRevisionAttribute(_value);
}

const std::string& DriveStubDefault::getSerialAttribute() {
    return serialAttributeValue_;
}

const std::string& DriveStubDefault::getSerialAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getSerialAttribute();
}

void DriveStubDefault::setSerialAttribute(std::string _value) {
    const bool valueChanged = trySetSerialAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireSerialAttributeChanged(serialAttributeValue_);
    }
}

bool DriveStubDefault::trySetSerialAttribute(std::string _value) {
    if (!validateSerialAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (serialAttributeValue_ != _value);
    serialAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateSerialAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setSerialAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setSerialAttribute(_value);
}

void DriveStubDefault::onRemoteSerialAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteSerialAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteSerialAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSerialAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetSerialAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSerialAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetSerialAttribute(_value);
}

const std::string& DriveStubDefault::getWWNAttribute() {
    return wWNAttributeValue_;
}

const std::string& DriveStubDefault::getWWNAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getWWNAttribute();
}

void DriveStubDefault::setWWNAttribute(std::string _value) {
    const bool valueChanged = trySetWWNAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireWWNAttributeChanged(wWNAttributeValue_);
    }
}

bool DriveStubDefault::trySetWWNAttribute(std::string _value) {
    if (!validateWWNAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (wWNAttributeValue_ != _value);
    wWNAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateWWNAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setWWNAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setWWNAttribute(_value);
}

void DriveStubDefault::onRemoteWWNAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteWWNAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteWWNAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetWWNAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetWWNAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetWWNAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetWWNAttribute(_value);
}

const std::string& DriveStubDefault::getIdAttribute() {
    return idAttributeValue_;
}

const std::string& DriveStubDefault::getIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getIdAttribute();
}

void DriveStubDefault::setIdAttribute(std::string _value) {
    const bool valueChanged = trySetIdAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireIdAttributeChanged(idAttributeValue_);
    }
}

bool DriveStubDefault::trySetIdAttribute(std::string _value) {
    if (!validateIdAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (idAttributeValue_ != _value);
    idAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateIdAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setIdAttribute(_value);
}

void DriveStubDefault::onRemoteIdAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteIdAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteIdAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetIdAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetIdAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetIdAttribute(_value);
}

const ::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict& DriveStubDefault::getConfigurationAttribute() {
    return configurationAttributeValue_;
}

const ::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict& DriveStubDefault::getConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getConfigurationAttribute();
}

void DriveStubDefault::setConfigurationAttribute(::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict _value) {
    const bool valueChanged = trySetConfigurationAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireConfigurationAttributeChanged(configurationAttributeValue_);
    }
}

bool DriveStubDefault::trySetConfigurationAttribute(::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict _value) {
    if (!validateConfigurationAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (configurationAttributeValue_ != _value);
    configurationAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateConfigurationAttributeRequestedValue(const ::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, ::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict _value) {
    (void)_client;
    setConfigurationAttribute(_value);
}

void DriveStubDefault::onRemoteConfigurationAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteConfigurationAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteConfigurationAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetConfigurationAttribute(::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetConfigurationAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetConfigurationAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, ::v2::org::freedesktop::UDisks2::Drive::tConfigurationDict _value) {
    (void)_client;
    return onRemoteSetConfigurationAttribute(_value);
}

const std::string& DriveStubDefault::getMediaAttribute() {
    return mediaAttributeValue_;
}

const std::string& DriveStubDefault::getMediaAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getMediaAttribute();
}

void DriveStubDefault::setMediaAttribute(std::string _value) {
    const bool valueChanged = trySetMediaAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMediaAttributeChanged(mediaAttributeValue_);
    }
}

bool DriveStubDefault::trySetMediaAttribute(std::string _value) {
    if (!validateMediaAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (mediaAttributeValue_ != _value);
    mediaAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateMediaAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setMediaAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setMediaAttribute(_value);
}

void DriveStubDefault::onRemoteMediaAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteMediaAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteMediaAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetMediaAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetMediaAttribute(_value);
}

const std::vector<std::string>& DriveStubDefault::getMediaCompatibilityAttribute() {
    return mediaCompatibilityAttributeValue_;
}

const std::vector<std::string>& DriveStubDefault::getMediaCompatibilityAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getMediaCompatibilityAttribute();
}

void DriveStubDefault::setMediaCompatibilityAttribute(std::vector<std::string> _value) {
    const bool valueChanged = trySetMediaCompatibilityAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMediaCompatibilityAttributeChanged(mediaCompatibilityAttributeValue_);
    }
}

bool DriveStubDefault::trySetMediaCompatibilityAttribute(std::vector<std::string> _value) {
    if (!validateMediaCompatibilityAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (mediaCompatibilityAttributeValue_ != _value);
    mediaCompatibilityAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateMediaCompatibilityAttributeRequestedValue(const std::vector<std::string> &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setMediaCompatibilityAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<std::string> _value) {
    (void)_client;
    setMediaCompatibilityAttribute(_value);
}

void DriveStubDefault::onRemoteMediaCompatibilityAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteMediaCompatibilityAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteMediaCompatibilityAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaCompatibilityAttribute(std::vector<std::string> _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetMediaCompatibilityAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaCompatibilityAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<std::string> _value) {
    (void)_client;
    return onRemoteSetMediaCompatibilityAttribute(_value);
}

const bool& DriveStubDefault::getMediaRemovableAttribute() {
    return mediaRemovableAttributeValue_;
}

const bool& DriveStubDefault::getMediaRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getMediaRemovableAttribute();
}

void DriveStubDefault::setMediaRemovableAttribute(bool _value) {
    const bool valueChanged = trySetMediaRemovableAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMediaRemovableAttributeChanged(mediaRemovableAttributeValue_);
    }
}

bool DriveStubDefault::trySetMediaRemovableAttribute(bool _value) {
    if (!validateMediaRemovableAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (mediaRemovableAttributeValue_ != _value);
    mediaRemovableAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateMediaRemovableAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setMediaRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setMediaRemovableAttribute(_value);
}

void DriveStubDefault::onRemoteMediaRemovableAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteMediaRemovableAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteMediaRemovableAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaRemovableAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetMediaRemovableAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetMediaRemovableAttribute(_value);
}

const bool& DriveStubDefault::getMediaAvailableAttribute() {
    return mediaAvailableAttributeValue_;
}

const bool& DriveStubDefault::getMediaAvailableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getMediaAvailableAttribute();
}

void DriveStubDefault::setMediaAvailableAttribute(bool _value) {
    const bool valueChanged = trySetMediaAvailableAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMediaAvailableAttributeChanged(mediaAvailableAttributeValue_);
    }
}

bool DriveStubDefault::trySetMediaAvailableAttribute(bool _value) {
    if (!validateMediaAvailableAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (mediaAvailableAttributeValue_ != _value);
    mediaAvailableAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateMediaAvailableAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setMediaAvailableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setMediaAvailableAttribute(_value);
}

void DriveStubDefault::onRemoteMediaAvailableAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteMediaAvailableAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteMediaAvailableAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaAvailableAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetMediaAvailableAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaAvailableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetMediaAvailableAttribute(_value);
}

const bool& DriveStubDefault::getMediaChangeDetectedAttribute() {
    return mediaChangeDetectedAttributeValue_;
}

const bool& DriveStubDefault::getMediaChangeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getMediaChangeDetectedAttribute();
}

void DriveStubDefault::setMediaChangeDetectedAttribute(bool _value) {
    const bool valueChanged = trySetMediaChangeDetectedAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMediaChangeDetectedAttributeChanged(mediaChangeDetectedAttributeValue_);
    }
}

bool DriveStubDefault::trySetMediaChangeDetectedAttribute(bool _value) {
    if (!validateMediaChangeDetectedAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (mediaChangeDetectedAttributeValue_ != _value);
    mediaChangeDetectedAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateMediaChangeDetectedAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setMediaChangeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setMediaChangeDetectedAttribute(_value);
}

void DriveStubDefault::onRemoteMediaChangeDetectedAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteMediaChangeDetectedAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteMediaChangeDetectedAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaChangeDetectedAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetMediaChangeDetectedAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetMediaChangeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetMediaChangeDetectedAttribute(_value);
}

const uint64_t& DriveStubDefault::getSizeAttribute() {
    return sizeAttributeValue_;
}

const uint64_t& DriveStubDefault::getSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getSizeAttribute();
}

void DriveStubDefault::setSizeAttribute(uint64_t _value) {
    const bool valueChanged = trySetSizeAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireSizeAttributeChanged(sizeAttributeValue_);
    }
}

bool DriveStubDefault::trySetSizeAttribute(uint64_t _value) {
    if (!validateSizeAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (sizeAttributeValue_ != _value);
    sizeAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateSizeAttributeRequestedValue(const uint64_t &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    setSizeAttribute(_value);
}

void DriveStubDefault::onRemoteSizeAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteSizeAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteSizeAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSizeAttribute(uint64_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetSizeAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    return onRemoteSetSizeAttribute(_value);
}

const uint64_t& DriveStubDefault::getTimeDetectedAttribute() {
    return timeDetectedAttributeValue_;
}

const uint64_t& DriveStubDefault::getTimeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getTimeDetectedAttribute();
}

void DriveStubDefault::setTimeDetectedAttribute(uint64_t _value) {
    const bool valueChanged = trySetTimeDetectedAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireTimeDetectedAttributeChanged(timeDetectedAttributeValue_);
    }
}

bool DriveStubDefault::trySetTimeDetectedAttribute(uint64_t _value) {
    if (!validateTimeDetectedAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (timeDetectedAttributeValue_ != _value);
    timeDetectedAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateTimeDetectedAttributeRequestedValue(const uint64_t &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setTimeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    setTimeDetectedAttribute(_value);
}

void DriveStubDefault::onRemoteTimeDetectedAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteTimeDetectedAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteTimeDetectedAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetTimeDetectedAttribute(uint64_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetTimeDetectedAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetTimeDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    return onRemoteSetTimeDetectedAttribute(_value);
}

const uint64_t& DriveStubDefault::getTimeMediaDetectedAttribute() {
    return timeMediaDetectedAttributeValue_;
}

const uint64_t& DriveStubDefault::getTimeMediaDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getTimeMediaDetectedAttribute();
}

void DriveStubDefault::setTimeMediaDetectedAttribute(uint64_t _value) {
    const bool valueChanged = trySetTimeMediaDetectedAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireTimeMediaDetectedAttributeChanged(timeMediaDetectedAttributeValue_);
    }
}

bool DriveStubDefault::trySetTimeMediaDetectedAttribute(uint64_t _value) {
    if (!validateTimeMediaDetectedAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (timeMediaDetectedAttributeValue_ != _value);
    timeMediaDetectedAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateTimeMediaDetectedAttributeRequestedValue(const uint64_t &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setTimeMediaDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    setTimeMediaDetectedAttribute(_value);
}

void DriveStubDefault::onRemoteTimeMediaDetectedAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteTimeMediaDetectedAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteTimeMediaDetectedAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetTimeMediaDetectedAttribute(uint64_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetTimeMediaDetectedAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetTimeMediaDetectedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) {
    (void)_client;
    return onRemoteSetTimeMediaDetectedAttribute(_value);
}

const bool& DriveStubDefault::getOpticalAttribute() {
    return opticalAttributeValue_;
}

const bool& DriveStubDefault::getOpticalAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getOpticalAttribute();
}

void DriveStubDefault::setOpticalAttribute(bool _value) {
    const bool valueChanged = trySetOpticalAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireOpticalAttributeChanged(opticalAttributeValue_);
    }
}

bool DriveStubDefault::trySetOpticalAttribute(bool _value) {
    if (!validateOpticalAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (opticalAttributeValue_ != _value);
    opticalAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateOpticalAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setOpticalAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setOpticalAttribute(_value);
}

void DriveStubDefault::onRemoteOpticalAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteOpticalAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteOpticalAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetOpticalAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetOpticalAttribute(_value);
}

const bool& DriveStubDefault::getOpticalBlankAttribute() {
    return opticalBlankAttributeValue_;
}

const bool& DriveStubDefault::getOpticalBlankAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getOpticalBlankAttribute();
}

void DriveStubDefault::setOpticalBlankAttribute(bool _value) {
    const bool valueChanged = trySetOpticalBlankAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireOpticalBlankAttributeChanged(opticalBlankAttributeValue_);
    }
}

bool DriveStubDefault::trySetOpticalBlankAttribute(bool _value) {
    if (!validateOpticalBlankAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (opticalBlankAttributeValue_ != _value);
    opticalBlankAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateOpticalBlankAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setOpticalBlankAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setOpticalBlankAttribute(_value);
}

void DriveStubDefault::onRemoteOpticalBlankAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteOpticalBlankAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteOpticalBlankAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalBlankAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetOpticalBlankAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalBlankAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetOpticalBlankAttribute(_value);
}

const uint32_t& DriveStubDefault::getOpticalNumTracksAttribute() {
    return opticalNumTracksAttributeValue_;
}

const uint32_t& DriveStubDefault::getOpticalNumTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getOpticalNumTracksAttribute();
}

void DriveStubDefault::setOpticalNumTracksAttribute(uint32_t _value) {
    const bool valueChanged = trySetOpticalNumTracksAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireOpticalNumTracksAttributeChanged(opticalNumTracksAttributeValue_);
    }
}

bool DriveStubDefault::trySetOpticalNumTracksAttribute(uint32_t _value) {
    if (!validateOpticalNumTracksAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (opticalNumTracksAttributeValue_ != _value);
    opticalNumTracksAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateOpticalNumTracksAttributeRequestedValue(const uint32_t &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setOpticalNumTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) {
    (void)_client;
    setOpticalNumTracksAttribute(_value);
}

void DriveStubDefault::onRemoteOpticalNumTracksAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteOpticalNumTracksAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteOpticalNumTracksAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalNumTracksAttribute(uint32_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetOpticalNumTracksAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalNumTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) {
    (void)_client;
    return onRemoteSetOpticalNumTracksAttribute(_value);
}

const uint32_t& DriveStubDefault::getOpticalNumAudioTracksAttribute() {
    return opticalNumAudioTracksAttributeValue_;
}

const uint32_t& DriveStubDefault::getOpticalNumAudioTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getOpticalNumAudioTracksAttribute();
}

void DriveStubDefault::setOpticalNumAudioTracksAttribute(uint32_t _value) {
    const bool valueChanged = trySetOpticalNumAudioTracksAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireOpticalNumAudioTracksAttributeChanged(opticalNumAudioTracksAttributeValue_);
    }
}

bool DriveStubDefault::trySetOpticalNumAudioTracksAttribute(uint32_t _value) {
    if (!validateOpticalNumAudioTracksAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (opticalNumAudioTracksAttributeValue_ != _value);
    opticalNumAudioTracksAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateOpticalNumAudioTracksAttributeRequestedValue(const uint32_t &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setOpticalNumAudioTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) {
    (void)_client;
    setOpticalNumAudioTracksAttribute(_value);
}

void DriveStubDefault::onRemoteOpticalNumAudioTracksAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteOpticalNumAudioTracksAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteOpticalNumAudioTracksAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalNumAudioTracksAttribute(uint32_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetOpticalNumAudioTracksAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalNumAudioTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) {
    (void)_client;
    return onRemoteSetOpticalNumAudioTracksAttribute(_value);
}

const uint32_t& DriveStubDefault::getOpticalNumDataTracksAttribute() {
    return opticalNumDataTracksAttributeValue_;
}

const uint32_t& DriveStubDefault::getOpticalNumDataTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getOpticalNumDataTracksAttribute();
}

void DriveStubDefault::setOpticalNumDataTracksAttribute(uint32_t _value) {
    const bool valueChanged = trySetOpticalNumDataTracksAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireOpticalNumDataTracksAttributeChanged(opticalNumDataTracksAttributeValue_);
    }
}

bool DriveStubDefault::trySetOpticalNumDataTracksAttribute(uint32_t _value) {
    if (!validateOpticalNumDataTracksAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (opticalNumDataTracksAttributeValue_ != _value);
    opticalNumDataTracksAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateOpticalNumDataTracksAttributeRequestedValue(const uint32_t &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setOpticalNumDataTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) {
    (void)_client;
    setOpticalNumDataTracksAttribute(_value);
}

void DriveStubDefault::onRemoteOpticalNumDataTracksAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteOpticalNumDataTracksAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteOpticalNumDataTracksAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalNumDataTracksAttribute(uint32_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetOpticalNumDataTracksAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalNumDataTracksAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) {
    (void)_client;
    return onRemoteSetOpticalNumDataTracksAttribute(_value);
}

const uint32_t& DriveStubDefault::getOpticalNumSessionsAttribute() {
    return opticalNumSessionsAttributeValue_;
}

const uint32_t& DriveStubDefault::getOpticalNumSessionsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getOpticalNumSessionsAttribute();
}

void DriveStubDefault::setOpticalNumSessionsAttribute(uint32_t _value) {
    const bool valueChanged = trySetOpticalNumSessionsAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireOpticalNumSessionsAttributeChanged(opticalNumSessionsAttributeValue_);
    }
}

bool DriveStubDefault::trySetOpticalNumSessionsAttribute(uint32_t _value) {
    if (!validateOpticalNumSessionsAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (opticalNumSessionsAttributeValue_ != _value);
    opticalNumSessionsAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateOpticalNumSessionsAttributeRequestedValue(const uint32_t &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setOpticalNumSessionsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) {
    (void)_client;
    setOpticalNumSessionsAttribute(_value);
}

void DriveStubDefault::onRemoteOpticalNumSessionsAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteOpticalNumSessionsAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteOpticalNumSessionsAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalNumSessionsAttribute(uint32_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetOpticalNumSessionsAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetOpticalNumSessionsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) {
    (void)_client;
    return onRemoteSetOpticalNumSessionsAttribute(_value);
}

const int32_t& DriveStubDefault::getRotationRateAttribute() {
    return rotationRateAttributeValue_;
}

const int32_t& DriveStubDefault::getRotationRateAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getRotationRateAttribute();
}

void DriveStubDefault::setRotationRateAttribute(int32_t _value) {
    const bool valueChanged = trySetRotationRateAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireRotationRateAttributeChanged(rotationRateAttributeValue_);
    }
}

bool DriveStubDefault::trySetRotationRateAttribute(int32_t _value) {
    if (!validateRotationRateAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (rotationRateAttributeValue_ != _value);
    rotationRateAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateRotationRateAttributeRequestedValue(const int32_t &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setRotationRateAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, int32_t _value) {
    (void)_client;
    setRotationRateAttribute(_value);
}

void DriveStubDefault::onRemoteRotationRateAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteRotationRateAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteRotationRateAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetRotationRateAttribute(int32_t _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetRotationRateAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetRotationRateAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, int32_t _value) {
    (void)_client;
    return onRemoteSetRotationRateAttribute(_value);
}

const std::string& DriveStubDefault::getConnectionBusAttribute() {
    return connectionBusAttributeValue_;
}

const std::string& DriveStubDefault::getConnectionBusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getConnectionBusAttribute();
}

void DriveStubDefault::setConnectionBusAttribute(std::string _value) {
    const bool valueChanged = trySetConnectionBusAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireConnectionBusAttributeChanged(connectionBusAttributeValue_);
    }
}

bool DriveStubDefault::trySetConnectionBusAttribute(std::string _value) {
    if (!validateConnectionBusAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (connectionBusAttributeValue_ != _value);
    connectionBusAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateConnectionBusAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setConnectionBusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setConnectionBusAttribute(_value);
}

void DriveStubDefault::onRemoteConnectionBusAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteConnectionBusAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteConnectionBusAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetConnectionBusAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetConnectionBusAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetConnectionBusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetConnectionBusAttribute(_value);
}

const std::string& DriveStubDefault::getSeatAttribute() {
    return seatAttributeValue_;
}

const std::string& DriveStubDefault::getSeatAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getSeatAttribute();
}

void DriveStubDefault::setSeatAttribute(std::string _value) {
    const bool valueChanged = trySetSeatAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireSeatAttributeChanged(seatAttributeValue_);
    }
}

bool DriveStubDefault::trySetSeatAttribute(std::string _value) {
    if (!validateSeatAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (seatAttributeValue_ != _value);
    seatAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateSeatAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setSeatAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setSeatAttribute(_value);
}

void DriveStubDefault::onRemoteSeatAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteSeatAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteSeatAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSeatAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetSeatAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSeatAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetSeatAttribute(_value);
}

const bool& DriveStubDefault::getRemovableAttribute() {
    return removableAttributeValue_;
}

const bool& DriveStubDefault::getRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getRemovableAttribute();
}

void DriveStubDefault::setRemovableAttribute(bool _value) {
    const bool valueChanged = trySetRemovableAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireRemovableAttributeChanged(removableAttributeValue_);
    }
}

bool DriveStubDefault::trySetRemovableAttribute(bool _value) {
    if (!validateRemovableAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (removableAttributeValue_ != _value);
    removableAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateRemovableAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setRemovableAttribute(_value);
}

void DriveStubDefault::onRemoteRemovableAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteRemovableAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteRemovableAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetRemovableAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetRemovableAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetRemovableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetRemovableAttribute(_value);
}

const bool& DriveStubDefault::getEjectableAttribute() {
    return ejectableAttributeValue_;
}

const bool& DriveStubDefault::getEjectableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getEjectableAttribute();
}

void DriveStubDefault::setEjectableAttribute(bool _value) {
    const bool valueChanged = trySetEjectableAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireEjectableAttributeChanged(ejectableAttributeValue_);
    }
}

bool DriveStubDefault::trySetEjectableAttribute(bool _value) {
    if (!validateEjectableAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (ejectableAttributeValue_ != _value);
    ejectableAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateEjectableAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setEjectableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setEjectableAttribute(_value);
}

void DriveStubDefault::onRemoteEjectableAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteEjectableAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteEjectableAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetEjectableAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetEjectableAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetEjectableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetEjectableAttribute(_value);
}

const std::string& DriveStubDefault::getSortKeyAttribute() {
    return sortKeyAttributeValue_;
}

const std::string& DriveStubDefault::getSortKeyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getSortKeyAttribute();
}

void DriveStubDefault::setSortKeyAttribute(std::string _value) {
    const bool valueChanged = trySetSortKeyAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireSortKeyAttributeChanged(sortKeyAttributeValue_);
    }
}

bool DriveStubDefault::trySetSortKeyAttribute(std::string _value) {
    if (!validateSortKeyAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (sortKeyAttributeValue_ != _value);
    sortKeyAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateSortKeyAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setSortKeyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setSortKeyAttribute(_value);
}

void DriveStubDefault::onRemoteSortKeyAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteSortKeyAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteSortKeyAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSortKeyAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetSortKeyAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSortKeyAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetSortKeyAttribute(_value);
}

const bool& DriveStubDefault::getCanPowerOffAttribute() {
    return canPowerOffAttributeValue_;
}

const bool& DriveStubDefault::getCanPowerOffAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getCanPowerOffAttribute();
}

void DriveStubDefault::setCanPowerOffAttribute(bool _value) {
    const bool valueChanged = trySetCanPowerOffAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireCanPowerOffAttributeChanged(canPowerOffAttributeValue_);
    }
}

bool DriveStubDefault::trySetCanPowerOffAttribute(bool _value) {
    if (!validateCanPowerOffAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (canPowerOffAttributeValue_ != _value);
    canPowerOffAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateCanPowerOffAttributeRequestedValue(const bool &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setCanPowerOffAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    setCanPowerOffAttribute(_value);
}

void DriveStubDefault::onRemoteCanPowerOffAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteCanPowerOffAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteCanPowerOffAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetCanPowerOffAttribute(bool _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetCanPowerOffAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetCanPowerOffAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) {
    (void)_client;
    return onRemoteSetCanPowerOffAttribute(_value);
}

const std::string& DriveStubDefault::getSiblingIdAttribute() {
    return siblingIdAttributeValue_;
}

const std::string& DriveStubDefault::getSiblingIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getSiblingIdAttribute();
}

void DriveStubDefault::setSiblingIdAttribute(std::string _value) {
    const bool valueChanged = trySetSiblingIdAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<DriveStubAdapter, DriveStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireSiblingIdAttributeChanged(siblingIdAttributeValue_);
    }
}

bool DriveStubDefault::trySetSiblingIdAttribute(std::string _value) {
    if (!validateSiblingIdAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (siblingIdAttributeValue_ != _value);
    siblingIdAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool DriveStubDefault::validateSiblingIdAttributeRequestedValue(const std::string &_value) {
    (void)_value;
	return true;
}

void DriveStubDefault::setSiblingIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    setSiblingIdAttribute(_value);
}

void DriveStubDefault::onRemoteSiblingIdAttributeChanged() {
    // No operation in default
}

void DriveStubDefault::RemoteEventHandler::onRemoteSiblingIdAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteSiblingIdAttributeChanged();
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSiblingIdAttribute(std::string _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetSiblingIdAttribute(std::move(_value));
}

bool DriveStubDefault::RemoteEventHandler::onRemoteSetSiblingIdAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) {
    (void)_client;
    return onRemoteSetSiblingIdAttribute(_value);
}


void DriveStubDefault::Eject(const std::shared_ptr<CommonAPI::ClientId> _client, Drive::tEject_optionsDict _options, EjectReply_t _reply) {
    (void)_client;
    (void) _options;
    _reply();
}

void DriveStubDefault::SetConfiguration(const std::shared_ptr<CommonAPI::ClientId> _client, Drive::tSetConfiguration_valueDict _value, Drive::tSetConfiguration_optionsDict _options, SetConfigurationReply_t _reply) {
    (void)_client;
    (void) _value;
    (void) _options;
    _reply();
}

void DriveStubDefault::PowerOff(const std::shared_ptr<CommonAPI::ClientId> _client, Drive::tPowerOff_optionsDict _options, PowerOffReply_t _reply) {
    (void)_client;
    (void) _options;
    _reply();
}




DriveStubDefault::RemoteEventHandler::RemoteEventHandler(DriveStubDefault *_defaultStub)
    : 
      defaultStub_(_defaultStub) {
}

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2
