/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/FilesystemDBusProxy.hpp>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

std::shared_ptr<CommonAPI::DBus::DBusProxy> createFilesystemDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection) {
	return std::make_shared<FilesystemDBusProxy>(_address, _connection);
}

INITIALIZER(registerFilesystemDBusProxy) {
     CommonAPI::DBus::Factory::get()->registerProxyCreateMethod(
		Filesystem::getInterface(),
		&createFilesystemDBusProxy);
}

FilesystemDBusProxy::FilesystemDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection)
	:	CommonAPI::DBus::DBusProxy(_address, _connection)
,		mountPoints_(*this, "onMountPointsAttributeChanged", "setMountPointsAttribute", "aay", "getMountPointsAttribute", static_cast<CommonAPI::DBus::ArrayDeployment<Filesystem_::tMountPointsArrayDeployment_t>*>(nullptr))
{
}

      FilesystemDBusProxy::MountPointsAttribute& FilesystemDBusProxy::getMountPointsAttribute() {
          return mountPoints_;
      }

    
    /**
     * description: array generated for DBus argument MountPoints
     */
    void FilesystemDBusProxy::SetLabel(const std::string &_label, const Filesystem::tSetLabel_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_label(_label, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Filesystem::tSetLabel_optionsDict, Filesystem_::tSetLabel_optionsDictDeployment_t> deploy_options(_options, static_cast<Filesystem_::tSetLabel_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Filesystem::tSetLabel_optionsDict, Filesystem_::tSetLabel_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "SetLabel",
        "sa{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_label, deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> FilesystemDBusProxy::SetLabelAsync(const std::string &_label, const Filesystem::tSetLabel_optionsDict &_options, SetLabelAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_label(_label, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Filesystem::tSetLabel_optionsDict, Filesystem_::tSetLabel_optionsDictDeployment_t> deploy_options(_options, static_cast<Filesystem_::tSetLabel_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Filesystem::tSetLabel_optionsDict, Filesystem_::tSetLabel_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "SetLabel",
        "sa{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_label, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void FilesystemDBusProxy::Mount(const Filesystem::tMount_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::string &_mount_path, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Filesystem::tMount_optionsDict, Filesystem_::tMount_optionsDictDeployment_t> deploy_options(_options, static_cast<Filesystem_::tMount_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_mount_path(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Filesystem::tMount_optionsDict, Filesystem_::tMount_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "Mount",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus,
deploy_mount_path);
_mount_path = deploy_mount_path.getValue();
}
    std::future<CommonAPI::CallStatus> FilesystemDBusProxy::MountAsync(const Filesystem::tMount_optionsDict &_options, MountAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Filesystem::tMount_optionsDict, Filesystem_::tMount_optionsDictDeployment_t> deploy_options(_options, static_cast<Filesystem_::tMount_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_mount_path(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Filesystem::tMount_optionsDict, Filesystem_::tMount_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodAsync(
        *this,
        "Mount",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _mount_path) {
        	if (_callback)
        		_callback(_internalCallStatus, _mount_path.getValue());
        },
        std::make_tuple(deploy_mount_path));
    }
    void FilesystemDBusProxy::Unmount(const Filesystem::tUnmount_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Filesystem::tUnmount_optionsDict, Filesystem_::tUnmount_optionsDictDeployment_t> deploy_options(_options, static_cast<Filesystem_::tUnmount_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Filesystem::tUnmount_optionsDict, Filesystem_::tUnmount_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "Unmount",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> FilesystemDBusProxy::UnmountAsync(const Filesystem::tUnmount_optionsDict &_options, UnmountAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Filesystem::tUnmount_optionsDict, Filesystem_::tUnmount_optionsDictDeployment_t> deploy_options(_options, static_cast<Filesystem_::tUnmount_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Filesystem::tUnmount_optionsDict, Filesystem_::tUnmount_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "Unmount",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }


void FilesystemDBusProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
          ownVersionMajor = 2;
          ownVersionMinor = 1;
      }

      } // namespace UDisks2
      } // namespace freedesktop
      } // namespace org
      } // namespace v2
