/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/Filesystem.hpp>
#include <v2/org/freedesktop/UDisks2/FilesystemDBusStubAdapter.hpp>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> createFilesystemDBusStubAdapter(
                   const CommonAPI::DBus::DBusAddress &_address,
                   const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
                   const std::shared_ptr<CommonAPI::StubBase> &_stub) {
    return std::make_shared<FilesystemDBusStubAdapter>(_address, _connection, _stub);
}

INITIALIZER(registerFilesystemDBusStubAdapter) {
    CommonAPI::DBus::Factory::get()->registerStubAdapterCreateMethod(
    	Filesystem::getInterface(), &createFilesystemDBusStubAdapter);
}

FilesystemDBusStubAdapterInternal::~FilesystemDBusStubAdapterInternal() {
    deactivateManagedInstances();
    FilesystemDBusStubAdapterHelper::deinit();
}

void FilesystemDBusStubAdapterInternal::deactivateManagedInstances() {

}

const char* FilesystemDBusStubAdapterInternal::getMethodsDBusIntrospectionXmlData() const {
    static const std::string introspectionData =
        "<method name=\"getInterfaceVersion\">\n"
            "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"getMountPointsAttribute\">\n"
            "<arg name=\"value\" type=\"aay\" direction=\"out\" />"
        "</method>\n"
        "<method name=\"setMountPointsAttribute\">\n"
            "<arg name=\"requestedValue\" type=\"aay\" direction=\"in\" />\n"
            "<arg name=\"setValue\" type=\"aay\" direction=\"out\" />\n"
        "</method>\n"
        "<signal name=\"onMountPointsAttributeChanged\">\n"
            "<arg name=\"changedValue\" type=\"aay\" />\n"
        "</signal>\n"
        /**
         * description: array generated for DBus argument MountPoints
         */
        "<method name=\"SetLabel\">\n"
            "<arg name=\"_label\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
        "</method>\n"
        "<method name=\"Mount\">\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
            "<arg name=\"_mount_path\" type=\"s\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"Unmount\">\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
        "</method>\n"

    ;
    return introspectionData.c_str();
}

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::FilesystemStub,
        CommonAPI::Version
        > FilesystemDBusStubAdapterInternal::getFilesystemInterfaceVersionStubDispatcher(&FilesystemStub::getInterfaceVersion, "uu");

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::FilesystemStub,
        std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray>,
        CommonAPI::DBus::ArrayDeployment<Filesystem_::tMountPointsArrayDeployment_t>
        > FilesystemDBusStubAdapterInternal::getMountPointsAttributeStubDispatcher(
            &::v2::org::freedesktop::UDisks2::FilesystemStub::getMountPointsAttribute
            , "aay"
            );
CommonAPI::DBus::DBusSetObservableAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::FilesystemStub,
        std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray>,
        CommonAPI::DBus::ArrayDeployment<Filesystem_::tMountPointsArrayDeployment_t>
        > FilesystemDBusStubAdapterInternal::setMountPointsAttributeStubDispatcher(
                &::v2::org::freedesktop::UDisks2::FilesystemStub::getMountPointsAttribute,
                &FilesystemStubRemoteEvent::onRemoteSetMountPointsAttribute,
                &FilesystemStubRemoteEvent::onRemoteMountPointsAttributeChanged
                ,&FilesystemStubAdapter::fireMountPointsAttributeChanged
                ,"aay"
                );



/**
 * description: array generated for DBus argument MountPoints
 */
CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::FilesystemStub,
    std::tuple<std::string, Filesystem::tSetLabel_optionsDict>,
    std::tuple<>,
    std::tuple<CommonAPI::DBus::StringDeployment, Filesystem_::tSetLabel_optionsDictDeployment_t>,
    std::tuple<>
    
    > FilesystemDBusStubAdapterInternal::setLabelStubDispatcher(
    &FilesystemStub::SetLabel, "",
					std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<Filesystem_::tSetLabel_optionsDictDeployment_t*>(nullptr)),
                	std::make_tuple());

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::FilesystemStub,
    std::tuple<Filesystem::tMount_optionsDict>,
    std::tuple<std::string>,
    std::tuple<Filesystem_::tMount_optionsDictDeployment_t>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > FilesystemDBusStubAdapterInternal::mountStubDispatcher(
    &FilesystemStub::Mount, "s",
					std::make_tuple(static_cast<Filesystem_::tMount_optionsDictDeployment_t*>(nullptr)),
                	std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::FilesystemStub,
    std::tuple<Filesystem::tUnmount_optionsDict>,
    std::tuple<>,
    std::tuple<Filesystem_::tUnmount_optionsDictDeployment_t>,
    std::tuple<>
    
    > FilesystemDBusStubAdapterInternal::unmountStubDispatcher(
    &FilesystemStub::Unmount, "",
					std::make_tuple(static_cast<Filesystem_::tUnmount_optionsDictDeployment_t*>(nullptr)),
                	std::make_tuple());


void FilesystemDBusStubAdapterInternal::fireMountPointsAttributeChanged(const std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray>& value) {
    CommonAPI::Deployable<std::vector<Filesystem::tMountPointsArray>, CommonAPI::DBus::ArrayDeployment<Filesystem_::tMountPointsArrayDeployment_t>> deployedValue(value, static_cast<CommonAPI::DBus::ArrayDeployment<Filesystem_::tMountPointsArrayDeployment_t>*>(nullptr));
    CommonAPI::DBus::DBusStubSignalHelper<CommonAPI::DBus::DBusSerializableArguments<
    CommonAPI::Deployable<
        std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray>,
        CommonAPI::DBus::ArrayDeployment<Filesystem_::tMountPointsArrayDeployment_t>
    >
    >>
        ::sendSignal(
            *this,
            "onMountPointsAttributeChanged",
            "aay",
            deployedValue
    
    );
}



const FilesystemDBusStubAdapterHelper::StubDispatcherTable& FilesystemDBusStubAdapterInternal::getStubDispatcherTable() {
    return stubDispatcherTable_;
}

const CommonAPI::DBus::StubAttributeTable& FilesystemDBusStubAdapterInternal::getStubAttributeTable() {
    return stubAttributeTable_;
}

FilesystemDBusStubAdapterInternal::FilesystemDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub)
	: CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      FilesystemDBusStubAdapterHelper(_address, _connection, std::dynamic_pointer_cast<FilesystemStub>(_stub), false),
      stubDispatcherTable_({
            { { "getMountPointsAttribute", "" }, &org::freedesktop::UDisks2::FilesystemDBusStubAdapterInternal::getMountPointsAttributeStubDispatcher }
            , { { "setMountPointsAttribute", "aay" }, &org::freedesktop::UDisks2::FilesystemDBusStubAdapterInternal::setMountPointsAttributeStubDispatcher }
            ,
            /**
             * description: array generated for DBus argument MountPoints
             */
            { { "SetLabel", "sa{s(yv)}" }, &org::freedesktop::UDisks2::FilesystemDBusStubAdapterInternal::setLabelStubDispatcher },
            { { "Mount", "a{s(yv)}" }, &org::freedesktop::UDisks2::FilesystemDBusStubAdapterInternal::mountStubDispatcher },
            { { "Unmount", "a{s(yv)}" }, &org::freedesktop::UDisks2::FilesystemDBusStubAdapterInternal::unmountStubDispatcher }
            }),
        stubAttributeTable_() {

    stubDispatcherTable_.insert({ { "getInterfaceVersion", "" }, &org::freedesktop::UDisks2::FilesystemDBusStubAdapterInternal::getFilesystemInterfaceVersionStubDispatcher });
}

bool FilesystemDBusStubAdapterInternal::hasFreedesktopProperties() {
    return false;
}

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2
