/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_PROXY_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_PROXY_HPP_

#include <v2/org/freedesktop/UDisks2/FilesystemProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

template <typename ... _AttributeExtensions>
class FilesystemProxy
    : virtual public Filesystem, 
      virtual public FilesystemProxyBase,
      virtual public _AttributeExtensions... {
public:
    FilesystemProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~FilesystemProxy();

    typedef Filesystem InterfaceType;


    /**
     * Returns the wrapper class that provides access to the attribute MountPoints.
     */
    virtual MountPointsAttribute& getMountPointsAttribute() {
        return delegate_->getMountPointsAttribute();
    }


    /**
     * description: array generated for DBus argument MountPoints
     * Calls SetLabel with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void SetLabel(const std::string &_label, const Filesystem::tSetLabel_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetLabel with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> SetLabelAsync(const std::string &_label, const Filesystem::tSetLabel_optionsDict &_options, SetLabelAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Mount with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void Mount(const Filesystem::tMount_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::string &_mount_path, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Mount with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> MountAsync(const Filesystem::tMount_optionsDict &_options, MountAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Unmount with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void Unmount(const Filesystem::tUnmount_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Unmount with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> UnmountAsync(const Filesystem::tUnmount_optionsDict &_options, UnmountAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<FilesystemProxyBase> delegate_;
};

typedef FilesystemProxy<> FilesystemProxyDefault;

namespace FilesystemExtensions {
    template <template <typename > class _ExtensionType>
    class MountPointsAttributeExtension {
     public:
        typedef _ExtensionType<FilesystemProxyBase::MountPointsAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<FilesystemProxyBase::MountPointsAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        MountPointsAttributeExtension() {}
    #endif
    
        MountPointsAttributeExtension(FilesystemProxyBase& proxy): attributeExtension_(proxy.getMountPointsAttribute()) {
        }
    
        inline extension_type& getMountPointsAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace FilesystemExtensions

//
// FilesystemProxy Implementation
//
template <typename ... _AttributeExtensions>
FilesystemProxy<_AttributeExtensions...>::FilesystemProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<FilesystemProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<FilesystemProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
FilesystemProxy<_AttributeExtensions...>::~FilesystemProxy() {
}

/**
 * description: array generated for DBus argument MountPoints
 */
template <typename ... _AttributeExtensions>
void FilesystemProxy<_AttributeExtensions...>::SetLabel(const std::string &_label, const Filesystem::tSetLabel_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->SetLabel(_label, _options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> FilesystemProxy<_AttributeExtensions...>::SetLabelAsync(const std::string &_label, const Filesystem::tSetLabel_optionsDict &_options, SetLabelAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->SetLabelAsync(_label, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void FilesystemProxy<_AttributeExtensions...>::Mount(const Filesystem::tMount_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::string &_mount_path, const CommonAPI::CallInfo *_info) {
    delegate_->Mount(_options, _internalCallStatus, _mount_path, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> FilesystemProxy<_AttributeExtensions...>::MountAsync(const Filesystem::tMount_optionsDict &_options, MountAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->MountAsync(_options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void FilesystemProxy<_AttributeExtensions...>::Unmount(const Filesystem::tUnmount_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->Unmount(_options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> FilesystemProxy<_AttributeExtensions...>::UnmountAsync(const Filesystem::tUnmount_optionsDict &_options, UnmountAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->UnmountAsync(_options, _callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &FilesystemProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool FilesystemProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool FilesystemProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& FilesystemProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& FilesystemProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::v2::org::freedesktop::UDisks2::FilesystemProxy,
    _AttributeExtension> {
    typedef typename ::v2::org::freedesktop::UDisks2::FilesystemProxy<
            ::v2::org::freedesktop::UDisks2::FilesystemExtensions::MountPointsAttributeExtension<_AttributeExtension>
    > class_t;
};
}


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_PROXY_HPP_
