/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_STUB_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_STUB_HPP_

#include <functional>




#include <v2/org/freedesktop/UDisks2/Filesystem.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <cstdint>
#include <string>
#include <unordered_map>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Filesystem. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class FilesystemStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual Filesystem {
 public:
    ///Notifies all remote listeners about a change of value of the attribute MountPoints.
    virtual void fireMountPointsAttributeChanged(const std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray>& MountPoints) = 0;



    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Filesystem.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class FilesystemStubRemoteEvent
{
public:
    virtual ~FilesystemStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute MountPoints
    virtual bool onRemoteSetMountPointsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value) = 0;
    /// Action callback for remote set requests on the attribute MountPoints
    virtual void onRemoteMountPointsAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Filesystem to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class FilesystemStub
    : public virtual CommonAPI::Stub<FilesystemStubAdapter, FilesystemStubRemoteEvent>
{
public:
    typedef std::function<void ()>SetLabelReply_t;
    typedef std::function<void (std::string _mount_path)>MountReply_t;
    typedef std::function<void ()>UnmountReply_t;

    virtual ~FilesystemStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute MountPoints
    virtual const std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> &getMountPointsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /**
     * description: array generated for DBus argument MountPoints
     */
    /// This is the method that will be called on remote calls on the method SetLabel.
    virtual void SetLabel(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _label, Filesystem::tSetLabel_optionsDict _options, SetLabelReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method Mount.
    virtual void Mount(const std::shared_ptr<CommonAPI::ClientId> _client, Filesystem::tMount_optionsDict _options, MountReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method Unmount.
    virtual void Unmount(const std::shared_ptr<CommonAPI::ClientId> _client, Filesystem::tUnmount_optionsDict _options, UnmountReply_t _reply) = 0;

    using CommonAPI::Stub<FilesystemStubAdapter, FilesystemStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<FilesystemStubAdapter, FilesystemStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<FilesystemStubAdapter, FilesystemStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef FilesystemStubRemoteEvent RemoteEventType;
    typedef Filesystem StubInterface;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_STUB_HPP_
