/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/FilesystemStubDefault.hpp>
#include <assert.h>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

FilesystemStubDefault::FilesystemStubDefault():
        remoteEventHandler_(this),
        interfaceVersion_(Filesystem::getInterfaceVersion()) {
}

const CommonAPI::Version& FilesystemStubDefault::getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return interfaceVersion_;
}

FilesystemStubRemoteEvent* FilesystemStubDefault::initStubAdapter(const std::shared_ptr<FilesystemStubAdapter> &_adapter) {
    CommonAPI::Stub<FilesystemStubAdapter, FilesystemStubRemoteEvent>::stubAdapter_ = _adapter;
    return &remoteEventHandler_;
}

const std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray>& FilesystemStubDefault::getMountPointsAttribute() {
    return mountPointsAttributeValue_;
}

const std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray>& FilesystemStubDefault::getMountPointsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return getMountPointsAttribute();
}

void FilesystemStubDefault::setMountPointsAttribute(std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value) {
    const bool valueChanged = trySetMountPointsAttribute(std::move(_value));
    if (valueChanged) {
        auto stubAdapter = CommonAPI::Stub<FilesystemStubAdapter, FilesystemStubRemoteEvent>::stubAdapter_.lock();
        if (stubAdapter)
            stubAdapter->fireMountPointsAttributeChanged(mountPointsAttributeValue_);
    }
}

bool FilesystemStubDefault::trySetMountPointsAttribute(std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value) {
    if (!validateMountPointsAttributeRequestedValue(_value))
        return false;

    const bool valueChanged = (mountPointsAttributeValue_ != _value);
    mountPointsAttributeValue_ = std::move(_value);
    return valueChanged;
}

bool FilesystemStubDefault::validateMountPointsAttributeRequestedValue(const std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> &_value) {
    (void)_value;
	return true;
}

void FilesystemStubDefault::setMountPointsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value) {
    (void)_client;
    setMountPointsAttribute(_value);
}

void FilesystemStubDefault::onRemoteMountPointsAttributeChanged() {
    // No operation in default
}

void FilesystemStubDefault::RemoteEventHandler::onRemoteMountPointsAttributeChanged() {
	assert(defaultStub_ !=NULL);
    defaultStub_->onRemoteMountPointsAttributeChanged();
}

bool FilesystemStubDefault::RemoteEventHandler::onRemoteSetMountPointsAttribute(std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value) {
	assert(defaultStub_ !=NULL);
    return defaultStub_->trySetMountPointsAttribute(std::move(_value));
}

bool FilesystemStubDefault::RemoteEventHandler::onRemoteSetMountPointsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value) {
    (void)_client;
    return onRemoteSetMountPointsAttribute(_value);
}


/**
 * description: array generated for DBus argument MountPoints
 */
void FilesystemStubDefault::SetLabel(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _label, Filesystem::tSetLabel_optionsDict _options, SetLabelReply_t _reply) {
    (void)_client;
    (void) _label;
    (void) _options;
    _reply();
}

void FilesystemStubDefault::Mount(const std::shared_ptr<CommonAPI::ClientId> _client, Filesystem::tMount_optionsDict _options, MountReply_t _reply) {
    (void)_client;
    (void) _options;
    std::string mount_path = "";
    _reply(mount_path);
}

void FilesystemStubDefault::Unmount(const std::shared_ptr<CommonAPI::ClientId> _client, Filesystem::tUnmount_optionsDict _options, UnmountReply_t _reply) {
    (void)_client;
    (void) _options;
    _reply();
}




FilesystemStubDefault::RemoteEventHandler::RemoteEventHandler(FilesystemStubDefault *_defaultStub)
    : 
      defaultStub_(_defaultStub) {
}

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2
