/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_STUB_DEFAULT_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_STUB_DEFAULT_HPP_


#include <v2/org/freedesktop/UDisks2/FilesystemStub.hpp>
#include <sstream>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

/**
 * Provides a default implementation for FilesystemStubRemoteEvent and
 * FilesystemStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class FilesystemStubDefault
    : public virtual FilesystemStub {
public:
    FilesystemStubDefault();

    FilesystemStubRemoteEvent* initStubAdapter(const std::shared_ptr<FilesystemStubAdapter> &_adapter);

    const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client);

    virtual const std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray>& getMountPointsAttribute();
    virtual const std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray>& getMountPointsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setMountPointsAttribute(std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value);
    virtual void setMountPointsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value);

    /**
     * description: array generated for DBus argument MountPoints
     */
    virtual void SetLabel(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _label, Filesystem::tSetLabel_optionsDict _options, SetLabelReply_t _reply);
    virtual void Mount(const std::shared_ptr<CommonAPI::ClientId> _client, Filesystem::tMount_optionsDict _options, MountReply_t _reply);
    virtual void Unmount(const std::shared_ptr<CommonAPI::ClientId> _client, Filesystem::tUnmount_optionsDict _options, UnmountReply_t _reply);



protected:
    virtual bool trySetMountPointsAttribute(std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value);
    virtual bool validateMountPointsAttributeRequestedValue(const std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> &_value);
    virtual void onRemoteMountPointsAttributeChanged();
    class RemoteEventHandler: public virtual FilesystemStubRemoteEvent {
    public:
        RemoteEventHandler(FilesystemStubDefault *_defaultStub);

        virtual bool onRemoteSetMountPointsAttribute(std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value);
        virtual bool onRemoteSetMountPointsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> _value);
        virtual void onRemoteMountPointsAttributeChanged();


    private:
        FilesystemStubDefault *defaultStub_;
    };
private:
    FilesystemStubDefault::RemoteEventHandler remoteEventHandler_;

    std::vector<::v2::org::freedesktop::UDisks2::Filesystem::tMountPointsArray> mountPointsAttributeValue_ {};

    CommonAPI::Version interfaceVersion_;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Filesystem_STUB_DEFAULT
