/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/ManagerDBusProxy.hpp>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

std::shared_ptr<CommonAPI::DBus::DBusProxy> createManagerDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection) {
	return std::make_shared<ManagerDBusProxy>(_address, _connection);
}

INITIALIZER(registerManagerDBusProxy) {
     CommonAPI::DBus::Factory::get()->registerProxyCreateMethod(
		Manager::getInterface(),
		&createManagerDBusProxy);
}

ManagerDBusProxy::ManagerDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection)
	:	CommonAPI::DBus::DBusProxy(_address, _connection)
,		version_(*this, getAddress().getInterface(), "Version", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
{
}

      ManagerDBusProxy::VersionAttribute& ManagerDBusProxy::getVersionAttribute() {
          return version_;
      }

    
    void ManagerDBusProxy::LoopSetup(const uint32_t &_fd, const Manager::tLoopSetup_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::string &_resulting_device, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> deploy_fd(_fd, static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<Manager::tLoopSetup_optionsDict, Manager_::tLoopSetup_optionsDictDeployment_t> deploy_options(_options, static_cast<Manager_::tLoopSetup_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_resulting_device(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment >,
            CommonAPI::Deployable<Manager::tLoopSetup_optionsDict, Manager_::tLoopSetup_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "LoopSetup",
        "ua{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_fd, deploy_options,
_internalCallStatus,
deploy_resulting_device);
_resulting_device = deploy_resulting_device.getValue();
}
    std::future<CommonAPI::CallStatus> ManagerDBusProxy::LoopSetupAsync(const uint32_t &_fd, const Manager::tLoopSetup_optionsDict &_options, LoopSetupAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment> deploy_fd(_fd, static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<Manager::tLoopSetup_optionsDict, Manager_::tLoopSetup_optionsDictDeployment_t> deploy_options(_options, static_cast<Manager_::tLoopSetup_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_resulting_device(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint32_t, CommonAPI::EmptyDeployment >,
            CommonAPI::Deployable<Manager::tLoopSetup_optionsDict, Manager_::tLoopSetup_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodAsync(
        *this,
        "LoopSetup",
        "ua{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_fd, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _resulting_device) {
        	if (_callback)
        		_callback(_internalCallStatus, _resulting_device.getValue());
        },
        std::make_tuple(deploy_resulting_device));
    }
    void ManagerDBusProxy::MDRaidCreate(const std::vector<std::string> &_blocks, const std::string &_level, const std::string &_name, const uint64_t &_chunk, const Manager::tMDRaidCreate_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::string &_resulting_array, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>> deploy_blocks(_blocks, static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_level(_level, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_name(_name, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<uint64_t, CommonAPI::EmptyDeployment> deploy_chunk(_chunk, static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<Manager::tMDRaidCreate_optionsDict, Manager_::tMDRaidCreate_optionsDictDeployment_t> deploy_options(_options, static_cast<Manager_::tMDRaidCreate_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_resulting_array(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment> >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<uint64_t, CommonAPI::EmptyDeployment >,
            CommonAPI::Deployable<Manager::tMDRaidCreate_optionsDict, Manager_::tMDRaidCreate_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodWithReply(
        *this,
        "MDRaidCreate",
        "asssta{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_blocks, deploy_level, deploy_name, deploy_chunk, deploy_options,
_internalCallStatus,
deploy_resulting_array);
_resulting_array = deploy_resulting_array.getValue();
}
    std::future<CommonAPI::CallStatus> ManagerDBusProxy::MDRaidCreateAsync(const std::vector<std::string> &_blocks, const std::string &_level, const std::string &_name, const uint64_t &_chunk, const Manager::tMDRaidCreate_optionsDict &_options, MDRaidCreateAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>> deploy_blocks(_blocks, static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_level(_level, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_name(_name, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<uint64_t, CommonAPI::EmptyDeployment> deploy_chunk(_chunk, static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<Manager::tMDRaidCreate_optionsDict, Manager_::tMDRaidCreate_optionsDictDeployment_t> deploy_options(_options, static_cast<Manager_::tMDRaidCreate_optionsDictDeployment_t*>(nullptr));
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_resulting_array(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::vector<std::string>, CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment> >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<uint64_t, CommonAPI::EmptyDeployment >,
            CommonAPI::Deployable<Manager::tMDRaidCreate_optionsDict, Manager_::tMDRaidCreate_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>
            >
        	>::callMethodAsync(
        *this,
        "MDRaidCreate",
        "asssta{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_blocks, deploy_level, deploy_name, deploy_chunk, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _resulting_array) {
        	if (_callback)
        		_callback(_internalCallStatus, _resulting_array.getValue());
        },
        std::make_tuple(deploy_resulting_array));
    }


void ManagerDBusProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
          ownVersionMajor = 2;
          ownVersionMinor = 1;
      }

      } // namespace UDisks2
      } // namespace freedesktop
      } // namespace org
      } // namespace v2
