/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/Manager.hpp>
#include <v2/org/freedesktop/UDisks2/ManagerDBusStubAdapter.hpp>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> createManagerDBusStubAdapter(
                   const CommonAPI::DBus::DBusAddress &_address,
                   const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
                   const std::shared_ptr<CommonAPI::StubBase> &_stub) {
    return std::make_shared<ManagerDBusStubAdapter>(_address, _connection, _stub);
}

INITIALIZER(registerManagerDBusStubAdapter) {
    CommonAPI::DBus::Factory::get()->registerStubAdapterCreateMethod(
    	Manager::getInterface(), &createManagerDBusStubAdapter);
}

ManagerDBusStubAdapterInternal::~ManagerDBusStubAdapterInternal() {
    deactivateManagedInstances();
    ManagerDBusStubAdapterHelper::deinit();
}

void ManagerDBusStubAdapterInternal::deactivateManagedInstances() {

}

const char* ManagerDBusStubAdapterInternal::getMethodsDBusIntrospectionXmlData() const {
    static const std::string introspectionData =
        "<method name=\"getInterfaceVersion\">\n"
            "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
        "</method>\n"
        "<property name=\"Version\" type=\"s\" access=\"readwrite\" />\n"
        "<method name=\"LoopSetup\">\n"
            "<arg name=\"_fd\" type=\"u\" direction=\"in\" />\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
            "<arg name=\"_resulting_device\" type=\"s\" direction=\"out\" />\n"
        "</method>\n"
        "<method name=\"MDRaidCreate\">\n"
            "<arg name=\"_blocks\" type=\"as\" direction=\"in\" />\n"
            "<arg name=\"_level\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_name\" type=\"s\" direction=\"in\" />\n"
            "<arg name=\"_chunk\" type=\"t\" direction=\"in\" />\n"
            "<arg name=\"_options\" type=\"a{s(yv)}\" direction=\"in\" />\n"
            "<arg name=\"_resulting_array\" type=\"s\" direction=\"out\" />\n"
        "</method>\n"

    ;
    return introspectionData.c_str();
}

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::ManagerStub,
        CommonAPI::Version
        > ManagerDBusStubAdapterInternal::getManagerInterfaceVersionStubDispatcher(&ManagerStub::getInterfaceVersion, "uu");

CommonAPI::DBus::DBusGetFreedesktopAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::ManagerStub,
        std::string,
        CommonAPI::DBus::StringDeployment
        > ManagerDBusStubAdapterInternal::getVersionAttributeStubDispatcher(
            &::v2::org::freedesktop::UDisks2::ManagerStub::getVersionAttribute
            );
CommonAPI::DBus::DBusSetFreedesktopObservableAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::ManagerStub,
        std::string,
        CommonAPI::DBus::StringDeployment
        > ManagerDBusStubAdapterInternal::setVersionAttributeStubDispatcher(
                &::v2::org::freedesktop::UDisks2::ManagerStub::getVersionAttribute,
                &ManagerStubRemoteEvent::onRemoteSetVersionAttribute,
                &ManagerStubRemoteEvent::onRemoteVersionAttributeChanged
                ,&ManagerStubAdapter::fireVersionAttributeChanged
                );



CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::ManagerStub,
    std::tuple<uint32_t, Manager::tLoopSetup_optionsDict>,
    std::tuple<std::string>,
    std::tuple<CommonAPI::EmptyDeployment, Manager_::tLoopSetup_optionsDictDeployment_t>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > ManagerDBusStubAdapterInternal::loopSetupStubDispatcher(
    &ManagerStub::LoopSetup, "s",
					std::make_tuple(static_cast<CommonAPI::EmptyDeployment*>(nullptr), static_cast<Manager_::tLoopSetup_optionsDictDeployment_t*>(nullptr)),
                	std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)));

CommonAPI::DBus::DBusMethodWithReplyStubDispatcher<
    ::v2::org::freedesktop::UDisks2::ManagerStub,
    std::tuple<std::vector<std::string>, std::string, std::string, uint64_t, Manager::tMDRaidCreate_optionsDict>,
    std::tuple<std::string>,
    std::tuple<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>, CommonAPI::DBus::StringDeployment, CommonAPI::DBus::StringDeployment, CommonAPI::EmptyDeployment, Manager_::tMDRaidCreate_optionsDictDeployment_t>,
    std::tuple<CommonAPI::DBus::StringDeployment>
    
    > ManagerDBusStubAdapterInternal::mDRaidCreateStubDispatcher(
    &ManagerStub::MDRaidCreate, "s",
					std::make_tuple(static_cast<CommonAPI::DBus::ArrayDeployment<CommonAPI::DBus::StringDeployment>*>(nullptr), static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), static_cast<CommonAPI::EmptyDeployment*>(nullptr), static_cast<Manager_::tMDRaidCreate_optionsDictDeployment_t*>(nullptr)),
                	std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)));


void ManagerDBusStubAdapterInternal::fireVersionAttributeChanged(const std::string& value) {
    CommonAPI::DBus::DBusStubFreedesktopPropertiesSignalHelper<
        std::string,
        CommonAPI::DBus::StringDeployment
    > ::sendPropertiesChangedSignal(
            *this,
            "Version",
            value,
            static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)
    );
}



const ManagerDBusStubAdapterHelper::StubDispatcherTable& ManagerDBusStubAdapterInternal::getStubDispatcherTable() {
    return stubDispatcherTable_;
}

const CommonAPI::DBus::StubAttributeTable& ManagerDBusStubAdapterInternal::getStubAttributeTable() {
    return stubAttributeTable_;
}

ManagerDBusStubAdapterInternal::ManagerDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub)
	: CommonAPI::DBus::DBusStubAdapter(_address, _connection,false),
      ManagerDBusStubAdapterHelper(_address, _connection, std::dynamic_pointer_cast<ManagerStub>(_stub), false),
      stubDispatcherTable_({
            { { "LoopSetup", "ua{s(yv)}" }, &org::freedesktop::UDisks2::ManagerDBusStubAdapterInternal::loopSetupStubDispatcher },
            { { "MDRaidCreate", "asssta{s(yv)}" }, &org::freedesktop::UDisks2::ManagerDBusStubAdapterInternal::mDRaidCreateStubDispatcher }
            }),
        stubAttributeTable_({
        {
            "Version",
            {
                &org::freedesktop::UDisks2::ManagerDBusStubAdapterInternal::getVersionAttributeStubDispatcher,
                &org::freedesktop::UDisks2::ManagerDBusStubAdapterInternal::setVersionAttributeStubDispatcher
            }
        }
        }
        ) {

    stubDispatcherTable_.insert({ { "getInterfaceVersion", "" }, &org::freedesktop::UDisks2::ManagerDBusStubAdapterInternal::getManagerInterfaceVersionStubDispatcher });
}

bool ManagerDBusStubAdapterInternal::hasFreedesktopProperties() {
    return true;
}

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2
