/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Manager_PROXY_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Manager_PROXY_HPP_

#include <v2/org/freedesktop/UDisks2/ManagerProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

template <typename ... _AttributeExtensions>
class ManagerProxy
    : virtual public Manager, 
      virtual public ManagerProxyBase,
      virtual public _AttributeExtensions... {
public:
    ManagerProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~ManagerProxy();

    typedef Manager InterfaceType;


    /**
     * Returns the wrapper class that provides access to the attribute Version.
     */
    virtual VersionAttribute& getVersionAttribute() {
        return delegate_->getVersionAttribute();
    }


    /**
     * Calls LoopSetup with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void LoopSetup(const uint32_t &_fd, const Manager::tLoopSetup_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::string &_resulting_device, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls LoopSetup with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> LoopSetupAsync(const uint32_t &_fd, const Manager::tLoopSetup_optionsDict &_options, LoopSetupAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls MDRaidCreate with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void MDRaidCreate(const std::vector<std::string> &_blocks, const std::string &_level, const std::string &_name, const uint64_t &_chunk, const Manager::tMDRaidCreate_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::string &_resulting_array, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls MDRaidCreate with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> MDRaidCreateAsync(const std::vector<std::string> &_blocks, const std::string &_level, const std::string &_name, const uint64_t &_chunk, const Manager::tMDRaidCreate_optionsDict &_options, MDRaidCreateAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<ManagerProxyBase> delegate_;
};

typedef ManagerProxy<> ManagerProxyDefault;

namespace ManagerExtensions {
    template <template <typename > class _ExtensionType>
    class VersionAttributeExtension {
     public:
        typedef _ExtensionType<ManagerProxyBase::VersionAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<ManagerProxyBase::VersionAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        VersionAttributeExtension() {}
    #endif
    
        VersionAttributeExtension(ManagerProxyBase& proxy): attributeExtension_(proxy.getVersionAttribute()) {
        }
    
        inline extension_type& getVersionAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace ManagerExtensions

//
// ManagerProxy Implementation
//
template <typename ... _AttributeExtensions>
ManagerProxy<_AttributeExtensions...>::ManagerProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<ManagerProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<ManagerProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
ManagerProxy<_AttributeExtensions...>::~ManagerProxy() {
}

template <typename ... _AttributeExtensions>
void ManagerProxy<_AttributeExtensions...>::LoopSetup(const uint32_t &_fd, const Manager::tLoopSetup_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::string &_resulting_device, const CommonAPI::CallInfo *_info) {
    delegate_->LoopSetup(_fd, _options, _internalCallStatus, _resulting_device, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ManagerProxy<_AttributeExtensions...>::LoopSetupAsync(const uint32_t &_fd, const Manager::tLoopSetup_optionsDict &_options, LoopSetupAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->LoopSetupAsync(_fd, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void ManagerProxy<_AttributeExtensions...>::MDRaidCreate(const std::vector<std::string> &_blocks, const std::string &_level, const std::string &_name, const uint64_t &_chunk, const Manager::tMDRaidCreate_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, std::string &_resulting_array, const CommonAPI::CallInfo *_info) {
    delegate_->MDRaidCreate(_blocks, _level, _name, _chunk, _options, _internalCallStatus, _resulting_array, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> ManagerProxy<_AttributeExtensions...>::MDRaidCreateAsync(const std::vector<std::string> &_blocks, const std::string &_level, const std::string &_name, const uint64_t &_chunk, const Manager::tMDRaidCreate_optionsDict &_options, MDRaidCreateAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->MDRaidCreateAsync(_blocks, _level, _name, _chunk, _options, _callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &ManagerProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool ManagerProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool ManagerProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& ManagerProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& ManagerProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::v2::org::freedesktop::UDisks2::ManagerProxy,
    _AttributeExtension> {
    typedef typename ::v2::org::freedesktop::UDisks2::ManagerProxy<
            ::v2::org::freedesktop::UDisks2::ManagerExtensions::VersionAttributeExtension<_AttributeExtension>
    > class_t;
};
}


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Manager_PROXY_HPP_
