/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Manager_STUB_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Manager_STUB_HPP_

#include <functional>




#include <v2/org/freedesktop/UDisks2/Manager.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <cstdint>
#include <string>
#include <unordered_map>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Manager. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class ManagerStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual Manager {
 public:
    ///Notifies all remote listeners about a change of value of the attribute Version.
    virtual void fireVersionAttributeChanged(const std::string& Version) = 0;



    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Manager.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class ManagerStubRemoteEvent
{
public:
    virtual ~ManagerStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute Version
    virtual bool onRemoteSetVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Version
    virtual void onRemoteVersionAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Manager to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class ManagerStub
    : public virtual CommonAPI::Stub<ManagerStubAdapter, ManagerStubRemoteEvent>
{
public:
    typedef std::function<void (std::string _resulting_device)>LoopSetupReply_t;
    typedef std::function<void (std::string _resulting_array)>MDRaidCreateReply_t;

    virtual ~ManagerStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute Version
    virtual const std::string &getVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /// This is the method that will be called on remote calls on the method LoopSetup.
    virtual void LoopSetup(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _fd, Manager::tLoopSetup_optionsDict _options, LoopSetupReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method MDRaidCreate.
    virtual void MDRaidCreate(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<std::string> _blocks, std::string _level, std::string _name, uint64_t _chunk, Manager::tMDRaidCreate_optionsDict _options, MDRaidCreateReply_t _reply) = 0;

    using CommonAPI::Stub<ManagerStubAdapter, ManagerStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<ManagerStubAdapter, ManagerStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<ManagerStubAdapter, ManagerStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef ManagerStubRemoteEvent RemoteEventType;
    typedef Manager StubInterface;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Manager_STUB_HPP_
