/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Manager_STUB_DEFAULT_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Manager_STUB_DEFAULT_HPP_


#include <v2/org/freedesktop/UDisks2/ManagerStub.hpp>
#include <sstream>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

/**
 * Provides a default implementation for ManagerStubRemoteEvent and
 * ManagerStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class ManagerStubDefault
    : public virtual ManagerStub {
public:
    ManagerStubDefault();

    ManagerStubRemoteEvent* initStubAdapter(const std::shared_ptr<ManagerStubAdapter> &_adapter);

    const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client);

    virtual const std::string& getVersionAttribute();
    virtual const std::string& getVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setVersionAttribute(std::string _value);
    virtual void setVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);

    virtual void LoopSetup(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _fd, Manager::tLoopSetup_optionsDict _options, LoopSetupReply_t _reply);
    virtual void MDRaidCreate(const std::shared_ptr<CommonAPI::ClientId> _client, std::vector<std::string> _blocks, std::string _level, std::string _name, uint64_t _chunk, Manager::tMDRaidCreate_optionsDict _options, MDRaidCreateReply_t _reply);



protected:
    virtual bool trySetVersionAttribute(std::string _value);
    virtual bool validateVersionAttributeRequestedValue(const std::string &_value);
    virtual void onRemoteVersionAttributeChanged();
    class RemoteEventHandler: public virtual ManagerStubRemoteEvent {
    public:
        RemoteEventHandler(ManagerStubDefault *_defaultStub);

        virtual bool onRemoteSetVersionAttribute(std::string _value);
        virtual bool onRemoteSetVersionAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        virtual void onRemoteVersionAttributeChanged();


    private:
        ManagerStubDefault *defaultStub_;
    };
private:
    ManagerStubDefault::RemoteEventHandler remoteEventHandler_;

    std::string versionAttributeValue_ {};

    CommonAPI::Version interfaceVersion_;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Manager_STUB_DEFAULT
