/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/PartitionDBusProxy.hpp>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

std::shared_ptr<CommonAPI::DBus::DBusProxy> createPartitionDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection) {
	return std::make_shared<PartitionDBusProxy>(_address, _connection);
}

INITIALIZER(registerPartitionDBusProxy) {
     CommonAPI::DBus::Factory::get()->registerProxyCreateMethod(
		Partition::getInterface(),
		&createPartitionDBusProxy);
}

PartitionDBusProxy::PartitionDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection)
	:	CommonAPI::DBus::DBusProxy(_address, _connection)
,		number_(*this, "onNumberAttributeChanged", "setNumberAttribute", "u", "getNumberAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		type_(*this, "onTypeAttributeChanged", "setTypeAttribute", "s", "getTypeAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		flags_(*this, "onFlagsAttributeChanged", "setFlagsAttribute", "t", "getFlagsAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		offset_(*this, "onOffsetAttributeChanged", "setOffsetAttribute", "t", "getOffsetAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		size_(*this, "onSizeAttributeChanged", "setSizeAttribute", "t", "getSizeAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		name_(*this, "onNameAttributeChanged", "setNameAttribute", "s", "getNameAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		uUID_(*this, "onUUIDAttributeChanged", "setUUIDAttribute", "s", "getUUIDAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		table_(*this, "onTableAttributeChanged", "setTableAttribute", "s", "getTableAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr)),
		isContainer_(*this, "onIsContainerAttributeChanged", "setIsContainerAttribute", "b", "getIsContainerAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr)),
		isContained_(*this, "onIsContainedAttributeChanged", "setIsContainedAttribute", "b", "getIsContainedAttribute", static_cast<CommonAPI::EmptyDeployment*>(nullptr))
{
}

      PartitionDBusProxy::NumberAttribute& PartitionDBusProxy::getNumberAttribute() {
          return number_;
      }
      PartitionDBusProxy::TypeAttribute& PartitionDBusProxy::getTypeAttribute() {
          return type_;
      }
      PartitionDBusProxy::FlagsAttribute& PartitionDBusProxy::getFlagsAttribute() {
          return flags_;
      }
      PartitionDBusProxy::OffsetAttribute& PartitionDBusProxy::getOffsetAttribute() {
          return offset_;
      }
      PartitionDBusProxy::SizeAttribute& PartitionDBusProxy::getSizeAttribute() {
          return size_;
      }
      PartitionDBusProxy::NameAttribute& PartitionDBusProxy::getNameAttribute() {
          return name_;
      }
      PartitionDBusProxy::UUIDAttribute& PartitionDBusProxy::getUUIDAttribute() {
          return uUID_;
      }
      PartitionDBusProxy::TableAttribute& PartitionDBusProxy::getTableAttribute() {
          return table_;
      }
      PartitionDBusProxy::IsContainerAttribute& PartitionDBusProxy::getIsContainerAttribute() {
          return isContainer_;
      }
      PartitionDBusProxy::IsContainedAttribute& PartitionDBusProxy::getIsContainedAttribute() {
          return isContained_;
      }

    
    void PartitionDBusProxy::SetType(const std::string &_type, const Partition::tSetType_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_type(_type, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Partition::tSetType_optionsDict, Partition_::tSetType_optionsDictDeployment_t> deploy_options(_options, static_cast<Partition_::tSetType_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Partition::tSetType_optionsDict, Partition_::tSetType_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "SetType",
        "sa{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_type, deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> PartitionDBusProxy::SetTypeAsync(const std::string &_type, const Partition::tSetType_optionsDict &_options, SetTypeAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_type(_type, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Partition::tSetType_optionsDict, Partition_::tSetType_optionsDictDeployment_t> deploy_options(_options, static_cast<Partition_::tSetType_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Partition::tSetType_optionsDict, Partition_::tSetType_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "SetType",
        "sa{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_type, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void PartitionDBusProxy::SetName(const std::string &_name, const Partition::tSetName_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_name(_name, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Partition::tSetName_optionsDict, Partition_::tSetName_optionsDictDeployment_t> deploy_options(_options, static_cast<Partition_::tSetName_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Partition::tSetName_optionsDict, Partition_::tSetName_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "SetName",
        "sa{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_name, deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> PartitionDBusProxy::SetNameAsync(const std::string &_name, const Partition::tSetName_optionsDict &_options, SetNameAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_name(_name, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<Partition::tSetName_optionsDict, Partition_::tSetName_optionsDictDeployment_t> deploy_options(_options, static_cast<Partition_::tSetName_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<Partition::tSetName_optionsDict, Partition_::tSetName_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "SetName",
        "sa{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_name, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void PartitionDBusProxy::SetFlags(const uint64_t &_flags, const Partition::tSetFlags_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<uint64_t, CommonAPI::EmptyDeployment> deploy_flags(_flags, static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<Partition::tSetFlags_optionsDict, Partition_::tSetFlags_optionsDictDeployment_t> deploy_options(_options, static_cast<Partition_::tSetFlags_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint64_t, CommonAPI::EmptyDeployment >,
            CommonAPI::Deployable<Partition::tSetFlags_optionsDict, Partition_::tSetFlags_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "SetFlags",
        "ta{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_flags, deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> PartitionDBusProxy::SetFlagsAsync(const uint64_t &_flags, const Partition::tSetFlags_optionsDict &_options, SetFlagsAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<uint64_t, CommonAPI::EmptyDeployment> deploy_flags(_flags, static_cast<CommonAPI::EmptyDeployment*>(nullptr));
        CommonAPI::Deployable<Partition::tSetFlags_optionsDict, Partition_::tSetFlags_optionsDictDeployment_t> deploy_options(_options, static_cast<Partition_::tSetFlags_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<uint64_t, CommonAPI::EmptyDeployment >,
            CommonAPI::Deployable<Partition::tSetFlags_optionsDict, Partition_::tSetFlags_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "SetFlags",
        "ta{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_flags, deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void PartitionDBusProxy::Delete(const Partition::tDelete_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Partition::tDelete_optionsDict, Partition_::tDelete_optionsDictDeployment_t> deploy_options(_options, static_cast<Partition_::tDelete_optionsDictDeployment_t*>(nullptr));
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Partition::tDelete_optionsDict, Partition_::tDelete_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "Delete",
        "a{s(yv)}",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_options,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> PartitionDBusProxy::DeleteAsync(const Partition::tDelete_optionsDict &_options, DeleteAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<Partition::tDelete_optionsDict, Partition_::tDelete_optionsDictDeployment_t> deploy_options(_options, static_cast<Partition_::tDelete_optionsDictDeployment_t*>(nullptr));
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<Partition::tDelete_optionsDict, Partition_::tDelete_optionsDictDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "Delete",
        "a{s(yv)}",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_options,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }


void PartitionDBusProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
          ownVersionMajor = 2;
          ownVersionMinor = 1;
      }

      } // namespace UDisks2
      } // namespace freedesktop
      } // namespace org
      } // namespace v2
