/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Partition_PROXY_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Partition_PROXY_HPP_

#include <v2/org/freedesktop/UDisks2/PartitionProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

template <typename ... _AttributeExtensions>
class PartitionProxy
    : virtual public Partition, 
      virtual public PartitionProxyBase,
      virtual public _AttributeExtensions... {
public:
    PartitionProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~PartitionProxy();

    typedef Partition InterfaceType;


    /**
     * Returns the wrapper class that provides access to the attribute Number.
     */
    virtual NumberAttribute& getNumberAttribute() {
        return delegate_->getNumberAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Type.
     */
    virtual TypeAttribute& getTypeAttribute() {
        return delegate_->getTypeAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Flags.
     */
    virtual FlagsAttribute& getFlagsAttribute() {
        return delegate_->getFlagsAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Offset.
     */
    virtual OffsetAttribute& getOffsetAttribute() {
        return delegate_->getOffsetAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Size.
     */
    virtual SizeAttribute& getSizeAttribute() {
        return delegate_->getSizeAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Name.
     */
    virtual NameAttribute& getNameAttribute() {
        return delegate_->getNameAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute UUID.
     */
    virtual UUIDAttribute& getUUIDAttribute() {
        return delegate_->getUUIDAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute Table.
     */
    virtual TableAttribute& getTableAttribute() {
        return delegate_->getTableAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute IsContainer.
     */
    virtual IsContainerAttribute& getIsContainerAttribute() {
        return delegate_->getIsContainerAttribute();
    }
    /**
     * Returns the wrapper class that provides access to the attribute IsContained.
     */
    virtual IsContainedAttribute& getIsContainedAttribute() {
        return delegate_->getIsContainedAttribute();
    }


    /**
     * Calls SetType with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void SetType(const std::string &_type, const Partition::tSetType_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetType with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> SetTypeAsync(const std::string &_type, const Partition::tSetType_optionsDict &_options, SetTypeAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetName with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void SetName(const std::string &_name, const Partition::tSetName_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetName with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> SetNameAsync(const std::string &_name, const Partition::tSetName_optionsDict &_options, SetNameAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetFlags with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void SetFlags(const uint64_t &_flags, const Partition::tSetFlags_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls SetFlags with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> SetFlagsAsync(const uint64_t &_flags, const Partition::tSetFlags_optionsDict &_options, SetFlagsAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Delete with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void Delete(const Partition::tDelete_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls Delete with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> DeleteAsync(const Partition::tDelete_optionsDict &_options, DeleteAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<PartitionProxyBase> delegate_;
};

typedef PartitionProxy<> PartitionProxyDefault;

namespace PartitionExtensions {
    template <template <typename > class _ExtensionType>
    class NumberAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::NumberAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::NumberAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        NumberAttributeExtension() {}
    #endif
    
        NumberAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getNumberAttribute()) {
        }
    
        inline extension_type& getNumberAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class TypeAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::TypeAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::TypeAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        TypeAttributeExtension() {}
    #endif
    
        TypeAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getTypeAttribute()) {
        }
    
        inline extension_type& getTypeAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class FlagsAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::FlagsAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::FlagsAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        FlagsAttributeExtension() {}
    #endif
    
        FlagsAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getFlagsAttribute()) {
        }
    
        inline extension_type& getFlagsAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class OffsetAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::OffsetAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::OffsetAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        OffsetAttributeExtension() {}
    #endif
    
        OffsetAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getOffsetAttribute()) {
        }
    
        inline extension_type& getOffsetAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class SizeAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::SizeAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::SizeAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        SizeAttributeExtension() {}
    #endif
    
        SizeAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getSizeAttribute()) {
        }
    
        inline extension_type& getSizeAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class NameAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::NameAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::NameAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        NameAttributeExtension() {}
    #endif
    
        NameAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getNameAttribute()) {
        }
    
        inline extension_type& getNameAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class UUIDAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::UUIDAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::UUIDAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        UUIDAttributeExtension() {}
    #endif
    
        UUIDAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getUUIDAttribute()) {
        }
    
        inline extension_type& getUUIDAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class TableAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::TableAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::TableAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        TableAttributeExtension() {}
    #endif
    
        TableAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getTableAttribute()) {
        }
    
        inline extension_type& getTableAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class IsContainerAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::IsContainerAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::IsContainerAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        IsContainerAttributeExtension() {}
    #endif
    
        IsContainerAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getIsContainerAttribute()) {
        }
    
        inline extension_type& getIsContainerAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

    template <template <typename > class _ExtensionType>
    class IsContainedAttributeExtension {
     public:
        typedef _ExtensionType<PartitionProxyBase::IsContainedAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<PartitionProxyBase::IsContainedAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        IsContainedAttributeExtension() {}
    #endif
    
        IsContainedAttributeExtension(PartitionProxyBase& proxy): attributeExtension_(proxy.getIsContainedAttribute()) {
        }
    
        inline extension_type& getIsContainedAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace PartitionExtensions

//
// PartitionProxy Implementation
//
template <typename ... _AttributeExtensions>
PartitionProxy<_AttributeExtensions...>::PartitionProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<PartitionProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<PartitionProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
PartitionProxy<_AttributeExtensions...>::~PartitionProxy() {
}

template <typename ... _AttributeExtensions>
void PartitionProxy<_AttributeExtensions...>::SetType(const std::string &_type, const Partition::tSetType_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->SetType(_type, _options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> PartitionProxy<_AttributeExtensions...>::SetTypeAsync(const std::string &_type, const Partition::tSetType_optionsDict &_options, SetTypeAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->SetTypeAsync(_type, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void PartitionProxy<_AttributeExtensions...>::SetName(const std::string &_name, const Partition::tSetName_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->SetName(_name, _options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> PartitionProxy<_AttributeExtensions...>::SetNameAsync(const std::string &_name, const Partition::tSetName_optionsDict &_options, SetNameAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->SetNameAsync(_name, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void PartitionProxy<_AttributeExtensions...>::SetFlags(const uint64_t &_flags, const Partition::tSetFlags_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->SetFlags(_flags, _options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> PartitionProxy<_AttributeExtensions...>::SetFlagsAsync(const uint64_t &_flags, const Partition::tSetFlags_optionsDict &_options, SetFlagsAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->SetFlagsAsync(_flags, _options, _callback, _info);
}
template <typename ... _AttributeExtensions>
void PartitionProxy<_AttributeExtensions...>::Delete(const Partition::tDelete_optionsDict &_options, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->Delete(_options, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> PartitionProxy<_AttributeExtensions...>::DeleteAsync(const Partition::tDelete_optionsDict &_options, DeleteAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->DeleteAsync(_options, _callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &PartitionProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool PartitionProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool PartitionProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& PartitionProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& PartitionProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::v2::org::freedesktop::UDisks2::PartitionProxy,
    _AttributeExtension> {
    typedef typename ::v2::org::freedesktop::UDisks2::PartitionProxy<
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::NumberAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::TypeAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::FlagsAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::OffsetAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::SizeAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::NameAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::UUIDAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::TableAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::IsContainerAttributeExtension<_AttributeExtension>, 
            ::v2::org::freedesktop::UDisks2::PartitionExtensions::IsContainedAttributeExtension<_AttributeExtension>
    > class_t;
};
}


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Partition_PROXY_HPP_
