/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Partition_STUB_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Partition_STUB_HPP_

#include <functional>




#include <v2/org/freedesktop/UDisks2/Partition.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <cstdint>
#include <string>
#include <unordered_map>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Partition. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class PartitionStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual Partition {
 public:
    ///Notifies all remote listeners about a change of value of the attribute Number.
    virtual void fireNumberAttributeChanged(const uint32_t& Number) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Type.
    virtual void fireTypeAttributeChanged(const std::string& Type) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Flags.
    virtual void fireFlagsAttributeChanged(const uint64_t& Flags) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Offset.
    virtual void fireOffsetAttributeChanged(const uint64_t& Offset) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Size.
    virtual void fireSizeAttributeChanged(const uint64_t& Size) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Name.
    virtual void fireNameAttributeChanged(const std::string& Name) = 0;
    ///Notifies all remote listeners about a change of value of the attribute UUID.
    virtual void fireUUIDAttributeChanged(const std::string& UUID) = 0;
    ///Notifies all remote listeners about a change of value of the attribute Table.
    virtual void fireTableAttributeChanged(const std::string& Table) = 0;
    ///Notifies all remote listeners about a change of value of the attribute IsContainer.
    virtual void fireIsContainerAttributeChanged(const bool& IsContainer) = 0;
    ///Notifies all remote listeners about a change of value of the attribute IsContained.
    virtual void fireIsContainedAttributeChanged(const bool& IsContained) = 0;



    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Partition.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class PartitionStubRemoteEvent
{
public:
    virtual ~PartitionStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute Number
    virtual bool onRemoteSetNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value) = 0;
    /// Action callback for remote set requests on the attribute Number
    virtual void onRemoteNumberAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Type
    virtual bool onRemoteSetTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Type
    virtual void onRemoteTypeAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Flags
    virtual bool onRemoteSetFlagsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) = 0;
    /// Action callback for remote set requests on the attribute Flags
    virtual void onRemoteFlagsAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Offset
    virtual bool onRemoteSetOffsetAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) = 0;
    /// Action callback for remote set requests on the attribute Offset
    virtual void onRemoteOffsetAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Size
    virtual bool onRemoteSetSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value) = 0;
    /// Action callback for remote set requests on the attribute Size
    virtual void onRemoteSizeAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Name
    virtual bool onRemoteSetNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Name
    virtual void onRemoteNameAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute UUID
    virtual bool onRemoteSetUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute UUID
    virtual void onRemoteUUIDAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute Table
    virtual bool onRemoteSetTableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute Table
    virtual void onRemoteTableAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute IsContainer
    virtual bool onRemoteSetIsContainerAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute IsContainer
    virtual void onRemoteIsContainerAttributeChanged() = 0;
    /// Verification callback for remote set requests on the attribute IsContained
    virtual bool onRemoteSetIsContainedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value) = 0;
    /// Action callback for remote set requests on the attribute IsContained
    virtual void onRemoteIsContainedAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Partition to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class PartitionStub
    : public virtual CommonAPI::Stub<PartitionStubAdapter, PartitionStubRemoteEvent>
{
public:
    typedef std::function<void ()>SetTypeReply_t;
    typedef std::function<void ()>SetNameReply_t;
    typedef std::function<void ()>SetFlagsReply_t;
    typedef std::function<void ()>DeleteReply_t;

    virtual ~PartitionStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute Number
    virtual const uint32_t &getNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Type
    virtual const std::string &getTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Flags
    virtual const uint64_t &getFlagsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Offset
    virtual const uint64_t &getOffsetAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Size
    virtual const uint64_t &getSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Name
    virtual const std::string &getNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute UUID
    virtual const std::string &getUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute Table
    virtual const std::string &getTableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute IsContainer
    virtual const bool &getIsContainerAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;
    /// Provides getter access to the attribute IsContained
    virtual const bool &getIsContainedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /// This is the method that will be called on remote calls on the method SetType.
    virtual void SetType(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _type, Partition::tSetType_optionsDict _options, SetTypeReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method SetName.
    virtual void SetName(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _name, Partition::tSetName_optionsDict _options, SetNameReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method SetFlags.
    virtual void SetFlags(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _flags, Partition::tSetFlags_optionsDict _options, SetFlagsReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method Delete.
    virtual void Delete(const std::shared_ptr<CommonAPI::ClientId> _client, Partition::tDelete_optionsDict _options, DeleteReply_t _reply) = 0;

    using CommonAPI::Stub<PartitionStubAdapter, PartitionStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<PartitionStubAdapter, PartitionStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<PartitionStubAdapter, PartitionStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef PartitionStubRemoteEvent RemoteEventType;
    typedef Partition StubInterface;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Partition_STUB_HPP_
