/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Partition_STUB_DEFAULT_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Partition_STUB_DEFAULT_HPP_


#include <v2/org/freedesktop/UDisks2/PartitionStub.hpp>
#include <sstream>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

/**
 * Provides a default implementation for PartitionStubRemoteEvent and
 * PartitionStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class PartitionStubDefault
    : public virtual PartitionStub {
public:
    PartitionStubDefault();

    PartitionStubRemoteEvent* initStubAdapter(const std::shared_ptr<PartitionStubAdapter> &_adapter);

    const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client);

    virtual const uint32_t& getNumberAttribute();
    virtual const uint32_t& getNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setNumberAttribute(uint32_t _value);
    virtual void setNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value);
    virtual const std::string& getTypeAttribute();
    virtual const std::string& getTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setTypeAttribute(std::string _value);
    virtual void setTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
    virtual const uint64_t& getFlagsAttribute();
    virtual const uint64_t& getFlagsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setFlagsAttribute(uint64_t _value);
    virtual void setFlagsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value);
    virtual const uint64_t& getOffsetAttribute();
    virtual const uint64_t& getOffsetAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setOffsetAttribute(uint64_t _value);
    virtual void setOffsetAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value);
    virtual const uint64_t& getSizeAttribute();
    virtual const uint64_t& getSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setSizeAttribute(uint64_t _value);
    virtual void setSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value);
    virtual const std::string& getNameAttribute();
    virtual const std::string& getNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setNameAttribute(std::string _value);
    virtual void setNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
    virtual const std::string& getUUIDAttribute();
    virtual const std::string& getUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setUUIDAttribute(std::string _value);
    virtual void setUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
    virtual const std::string& getTableAttribute();
    virtual const std::string& getTableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setTableAttribute(std::string _value);
    virtual void setTableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
    virtual const bool& getIsContainerAttribute();
    virtual const bool& getIsContainerAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setIsContainerAttribute(bool _value);
    virtual void setIsContainerAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value);
    virtual const bool& getIsContainedAttribute();
    virtual const bool& getIsContainedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setIsContainedAttribute(bool _value);
    virtual void setIsContainedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value);

    virtual void SetType(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _type, Partition::tSetType_optionsDict _options, SetTypeReply_t _reply);
    virtual void SetName(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _name, Partition::tSetName_optionsDict _options, SetNameReply_t _reply);
    virtual void SetFlags(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _flags, Partition::tSetFlags_optionsDict _options, SetFlagsReply_t _reply);
    virtual void Delete(const std::shared_ptr<CommonAPI::ClientId> _client, Partition::tDelete_optionsDict _options, DeleteReply_t _reply);



protected:
    virtual bool trySetNumberAttribute(uint32_t _value);
    virtual bool validateNumberAttributeRequestedValue(const uint32_t &_value);
    virtual void onRemoteNumberAttributeChanged();
    virtual bool trySetTypeAttribute(std::string _value);
    virtual bool validateTypeAttributeRequestedValue(const std::string &_value);
    virtual void onRemoteTypeAttributeChanged();
    virtual bool trySetFlagsAttribute(uint64_t _value);
    virtual bool validateFlagsAttributeRequestedValue(const uint64_t &_value);
    virtual void onRemoteFlagsAttributeChanged();
    virtual bool trySetOffsetAttribute(uint64_t _value);
    virtual bool validateOffsetAttributeRequestedValue(const uint64_t &_value);
    virtual void onRemoteOffsetAttributeChanged();
    virtual bool trySetSizeAttribute(uint64_t _value);
    virtual bool validateSizeAttributeRequestedValue(const uint64_t &_value);
    virtual void onRemoteSizeAttributeChanged();
    virtual bool trySetNameAttribute(std::string _value);
    virtual bool validateNameAttributeRequestedValue(const std::string &_value);
    virtual void onRemoteNameAttributeChanged();
    virtual bool trySetUUIDAttribute(std::string _value);
    virtual bool validateUUIDAttributeRequestedValue(const std::string &_value);
    virtual void onRemoteUUIDAttributeChanged();
    virtual bool trySetTableAttribute(std::string _value);
    virtual bool validateTableAttributeRequestedValue(const std::string &_value);
    virtual void onRemoteTableAttributeChanged();
    virtual bool trySetIsContainerAttribute(bool _value);
    virtual bool validateIsContainerAttributeRequestedValue(const bool &_value);
    virtual void onRemoteIsContainerAttributeChanged();
    virtual bool trySetIsContainedAttribute(bool _value);
    virtual bool validateIsContainedAttributeRequestedValue(const bool &_value);
    virtual void onRemoteIsContainedAttributeChanged();
    class RemoteEventHandler: public virtual PartitionStubRemoteEvent {
    public:
        RemoteEventHandler(PartitionStubDefault *_defaultStub);

        virtual bool onRemoteSetNumberAttribute(uint32_t _value);
        virtual bool onRemoteSetNumberAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint32_t _value);
        virtual void onRemoteNumberAttributeChanged();

        virtual bool onRemoteSetTypeAttribute(std::string _value);
        virtual bool onRemoteSetTypeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        virtual void onRemoteTypeAttributeChanged();

        virtual bool onRemoteSetFlagsAttribute(uint64_t _value);
        virtual bool onRemoteSetFlagsAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value);
        virtual void onRemoteFlagsAttributeChanged();

        virtual bool onRemoteSetOffsetAttribute(uint64_t _value);
        virtual bool onRemoteSetOffsetAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value);
        virtual void onRemoteOffsetAttributeChanged();

        virtual bool onRemoteSetSizeAttribute(uint64_t _value);
        virtual bool onRemoteSetSizeAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, uint64_t _value);
        virtual void onRemoteSizeAttributeChanged();

        virtual bool onRemoteSetNameAttribute(std::string _value);
        virtual bool onRemoteSetNameAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        virtual void onRemoteNameAttributeChanged();

        virtual bool onRemoteSetUUIDAttribute(std::string _value);
        virtual bool onRemoteSetUUIDAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        virtual void onRemoteUUIDAttributeChanged();

        virtual bool onRemoteSetTableAttribute(std::string _value);
        virtual bool onRemoteSetTableAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        virtual void onRemoteTableAttributeChanged();

        virtual bool onRemoteSetIsContainerAttribute(bool _value);
        virtual bool onRemoteSetIsContainerAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value);
        virtual void onRemoteIsContainerAttributeChanged();

        virtual bool onRemoteSetIsContainedAttribute(bool _value);
        virtual bool onRemoteSetIsContainedAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, bool _value);
        virtual void onRemoteIsContainedAttributeChanged();


    private:
        PartitionStubDefault *defaultStub_;
    };
private:
    PartitionStubDefault::RemoteEventHandler remoteEventHandler_;

    uint32_t numberAttributeValue_ {};
    std::string typeAttributeValue_ {};
    uint64_t flagsAttributeValue_ {};
    uint64_t offsetAttributeValue_ {};
    uint64_t sizeAttributeValue_ {};
    std::string nameAttributeValue_ {};
    std::string uUIDAttributeValue_ {};
    std::string tableAttributeValue_ {};
    bool isContainerAttributeValue_ {};
    bool isContainedAttributeValue_ {};

    CommonAPI::Version interfaceVersion_;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Partition_STUB_DEFAULT
