/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/Root.hpp>
#include <v2/org/freedesktop/UDisks2/RootDBusStubAdapter.hpp>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> createRootDBusStubAdapter(
                   const CommonAPI::DBus::DBusAddress &_address,
                   const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
                   const std::shared_ptr<CommonAPI::StubBase> &_stub) {
    return std::make_shared<RootDBusStubAdapter>(_address, _connection, _stub);
}

INITIALIZER(registerRootDBusStubAdapter) {
    CommonAPI::DBus::Factory::get()->registerStubAdapterCreateMethod(
    	Root::getInterface(), &createRootDBusStubAdapter);
}

RootDBusStubAdapterInternal::~RootDBusStubAdapterInternal() {
    deactivateManagedInstances();
    RootDBusStubAdapterHelper::deinit();
}

void RootDBusStubAdapterInternal::deactivateManagedInstances() {
    std::set<std::string>::iterator iter;
    std::set<std::string>::iterator iterNext;

    iter = registeredDriveInstances.begin();
    while (iter != registeredDriveInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubDrive(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    iter = registeredBlockInstances.begin();
    while (iter != registeredBlockInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubBlock(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    iter = registeredFilesystemInstances.begin();
    while (iter != registeredFilesystemInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubFilesystem(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
    iter = registeredPartitionInstances.begin();
    while (iter != registeredPartitionInstances.end()) {
        iterNext = std::next(iter);

        if (deregisterManagedStubPartition(*iter)) {
            iter = iterNext;
        }
        else {
            iter++;
        }
    }
}

const char* RootDBusStubAdapterInternal::getMethodsDBusIntrospectionXmlData() const {
    static const std::string introspectionData =
        "<method name=\"getInterfaceVersion\">\n"
            "<arg name=\"value\" type=\"uu\" direction=\"out\" />"
        "</method>\n"

        ""
    ;
    return introspectionData.c_str();
}

CommonAPI::DBus::DBusGetAttributeStubDispatcher<
        ::v2::org::freedesktop::UDisks2::RootStub,
        CommonAPI::Version
        > RootDBusStubAdapterInternal::getRootInterfaceVersionStubDispatcher(&RootStub::getInterfaceVersion, "uu");








const RootDBusStubAdapterHelper::StubDispatcherTable& RootDBusStubAdapterInternal::getStubDispatcherTable() {
    return stubDispatcherTable_;
}

const CommonAPI::DBus::StubAttributeTable& RootDBusStubAdapterInternal::getStubAttributeTable() {
    return stubAttributeTable_;
}
bool RootDBusStubAdapterInternal::registerManagedStubDrive(std::shared_ptr<::v2::org::freedesktop::UDisks2::DriveStub> _stub, const std::string &_instance) {
    if (registeredDriveInstances.find(_instance) == registeredDriveInstances.end()) {
    	std::string itsAddress = "local:org.freedesktop.UDisks2.Drive:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string objectPath(itsDBusAddress.getObjectPath());
        std::string adapterObjectPath(getDBusAddress().getObjectPath());

        if (objectPath.compare(0, adapterObjectPath.length(), adapterObjectPath) == 0) {
        	std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

            auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "org.freedesktop.UDisks2.Drive", itsDBusAddress, connection_);
            bool isRegistered = itsFactory->registerManagedService(stubAdapter);
            if (isRegistered) {
                bool isExported = connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
                if (isExported) {
                    registeredDriveInstances.insert(_instance);
                    return true;
                } else {
                    itsFactory->unregisterManagedService(itsAddress);
                }
            }
        }
    }
    return false;
}

bool RootDBusStubAdapterInternal::deregisterManagedStubDrive(const std::string &_instance) {
    std::string itsAddress = "local:org.freedesktop.UDisks2.Drive:" + _instance;
    if (registeredDriveInstances.find(_instance) != registeredDriveInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredDriveInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

std::set<std::string>& RootDBusStubAdapterInternal::getDriveInstances() {
    return registeredDriveInstances;
}
bool RootDBusStubAdapterInternal::registerManagedStubBlock(std::shared_ptr<::v2::org::freedesktop::UDisks2::BlockStub> _stub, const std::string &_instance) {
    if (registeredBlockInstances.find(_instance) == registeredBlockInstances.end()) {
    	std::string itsAddress = "local:org.freedesktop.UDisks2.Block:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string objectPath(itsDBusAddress.getObjectPath());
        std::string adapterObjectPath(getDBusAddress().getObjectPath());

        if (objectPath.compare(0, adapterObjectPath.length(), adapterObjectPath) == 0) {
        	std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

            auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "org.freedesktop.UDisks2.Block", itsDBusAddress, connection_);
            bool isRegistered = itsFactory->registerManagedService(stubAdapter);
            if (isRegistered) {
                bool isExported = connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
                if (isExported) {
                    registeredBlockInstances.insert(_instance);
                    return true;
                } else {
                    itsFactory->unregisterManagedService(itsAddress);
                }
            }
        }
    }
    return false;
}

bool RootDBusStubAdapterInternal::deregisterManagedStubBlock(const std::string &_instance) {
    std::string itsAddress = "local:org.freedesktop.UDisks2.Block:" + _instance;
    if (registeredBlockInstances.find(_instance) != registeredBlockInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredBlockInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

std::set<std::string>& RootDBusStubAdapterInternal::getBlockInstances() {
    return registeredBlockInstances;
}
bool RootDBusStubAdapterInternal::registerManagedStubFilesystem(std::shared_ptr<::v2::org::freedesktop::UDisks2::FilesystemStub> _stub, const std::string &_instance) {
    if (registeredFilesystemInstances.find(_instance) == registeredFilesystemInstances.end()) {
    	std::string itsAddress = "local:org.freedesktop.UDisks2.Filesystem:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string objectPath(itsDBusAddress.getObjectPath());
        std::string adapterObjectPath(getDBusAddress().getObjectPath());

        if (objectPath.compare(0, adapterObjectPath.length(), adapterObjectPath) == 0) {
        	std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

            auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "org.freedesktop.UDisks2.Filesystem", itsDBusAddress, connection_);
            bool isRegistered = itsFactory->registerManagedService(stubAdapter);
            if (isRegistered) {
                bool isExported = connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
                if (isExported) {
                    registeredFilesystemInstances.insert(_instance);
                    return true;
                } else {
                    itsFactory->unregisterManagedService(itsAddress);
                }
            }
        }
    }
    return false;
}

bool RootDBusStubAdapterInternal::deregisterManagedStubFilesystem(const std::string &_instance) {
    std::string itsAddress = "local:org.freedesktop.UDisks2.Filesystem:" + _instance;
    if (registeredFilesystemInstances.find(_instance) != registeredFilesystemInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredFilesystemInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

std::set<std::string>& RootDBusStubAdapterInternal::getFilesystemInstances() {
    return registeredFilesystemInstances;
}
bool RootDBusStubAdapterInternal::registerManagedStubPartition(std::shared_ptr<::v2::org::freedesktop::UDisks2::PartitionStub> _stub, const std::string &_instance) {
    if (registeredPartitionInstances.find(_instance) == registeredPartitionInstances.end()) {
    	std::string itsAddress = "local:org.freedesktop.UDisks2.Partition:" + _instance;
        CommonAPI::DBus::DBusAddress itsDBusAddress;
        CommonAPI::DBus::DBusAddressTranslator::get()->translate(itsAddress, itsDBusAddress);

        std::string objectPath(itsDBusAddress.getObjectPath());
        std::string adapterObjectPath(getDBusAddress().getObjectPath());

        if (objectPath.compare(0, adapterObjectPath.length(), adapterObjectPath) == 0) {
        	std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();

            auto stubAdapter = itsFactory->createDBusStubAdapter(_stub, "org.freedesktop.UDisks2.Partition", itsDBusAddress, connection_);
            bool isRegistered = itsFactory->registerManagedService(stubAdapter);
            if (isRegistered) {
                bool isExported = connection_->getDBusObjectManager()->exportManagedDBusStubAdapter(adapterObjectPath, stubAdapter);
                if (isExported) {
                    registeredPartitionInstances.insert(_instance);
                    return true;
                } else {
                    itsFactory->unregisterManagedService(itsAddress);
                }
            }
        }
    }
    return false;
}

bool RootDBusStubAdapterInternal::deregisterManagedStubPartition(const std::string &_instance) {
    std::string itsAddress = "local:org.freedesktop.UDisks2.Partition:" + _instance;
    if (registeredPartitionInstances.find(_instance) != registeredPartitionInstances.end()) {
        std::shared_ptr<CommonAPI::DBus::Factory> itsFactory = CommonAPI::DBus::Factory::get();
        std::shared_ptr<CommonAPI::DBus::DBusStubAdapter> stubAdapter
            = itsFactory->getRegisteredService(itsAddress);
        if (stubAdapter) {
            connection_->getDBusObjectManager()->unexportManagedDBusStubAdapter(
                getDBusAddress().getObjectPath(), stubAdapter);
            itsFactory->unregisterManagedService(itsAddress);
            registeredPartitionInstances.erase(_instance);
            return true;
        }
    }
    return false;
}

std::set<std::string>& RootDBusStubAdapterInternal::getPartitionInstances() {
    return registeredPartitionInstances;
}

RootDBusStubAdapterInternal::RootDBusStubAdapterInternal(
        const CommonAPI::DBus::DBusAddress &_address,
        const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection,
        const std::shared_ptr<CommonAPI::StubBase> &_stub)
	: CommonAPI::DBus::DBusStubAdapter(_address, _connection,true),
      RootDBusStubAdapterHelper(_address, _connection, std::dynamic_pointer_cast<RootStub>(_stub), true),
      stubDispatcherTable_({
            }),
        stubAttributeTable_() {

    stubDispatcherTable_.insert({ { "getInterfaceVersion", "" }, &org::freedesktop::UDisks2::RootDBusStubAdapterInternal::getRootInterfaceVersionStubDispatcher });
}

bool RootDBusStubAdapterInternal::hasFreedesktopProperties() {
    return false;
}

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2
