/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Root_PROXY_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Root_PROXY_HPP_

#include <v2/org/freedesktop/UDisks2/RootProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif


#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

template <typename ... _AttributeExtensions>
class RootProxy
    : virtual public Root, 
      virtual public RootProxyBase,
      virtual public _AttributeExtensions... {
public:
    RootProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~RootProxy();

    typedef Root InterfaceType;





    virtual CommonAPI::ProxyManager& getProxyManagerDrive();
    virtual CommonAPI::ProxyManager& getProxyManagerBlock();
    virtual CommonAPI::ProxyManager& getProxyManagerFilesystem();
    virtual CommonAPI::ProxyManager& getProxyManagerPartition();

    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<RootProxyBase> delegate_;
};

typedef RootProxy<> RootProxyDefault;


//
// RootProxy Implementation
//
template <typename ... _AttributeExtensions>
RootProxy<_AttributeExtensions...>::RootProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<RootProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<RootProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
RootProxy<_AttributeExtensions...>::~RootProxy() {
}


template <typename ... _AttributeExtensions>
const CommonAPI::Address &RootProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool RootProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool RootProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& RootProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& RootProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyManager& RootProxy<_AttributeExtensions...>::getProxyManagerDrive() {
    return delegate_->getProxyManagerDrive();
}
template <typename ... _AttributeExtensions>
CommonAPI::ProxyManager& RootProxy<_AttributeExtensions...>::getProxyManagerBlock() {
    return delegate_->getProxyManagerBlock();
}
template <typename ... _AttributeExtensions>
CommonAPI::ProxyManager& RootProxy<_AttributeExtensions...>::getProxyManagerFilesystem() {
    return delegate_->getProxyManagerFilesystem();
}
template <typename ... _AttributeExtensions>
CommonAPI::ProxyManager& RootProxy<_AttributeExtensions...>::getProxyManagerPartition() {
    return delegate_->getProxyManagerPartition();
}

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2



// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Root_PROXY_HPP_
