/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_ORG_FREEDESKTOP_UDISKS2_Root_STUB_HPP_
#define V2_ORG_FREEDESKTOP_UDISKS2_Root_STUB_HPP_

#include <functional>



#include <v2/org/freedesktop/UDisks2/BlockStub.hpp>
#include <v2/org/freedesktop/UDisks2/DriveStub.hpp>
#include <v2/org/freedesktop/UDisks2/FilesystemStub.hpp>
#include <v2/org/freedesktop/UDisks2/PartitionStub.hpp>

#include <v2/org/freedesktop/UDisks2/Root.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif


#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service Root. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class RootStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual Root {
 public:


    virtual bool registerManagedStubDrive(std::shared_ptr<::v2::org::freedesktop::UDisks2::DriveStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubDrive(const std::string&) = 0;
    virtual std::set<std::string>& getDriveInstances() = 0;
    virtual bool registerManagedStubBlock(std::shared_ptr<::v2::org::freedesktop::UDisks2::BlockStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubBlock(const std::string&) = 0;
    virtual std::set<std::string>& getBlockInstances() = 0;
    virtual bool registerManagedStubFilesystem(std::shared_ptr<::v2::org::freedesktop::UDisks2::FilesystemStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubFilesystem(const std::string&) = 0;
    virtual std::set<std::string>& getFilesystemInstances() = 0;
    virtual bool registerManagedStubPartition(std::shared_ptr<::v2::org::freedesktop::UDisks2::PartitionStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubPartition(const std::string&) = 0;
    virtual std::set<std::string>& getPartitionInstances() = 0;

    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for Root.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class RootStubRemoteEvent
{
public:
    virtual ~RootStubRemoteEvent() { }

};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service Root to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class RootStub
    : public virtual CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>
{
public:

    virtual ~RootStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;



    virtual bool registerManagedStubDrive(std::shared_ptr<::v2::org::freedesktop::UDisks2::DriveStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubDrive(const std::string&) = 0;
    virtual std::set<std::string>& getDriveInstances() = 0;
    virtual bool registerManagedStubBlock(std::shared_ptr<::v2::org::freedesktop::UDisks2::BlockStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubBlock(const std::string&) = 0;
    virtual std::set<std::string>& getBlockInstances() = 0;
    virtual bool registerManagedStubFilesystem(std::shared_ptr<::v2::org::freedesktop::UDisks2::FilesystemStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubFilesystem(const std::string&) = 0;
    virtual std::set<std::string>& getFilesystemInstances() = 0;
    virtual bool registerManagedStubPartition(std::shared_ptr<::v2::org::freedesktop::UDisks2::PartitionStub>, const std::string&) = 0;
    virtual bool deregisterManagedStubPartition(const std::string&) = 0;
    virtual std::set<std::string>& getPartitionInstances() = 0;
    using CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef RootStubRemoteEvent RemoteEventType;
    typedef Root StubInterface;
};

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2


// Compatibility
namespace v2_1 = v2;

#endif // V2_ORG_FREEDESKTOP_UDISKS2_Root_STUB_HPP_
