/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v2/org/freedesktop/UDisks2/RootStubDefault.hpp>
#include <assert.h>

namespace v2 {
namespace org {
namespace freedesktop {
namespace UDisks2 {

RootStubDefault::RootStubDefault():
        remoteEventHandler_(this),
        autoInstanceCounter_(0),
        interfaceVersion_(Root::getInterfaceVersion()) {
}

const CommonAPI::Version& RootStubDefault::getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
    (void)_client;
    return interfaceVersion_;
}

RootStubRemoteEvent* RootStubDefault::initStubAdapter(const std::shared_ptr<RootStubAdapter> &_adapter) {
    CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_ = _adapter;
    return &remoteEventHandler_;
}




bool RootStubDefault::registerManagedStubDriveAutoInstance(std::shared_ptr<::v2::org::freedesktop::UDisks2::DriveStub> _stub) {
    autoInstanceCounter_++;
    std::stringstream ss;
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        ss << stubAdapter->getAddress().getInstance() << ".i" << autoInstanceCounter_;
        std::string instance = ss.str();
        return stubAdapter->registerManagedStubDrive(_stub, instance);
    } else {
        return false;
    }
}
bool RootStubDefault::registerManagedStubDrive(std::shared_ptr<::v2::org::freedesktop::UDisks2::DriveStub> _stub, const std::string &_instance) {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->registerManagedStubDrive(_stub, _instance);
    else
        return false;
}
bool RootStubDefault::deregisterManagedStubDrive(const std::string &_instance) {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->deregisterManagedStubDrive(_instance);
    else
        return false;
}
std::set<std::string>& RootStubDefault::getDriveInstances() {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        return stubAdapter->getDriveInstances();
    } else {
        static std::set<std::string> emptySet = std::set<std::string>();
        return emptySet;
    }
}
bool RootStubDefault::registerManagedStubBlockAutoInstance(std::shared_ptr<::v2::org::freedesktop::UDisks2::BlockStub> _stub) {
    autoInstanceCounter_++;
    std::stringstream ss;
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        ss << stubAdapter->getAddress().getInstance() << ".i" << autoInstanceCounter_;
        std::string instance = ss.str();
        return stubAdapter->registerManagedStubBlock(_stub, instance);
    } else {
        return false;
    }
}
bool RootStubDefault::registerManagedStubBlock(std::shared_ptr<::v2::org::freedesktop::UDisks2::BlockStub> _stub, const std::string &_instance) {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->registerManagedStubBlock(_stub, _instance);
    else
        return false;
}
bool RootStubDefault::deregisterManagedStubBlock(const std::string &_instance) {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->deregisterManagedStubBlock(_instance);
    else
        return false;
}
std::set<std::string>& RootStubDefault::getBlockInstances() {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        return stubAdapter->getBlockInstances();
    } else {
        static std::set<std::string> emptySet = std::set<std::string>();
        return emptySet;
    }
}
bool RootStubDefault::registerManagedStubFilesystemAutoInstance(std::shared_ptr<::v2::org::freedesktop::UDisks2::FilesystemStub> _stub) {
    autoInstanceCounter_++;
    std::stringstream ss;
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        ss << stubAdapter->getAddress().getInstance() << ".i" << autoInstanceCounter_;
        std::string instance = ss.str();
        return stubAdapter->registerManagedStubFilesystem(_stub, instance);
    } else {
        return false;
    }
}
bool RootStubDefault::registerManagedStubFilesystem(std::shared_ptr<::v2::org::freedesktop::UDisks2::FilesystemStub> _stub, const std::string &_instance) {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->registerManagedStubFilesystem(_stub, _instance);
    else
        return false;
}
bool RootStubDefault::deregisterManagedStubFilesystem(const std::string &_instance) {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->deregisterManagedStubFilesystem(_instance);
    else
        return false;
}
std::set<std::string>& RootStubDefault::getFilesystemInstances() {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        return stubAdapter->getFilesystemInstances();
    } else {
        static std::set<std::string> emptySet = std::set<std::string>();
        return emptySet;
    }
}
bool RootStubDefault::registerManagedStubPartitionAutoInstance(std::shared_ptr<::v2::org::freedesktop::UDisks2::PartitionStub> _stub) {
    autoInstanceCounter_++;
    std::stringstream ss;
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        ss << stubAdapter->getAddress().getInstance() << ".i" << autoInstanceCounter_;
        std::string instance = ss.str();
        return stubAdapter->registerManagedStubPartition(_stub, instance);
    } else {
        return false;
    }
}
bool RootStubDefault::registerManagedStubPartition(std::shared_ptr<::v2::org::freedesktop::UDisks2::PartitionStub> _stub, const std::string &_instance) {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->registerManagedStubPartition(_stub, _instance);
    else
        return false;
}
bool RootStubDefault::deregisterManagedStubPartition(const std::string &_instance) {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) 
        return stubAdapter->deregisterManagedStubPartition(_instance);
    else
        return false;
}
std::set<std::string>& RootStubDefault::getPartitionInstances() {
    assert((CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock()) !=NULL);
    auto stubAdapter = CommonAPI::Stub<RootStubAdapter, RootStubRemoteEvent>::stubAdapter_.lock();
    if (stubAdapter) {
        return stubAdapter->getPartitionInstances();
    } else {
        static std::set<std::string> emptySet = std::set<std::string>();
        return emptySet;
    }
}

RootStubDefault::RemoteEventHandler::RemoteEventHandler(RootStubDefault *_defaultStub)
    : 
      defaultStub_(_defaultStub) {
}

} // namespace UDisks2
} // namespace freedesktop
} // namespace org
} // namespace v2
