/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.dbus 3.1.5.v201602250927.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#include <v0/commonapi/examples/VariantSimpleDBusProxy.hpp>

namespace v0 {
namespace commonapi {
namespace examples {

std::shared_ptr<CommonAPI::DBus::DBusProxy> createVariantSimpleDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection) {
	return std::make_shared<VariantSimpleDBusProxy>(_address, _connection);
}

INITIALIZER(registerVariantSimpleDBusProxy) {
     CommonAPI::DBus::Factory::get()->registerProxyCreateMethod(
		VariantSimple::getInterface(),
		&createVariantSimpleDBusProxy);
}

VariantSimpleDBusProxy::VariantSimpleDBusProxy(
	const CommonAPI::DBus::DBusAddress &_address,
	const std::shared_ptr<CommonAPI::DBus::DBusProxyConnection> &_connection)
	:	CommonAPI::DBus::DBusProxy(_address, _connection)
,		status_(*this, "onStatusAttributeChanged", "setStatusAttribute", "s", "getStatusAttribute", static_cast<CommonAPI::DBus::StringDeployment*>(nullptr))
,		gotToTell_(*this, "gotToTell", "i(yv)", std::make_tuple(static_cast<CommonAPI::EmptyDeployment*>(nullptr), &VariantSimple_::ComplexUnionDeployment)),
		deviceFound_(*this, "DeviceFound", "sa{sv}", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), &VariantSimple_::tPropertiesDictDeployment)),
		signedUpSelective_(*this, "SignedUp", "sv", std::make_tuple(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr), &VariantSimple_::SampleUnionDeployment))
{
}

      VariantSimpleDBusProxy::StatusAttribute& VariantSimpleDBusProxy::getStatusAttribute() {
          return status_;
      }

VariantSimpleDBusProxy::GotToTellEvent& VariantSimpleDBusProxy::getGotToTellEvent() {
    return gotToTell_;
}
VariantSimpleDBusProxy::DeviceFoundEvent& VariantSimpleDBusProxy::getDeviceFoundEvent() {
    return deviceFound_;
}
VariantSimpleDBusProxy::SignedUpSelectiveEvent& VariantSimpleDBusProxy::getSignedUpSelectiveEvent() {
    return signedUpSelective_;
}
    
    void VariantSimpleDBusProxy::callMe(const std::string &_strArg, const VariantSimple::SampleUnion &_varArg, CommonAPI::CallStatus &_internalCallStatus, std::string &_strOutArg, VariantSimple::SampleUnion &_varOutArg, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_strArg(_strArg, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> deploy_varArg(_varArg, &VariantSimple_::SampleUnionDeployment);
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_strOutArg(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> deploy_varOutArg(&VariantSimple_::SampleUnionDeployment);
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>,
            CommonAPI::Deployable<VariantSimple::SampleUnion,VariantSimple_::SampleUnionDeployment_t>
            >
        	>::callMethodWithReply(
        *this,
        "callMe",
        "sv",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_strArg, deploy_varArg,
_internalCallStatus,
deploy_strOutArg, deploy_varOutArg);
_strOutArg = deploy_strOutArg.getValue();
_varOutArg = deploy_varOutArg.getValue();
}
    std::future<CommonAPI::CallStatus> VariantSimpleDBusProxy::callMeAsync(const std::string &_strArg, const VariantSimple::SampleUnion &_varArg, CallMeAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_strArg(_strArg, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> deploy_varArg(_varArg, &VariantSimple_::SampleUnionDeployment);
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_strOutArg(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> deploy_varOutArg(&VariantSimple_::SampleUnionDeployment);
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>,
            CommonAPI::Deployable<VariantSimple::SampleUnion,VariantSimple_::SampleUnionDeployment_t>
            >
        	>::callMethodAsync(
        *this,
        "callMe",
        "sv",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_strArg, deploy_varArg,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _strOutArg, CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> _varOutArg) {
        	if (_callback)
        		_callback(_internalCallStatus, _strOutArg.getValue(), _varOutArg.getValue());
        },
        std::make_tuple(deploy_strOutArg, deploy_varOutArg));
    }
    void VariantSimpleDBusProxy::callMeComplex(const std::string &_strArg, const VariantSimple::ComplexUnion &_varArg, CommonAPI::CallStatus &_internalCallStatus, std::string &_strOutArg, VariantSimple::ComplexUnion &_varOutArg, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_strArg(_strArg, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<VariantSimple::ComplexUnion, VariantSimple_::ComplexUnionDeployment_t> deploy_varArg(_varArg, &VariantSimple_::ComplexUnionDeployment);
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_strOutArg(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<VariantSimple::ComplexUnion, VariantSimple_::ComplexUnionDeployment_t> deploy_varOutArg(&VariantSimple_::ComplexUnionDeployment);
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<VariantSimple::ComplexUnion, VariantSimple_::ComplexUnionDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>,
            CommonAPI::Deployable<VariantSimple::ComplexUnion,VariantSimple_::ComplexUnionDeployment_t>
            >
        	>::callMethodWithReply(
        *this,
        "callMeComplex",
        "s(yv)",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_strArg, deploy_varArg,
_internalCallStatus,
deploy_strOutArg, deploy_varOutArg);
_strOutArg = deploy_strOutArg.getValue();
_varOutArg = deploy_varOutArg.getValue();
}
    std::future<CommonAPI::CallStatus> VariantSimpleDBusProxy::callMeComplexAsync(const std::string &_strArg, const VariantSimple::ComplexUnion &_varArg, CallMeComplexAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_strArg(_strArg, static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<VariantSimple::ComplexUnion, VariantSimple_::ComplexUnionDeployment_t> deploy_varArg(_varArg, &VariantSimple_::ComplexUnionDeployment);
        CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> deploy_strOutArg(static_cast<CommonAPI::DBus::StringDeployment*>(nullptr));
        CommonAPI::Deployable<VariantSimple::ComplexUnion, VariantSimple_::ComplexUnionDeployment_t> deploy_varOutArg(&VariantSimple_::ComplexUnionDeployment);
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment >,
            CommonAPI::Deployable<VariantSimple::ComplexUnion, VariantSimple_::ComplexUnionDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<std::string,CommonAPI::DBus::StringDeployment>,
            CommonAPI::Deployable<VariantSimple::ComplexUnion,VariantSimple_::ComplexUnionDeployment_t>
            >
        	>::callMethodAsync(
        *this,
        "callMeComplex",
        "s(yv)",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_strArg, deploy_varArg,
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<std::string, CommonAPI::DBus::StringDeployment> _strOutArg, CommonAPI::Deployable<VariantSimple::ComplexUnion, VariantSimple_::ComplexUnionDeployment_t> _varOutArg) {
        	if (_callback)
        		_callback(_internalCallStatus, _strOutArg.getValue(), _varOutArg.getValue());
        },
        std::make_tuple(deploy_strOutArg, deploy_varOutArg));
    }
    void VariantSimpleDBusProxy::singleInArgMethod(const VariantSimple::SampleUnion &_varInArg, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> deploy_varInArg(_varInArg, &VariantSimple_::SampleUnionDeployment);
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodWithReply(
        *this,
        "singleInArgMethod",
        "v",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
deploy_varInArg,
_internalCallStatus);
}
    std::future<CommonAPI::CallStatus> VariantSimpleDBusProxy::singleInArgMethodAsync(const VariantSimple::SampleUnion &_varInArg, SingleInArgMethodAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> deploy_varInArg(_varInArg, &VariantSimple_::SampleUnionDeployment);
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t >
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            >
        	>::callMethodAsync(
        *this,
        "singleInArgMethod",
        "v",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        deploy_varInArg,
        [_callback] (CommonAPI::CallStatus _internalCallStatus) {
        	if (_callback)
        		_callback(_internalCallStatus);
        },
        std::make_tuple());
    }
    void VariantSimpleDBusProxy::singleOutArgMethod(CommonAPI::CallStatus &_internalCallStatus, VariantSimple::SampleUnion &_varOutArg, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> deploy_varOutArg(&VariantSimple_::SampleUnionDeployment);
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<VariantSimple::SampleUnion,VariantSimple_::SampleUnionDeployment_t>
            >
        	>::callMethodWithReply(
        *this,
        "singleOutArgMethod",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus,
deploy_varOutArg);
_varOutArg = deploy_varOutArg.getValue();
}
    std::future<CommonAPI::CallStatus> VariantSimpleDBusProxy::singleOutArgMethodAsync(SingleOutArgMethodAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> deploy_varOutArg(&VariantSimple_::SampleUnionDeployment);
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<VariantSimple::SampleUnion,VariantSimple_::SampleUnionDeployment_t>
            >
        	>::callMethodAsync(
        *this,
        "singleOutArgMethod",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<VariantSimple::SampleUnion, VariantSimple_::SampleUnionDeployment_t> _varOutArg) {
        	if (_callback)
        		_callback(_internalCallStatus, _varOutArg.getValue());
        },
        std::make_tuple(deploy_varOutArg));
    }
    void VariantSimpleDBusProxy::getProperties(CommonAPI::CallStatus &_internalCallStatus, VariantSimple::tPropertiesDict &_properties, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<VariantSimple::tPropertiesDict, VariantSimple_::tPropertiesDictDeployment_t> deploy_properties(&VariantSimple_::tPropertiesDictDeployment);
        CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<VariantSimple::tPropertiesDict,VariantSimple_::tPropertiesDictDeployment_t>
            >
        	>::callMethodWithReply(
        *this,
        "getProperties",
        "",
(_info ? _info : &CommonAPI::DBus::defaultCallInfo),
_internalCallStatus,
deploy_properties);
_properties = deploy_properties.getValue();
}
    std::future<CommonAPI::CallStatus> VariantSimpleDBusProxy::getPropertiesAsync(GetPropertiesAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
        CommonAPI::Deployable<VariantSimple::tPropertiesDict, VariantSimple_::tPropertiesDictDeployment_t> deploy_properties(&VariantSimple_::tPropertiesDictDeployment);
        return CommonAPI::DBus::DBusProxyHelper<
            CommonAPI::DBus::DBusSerializableArguments<
            >,
            CommonAPI::DBus::DBusSerializableArguments<
            CommonAPI::Deployable<VariantSimple::tPropertiesDict,VariantSimple_::tPropertiesDictDeployment_t>
            >
        	>::callMethodAsync(
        *this,
        "getProperties",
        "",
        (_info ? _info : &CommonAPI::DBus::defaultCallInfo),
        [_callback] (CommonAPI::CallStatus _internalCallStatus, CommonAPI::Deployable<VariantSimple::tPropertiesDict, VariantSimple_::tPropertiesDictDeployment_t> _properties) {
        	if (_callback)
        		_callback(_internalCallStatus, _properties.getValue());
        },
        std::make_tuple(deploy_properties));
    }


void VariantSimpleDBusProxy::getOwnVersion(uint16_t& ownVersionMajor, uint16_t& ownVersionMinor) const {
          ownVersionMajor = 0;
          ownVersionMinor = 1;
      }

      } // namespace examples
      } // namespace commonapi
      } // namespace v0
