/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V0_COMMONAPI_EXAMPLES_Variant_Simple_PROXY_HPP_
#define V0_COMMONAPI_EXAMPLES_Variant_Simple_PROXY_HPP_

#include <v0/commonapi/examples/VariantSimpleProxyBase.hpp>


#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/AttributeExtension.hpp>
#include <CommonAPI/Factory.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v0 {
namespace commonapi {
namespace examples {

template <typename ... _AttributeExtensions>
class VariantSimpleProxy
    : virtual public VariantSimple, 
      virtual public VariantSimpleProxyBase,
      virtual public _AttributeExtensions... {
public:
    VariantSimpleProxy(std::shared_ptr<CommonAPI::Proxy> delegate);
    ~VariantSimpleProxy();

    typedef VariantSimple InterfaceType;


    /**
     * Returns the wrapper class that provides access to the attribute status.
     */
    virtual StatusAttribute& getStatusAttribute() {
        return delegate_->getStatusAttribute();
    }

    /**
     * Returns the wrapper class that provides access to the broadcast gotToTell.
     */
    virtual GotToTellEvent& getGotToTellEvent() {
        return delegate_->getGotToTellEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast DeviceFound.
     */
    virtual DeviceFoundEvent& getDeviceFoundEvent() {
        return delegate_->getDeviceFoundEvent();
    }
    /**
     * Returns the wrapper class that provides access to the broadcast SignedUp.
     */
    virtual SignedUpSelectiveEvent& getSignedUpSelectiveEvent() {
        return delegate_->getSignedUpSelectiveEvent();
    }

    /**
     * Calls callMe with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void callMe(const std::string &_strArg, const VariantSimple::SampleUnion &_varArg, CommonAPI::CallStatus &_internalCallStatus, std::string &_strOutArg, VariantSimple::SampleUnion &_varOutArg, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls callMe with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> callMeAsync(const std::string &_strArg, const VariantSimple::SampleUnion &_varArg, CallMeAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls callMeComplex with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void callMeComplex(const std::string &_strArg, const VariantSimple::ComplexUnion &_varArg, CommonAPI::CallStatus &_internalCallStatus, std::string &_strOutArg, VariantSimple::ComplexUnion &_varOutArg, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls callMeComplex with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> callMeComplexAsync(const std::string &_strArg, const VariantSimple::ComplexUnion &_varArg, CallMeComplexAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls singleInArgMethod with synchronous semantics.
     * 
    * All const parameters are input parameters to this method.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void singleInArgMethod(const VariantSimple::SampleUnion &_varInArg, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls singleInArgMethod with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> singleInArgMethodAsync(const VariantSimple::SampleUnion &_varInArg, SingleInArgMethodAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls singleOutArgMethod with synchronous semantics.
     * 
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void singleOutArgMethod(CommonAPI::CallStatus &_internalCallStatus, VariantSimple::SampleUnion &_varOutArg, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls singleOutArgMethod with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> singleOutArgMethodAsync(SingleOutArgMethodAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls getProperties with synchronous semantics.
     * 
    * All non-const parameters will be filled with the returned values.
     * The CallStatus will be filled when the method returns and indicate either
     * "SUCCESS" or which type of error has occurred. In case of an error, ONLY the CallStatus
     * will be set.
     */
    virtual void getProperties(CommonAPI::CallStatus &_internalCallStatus, VariantSimple::tPropertiesDict &_properties, const CommonAPI::CallInfo *_info = nullptr);
    /**
     * Calls getProperties with asynchronous semantics.
     * 
     * The provided callback will be called when the reply to this call arrives or
     * an error occurs during the call. The CallStatus will indicate either "SUCCESS"
     * or which type of error has occurred. In case of any error, ONLY the CallStatus
     * will have a defined value.
     * The std::future returned by this method will be fulfilled at arrival of the reply.
     * It will provide the same value for CallStatus as will be handed to the callback.
     */
    virtual std::future<CommonAPI::CallStatus> getPropertiesAsync(GetPropertiesAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr);


    /**
     * Returns the CommonAPI address of the remote partner this proxy communicates with.
     */
    virtual const CommonAPI::Address &getAddress() const;

    /**
     * Returns true if the remote partner for this proxy is currently known to be available.
     */
    virtual bool isAvailable() const;

    /**
     * Returns true if the remote partner for this proxy is available.
     */
    virtual bool isAvailableBlocking() const;

    /**
     * Returns the wrapper class that is used to (de-)register for notifications about
     * the availability of the remote partner of this proxy.
     */
    virtual CommonAPI::ProxyStatusEvent& getProxyStatusEvent();

    /**
     * Returns the wrapper class that is used to access version information of the remote
     * partner of this proxy.
     */
    virtual CommonAPI::InterfaceVersionAttribute& getInterfaceVersionAttribute();

 private:
    std::shared_ptr<VariantSimpleProxyBase> delegate_;
};

typedef VariantSimpleProxy<> VariantSimpleProxyDefault;

namespace VariantSimpleExtensions {
    template <template <typename > class _ExtensionType>
    class StatusAttributeExtension {
     public:
        typedef _ExtensionType<VariantSimpleProxyBase::StatusAttribute> extension_type;
    
        static_assert(std::is_base_of<typename CommonAPI::AttributeExtension<VariantSimpleProxyBase::StatusAttribute>, extension_type>::value,
                      "Not CommonAPI Attribute Extension!");
    #ifdef WIN32
        StatusAttributeExtension() {}
    #endif
    
        StatusAttributeExtension(VariantSimpleProxyBase& proxy): attributeExtension_(proxy.getStatusAttribute()) {
        }
    
        inline extension_type& getStatusAttributeExtension() {
            return attributeExtension_;
        }
    
     private:
        extension_type attributeExtension_;
    };

} // namespace VariantSimpleExtensions

//
// VariantSimpleProxy Implementation
//
template <typename ... _AttributeExtensions>
VariantSimpleProxy<_AttributeExtensions...>::VariantSimpleProxy(std::shared_ptr<CommonAPI::Proxy> delegate):
        _AttributeExtensions(*(std::dynamic_pointer_cast<VariantSimpleProxyBase>(delegate)))...,
        delegate_(std::dynamic_pointer_cast<VariantSimpleProxyBase>(delegate)) {
}

template <typename ... _AttributeExtensions>
VariantSimpleProxy<_AttributeExtensions...>::~VariantSimpleProxy() {
}

template <typename ... _AttributeExtensions>
void VariantSimpleProxy<_AttributeExtensions...>::callMe(const std::string &_strArg, const VariantSimple::SampleUnion &_varArg, CommonAPI::CallStatus &_internalCallStatus, std::string &_strOutArg, VariantSimple::SampleUnion &_varOutArg, const CommonAPI::CallInfo *_info) {
    delegate_->callMe(_strArg, _varArg, _internalCallStatus, _strOutArg, _varOutArg, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> VariantSimpleProxy<_AttributeExtensions...>::callMeAsync(const std::string &_strArg, const VariantSimple::SampleUnion &_varArg, CallMeAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->callMeAsync(_strArg, _varArg, _callback, _info);
}
template <typename ... _AttributeExtensions>
void VariantSimpleProxy<_AttributeExtensions...>::callMeComplex(const std::string &_strArg, const VariantSimple::ComplexUnion &_varArg, CommonAPI::CallStatus &_internalCallStatus, std::string &_strOutArg, VariantSimple::ComplexUnion &_varOutArg, const CommonAPI::CallInfo *_info) {
    delegate_->callMeComplex(_strArg, _varArg, _internalCallStatus, _strOutArg, _varOutArg, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> VariantSimpleProxy<_AttributeExtensions...>::callMeComplexAsync(const std::string &_strArg, const VariantSimple::ComplexUnion &_varArg, CallMeComplexAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->callMeComplexAsync(_strArg, _varArg, _callback, _info);
}
template <typename ... _AttributeExtensions>
void VariantSimpleProxy<_AttributeExtensions...>::singleInArgMethod(const VariantSimple::SampleUnion &_varInArg, CommonAPI::CallStatus &_internalCallStatus, const CommonAPI::CallInfo *_info) {
    delegate_->singleInArgMethod(_varInArg, _internalCallStatus, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> VariantSimpleProxy<_AttributeExtensions...>::singleInArgMethodAsync(const VariantSimple::SampleUnion &_varInArg, SingleInArgMethodAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->singleInArgMethodAsync(_varInArg, _callback, _info);
}
template <typename ... _AttributeExtensions>
void VariantSimpleProxy<_AttributeExtensions...>::singleOutArgMethod(CommonAPI::CallStatus &_internalCallStatus, VariantSimple::SampleUnion &_varOutArg, const CommonAPI::CallInfo *_info) {
    delegate_->singleOutArgMethod(_internalCallStatus, _varOutArg, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> VariantSimpleProxy<_AttributeExtensions...>::singleOutArgMethodAsync(SingleOutArgMethodAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->singleOutArgMethodAsync(_callback, _info);
}
template <typename ... _AttributeExtensions>
void VariantSimpleProxy<_AttributeExtensions...>::getProperties(CommonAPI::CallStatus &_internalCallStatus, VariantSimple::tPropertiesDict &_properties, const CommonAPI::CallInfo *_info) {
    delegate_->getProperties(_internalCallStatus, _properties, _info);
}

template <typename ... _AttributeExtensions>
std::future<CommonAPI::CallStatus> VariantSimpleProxy<_AttributeExtensions...>::getPropertiesAsync(GetPropertiesAsyncCallback _callback, const CommonAPI::CallInfo *_info) {
    return delegate_->getPropertiesAsync(_callback, _info);
}

template <typename ... _AttributeExtensions>
const CommonAPI::Address &VariantSimpleProxy<_AttributeExtensions...>::getAddress() const {
    return delegate_->getAddress();
}

template <typename ... _AttributeExtensions>
bool VariantSimpleProxy<_AttributeExtensions...>::isAvailable() const {
    return delegate_->isAvailable();
}

template <typename ... _AttributeExtensions>
bool VariantSimpleProxy<_AttributeExtensions...>::isAvailableBlocking() const {
    return delegate_->isAvailableBlocking();
}

template <typename ... _AttributeExtensions>
CommonAPI::ProxyStatusEvent& VariantSimpleProxy<_AttributeExtensions...>::getProxyStatusEvent() {
    return delegate_->getProxyStatusEvent();
}

template <typename ... _AttributeExtensions>
CommonAPI::InterfaceVersionAttribute& VariantSimpleProxy<_AttributeExtensions...>::getInterfaceVersionAttribute() {
    return delegate_->getInterfaceVersionAttribute();
}


} // namespace examples
} // namespace commonapi
} // namespace v0

namespace CommonAPI {
template<template<typename > class _AttributeExtension>
struct DefaultAttributeProxyHelper<::v0::commonapi::examples::VariantSimpleProxy,
    _AttributeExtension> {
    typedef typename ::v0::commonapi::examples::VariantSimpleProxy<
            ::v0::commonapi::examples::VariantSimpleExtensions::StatusAttributeExtension<_AttributeExtension>
    > class_t;
};
}


// Compatibility
namespace v0_1 = v0;

#endif // V0_COMMONAPI_EXAMPLES_Variant_Simple_PROXY_HPP_
