/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V0_COMMONAPI_EXAMPLES_Variant_Simple_STUB_HPP_
#define V0_COMMONAPI_EXAMPLES_Variant_Simple_STUB_HPP_

#include <functional>




#include <v0/commonapi/examples/VariantSimple.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#endif

#include <CommonAPI/Variant.hpp>
#include <cstdint>
#include <memory>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

#include <CommonAPI/Stub.hpp>

#undef COMMONAPI_INTERNAL_COMPILATION

namespace v0 {
namespace commonapi {
namespace examples {

/**
 * Receives messages from remote and handles all dispatching of deserialized calls
 * to a stub for the service VariantSimple. Also provides means to send broadcasts
 * and attribute-changed-notifications of observable attributes as defined by this service.
 * An application developer should not need to bother with this class.
 */
class VariantSimpleStubAdapter
    : public virtual CommonAPI::StubAdapter, 
      public virtual VariantSimple {
 public:
    ///Notifies all remote listeners about a change of value of the attribute status.
    virtual void fireStatusAttributeChanged(const std::string& status) = 0;

    /**
     * Sends a broadcast event for gotToTell. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireGotToTellEvent(const int32_t &_count, const ::v0::commonapi::examples::VariantSimple::ComplexUnion &_anything) = 0;
    /**
     * Sends a broadcast event for DeviceFound. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireDeviceFoundEvent(const std::string &_address, const ::v0::commonapi::examples::VariantSimple::tPropertiesDict &_values) = 0;
    /**
     * Sends a selective broadcast event for SignedUp. Should not be called directly.
     * Instead, the "fire<broadcastName>Event" methods of the stub should be used.
     */
    virtual void fireSignedUpSelective(const std::shared_ptr<CommonAPI::ClientId> _client, const std::string &_sth, const ::v0::commonapi::examples::VariantSimple::SampleUnion &_more) = 0;
    virtual void sendSignedUpSelective(const std::string &_sth, const ::v0::commonapi::examples::VariantSimple::SampleUnion &_more, const std::shared_ptr<CommonAPI::ClientIdList> _receivers = nullptr) = 0;
    virtual void subscribeForSignedUpSelective(const std::shared_ptr<CommonAPI::ClientId> clientId, bool& success) = 0;
    virtual void unsubscribeFromSignedUpSelective(const std::shared_ptr<CommonAPI::ClientId> clientId) = 0;
    virtual std::shared_ptr<CommonAPI::ClientIdList> const getSubscribersForSignedUpSelective() = 0;


    virtual void deactivateManagedInstances() = 0;
protected:
    /**
     * Defines properties for storing the ClientIds of clients / proxies that have
     * subscribed to the selective broadcasts
     */
    std::shared_ptr<CommonAPI::ClientIdList> subscribersForSignedUpSelective_;
};

/**
 * Defines the necessary callbacks to handle remote set events related to the attributes
 * defined in the IDL description for VariantSimple.
 * For each attribute two callbacks are defined:
 * - a verification callback that allows to verify the requested value and to prevent setting
 *   e.g. an invalid value ("onRemoteSet<AttributeName>").
 * - an action callback to do local work after the attribute value has been changed
 *   ("onRemote<AttributeName>Changed").
 *
 * This class and the one below are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class VariantSimpleStubRemoteEvent
{
public:
    virtual ~VariantSimpleStubRemoteEvent() { }

    /// Verification callback for remote set requests on the attribute status
    virtual bool onRemoteSetStatusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value) = 0;
    /// Action callback for remote set requests on the attribute status
    virtual void onRemoteStatusAttributeChanged() = 0;
};

/**
 * Defines the interface that must be implemented by any class that should provide
 * the service VariantSimple to remote clients.
 * This class and the one above are the ones an application developer needs to have
 * a look at if he wants to implement a service.
 */
class VariantSimpleStub
    : public virtual CommonAPI::Stub<VariantSimpleStubAdapter, VariantSimpleStubRemoteEvent>
{
public:
    typedef std::function<void (std::string _strOutArg, VariantSimple::SampleUnion _varOutArg)>callMeReply_t;
    typedef std::function<void (std::string _strOutArg, VariantSimple::ComplexUnion _varOutArg)>callMeComplexReply_t;
    typedef std::function<void ()>singleInArgMethodReply_t;
    typedef std::function<void (VariantSimple::SampleUnion _varOutArg)>singleOutArgMethodReply_t;
    typedef std::function<void (VariantSimple::tPropertiesDict _properties)>getPropertiesReply_t;

    virtual ~VariantSimpleStub() {}
    virtual const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> clientId) = 0;

    /// Provides getter access to the attribute status
    virtual const std::string &getStatusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    /// This is the method that will be called on remote calls on the method callMe.
    virtual void callMe(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _strArg, VariantSimple::SampleUnion _varArg, callMeReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method callMeComplex.
    virtual void callMeComplex(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _strArg, VariantSimple::ComplexUnion _varArg, callMeComplexReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method singleInArgMethod.
    virtual void singleInArgMethod(const std::shared_ptr<CommonAPI::ClientId> _client, VariantSimple::SampleUnion _varInArg, singleInArgMethodReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method singleOutArgMethod.
    virtual void singleOutArgMethod(const std::shared_ptr<CommonAPI::ClientId> _client, singleOutArgMethodReply_t _reply) = 0;
    /// This is the method that will be called on remote calls on the method getProperties.
    virtual void getProperties(const std::shared_ptr<CommonAPI::ClientId> _client, getPropertiesReply_t _reply) = 0;
    /// Sends a broadcast event for gotToTell.
    virtual void fireGotToTellEvent(const int32_t &_count, const ::v0::commonapi::examples::VariantSimple::ComplexUnion &_anything) = 0;
    /// Sends a broadcast event for DeviceFound.
    virtual void fireDeviceFoundEvent(const std::string &_address, const ::v0::commonapi::examples::VariantSimple::tPropertiesDict &_values) = 0;
    /**
     * Sends a selective broadcast event for SignedUp to the given ClientIds.
     * The ClientIds must all be out of the set of subscribed clients.
     * If no ClientIds are given, the selective broadcast is sent to all subscribed clients.
     */
    virtual void fireSignedUpSelective(const std::string &_sth, const ::v0::commonapi::examples::VariantSimple::SampleUnion &_more, const std::shared_ptr<CommonAPI::ClientIdList> _receivers = nullptr) = 0;
    /// retreives the list of all subscribed clients for SignedUp
    virtual std::shared_ptr<CommonAPI::ClientIdList> const getSubscribersForSignedUpSelective() = 0;
    /// Hook method for reacting on new subscriptions or removed subscriptions respectively for selective broadcasts.
    virtual void onSignedUpSelectiveSubscriptionChanged(const std::shared_ptr<CommonAPI::ClientId> _client, const CommonAPI::SelectiveBroadcastSubscriptionEvent _event) = 0;
    /// Hook method for reacting accepting or denying new subscriptions 
    virtual bool onSignedUpSelectiveSubscriptionRequested(const std::shared_ptr<CommonAPI::ClientId> _client) = 0;

    using CommonAPI::Stub<VariantSimpleStubAdapter, VariantSimpleStubRemoteEvent>::initStubAdapter;
    typedef CommonAPI::Stub<VariantSimpleStubAdapter, VariantSimpleStubRemoteEvent>::StubAdapterType StubAdapterType;
    typedef CommonAPI::Stub<VariantSimpleStubAdapter, VariantSimpleStubRemoteEvent>::RemoteEventHandlerType RemoteEventHandlerType;
    typedef VariantSimpleStubRemoteEvent RemoteEventType;
    typedef VariantSimple StubInterface;
};

} // namespace examples
} // namespace commonapi
} // namespace v0


// Compatibility
namespace v0_1 = v0;

#endif // V0_COMMONAPI_EXAMPLES_Variant_Simple_STUB_HPP_
