/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.1.5.v201602250925.
* Used org.franca.core 0.9.1.201412191134.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V0_COMMONAPI_EXAMPLES_Variant_Simple_STUB_DEFAULT_HPP_
#define V0_COMMONAPI_EXAMPLES_Variant_Simple_STUB_DEFAULT_HPP_


#include <v0/commonapi/examples/VariantSimpleStub.hpp>
#include <sstream>

namespace v0 {
namespace commonapi {
namespace examples {

/**
 * Provides a default implementation for VariantSimpleStubRemoteEvent and
 * VariantSimpleStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class VariantSimpleStubDefault
    : public virtual VariantSimpleStub {
public:
    VariantSimpleStubDefault();

    VariantSimpleStubRemoteEvent* initStubAdapter(const std::shared_ptr<VariantSimpleStubAdapter> &_adapter);

    const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client);

    virtual const std::string& getStatusAttribute();
    virtual const std::string& getStatusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client);
    virtual void setStatusAttribute(std::string _value);
    virtual void setStatusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);

    virtual void callMe(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _strArg, VariantSimple::SampleUnion _varArg, callMeReply_t _reply);
    virtual void callMeComplex(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _strArg, VariantSimple::ComplexUnion _varArg, callMeComplexReply_t _reply);
    virtual void singleInArgMethod(const std::shared_ptr<CommonAPI::ClientId> _client, VariantSimple::SampleUnion _varInArg, singleInArgMethodReply_t _reply);
    virtual void singleOutArgMethod(const std::shared_ptr<CommonAPI::ClientId> _client, singleOutArgMethodReply_t _reply);
    virtual void getProperties(const std::shared_ptr<CommonAPI::ClientId> _client, getPropertiesReply_t _reply);

virtual void fireGotToTellEvent(const int32_t &_count, const ::v0::commonapi::examples::VariantSimple::ComplexUnion &_anything);
virtual void fireDeviceFoundEvent(const std::string &_address, const ::v0::commonapi::examples::VariantSimple::tPropertiesDict &_values);
virtual void fireSignedUpSelective(const std::string &_sth, const ::v0::commonapi::examples::VariantSimple::SampleUnion &_more, const std::shared_ptr<CommonAPI::ClientIdList> _receivers = nullptr);
virtual std::shared_ptr<CommonAPI::ClientIdList> const getSubscribersForSignedUpSelective();
/// Hook method for reacting on new subscriptions or removed subscriptions respectively for selective broadcasts.
virtual void onSignedUpSelectiveSubscriptionChanged(const std::shared_ptr<CommonAPI::ClientId> _client, const CommonAPI::SelectiveBroadcastSubscriptionEvent _event);
/// Hook method for reacting accepting or denying new subscriptions 
virtual bool onSignedUpSelectiveSubscriptionRequested(const std::shared_ptr<CommonAPI::ClientId> _client);


protected:
    virtual bool trySetStatusAttribute(std::string _value);
    virtual bool validateStatusAttributeRequestedValue(const std::string &_value);
    virtual void onRemoteStatusAttributeChanged();
    class RemoteEventHandler: public virtual VariantSimpleStubRemoteEvent {
    public:
        RemoteEventHandler(VariantSimpleStubDefault *_defaultStub);

        virtual bool onRemoteSetStatusAttribute(std::string _value);
        virtual bool onRemoteSetStatusAttribute(const std::shared_ptr<CommonAPI::ClientId> _client, std::string _value);
        virtual void onRemoteStatusAttributeChanged();


    private:
        VariantSimpleStubDefault *defaultStub_;
    };
private:
    VariantSimpleStubDefault::RemoteEventHandler remoteEventHandler_;

    std::string statusAttributeValue_ {};

    CommonAPI::Version interfaceVersion_;
};

} // namespace examples
} // namespace commonapi
} // namespace v0


// Compatibility
namespace v0_1 = v0;

#endif // V0_COMMONAPI_EXAMPLES_Variant_Simple_STUB_DEFAULT
